Index: ext/spl/spl_array.c
===================================================================
--- ext/spl/spl_array.c	(revision 297868)
+++ ext/spl/spl_array.c	(working copy)
@@ -717,63 +717,62 @@
 }
 /* }}} */
 
-static zval *spl_array_read_property(zval *object, zval *member, int type TSRMLS_DC) /* {{{ */
+static zval *spl_array_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	spl_array_object *intern = (spl_array_object*)zend_object_store_get_object(object TSRMLS_CC);
 
 	if ((intern->ar_flags & SPL_ARRAY_ARRAY_AS_PROPS) != 0
-	&& !std_object_handlers.has_property(object, member, 2 TSRMLS_CC)) {
+	&& !std_object_handlers.has_property(object, member, 2, key TSRMLS_CC)) {
 		return spl_array_read_dimension(object, member, type TSRMLS_CC);
 	}
-	return std_object_handlers.read_property(object, member, type TSRMLS_CC);
+	return std_object_handlers.read_property(object, member, type, key TSRMLS_CC);
 } /* }}} */
 
-static void spl_array_write_property(zval *object, zval *member, zval *value TSRMLS_DC) /* {{{ */
+static void spl_array_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	spl_array_object *intern = (spl_array_object*)zend_object_store_get_object(object TSRMLS_CC);
 
 	if ((intern->ar_flags & SPL_ARRAY_ARRAY_AS_PROPS) != 0
-	&& !std_object_handlers.has_property(object, member, 2 TSRMLS_CC)) {
+	&& !std_object_handlers.has_property(object, member, 2, key TSRMLS_CC)) {
 		spl_array_write_dimension(object, member, value TSRMLS_CC);
 		return;
 	}
-	std_object_handlers.write_property(object, member, value TSRMLS_CC);
+	std_object_handlers.write_property(object, member, value, key TSRMLS_CC);
 } /* }}} */
 
-static zval **spl_array_get_property_ptr_ptr(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static zval **spl_array_get_property_ptr_ptr(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	spl_array_object *intern = (spl_array_object*)zend_object_store_get_object(object TSRMLS_CC);
 
 	if ((intern->ar_flags & SPL_ARRAY_ARRAY_AS_PROPS) != 0
-	&& !std_object_handlers.has_property(object, member, 2 TSRMLS_CC)) {
+	&& !std_object_handlers.has_property(object, member, 2, key TSRMLS_CC)) {
 		return spl_array_get_dimension_ptr_ptr(1, object, member, 0 TSRMLS_CC);		
 	}
-	return std_object_handlers.get_property_ptr_ptr(object, member TSRMLS_CC);
+	return std_object_handlers.get_property_ptr_ptr(object, member, key TSRMLS_CC);
 } /* }}} */
 
-static int spl_array_has_property(zval *object, zval *member, int has_set_exists TSRMLS_DC) /* {{{ */
+static int spl_array_has_property(zval *object, zval *member, int has_set_exists, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	spl_array_object *intern = (spl_array_object*)zend_object_store_get_object(object TSRMLS_CC);
 
 	if ((intern->ar_flags & SPL_ARRAY_ARRAY_AS_PROPS) != 0
-	&& !std_object_handlers.has_property(object, member, 2 TSRMLS_CC)) {
+	&& !std_object_handlers.has_property(object, member, 2, key TSRMLS_CC)) {
 		return spl_array_has_dimension(object, member, has_set_exists TSRMLS_CC);
 	}
-	return std_object_handlers.has_property(object, member, has_set_exists TSRMLS_CC);
-
+	return std_object_handlers.has_property(object, member, has_set_exists, key TSRMLS_CC);
 } /* }}} */
 
-static void spl_array_unset_property(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static void spl_array_unset_property(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	spl_array_object *intern = (spl_array_object*)zend_object_store_get_object(object TSRMLS_CC);
 
 	if ((intern->ar_flags & SPL_ARRAY_ARRAY_AS_PROPS) != 0
-	&& !std_object_handlers.has_property(object, member, 2 TSRMLS_CC)) {
+	&& !std_object_handlers.has_property(object, member, 2, key TSRMLS_CC)) {
 		spl_array_unset_dimension(object, member TSRMLS_CC);
 		spl_array_rewind(intern TSRMLS_CC); /* because deletion might invalidate position */
 		return;
 	}
-	std_object_handlers.unset_property(object, member TSRMLS_CC);
+	std_object_handlers.unset_property(object, member, key TSRMLS_CC);
 } /* }}} */
 
 static int spl_array_skip_protected(spl_array_object *intern, HashTable *aht TSRMLS_DC) /* {{{ */
Index: ext/spl/spl_iterators.c
===================================================================
--- ext/spl/spl_iterators.c	(revision 297868)
+++ ext/spl/spl_iterators.c	(working copy)
@@ -753,7 +753,7 @@
 	}
 } /* }}} */
 
-static union _zend_function *spl_recursive_it_get_method(zval **object_ptr, char *method, int method_len TSRMLS_DC)
+static union _zend_function *spl_recursive_it_get_method(zval **object_ptr, char *method, int method_len, const zend_literal *key TSRMLS_DC)
 {
 	union _zend_function    *function_handler;
 	spl_recursive_it_object *object = (spl_recursive_it_object*)zend_object_store_get_object(*object_ptr TSRMLS_CC);
@@ -765,12 +765,12 @@
 	}
 	zobj = object->iterators[level].zobject;
 
-	function_handler = std_object_handlers.get_method(object_ptr, method, method_len TSRMLS_CC);
+	function_handler = std_object_handlers.get_method(object_ptr, method, method_len, key TSRMLS_CC);
 	if (!function_handler) {
 		if (zend_hash_find(&Z_OBJCE_P(zobj)->function_table, method, method_len+1, (void **) &function_handler) == FAILURE) {
 			if (Z_OBJ_HT_P(zobj)->get_method) {
 				*object_ptr = zobj;
-				function_handler = Z_OBJ_HT_P(*object_ptr)->get_method(object_ptr, method, method_len TSRMLS_CC);
+				function_handler = Z_OBJ_HT_P(*object_ptr)->get_method(object_ptr, method, method_len, key TSRMLS_CC);
 			}
 		}
 	}
@@ -1158,19 +1158,19 @@
 }
 #endif
 
-static union _zend_function *spl_dual_it_get_method(zval **object_ptr, char *method, int method_len TSRMLS_DC)
+static union _zend_function *spl_dual_it_get_method(zval **object_ptr, char *method, int method_len, const zend_literal *key TSRMLS_DC)
 {
 	union _zend_function *function_handler;
 	spl_dual_it_object   *intern;
 
 	intern = (spl_dual_it_object*)zend_object_store_get_object(*object_ptr TSRMLS_CC);
 
-	function_handler = std_object_handlers.get_method(object_ptr, method, method_len TSRMLS_CC);
+	function_handler = std_object_handlers.get_method(object_ptr, method, method_len, key TSRMLS_CC);
 	if (!function_handler && intern->inner.ce) {
 		if (zend_hash_find(&intern->inner.ce->function_table, method, method_len+1, (void **) &function_handler) == FAILURE) {
 			if (Z_OBJ_HT_P(intern->inner.zobject)->get_method) {
 				*object_ptr = intern->inner.zobject;
-				function_handler = Z_OBJ_HT_P(*object_ptr)->get_method(object_ptr, method, method_len TSRMLS_CC);
+				function_handler = Z_OBJ_HT_P(*object_ptr)->get_method(object_ptr, method, method_len, key TSRMLS_CC);
 			}
 		}
 	}
Index: ext/standard/incomplete_class.c
===================================================================
--- ext/standard/incomplete_class.c	(revision 297868)
+++ ext/standard/incomplete_class.c	(working copy)
@@ -54,7 +54,7 @@
 }
 /* }}} */
 
-static zval *incomplete_class_get_property(zval *object, zval *member, int type TSRMLS_DC) /* {{{ */
+static zval *incomplete_class_get_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	incomplete_class_message(object, E_NOTICE TSRMLS_CC);
 	
@@ -66,33 +66,33 @@
 }
 /* }}} */
 
-static void incomplete_class_write_property(zval *object, zval *member, zval *value TSRMLS_DC) /* {{{ */
+static void incomplete_class_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	incomplete_class_message(object, E_NOTICE TSRMLS_CC);
 }
 /* }}} */
 	
-static zval **incomplete_class_get_property_ptr_ptr(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static zval **incomplete_class_get_property_ptr_ptr(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	incomplete_class_message(object, E_NOTICE TSRMLS_CC);
 	return &EG(error_zval_ptr);
 }
 /* }}} */
 
-static void incomplete_class_unset_property(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static void incomplete_class_unset_property(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	incomplete_class_message(object, E_NOTICE TSRMLS_CC);
 }
 /* }}} */
 
-static int incomplete_class_has_property(zval *object, zval *member, int check_empty TSRMLS_DC) /* {{{ */
+static int incomplete_class_has_property(zval *object, zval *member, int check_empty, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	incomplete_class_message(object, E_NOTICE TSRMLS_CC);
 	return 0;
 }
 /* }}} */
 
-static union _zend_function *incomplete_class_get_method(zval **object, char *method, int method_len TSRMLS_DC) /* {{{ */
+static union _zend_function *incomplete_class_get_method(zval **object, char *method, int method_len, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	incomplete_class_message(*object, E_ERROR TSRMLS_CC);
 	return NULL;
Index: ext/standard/user_filters.c
===================================================================
--- ext/standard/user_filters.c	(revision 297868)
+++ ext/standard/user_filters.c	(working copy)
@@ -259,7 +259,7 @@
 	 * from being destroyed properly */
 	INIT_ZVAL(zpropname);
 	ZVAL_STRINGL(&zpropname, "stream", sizeof("stream")-1, 0);
-	Z_OBJ_HANDLER_P(obj, unset_property)(obj, &zpropname TSRMLS_CC);
+	Z_OBJ_HANDLER_P(obj, unset_property)(obj, &zpropname, 0 TSRMLS_CC);
 
 	zval_ptr_dtor(&zclosing);
 	zval_ptr_dtor(&zconsumed);
Index: ext/mysqli/mysqli.c
===================================================================
--- ext/mysqli/mysqli.c	(revision 297868)
+++ ext/mysqli/mysqli.c	(working copy)
@@ -311,7 +311,7 @@
 
 
 /* {{{ mysqli_read_property */
-zval *mysqli_read_property(zval *object, zval *member, int type TSRMLS_DC)
+zval *mysqli_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC)
 {
 	zval tmp_member;
 	zval *retval;
@@ -343,7 +343,7 @@
 		}
 	} else {
 		zend_object_handlers * std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->read_property(object, member, type TSRMLS_CC);
+		retval = std_hnd->read_property(object, member, type, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -354,7 +354,7 @@
 /* }}} */
 
 /* {{{ mysqli_write_property */
-void mysqli_write_property(zval *object, zval *member, zval *value TSRMLS_DC)
+void mysqli_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	zval tmp_member;
 	mysqli_object *obj;
@@ -382,7 +382,7 @@
 		}
 	} else {
 		zend_object_handlers * std_hnd = zend_get_std_object_handlers();
-		std_hnd->write_property(object, member, value TSRMLS_CC);
+		std_hnd->write_property(object, member, value, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -403,7 +403,7 @@
 }
 /* }}} */
 
-static int mysqli_object_has_property(zval *object, zval *member, int has_set_exists TSRMLS_DC) /* {{{ */
+static int mysqli_object_has_property(zval *object, zval *member, int has_set_exists, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	mysqli_object *obj = (mysqli_object *)zend_objects_get_address(object TSRMLS_CC);
 	mysqli_prop_handler	p;
@@ -415,7 +415,7 @@
 				ret = 1;
 				break;
 			case 1: {
-				zval *value = mysqli_read_property(object, member, BP_VAR_IS TSRMLS_CC);
+				zval *value = mysqli_read_property(object, member, BP_VAR_IS, key TSRMLS_CC);
 				if (value != EG(uninitialized_zval_ptr)) {
 					convert_to_boolean(value);
 					ret = Z_BVAL_P(value)? 1:0;
@@ -426,7 +426,7 @@
 				break;
 			}
 			case 0:{
-				zval *value = mysqli_read_property(object, member, BP_VAR_IS TSRMLS_CC);
+				zval *value = mysqli_read_property(object, member, BP_VAR_IS, key TSRMLS_CC);
 				if (value != EG(uninitialized_zval_ptr)) {
 					ret = Z_TYPE_P(value) != IS_NULL? 1:0;
 					/* refcount is 0 */
@@ -440,7 +440,7 @@
 		}
 	} else {
 		zend_object_handlers * std_hnd = zend_get_std_object_handlers();
-		ret = std_hnd->has_property(object, member, has_set_exists TSRMLS_CC);
+		ret = std_hnd->has_property(object, member, has_set_exists, key TSRMLS_CC);
 	}
 	return ret;
 } /* }}} */
@@ -463,7 +463,7 @@
 		zval *value;
 		INIT_ZVAL(member);
 		ZVAL_STRINGL(&member, entry->name, entry->name_len, 0); 
-		value = mysqli_read_property(object, &member, BP_VAR_IS TSRMLS_CC);
+		value = mysqli_read_property(object, &member, BP_VAR_IS, 0 TSRMLS_CC);
 		if (value != EG(uninitialized_zval_ptr)) {
 			Z_ADDREF_P(value);
 			zend_hash_add(retval, entry->name, entry->name_len + 1, &value, sizeof(zval *), NULL);
Index: ext/dom/php_dom.c
===================================================================
--- ext/dom/php_dom.c	(revision 297868)
+++ ext/dom/php_dom.c	(working copy)
@@ -302,7 +302,7 @@
 }
 /* }}} */
 
-static zval **dom_get_property_ptr_ptr(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static zval **dom_get_property_ptr_ptr(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	dom_object *obj;
 	zval tmp_member;
@@ -325,7 +325,7 @@
 	}
 	if (ret == FAILURE) {
 		std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->get_property_ptr_ptr(object, member TSRMLS_CC);
+		retval = std_hnd->get_property_ptr_ptr(object, member, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -336,7 +336,7 @@
 /* }}} */
 
 /* {{{ dom_read_property */
-zval *dom_read_property(zval *object, zval *member, int type TSRMLS_DC)
+zval *dom_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC)
 {
 	dom_object *obj;
 	zval tmp_member;
@@ -371,7 +371,7 @@
 		}
 	} else {
 		std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->read_property(object, member, type TSRMLS_CC);
+		retval = std_hnd->read_property(object, member, type, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -382,7 +382,7 @@
 /* }}} */
 
 /* {{{ dom_write_property */
-void dom_write_property(zval *object, zval *member, zval *value TSRMLS_DC)
+void dom_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	dom_object *obj;
 	zval tmp_member;
@@ -407,7 +407,7 @@
 		hnd->write_func(obj, value TSRMLS_CC);
 	} else {
 		std_hnd = zend_get_std_object_handlers();
-		std_hnd->write_property(object, member, value TSRMLS_CC);
+		std_hnd->write_property(object, member, value, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -417,7 +417,7 @@
 /* }}} */
 
 /* {{{ dom_property_exists */
-static int dom_property_exists(zval *object, zval *member, int check_empty TSRMLS_DC)
+static int dom_property_exists(zval *object, zval *member, int check_empty, const zend_literal *key TSRMLS_DC)
 {
 	dom_object *obj;
 	zval tmp_member;
@@ -455,7 +455,7 @@
 		}
 	} else {
 		std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->has_property(object, member, check_empty TSRMLS_CC);
+		retval = std_hnd->has_property(object, member, check_empty, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
Index: ext/soap/php_encoding.c
===================================================================
--- ext/soap/php_encoding.c	(revision 297868)
+++ ext/soap/php_encoding.c	(working copy)
@@ -1213,7 +1213,7 @@
 		ZVAL_STRING(&member, name, 0);
 		old_scope = EG(scope);
 		EG(scope) = Z_OBJCE_P(object);
-		data = Z_OBJ_HT_P(object)->read_property(object, &member, BP_VAR_IS TSRMLS_CC);
+		data = Z_OBJ_HT_P(object)->read_property(object, &member, BP_VAR_IS, 0 TSRMLS_CC);
 		if (data == EG(uninitialized_zval_ptr)) {
 			/* Hack for bug #32455 */
 			zend_property_info *property_info;
@@ -1247,7 +1247,7 @@
 		ZVAL_STRING(&member, name, 0);
 		old_scope = EG(scope);
 		EG(scope) = Z_OBJCE_P(object);
-		Z_OBJ_HT_P(object)->unset_property(object, &member TSRMLS_CC);
+		Z_OBJ_HT_P(object)->unset_property(object, &member, 0 TSRMLS_CC);
 		EG(scope) = old_scope;
 	} else if (Z_TYPE_P(object) == IS_ARRAY) {
 		zend_hash_del(Z_ARRVAL_P(object), name, strlen(name)+1);
Index: ext/pdo/pdo_dbh.c
===================================================================
--- ext/pdo/pdo_dbh.c	(revision 297868)
+++ ext/pdo/pdo_dbh.c	(working copy)
@@ -449,7 +449,7 @@
 	MAKE_STD_ZVAL(query_string);
 	ZVAL_STRINGL(query_string, stmt->query_string, stmt->query_stringlen, 1);
 	ZVAL_STRINGL(&z_key, "queryString", sizeof("queryString")-1, 0);
-	std_object_handlers.write_property(object, &z_key, query_string TSRMLS_CC);
+	std_object_handlers.write_property(object, &z_key, query_string, 0 TSRMLS_CC);
 	zval_ptr_dtor(&query_string);
 
 	if (dbstmt_ce->constructor) {
@@ -1327,7 +1327,7 @@
 #else
 	zval *object,
 #endif
-	char *method_name, int method_len TSRMLS_DC)
+	char *method_name, int method_len, const zend_literal *key TSRMLS_DC)
 {
 	zend_function *fbc = NULL;
 	char *lc_method_name;
@@ -1339,7 +1339,7 @@
 	lc_method_name = emalloc(method_len + 1);
 	zend_str_tolower_copy(lc_method_name, method_name, method_len);
 
-	if ((fbc = std_object_handlers.get_method(object_pp, method_name, method_len TSRMLS_CC)) == NULL) {
+	if ((fbc = std_object_handlers.get_method(object_pp, method_name, method_len, key TSRMLS_CC)) == NULL) {
 		/* not a pre-defined method, nor a user-defined method; check
 		 * the driver specific methods */
 		if (!dbh->cls_methods[PDO_DBH_DRIVER_METHOD_KIND_DBH]) {
Index: ext/pdo/pdo_stmt.c
===================================================================
--- ext/pdo/pdo_stmt.c	(revision 297868)
+++ ext/pdo/pdo_stmt.c	(working copy)
@@ -2234,7 +2234,7 @@
 };
 
 /* {{{ overloaded handlers for PDOStatement class */
-static void dbstmt_prop_write(zval *object, zval *member, zval *value TSRMLS_DC)
+static void dbstmt_prop_write(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	pdo_stmt_t * stmt = (pdo_stmt_t *) zend_object_store_get_object(object TSRMLS_CC);
 
@@ -2243,11 +2243,11 @@
 	if(strcmp(Z_STRVAL_P(member), "queryString") == 0) {
 		pdo_raise_impl_error(stmt->dbh, stmt, "HY000", "property queryString is read only" TSRMLS_CC);
 	} else {
-		std_object_handlers.write_property(object, member, value TSRMLS_CC);
+		std_object_handlers.write_property(object, member, value, key TSRMLS_CC);
 	}
 }
 
-static void dbstmt_prop_delete(zval *object, zval *member TSRMLS_DC)
+static void dbstmt_prop_delete(zval *object, zval *member, const zend_literal *key TSRMLS_DC)
 {
 	pdo_stmt_t * stmt = (pdo_stmt_t *) zend_object_store_get_object(object TSRMLS_CC);
 
@@ -2256,7 +2256,7 @@
 	if(strcmp(Z_STRVAL_P(member), "queryString") == 0) {
 		pdo_raise_impl_error(stmt->dbh, stmt, "HY000", "property queryString is read only" TSRMLS_CC);
 	} else {
-		std_object_handlers.unset_property(object, member TSRMLS_CC);
+		std_object_handlers.unset_property(object, member, key TSRMLS_CC);
 	}
 }
 
@@ -2266,7 +2266,7 @@
 #else
 	zval *object,
 #endif
-   	char *method_name, int method_len TSRMLS_DC)
+   	char *method_name, int method_len, const zend_literal *key TSRMLS_DC)
 {
 	zend_function *fbc = NULL;
 	char *lc_method_name;
@@ -2585,7 +2585,7 @@
 	{NULL, NULL, NULL}
 };
 
-static zval *row_prop_or_dim_read(zval *object, zval *member, int type TSRMLS_DC)
+static zval *row_prop_read(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC)
 {
 	zval *return_value;
 	pdo_stmt_t * stmt = (pdo_stmt_t *) zend_object_store_get_object(object TSRMLS_CC);
@@ -2613,7 +2613,7 @@
 			}
 			if (strcmp(Z_STRVAL_P(member), "queryString") == 0) {
 				zval_ptr_dtor(&return_value);
-				return std_object_handlers.read_property(object, member, IS_STRING TSRMLS_CC);
+				return std_object_handlers.read_property(object, member, IS_STRING, key TSRMLS_CC);
 			}
 		}
 	}
@@ -2624,13 +2624,23 @@
 	return return_value;
 }
 
-static void row_prop_or_dim_write(zval *object, zval *member, zval *value TSRMLS_DC)
+static zval *row_dim_read(zval *object, zval *member, int type TSRMLS_DC)
 {
+	return row_prop_read(object, member, type, NULL TSRMLS_CC);
+}
+
+static void row_prop_write(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
+{
 	php_error_docref(NULL TSRMLS_CC, E_WARNING, "This PDORow is not from a writable result set");
 }
 
-static int row_prop_or_dim_exists(zval *object, zval *member, int check_empty TSRMLS_DC)
+static void row_dim_write(zval *object, zval *member, zval *value TSRMLS_DC)
 {
+	php_error_docref(NULL TSRMLS_CC, E_WARNING, "This PDORow is not from a writable result set");
+}
+
+static int row_prop_exists(zval *object, zval *member, int check_empty, const zend_literal *key TSRMLS_DC)
+{
 	pdo_stmt_t * stmt = (pdo_stmt_t *) zend_object_store_get_object(object TSRMLS_CC);
 	int colno = -1;
 
@@ -2653,11 +2663,21 @@
 	return 0;
 }
 
-static void row_prop_or_dim_delete(zval *object, zval *offset TSRMLS_DC)
+static int row_dim_exists(zval *object, zval *member, int check_empty TSRMLS_DC)
 {
+	return row_prop_exists(object, member, check_empty, NULL TSRMLS_CC);
+}
+
+static void row_prop_delete(zval *object, zval *offset, const zend_literal *key TSRMLS_DC)
+{
 	php_error_docref(NULL TSRMLS_CC, E_WARNING, "Cannot delete properties from a PDORow");
 }
 
+static void row_dim_delete(zval *object, zval *offset TSRMLS_DC)
+{
+	php_error_docref(NULL TSRMLS_CC, E_WARNING, "Cannot delete properties from a PDORow");
+}
+
 static HashTable *row_get_properties(zval *object TSRMLS_DC)
 {
 	pdo_stmt_t * stmt = (pdo_stmt_t *) zend_object_store_get_object(object TSRMLS_CC);
@@ -2684,7 +2704,7 @@
 #else
 	zval *object,
 #endif
-	char *method_name, int method_len TSRMLS_DC)
+	char *method_name, int method_len, const zend_literal *key TSRMLS_DC)
 {
 	zend_function *fbc;
 	char *lc_method_name;
@@ -2741,17 +2761,17 @@
 
 zend_object_handlers pdo_row_object_handlers = {
 	ZEND_OBJECTS_STORE_HANDLERS,
-	row_prop_or_dim_read,
-	row_prop_or_dim_write,
-	row_prop_or_dim_read,
-	row_prop_or_dim_write,
+	row_prop_read,
+	row_prop_write,
+	row_dim_read,
+	row_dim_write,
 	NULL,
 	NULL,
 	NULL,
-	row_prop_or_dim_exists,
-	row_prop_or_dim_delete,
-	row_prop_or_dim_exists,
-	row_prop_or_dim_delete,
+	row_prop_exists,
+	row_prop_delete,
+	row_dim_exists,
+	row_dim_delete,
 	row_get_properties,
 	row_method_get,
 	row_call_method,
Index: ext/date/php_date.c
===================================================================
--- ext/date/php_date.c	(revision 297868)
+++ ext/date/php_date.c	(working copy)
@@ -564,8 +564,8 @@
 static HashTable *date_object_get_properties(zval *object TSRMLS_DC);
 static HashTable *date_object_get_properties_interval(zval *object TSRMLS_DC);
 
-zval *date_interval_read_property(zval *object, zval *member, int type TSRMLS_DC);
-void date_interval_write_property(zval *object, zval *member, zval *value TSRMLS_DC);
+zval *date_interval_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC);
+void date_interval_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC);
 
 /* {{{ Module struct */
 zend_module_entry date_module_entry = {
@@ -3427,7 +3427,7 @@
 }
 
 /* {{{ date_interval_read_property */
-zval *date_interval_read_property(zval *object, zval *member, int type TSRMLS_DC)
+zval *date_interval_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC)
 {
 	php_interval_obj *obj;
 	zval *retval;
@@ -3474,7 +3474,7 @@
 /* }}} */
 
 /* {{{ date_interval_write_property */
-void date_interval_write_property(zval *object, zval *member, zval *value TSRMLS_DC)
+void date_interval_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	php_interval_obj *obj;
 	zval tmp_member, tmp_value;
Index: ext/xmlreader/php_xmlreader.c
===================================================================
--- ext/xmlreader/php_xmlreader.c	(revision 297868)
+++ ext/xmlreader/php_xmlreader.c	(working copy)
@@ -112,7 +112,7 @@
 /* }}} */
 
 /* {{{ xmlreader_get_property_ptr_ptr */
-zval **xmlreader_get_property_ptr_ptr(zval *object, zval *member TSRMLS_DC)
+zval **xmlreader_get_property_ptr_ptr(zval *object, zval *member, const zend_literal *key TSRMLS_DC)
 {
 	xmlreader_object *obj;
 	zval tmp_member;
@@ -135,7 +135,7 @@
 	}
 	if (ret == FAILURE) {
 		std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->get_property_ptr_ptr(object, member TSRMLS_CC);
+		retval = std_hnd->get_property_ptr_ptr(object, member, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -146,7 +146,7 @@
 /* }}} */
 
 /* {{{ xmlreader_read_property */
-zval *xmlreader_read_property(zval *object, zval *member, int type TSRMLS_DC)
+zval *xmlreader_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC)
 {
 	xmlreader_object *obj;
 	zval tmp_member;
@@ -178,7 +178,7 @@
 		}
 	} else {
 		std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->read_property(object, member, type TSRMLS_CC);
+		retval = std_hnd->read_property(object, member, type, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -189,7 +189,7 @@
 /* }}} */
 
 /* {{{ xmlreader_write_property */
-void xmlreader_write_property(zval *object, zval *member, zval *value TSRMLS_DC)
+void xmlreader_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	xmlreader_object *obj;
 	zval tmp_member;
@@ -214,7 +214,7 @@
 		php_error_docref(NULL TSRMLS_CC, E_WARNING, "Cannot write to read-only property");
 	} else {
 		std_hnd = zend_get_std_object_handlers();
-		std_hnd->write_property(object, member, value TSRMLS_CC);
+		std_hnd->write_property(object, member, value, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
Index: ext/reflection/php_reflection.c
===================================================================
--- ext/reflection/php_reflection.c	(revision 297868)
+++ ext/reflection/php_reflection.c	(working copy)
@@ -650,7 +650,7 @@
 	++offset;
 	while (op < end) {
 		if ((op->opcode == ZEND_RECV || op->opcode == ZEND_RECV_INIT)
-			&& op->op1.u.constant.value.lval == (long)offset)
+			&& op->op1.num == (long)offset)
 		{
 			return op;
 		}
@@ -690,12 +690,12 @@
 	}
 	if (fptr->type == ZEND_USER_FUNCTION && offset >= required) {
 		zend_op *precv = _get_recv_op((zend_op_array*)fptr, offset);
-		if (precv && precv->opcode == ZEND_RECV_INIT && precv->op2.op_type != IS_UNUSED) {
+		if (precv && precv->opcode == ZEND_RECV_INIT && precv->op2_type != IS_UNUSED) {
 			zval *zv, zv_copy;
 			int use_copy;
 			string_write(str, " = ", sizeof(" = ")-1);
 			ALLOC_ZVAL(zv);
-			*zv = precv->op2.u.constant;
+			*zv = *precv->op2.zv;
 			zval_copy_ctor(zv);
 			INIT_PZVAL(zv);
 			zval_update_constant_ex(&zv, (void*)1, fptr->common.scope TSRMLS_CC);
@@ -2389,7 +2389,7 @@
 		RETURN_FALSE;
 	}
 	precv = _get_recv_op((zend_op_array*)param->fptr, param->offset);
-	if (!precv || precv->opcode != ZEND_RECV_INIT || precv->op2.op_type == IS_UNUSED) {
+	if (!precv || precv->opcode != ZEND_RECV_INIT || precv->op2_type == IS_UNUSED) {
 		RETURN_FALSE;
 	}
 	RETURN_TRUE;
@@ -2419,12 +2419,12 @@
 		return;
 	}
 	precv = _get_recv_op((zend_op_array*)param->fptr, param->offset);
-	if (!precv || precv->opcode != ZEND_RECV_INIT || precv->op2.op_type == IS_UNUSED) {
+	if (!precv || precv->opcode != ZEND_RECV_INIT || precv->op2_type == IS_UNUSED) {
 		zend_throw_exception_ex(reflection_exception_ptr, 0 TSRMLS_CC, "Internal error"); 
 		return;
 	}
 
-	*return_value = precv->op2.u.constant;
+	*return_value = *precv->op2.zv;
 	INIT_PZVAL(return_value);
 	if (Z_TYPE_P(return_value) != IS_CONSTANT) {
 		zval_copy_ctor(return_value);
@@ -3130,7 +3130,7 @@
 	GET_REFLECTION_OBJECT_PTR(ce);
 
 	zend_update_class_constants(ce TSRMLS_CC);
-	prop = zend_std_get_static_property(ce, name, name_len, 1 TSRMLS_CC);
+	prop = zend_std_get_static_property(ce, name, name_len, 1, NULL TSRMLS_CC);
 	if (!prop) {
 		if (def_value) {
 			RETURN_ZVAL(def_value, 1, 0);
@@ -3164,7 +3164,7 @@
 	GET_REFLECTION_OBJECT_PTR(ce);
 
 	zend_update_class_constants(ce TSRMLS_CC);
-	variable_ptr = zend_std_get_static_property(ce, name, name_len, 1 TSRMLS_CC);
+	variable_ptr = zend_std_get_static_property(ce, name, name_len, 1, NULL TSRMLS_CC);
 	if (!variable_ptr) {
 		zend_throw_exception_ex(reflection_exception_ptr, 0 TSRMLS_CC, 
 				"Class %s does not have a property named %s", ce->name, name);
@@ -3545,7 +3545,7 @@
 		if (intern->obj && Z_OBJ_HANDLER_P(intern->obj, has_property)) {
 			MAKE_STD_ZVAL(property);
 			ZVAL_STRINGL(property, name, name_len, 1);
-			if (Z_OBJ_HANDLER_P(intern->obj, has_property)(intern->obj, property, 2 TSRMLS_CC)) {
+			if (Z_OBJ_HANDLER_P(intern->obj, has_property)(intern->obj, property, 2, 0 TSRMLS_CC)) {
 				zval_ptr_dtor(&property);
 				RETURN_TRUE;
 			}
@@ -5598,7 +5598,7 @@
 static zend_object_handlers *zend_std_obj_handlers;
 
 /* {{{ _reflection_write_property */
-static void _reflection_write_property(zval *object, zval *member, zval *value TSRMLS_DC)
+static void _reflection_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	if ((Z_TYPE_P(member) == IS_STRING)
 		&& zend_hash_exists(&Z_OBJCE_P(object)->default_properties, Z_STRVAL_P(member), Z_STRLEN_P(member)+1)
@@ -5610,7 +5610,7 @@
 	}
 	else
 	{
-		zend_std_obj_handlers->write_property(object, member, value TSRMLS_CC);		
+		zend_std_obj_handlers->write_property(object, member, value, key TSRMLS_CC);
 	}
 }
 /* }}} */
Index: ext/simplexml/simplexml.c
===================================================================
--- ext/simplexml/simplexml.c	(revision 297868)
+++ ext/simplexml/simplexml.c	(working copy)
@@ -389,7 +389,7 @@
 
 /* {{{ sxe_property_read()
  */
-static zval * sxe_property_read(zval *object, zval *member, int type TSRMLS_DC)
+static zval * sxe_property_read(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC)
 {
 	return sxe_prop_dim_read(object, member, 1, 0, type TSRMLS_CC);
 }
@@ -680,7 +680,7 @@
 
 /* {{{ sxe_property_write()
  */
-static void sxe_property_write(zval *object, zval *member, zval *value TSRMLS_DC)
+static void sxe_property_write(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	sxe_prop_dim_write(object, member, value, 1, 0, NULL TSRMLS_CC);
 }
@@ -694,7 +694,7 @@
 }
 /* }}} */
 
-static zval** sxe_property_get_adr(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static zval** sxe_property_get_adr(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	php_sxe_object *sxe;
 	xmlNodePtr      node;
@@ -846,7 +846,7 @@
 
 /* {{{ sxe_property_exists()
  */
-static int sxe_property_exists(zval *object, zval *member, int check_empty TSRMLS_DC)
+static int sxe_property_exists(zval *object, zval *member, int check_empty, const zend_literal *key TSRMLS_DC)
 {
 	return sxe_prop_dim_exists(object, member, check_empty, 1, 0 TSRMLS_CC);
 }
@@ -971,7 +971,7 @@
 
 /* {{{ sxe_property_delete()
  */
-static void sxe_property_delete(zval *object, zval *member TSRMLS_DC)
+static void sxe_property_delete(zval *object, zval *member, const zend_literal *key TSRMLS_DC)
 {
 	sxe_prop_dim_delete(object, member, 1, 0 TSRMLS_CC);
 }
Index: Zend/zend.c
===================================================================
--- Zend/zend.c	(revision 297868)
+++ Zend/zend.c	(working copy)
@@ -464,19 +464,19 @@
 {
 	memset(EG(exception_op), 0, sizeof(EG(exception_op)));
 	EG(exception_op)[0].opcode = ZEND_HANDLE_EXCEPTION;
-	EG(exception_op)[0].op1.op_type = IS_UNUSED;
-	EG(exception_op)[0].op2.op_type = IS_UNUSED;
-	EG(exception_op)[0].result.op_type = IS_UNUSED;
+	EG(exception_op)[0].op1_type = IS_UNUSED;
+	EG(exception_op)[0].op2_type = IS_UNUSED;
+	EG(exception_op)[0].result_type = IS_UNUSED;
 	ZEND_VM_SET_OPCODE_HANDLER(EG(exception_op));
 	EG(exception_op)[1].opcode = ZEND_HANDLE_EXCEPTION;
-	EG(exception_op)[1].op1.op_type = IS_UNUSED;
-	EG(exception_op)[1].op2.op_type = IS_UNUSED;
-	EG(exception_op)[1].result.op_type = IS_UNUSED;
+	EG(exception_op)[1].op1_type = IS_UNUSED;
+	EG(exception_op)[1].op2_type = IS_UNUSED;
+	EG(exception_op)[1].result_type = IS_UNUSED;
 	ZEND_VM_SET_OPCODE_HANDLER(EG(exception_op)+1);
 	EG(exception_op)[2].opcode = ZEND_HANDLE_EXCEPTION;
-	EG(exception_op)[2].op1.op_type = IS_UNUSED;
-	EG(exception_op)[2].op2.op_type = IS_UNUSED;
-	EG(exception_op)[2].result.op_type = IS_UNUSED;
+	EG(exception_op)[2].op1_type = IS_UNUSED;
+	EG(exception_op)[2].op2_type = IS_UNUSED;
+	EG(exception_op)[2].result_type = IS_UNUSED;
 	ZEND_VM_SET_OPCODE_HANDLER(EG(exception_op)+2);
 }
 /* }}} */
Index: Zend/zend_hash.h
===================================================================
--- Zend/zend_hash.h	(revision 297868)
+++ Zend/zend_hash.h	(working copy)
@@ -304,7 +304,7 @@
 #define ZEND_INIT_SYMTABLE_EX(ht, n, persistent)			\
 	zend_hash_init(ht, n, NULL, ZVAL_PTR_DTOR, persistent)
 
-#define ZEND_HANDLE_NUMERIC(key, length, func) do {							\
+#define ZEND_HANDLE_NUMERIC_EX(key, length, idx, func) do {					\
 	register const char *tmp = key;											\
 																			\
 	if (*tmp == '-') {														\
@@ -312,7 +312,6 @@
 	}																		\
 	if (*tmp >= '0' && *tmp <= '9') { /* possibly a numeric index */		\
 		const char *end = key + length - 1;									\
-		long idx;															\
 																			\
 		if ((*end != '\0') /* not a null terminated string */				\
 		 || (*tmp == '0' && length > 2) /* numbers with leading zeros */	\
@@ -335,11 +334,17 @@
 			} else if (idx < 0) { /* overflow */							\
 				break;														\
 			}																\
-			return func;													\
+			func;															\
 		}																	\
 	}																		\
 } while (0)
 
+#define ZEND_HANDLE_NUMERIC(key, length, func) do {							\
+	long idx;																\
+																			\
+	ZEND_HANDLE_NUMERIC_EX(key, length, idx, return func);					\
+} while (0)
+
 static inline int zend_symtable_update(HashTable *ht, const char *arKey, uint nKeyLength, void *pData, uint nDataSize, void **pDest)					\
 {
 	ZEND_HANDLE_NUMERIC(arKey, nKeyLength, zend_hash_index_update(ht, idx, pData, nDataSize, pDest));
Index: Zend/zend_execute.c
===================================================================
--- Zend/zend_execute.c	(revision 297868)
+++ Zend/zend_execute.c	(working copy)
@@ -48,17 +48,17 @@
 
 typedef int (*incdec_t)(zval *);
 
-#define get_zval_ptr(node, Ts, should_free, type) _get_zval_ptr(node, Ts, should_free, type TSRMLS_CC)
-#define get_zval_ptr_ptr(node, Ts, should_free, type) _get_zval_ptr_ptr(node, Ts, should_free, type TSRMLS_CC)
-#define get_obj_zval_ptr(node, Ts, should_free, type) _get_obj_zval_ptr(node, Ts, should_free, type TSRMLS_CC)
-#define get_obj_zval_ptr_ptr(node, Ts, should_free, type) _get_obj_zval_ptr_ptr(node, Ts, should_free, type TSRMLS_CC)
+#define get_zval_ptr(op_type, node, Ts, should_free, type) _get_zval_ptr(op_type, node, Ts, should_free, type TSRMLS_CC)
+#define get_zval_ptr_ptr(op_type, node, Ts, should_free, type) _get_zval_ptr_ptr(op_type, node, Ts, should_free, type TSRMLS_CC)
+#define get_obj_zval_ptr(op_type, node, Ts, should_free, type) _get_obj_zval_ptr(op_type, node, Ts, should_free, type TSRMLS_CC)
+#define get_obj_zval_ptr_ptr(op_type, node, Ts, should_free, type) _get_obj_zval_ptr_ptr(op_type, node, Ts, should_free, type TSRMLS_CC)
 
 /* Prototypes */
 static void zend_extension_statement_handler(const zend_extension *extension, zend_op_array *op_array TSRMLS_DC);
 static void zend_extension_fcall_begin_handler(const zend_extension *extension, zend_op_array *op_array TSRMLS_DC);
 static void zend_extension_fcall_end_handler(const zend_extension *extension, zend_op_array *op_array TSRMLS_DC);
 
-#define RETURN_VALUE_USED(opline) (!((opline)->result.u.EA.type & EXT_TYPE_UNUSED))
+#define RETURN_VALUE_USED(opline) (!((opline)->result_type & EXT_TYPE_UNUSED))
 
 #define EX_T(offset) (*(temp_variable *)((char *) EX(Ts) + offset))
 #define T(offset) (*(temp_variable *)((char *) Ts + offset))
@@ -96,8 +96,7 @@
 #define PZVAL_UNLOCK_EX(z, f, u) zend_pzval_unlock_func(z, f, u TSRMLS_CC)
 #define PZVAL_UNLOCK_FREE(z) zend_pzval_unlock_free_func(z TSRMLS_CC)
 #define PZVAL_LOCK(z) Z_ADDREF_P((z))
-#define RETURN_VALUE_UNUSED(pzn)	(((pzn)->u.EA.type & EXT_TYPE_UNUSED))
-#define SELECTIVE_PZVAL_LOCK(pzv, pzn)	if (!RETURN_VALUE_UNUSED(pzn)) { PZVAL_LOCK(pzv); }
+#define SELECTIVE_PZVAL_LOCK(pzv, opline)	if (RETURN_VALUE_USED(opline)) { PZVAL_LOCK(pzv); }
 
 #define AI_USE_PTR(ai) \
 	if ((ai).ptr_ptr) { \
@@ -172,14 +171,14 @@
 	return execute_data_ptr->CVs[var];
 }
 
-static zend_always_inline zval *_get_zval_ptr_tmp(const znode *node, const temp_variable *Ts, zend_free_op *should_free TSRMLS_DC)
+static zend_always_inline zval *_get_zval_ptr_tmp(zend_uint var, const temp_variable *Ts, zend_free_op *should_free TSRMLS_DC)
 {
-	return should_free->var = &T(node->u.var).tmp_var;
+	return should_free->var = &T(var).tmp_var;
 }
 
-static zval *_get_zval_ptr_var_string_offset(const znode *node, const temp_variable *Ts, zend_free_op *should_free TSRMLS_DC)
+static zval *_get_zval_ptr_var_string_offset(zend_uint var, const temp_variable *Ts, zend_free_op *should_free TSRMLS_DC)
 {
-	temp_variable *T = &T(node->u.var);
+	temp_variable *T = &T(var);
 	zval *str = T->str_offset.str;
 	zval *ptr;
 
@@ -204,14 +203,14 @@
 	return ptr;
 }
 
-static zend_always_inline zval *_get_zval_ptr_var(const znode *node, const temp_variable *Ts, zend_free_op *should_free TSRMLS_DC)
+static zend_always_inline zval *_get_zval_ptr_var(zend_uint var, const temp_variable *Ts, zend_free_op *should_free TSRMLS_DC)
 {
-	zval *ptr = T(node->u.var).var.ptr;
+	zval *ptr = T(var).var.ptr;
 	if (EXPECTED(ptr != NULL)) {
 		PZVAL_UNLOCK(ptr, should_free);
 		return ptr;
 	} else {
-		return _get_zval_ptr_var_string_offset(node, Ts, should_free TSRMLS_CC);
+		return _get_zval_ptr_var_string_offset(var, Ts, should_free TSRMLS_CC);
 	}
 }
 
@@ -246,30 +245,30 @@
 	return *ptr;
 }
 
-static zend_always_inline zval *_get_zval_ptr_cv(const znode *node, const temp_variable *Ts, int type TSRMLS_DC)
+static zend_always_inline zval *_get_zval_ptr_cv(zend_uint var, int type TSRMLS_DC)
 {
-	zval ***ptr = &CV_OF(node->u.var);
+	zval ***ptr = &CV_OF(var);
 
 	if (UNEXPECTED(*ptr == NULL)) {
-		return *_get_zval_cv_lookup(ptr, node->u.var, type TSRMLS_CC);
+		return *_get_zval_cv_lookup(ptr, var, type TSRMLS_CC);
 	}
 	return **ptr;
 }
 
-static inline zval *_get_zval_ptr(znode *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC)
+static inline zval *_get_zval_ptr(int op_type, const znode_op *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC)
 {
 /*	should_free->is_var = 0; */
-	switch (node->op_type) {
+	switch (op_type) {
 		case IS_CONST:
 			should_free->var = 0;
-			return &node->u.constant;
+			return node->zv;
 			break;
 		case IS_TMP_VAR:
-			should_free->var = TMP_FREE(&T(node->u.var).tmp_var);
-			return &T(node->u.var).tmp_var;
+			should_free->var = TMP_FREE(&T(node->var).tmp_var);
+			return &T(node->var).tmp_var;
 			break;
 		case IS_VAR:
-			return _get_zval_ptr_var(node, Ts, should_free TSRMLS_CC);
+			return _get_zval_ptr_var(node->var, Ts, should_free TSRMLS_CC);
 			break;
 		case IS_UNUSED:
 			should_free->var = 0;
@@ -277,43 +276,43 @@
 			break;
 		case IS_CV:
 			should_free->var = 0;
-			return _get_zval_ptr_cv(node, Ts, type TSRMLS_CC);
+			return _get_zval_ptr_cv(node->var, type TSRMLS_CC);
 			break;
 		EMPTY_SWITCH_DEFAULT_CASE()
 	}
 	return NULL;
 }
 
-static zend_always_inline zval **_get_zval_ptr_ptr_var(const znode *node, const temp_variable *Ts, zend_free_op *should_free TSRMLS_DC)
+static zend_always_inline zval **_get_zval_ptr_ptr_var(zend_uint var, const temp_variable *Ts, zend_free_op *should_free TSRMLS_DC)
 {
-	zval** ptr_ptr = T(node->u.var).var.ptr_ptr;
+	zval** ptr_ptr = T(var).var.ptr_ptr;
 
 	if (EXPECTED(ptr_ptr != NULL)) {
 		PZVAL_UNLOCK(*ptr_ptr, should_free);
 	} else {
 		/* string offset */
-		PZVAL_UNLOCK(T(node->u.var).str_offset.str, should_free);
+		PZVAL_UNLOCK(T(var).str_offset.str, should_free);
 	}
 	return ptr_ptr;
 }
 
-static zend_always_inline zval **_get_zval_ptr_ptr_cv(const znode *node, const temp_variable *Ts, int type TSRMLS_DC)
+static zend_always_inline zval **_get_zval_ptr_ptr_cv(zend_uint var, int type TSRMLS_DC)
 {
-	zval ***ptr = &CV_OF(node->u.var);
+	zval ***ptr = &CV_OF(var);
 
 	if (UNEXPECTED(*ptr == NULL)) {
-		return _get_zval_cv_lookup(ptr, node->u.var, type TSRMLS_CC);
+		return _get_zval_cv_lookup(ptr, var, type TSRMLS_CC);
 	}
 	return *ptr;
 }
 
-static inline zval **_get_zval_ptr_ptr(const znode *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC)
+static inline zval **_get_zval_ptr_ptr(int op_type, const znode_op *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC)
 {
-	if (node->op_type == IS_CV) {
+	if (op_type == IS_CV) {
 		should_free->var = 0;
-		return _get_zval_ptr_ptr_cv(node, Ts, type TSRMLS_CC);
-	} else if (node->op_type == IS_VAR) {
-		return _get_zval_ptr_ptr_var(node, Ts, should_free TSRMLS_CC);
+		return _get_zval_ptr_ptr_cv(node->var, type TSRMLS_CC);
+	} else if (op_type == IS_VAR) {
+		return _get_zval_ptr_ptr_var(node->var, Ts, should_free TSRMLS_CC);
 	} else {
 		should_free->var = 0;
 		return NULL;
@@ -330,9 +329,9 @@
 	}
 }
 
-static inline zval **_get_obj_zval_ptr_ptr(const znode *op, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC)
+static inline zval **_get_obj_zval_ptr_ptr(int op_type, const znode_op *op, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC)
 {
-	if (op->op_type == IS_UNUSED) {
+	if (op_type == IS_UNUSED) {
 		if (EXPECTED(EG(This) != NULL)) {
 			/* this should actually never be modified, _ptr_ptr is modified only when
 			   the object is empty */
@@ -342,7 +341,7 @@
 			zend_error_noreturn(E_ERROR, "Using $this when not in object context");
 		}
 	}
-	return get_zval_ptr_ptr(op, Ts, should_free, type);
+	return get_zval_ptr_ptr(op_type, op, Ts, should_free, type);
 }
 
 static zend_always_inline zval **_get_obj_zval_ptr_ptr_unused(TSRMLS_D)
@@ -355,9 +354,9 @@
 	}
 }
 
-static inline zval *_get_obj_zval_ptr(znode *op, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC)
+static inline zval *_get_obj_zval_ptr(int op_type, znode_op *op, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC)
 {
-	if (op->op_type == IS_UNUSED) {
+	if (op_type == IS_UNUSED) {
 		if (EXPECTED(EG(This) != NULL)) {
 			should_free->var = 0;
 			return EG(This);
@@ -365,7 +364,7 @@
 			zend_error_noreturn(E_ERROR, "Using $this when not in object context");
 		}
 	}
-	return get_zval_ptr(op, Ts, should_free, type);
+	return get_zval_ptr(op_type, op, Ts, should_free, type);
 }
 
 static inline void zend_switch_free(temp_variable *T, int extended_value TSRMLS_DC)
@@ -515,17 +514,15 @@
 	return 1;
 }
 
-static inline void zend_assign_to_object(znode *result, zval **object_ptr, zval *property_name, znode *value_op, const temp_variable *Ts, int opcode TSRMLS_DC)
-
+static inline void zend_assign_to_object(zval **retval, zval **object_ptr, zval *property_name, int value_type, znode_op *value_op, const temp_variable *Ts, int opcode, const zend_literal *key TSRMLS_DC)
 {
 	zval *object = *object_ptr;
 	zend_free_op free_value;
-	zval *value = get_zval_ptr(value_op, Ts, &free_value, BP_VAR_R);
-	zval **retval = &T(result->u.var).var.ptr;
+ 	zval *value = get_zval_ptr(value_type, value_op, Ts, &free_value, BP_VAR_R);
 
 	if (Z_TYPE_P(object) != IS_OBJECT) {
 		if (object == EG(error_zval_ptr)) {
-			if (!RETURN_VALUE_UNUSED(result)) {
+ 			if (retval) {
 				*retval = EG(uninitialized_zval_ptr);
 				PZVAL_LOCK(*retval);
 			}
@@ -542,7 +539,7 @@
 			zend_error(E_STRICT, "Creating default object from empty value");
 		} else {
 			zend_error(E_WARNING, "Attempt to assign property of non-object");
-			if (!RETURN_VALUE_UNUSED(result)) {
+			if (retval) {
 				*retval = EG(uninitialized_zval_ptr);
 				PZVAL_LOCK(*retval);
 			}
@@ -552,14 +549,14 @@
 	}
 	
 	/* separate our value if necessary */
-	if (value_op->op_type == IS_TMP_VAR) {
+	if (value_type == IS_TMP_VAR) {
 		zval *orig_value = value;
 
 		ALLOC_ZVAL(value);
 		*value = *orig_value;
 		Z_UNSET_ISREF_P(value);
 		Z_SET_REFCOUNT_P(value, 0);
-	} else if (value_op->op_type == IS_CONST) {
+	} else if (value_type == IS_CONST) {
 		zval *orig_value = value;
 
 		ALLOC_ZVAL(value);
@@ -574,19 +571,19 @@
 	if (opcode == ZEND_ASSIGN_OBJ) {
 		if (!Z_OBJ_HT_P(object)->write_property) {
 			zend_error(E_WARNING, "Attempt to assign property of non-object");
-			if (!RETURN_VALUE_UNUSED(result)) {
+			if (retval) {
 				*retval = EG(uninitialized_zval_ptr);
 				PZVAL_LOCK(*retval);
 			}
-			if (value_op->op_type == IS_TMP_VAR) {
+			if (value_type == IS_TMP_VAR) {
 				FREE_ZVAL(value);
-			} else if (value_op->op_type == IS_CONST) {
+			} else if (value_type == IS_CONST) {
 				zval_ptr_dtor(&value);
 			}
 			FREE_OP(free_value);
 			return;
 		}
-		Z_OBJ_HT_P(object)->write_property(object, property_name, value TSRMLS_CC);
+		Z_OBJ_HT_P(object)->write_property(object, property_name, value, key TSRMLS_CC);
 	} else {
 		/* Note:  property_name in this case is really the array index! */
 		if (!Z_OBJ_HT_P(object)->write_dimension) {
@@ -595,8 +592,8 @@
 		Z_OBJ_HT_P(object)->write_dimension(object, property_name, value TSRMLS_CC);
 	}
 
-	if (!RETURN_VALUE_UNUSED(result) && !EG(exception)) {
-		AI_SET_PTR(T(result->u.var).var, value);
+	if (retval && !EG(exception)) {
+		*retval = value;
 		PZVAL_LOCK(value);
 	}
 	zval_ptr_dtor(&value);
@@ -757,9 +754,9 @@
 }
 
 
-static inline HashTable *zend_get_target_symbol_table(const zend_op *opline, const temp_variable *Ts, int type, const zval *variable TSRMLS_DC)
+static inline HashTable *zend_get_target_symbol_table(int fetch_type TSRMLS_DC)
 {
-	switch (opline->op2.u.EA.type) {
+	switch (fetch_type) {
 		case ZEND_FETCH_LOCAL:
 			if (!EG(active_symbol_table)) {
 				zend_rebuild_symbol_table(TSRMLS_C);
@@ -782,26 +779,34 @@
 	return NULL;
 }
 
-static inline zval **zend_fetch_dimension_address_inner(HashTable *ht, const zval *dim, int type TSRMLS_DC)
+static inline zval **zend_fetch_dimension_address_inner(HashTable *ht, const zval *dim, int dim_type, int type TSRMLS_DC)
 {
 	zval **retval;
 	char *offset_key;
 	int offset_key_length;
 	long index;
+	ulong hval;
 
 	switch (dim->type) {
 		case IS_NULL:
 			offset_key = "";
 			offset_key_length = 0;
+			hval = zend_inline_hash_func("", 1);
 			goto fetch_string_dim;
 
 		case IS_STRING:
 			
 			offset_key = dim->value.str.val;
 			offset_key_length = dim->value.str.len;
-			
+
+			if (dim_type == IS_CONST) {
+				hval = Z_HASH_P(dim);
+			} else {
+				ZEND_HANDLE_NUMERIC_EX(offset_key, offset_key_length+1, index, goto num_index);
+				hval = zend_hash_func(offset_key, offset_key_length+1);
+			}	
 fetch_string_dim:
-			if (zend_symtable_find(ht, offset_key, offset_key_length+1, (void **) &retval) == FAILURE) {
+			if (zend_hash_quick_find(ht, offset_key, offset_key_length+1, hval, (void **) &retval) == FAILURE) {
 				switch (type) {
 					case BP_VAR_R:
 						zend_error(E_NOTICE, "Undefined index: %s", offset_key);
@@ -817,7 +822,7 @@
 							zval *new_zval = &EG(uninitialized_zval);
 
 							Z_ADDREF_P(new_zval);
-							zend_symtable_update(ht, offset_key, offset_key_length+1, &new_zval, sizeof(zval *), (void **) &retval);
+							zend_hash_quick_update(ht, offset_key, offset_key_length+1, hval, &new_zval, sizeof(zval *), (void **) &retval);
 						}
 						break;
 				}
@@ -864,7 +869,7 @@
 	return retval;
 }
 
-static void zend_fetch_dimension_address(temp_variable *result, zval **container_ptr, zval *dim, int dim_is_tmp_var, int type TSRMLS_DC)
+static void zend_fetch_dimension_address(temp_variable *result, zval **container_ptr, zval *dim, int dim_type, int type TSRMLS_DC)
 {
 	zval *container = *container_ptr;
 	zval **retval;
@@ -887,7 +892,7 @@
 					Z_DELREF_P(new_zval);
 				}
 			} else {
-				retval = zend_fetch_dimension_address_inner(Z_ARRVAL_P(container), dim, type TSRMLS_CC);
+				retval = zend_fetch_dimension_address_inner(Z_ARRVAL_P(container), dim, dim_type, type TSRMLS_CC);
 			}
 			result->var.ptr_ptr = retval;
 			PZVAL_LOCK(*retval);
@@ -963,7 +968,7 @@
 			} else {
 				zval *overloaded_result;
 
-				if (dim_is_tmp_var) {
+				if (dim_type == IS_TMP_VAR) {
 					zval *orig = dim;
 					MAKE_REAL_ZVAL_PTR(dim);
 					ZVAL_NULL(orig);
@@ -992,7 +997,7 @@
 				}
 				AI_SET_PTR(result->var, *retval);
 				PZVAL_LOCK(*retval);
-				if (dim_is_tmp_var) {
+				if (dim_type == IS_TMP_VAR) {
 					zval_ptr_dtor(&dim);
 				}
 			}
@@ -1019,7 +1024,7 @@
 	}
 }
 
-static void zend_fetch_dimension_address_read(temp_variable *result, zval **container_ptr, zval *dim, int dim_is_tmp_var, int type TSRMLS_DC)
+static void zend_fetch_dimension_address_read(temp_variable *result, zval **container_ptr, zval *dim, int dim_type, int type TSRMLS_DC)
 {
 	zval *container = *container_ptr;
 	zval **retval;
@@ -1027,7 +1032,7 @@
 	switch (Z_TYPE_P(container)) {
 
 		case IS_ARRAY:
-			retval = zend_fetch_dimension_address_inner(Z_ARRVAL_P(container), dim, type TSRMLS_CC);
+			retval = zend_fetch_dimension_address_inner(Z_ARRVAL_P(container), dim, dim_type, type TSRMLS_CC);
 			if (result) {
 				AI_SET_PTR(result->var, *retval);
 				PZVAL_LOCK(*retval);
@@ -1085,7 +1090,7 @@
 			} else {
 				zval *overloaded_result;
 
-				if (dim_is_tmp_var) {
+				if (dim_type == IS_TMP_VAR) {
 					zval *orig = dim;
 					MAKE_REAL_ZVAL_PTR(dim);
 					ZVAL_NULL(orig);
@@ -1105,7 +1110,7 @@
 					AI_SET_PTR(result->var, EG(uninitialized_zval_ptr));
 					PZVAL_LOCK(EG(uninitialized_zval_ptr));
 				}
-				if (dim_is_tmp_var) {
+				if (dim_type == IS_TMP_VAR) {
 					zval_ptr_dtor(&dim);
 				}
 			}
@@ -1122,7 +1127,7 @@
 	}
 }
 
-static void zend_fetch_property_address(temp_variable *result, zval **container_ptr, zval *prop_ptr, int type TSRMLS_DC)
+static void zend_fetch_property_address(temp_variable *result, zval **container_ptr, zval *prop_ptr, const zend_literal *key, int type TSRMLS_DC)
 {
 	zval *container = *container_ptr;;
 
@@ -1152,12 +1157,12 @@
 	}
 
 	if (Z_OBJ_HT_P(container)->get_property_ptr_ptr) {
-		zval **ptr_ptr = Z_OBJ_HT_P(container)->get_property_ptr_ptr(container, prop_ptr TSRMLS_CC);
+		zval **ptr_ptr = Z_OBJ_HT_P(container)->get_property_ptr_ptr(container, prop_ptr, key TSRMLS_CC);
 		if (NULL == ptr_ptr) {
 			zval *ptr;
 
 			if (Z_OBJ_HT_P(container)->read_property &&
-				(ptr = Z_OBJ_HT_P(container)->read_property(container, prop_ptr, type TSRMLS_CC)) != NULL) {
+				(ptr = Z_OBJ_HT_P(container)->read_property(container, prop_ptr, type, key TSRMLS_CC)) != NULL) {
 				AI_SET_PTR(result->var, ptr);
 				PZVAL_LOCK(ptr);
 			} else {
@@ -1168,7 +1173,7 @@
 			PZVAL_LOCK(*ptr_ptr);
 		}
 	} else if (Z_OBJ_HT_P(container)->read_property) {
-		zval *ptr = Z_OBJ_HT_P(container)->read_property(container, prop_ptr, type TSRMLS_CC);
+		zval *ptr = Z_OBJ_HT_P(container)->read_property(container, prop_ptr, type, key TSRMLS_CC);
 
 		AI_SET_PTR(result->var, ptr);
 		PZVAL_LOCK(ptr);
@@ -1179,7 +1184,7 @@
 	}
 }
 
-static inline zend_brk_cont_element* zend_brk_cont(const zval *nest_levels_zval, int array_offset, const zend_op_array *op_array, const temp_variable *Ts TSRMLS_DC)
+static inline zend_brk_cont_element* zend_brk_cont(zval *nest_levels_zval, int array_offset, const zend_op_array *op_array, const temp_variable *Ts TSRMLS_DC)
 {
 	zval tmp;
 	int nest_levels, original_nest_levels;
@@ -1204,13 +1209,13 @@
 
 			switch (brk_opline->opcode) {
 				case ZEND_SWITCH_FREE:
-					if (brk_opline->op1.u.EA.type != EXT_TYPE_FREE_ON_RETURN) {
-						zend_switch_free(&T(brk_opline->op1.u.var), brk_opline->extended_value TSRMLS_CC);
+					if (!(brk_opline->extended_value & EXT_TYPE_FREE_ON_RETURN)) {
+						zend_switch_free(&T(brk_opline->op1.var), brk_opline->extended_value TSRMLS_CC);
 					}
 					break;
 				case ZEND_FREE:
-					if (brk_opline->op1.u.EA.type != EXT_TYPE_FREE_ON_RETURN) {
-						zendi_zval_dtor(T(brk_opline->op1.u.var).tmp_var);
+					if (!(brk_opline->extended_value & EXT_TYPE_FREE_ON_RETURN)) {
+						zendi_zval_dtor(T(brk_opline->op1.var).tmp_var);
 					}
 					break;
 			}
@@ -1256,7 +1261,7 @@
 
 ZEND_API void execute_internal(zend_execute_data *execute_data_ptr, int return_value_used TSRMLS_DC)
 {
-	zval **return_value_ptr = &(*(temp_variable *)((char *) execute_data_ptr->Ts + execute_data_ptr->opline->result.u.var)).var.ptr;
+	zval **return_value_ptr = &(*(temp_variable *)((char *) execute_data_ptr->Ts + execute_data_ptr->opline->result.var)).var.ptr;
 	((zend_internal_function *) execute_data_ptr->function_state.function)->handler(execute_data_ptr->opline->extended_value, *return_value_ptr, execute_data_ptr->function_state.function->common.return_reference?return_value_ptr:NULL, execute_data_ptr->object, return_value_used TSRMLS_CC);
 }
 
@@ -1296,12 +1301,12 @@
 	return zend_user_opcode_handlers[opcode];
 }
 
-ZEND_API zval *zend_get_zval_ptr(znode *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC) {
-	return get_zval_ptr(node, Ts, should_free, type);
+ZEND_API zval *zend_get_zval_ptr(int op_type, const znode_op *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC) {
+	return get_zval_ptr(op_type, node, Ts, should_free, type);
 }
 
-ZEND_API zval **zend_get_zval_ptr_ptr(const znode *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC) {
-	return get_zval_ptr_ptr(node, Ts, should_free, type);
+ZEND_API zval **zend_get_zval_ptr_ptr(int op_type, const znode_op *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC) {
+	return get_zval_ptr_ptr(op_type, node, Ts, should_free, type);
 }
 
 /*
Index: Zend/zend_execute.h
===================================================================
--- Zend/zend_execute.h	(revision 297868)
+++ Zend/zend_execute.h	(working copy)
@@ -71,7 +71,7 @@
 	}
 }
 ZEND_API int zend_lookup_class(const char *name, int name_length, zend_class_entry ***ce TSRMLS_DC);
-ZEND_API int zend_lookup_class_ex(const char *name, int name_length, int use_autoload, zend_class_entry ***ce TSRMLS_DC);
+ZEND_API int zend_lookup_class_ex(const char *name, int name_length, const zend_literal *key, int use_autoload, zend_class_entry ***ce TSRMLS_DC);
 ZEND_API int zend_eval_string(char *str, zval *retval_ptr, char *string_name TSRMLS_DC);
 ZEND_API int zend_eval_stringl(char *str, int str_len, zval *retval_ptr, char *string_name TSRMLS_DC);
 ZEND_API int zend_eval_string_ex(char *str, zval *retval_ptr, char *string_name, int handle_exceptions TSRMLS_DC);
@@ -364,6 +364,7 @@
 ZEND_API void zend_unset_timeout(TSRMLS_D);
 ZEND_API void zend_timeout(int dummy);
 ZEND_API zend_class_entry *zend_fetch_class(const char *class_name, uint class_name_len, int fetch_type TSRMLS_DC);
+ZEND_API zend_class_entry *zend_fetch_class_by_name(const char *class_name, uint class_name_len, const zend_literal *key, int fetch_type TSRMLS_DC);
 void zend_verify_abstract_class(zend_class_entry *ce TSRMLS_DC);
 
 #ifdef ZEND_WIN32
@@ -402,8 +403,8 @@
 /*	int   is_var; */
 } zend_free_op;
 
-ZEND_API zval *zend_get_zval_ptr(znode *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC);
-ZEND_API zval **zend_get_zval_ptr_ptr(const znode *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC);
+ZEND_API zval *zend_get_zval_ptr(int op_type, const znode_op *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC);
+ZEND_API zval **zend_get_zval_ptr_ptr(int op_type, const znode_op *node, const temp_variable *Ts, zend_free_op *should_free, int type TSRMLS_DC);
 
 ZEND_API int zend_do_fcall(ZEND_OPCODE_HANDLER_ARGS);
 
Index: Zend/zend_objects_API.c
===================================================================
--- Zend/zend_objects_API.c	(revision 297868)
+++ Zend/zend_objects_API.c	(working copy)
@@ -353,7 +353,7 @@
 	zend_proxy_object *probj = zend_object_store_get_object(*property TSRMLS_CC);
 
 	if (Z_OBJ_HT_P(probj->object) && Z_OBJ_HT_P(probj->object)->write_property) {
-		Z_OBJ_HT_P(probj->object)->write_property(probj->object, probj->property, value TSRMLS_CC);
+		Z_OBJ_HT_P(probj->object)->write_property(probj->object, probj->property, value, 0 TSRMLS_CC);
 	} else {
 		zend_error(E_WARNING, "Cannot write property of object - no write handler defined");
 	}
@@ -364,7 +364,7 @@
 	zend_proxy_object *probj = zend_object_store_get_object(property TSRMLS_CC);
 
 	if (Z_OBJ_HT_P(probj->object) && Z_OBJ_HT_P(probj->object)->read_property) {
-		return Z_OBJ_HT_P(probj->object)->read_property(probj->object, probj->property, BP_VAR_R TSRMLS_CC);
+		return Z_OBJ_HT_P(probj->object)->read_property(probj->object, probj->property, BP_VAR_R, 0 TSRMLS_CC);
 	} else {
 		zend_error(E_WARNING, "Cannot read property of object - no read handler defined");
 	}
Index: Zend/zend_builtin_functions.c
===================================================================
--- Zend/zend_builtin_functions.c	(revision 297868)
+++ Zend/zend_builtin_functions.c	(working copy)
@@ -839,7 +839,7 @@
 		RETURN_FALSE;
 	}
 
-	if (zend_lookup_class_ex(class_name, class_name_len, 0, &ce TSRMLS_CC) == FAILURE) {
+	if (zend_lookup_class_ex(class_name, class_name_len, NULL, 0, &ce TSRMLS_CC) == FAILURE) {
 		retval = 0;
 	} else {
 		if (only_subclass) {
@@ -1102,7 +1102,7 @@
 
 		if (Z_TYPE_P(klass) == IS_OBJECT 
 		&& Z_OBJ_HT_P(klass)->get_method != NULL
-		&& (func = Z_OBJ_HT_P(klass)->get_method(&klass, method_name, method_len TSRMLS_CC)) != NULL
+		&& (func = Z_OBJ_HT_P(klass)->get_method(&klass, method_name, method_len, NULL TSRMLS_CC)) != NULL
 		) {
 			if (func->type == ZEND_INTERNAL_FUNCTION 
 			&& ((zend_internal_function*)func)->handler == zend_std_call_user_call
@@ -1160,7 +1160,7 @@
 
 	if (Z_TYPE_P(object) ==  IS_OBJECT &&
 		Z_OBJ_HANDLER_P(object, has_property) && 
-		Z_OBJ_HANDLER_P(object, has_property)(object, &property_z, 2 TSRMLS_CC)) {
+		Z_OBJ_HANDLER_P(object, has_property)(object, &property_z, 2, 0 TSRMLS_CC)) {
 		RETURN_TRUE;
 	}
 	RETURN_FALSE;
@@ -2021,7 +2021,7 @@
 				function_name = "unknown";
 				build_filename_arg = 0;
 			} else
-			switch (Z_LVAL(ptr->opline->op2.u.constant)) {
+			switch (ptr->opline->extended_value) {
 				case ZEND_EVAL:
 					function_name = "eval";
 					build_filename_arg = 0;
@@ -2204,7 +2204,7 @@
 				function_name = "unknown";
 				build_filename_arg = 0;
 			} else
-			switch (ptr->opline->op2.u.constant.value.lval) {
+			switch (ptr->opline->extended_value) {
 				case ZEND_EVAL:
 					function_name = "eval";
 					build_filename_arg = 0;
Index: Zend/zend_closures.c
===================================================================
--- Zend/zend_closures.c	(revision 297868)
+++ Zend/zend_closures.c	(working copy)
@@ -111,7 +111,7 @@
 }
 /* }}} */
 
-static zend_function *zend_closure_get_method(zval **object_ptr, char *method_name, int method_len TSRMLS_DC) /* {{{ */
+static zend_function *zend_closure_get_method(zval **object_ptr, char *method_name, int method_len, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	char *lc_name;
 	ALLOCA_FLAG(use_heap)
@@ -129,7 +129,7 @@
 }
 /* }}} */
 
-static zval *zend_closure_read_property(zval *object, zval *member, int type TSRMLS_DC) /* {{{ */
+static zval *zend_closure_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	ZEND_CLOSURE_PROPERTY_ERROR();
 	Z_ADDREF(EG(uninitialized_zval));
@@ -137,20 +137,20 @@
 }
 /* }}} */
 
-static void zend_closure_write_property(zval *object, zval *member, zval *value TSRMLS_DC) /* {{{ */
+static void zend_closure_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	ZEND_CLOSURE_PROPERTY_ERROR();
 }
 /* }}} */
 
-static zval **zend_closure_get_property_ptr_ptr(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static zval **zend_closure_get_property_ptr_ptr(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	ZEND_CLOSURE_PROPERTY_ERROR();
 	return NULL;
 }
 /* }}} */
 
-static int zend_closure_has_property(zval *object, zval *member, int has_set_exists TSRMLS_DC) /* {{{ */
+static int zend_closure_has_property(zval *object, zval *member, int has_set_exists, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	if (has_set_exists != 2) {
 		ZEND_CLOSURE_PROPERTY_ERROR();
@@ -159,7 +159,7 @@
 }
 /* }}} */
 
-static void zend_closure_unset_property(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static void zend_closure_unset_property(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	ZEND_CLOSURE_PROPERTY_ERROR();
 }
@@ -245,7 +245,7 @@
 			MAKE_STD_ZVAL(val);
 			array_init(val);
 			zend_hash_copy(Z_ARRVAL_P(val), static_variables, (copy_ctor_func_t)zval_add_ref, NULL, sizeof(zval*));
-			zend_symtable_update(closure->debug_info, "static", sizeof("static"), (void *) &val, sizeof(zval *), NULL);
+			zend_hash_update(closure->debug_info, "static", sizeof("static"), (void *) &val, sizeof(zval *), NULL);
 		}
 
 		if (arg_info) {
@@ -272,7 +272,7 @@
 				efree(name);
 				arg_info++;
 			}
-			zend_symtable_update(closure->debug_info, "parameter", sizeof("parameter"), (void *) &val, sizeof(zval *), NULL);
+			zend_hash_update(closure->debug_info, "parameter", sizeof("parameter"), (void *) &val, sizeof(zval *), NULL);
 		}
 	}
 
Index: Zend/zend_object_handlers.c
===================================================================
--- Zend/zend_object_handlers.c	(revision 297868)
+++ Zend/zend_object_handlers.c	(working copy)
@@ -191,12 +191,11 @@
 }
 /* }}} */
 
-ZEND_API struct _zend_property_info *zend_get_property_info(zend_class_entry *ce, zval *member, int silent TSRMLS_DC) /* {{{ */
+static struct _zend_property_info *zend_get_property_info_quick(zend_class_entry *ce, zval *member, int silent, ulong h TSRMLS_DC) /* {{{ */
 {
 	zend_property_info *property_info = NULL;
 	zend_property_info *scope_property_info;
 	zend_bool denied_access = 0;
-	ulong h;
 
 	if (Z_STRVAL_P(member)[0] == '\0') {
 		if (!silent) {
@@ -208,7 +207,6 @@
 		}
 		return NULL;
 	}
-	h = zend_get_hash_value(Z_STRVAL_P(member), Z_STRLEN_P(member) + 1);
 	if (zend_hash_quick_find(&ce->properties_info, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, h, (void **) &property_info)==SUCCESS) {
 		if(property_info->flags & ZEND_ACC_SHADOW) {
 			/* if it's a shadow - go to access it's private */
@@ -261,6 +259,14 @@
 }
 /* }}} */
 
+ZEND_API struct _zend_property_info *zend_get_property_info(zend_class_entry *ce, zval *member, int silent TSRMLS_DC) /* {{{ */
+{
+	zend_ulong h = zend_get_hash_value(Z_STRVAL_P(member), Z_STRLEN_P(member) + 1);
+
+	return zend_get_property_info_quick(ce, member, silent, h TSRMLS_CC);
+}
+/* }}} */
+
 ZEND_API int zend_check_property_access(zend_object *zobj, char *prop_info_name, int prop_info_name_len TSRMLS_DC) /* {{{ */
 {
 	zend_property_info *property_info;
@@ -311,7 +317,7 @@
 }
 /* }}} */
 
-zval *zend_std_read_property(zval *object, zval *member, int type TSRMLS_DC) /* {{{ */
+zval *zend_std_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	zend_object *zobj;
 	zval *tmp_member = NULL;
@@ -330,6 +336,7 @@
 		zval_copy_ctor(tmp_member);
 		convert_to_string(tmp_member);
 		member = tmp_member;
+		key = NULL;
 	}
 
 #if DEBUG_OBJECT_HANDLERS
@@ -337,7 +344,11 @@
 #endif
 
 	/* make zend_get_property_info silent if we have getter - we may want to use it */
-	property_info = zend_get_property_info(zobj->ce, member, (zobj->ce->__get != NULL) TSRMLS_CC);
+	if (key) {
+		property_info = zend_get_property_info_quick(zobj->ce, member, (zobj->ce->__get != NULL), key->hash_value TSRMLS_CC);
+	} else {
+		property_info = zend_get_property_info(zobj->ce, member, (zobj->ce->__get != NULL) TSRMLS_CC);
+	}
 
 	if (!property_info || zend_hash_quick_find(zobj->properties, property_info->name, property_info->name_length+1, property_info->h, (void **) &retval) == FAILURE) {
 		zend_guard *guard;
@@ -388,7 +399,7 @@
 }
 /* }}} */
 
-static void zend_std_write_property(zval *object, zval *member, zval *value TSRMLS_DC) /* {{{ */
+static void zend_std_write_property(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	zend_object *zobj;
 	zval *tmp_member = NULL;
@@ -404,9 +415,14 @@
 		zval_copy_ctor(tmp_member);
 		convert_to_string(tmp_member);
 		member = tmp_member;
+		key = NULL;
 	}
 
-	property_info = zend_get_property_info(zobj->ce, member, (zobj->ce->__set != NULL) TSRMLS_CC);
+	if (key) {
+		property_info = zend_get_property_info_quick(zobj->ce, member, (zobj->ce->__set != NULL), key->hash_value TSRMLS_CC);
+	} else {
+		property_info = zend_get_property_info(zobj->ce, member, (zobj->ce->__set != NULL) TSRMLS_CC);
+	}
 
 	if (property_info && zend_hash_quick_find(zobj->properties, property_info->name, property_info->name_length+1, property_info->h, (void **) &variable_ptr) == SUCCESS) {
 		/* if we already have this value there, we don't actually need to do anything */
@@ -552,7 +568,7 @@
 }
 /* }}} */
 
-static zval **zend_std_get_property_ptr_ptr(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static zval **zend_std_get_property_ptr_ptr(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	zend_object *zobj;
 	zval tmp_member;
@@ -566,13 +582,18 @@
 		zval_copy_ctor(&tmp_member);
 		convert_to_string(&tmp_member);
 		member = &tmp_member;
+		key = NULL;
 	}
 
 #if DEBUG_OBJECT_HANDLERS
 	fprintf(stderr, "Ptr object #%d property: %s\n", Z_OBJ_HANDLE_P(object), Z_STRVAL_P(member));
 #endif
 
-	property_info = zend_get_property_info(zobj->ce, member, (zobj->ce->__get != NULL) TSRMLS_CC);
+    if (key) {
+		property_info = zend_get_property_info_quick(zobj->ce, member, (zobj->ce->__get != NULL), key->hash_value TSRMLS_CC);
+    } else {
+		property_info = zend_get_property_info(zobj->ce, member, (zobj->ce->__get != NULL) TSRMLS_CC);
+	}
 
 	if (!property_info || zend_hash_quick_find(zobj->properties, property_info->name, property_info->name_length+1, property_info->h, (void **) &retval) == FAILURE) {
 		zval *new_zval;
@@ -599,7 +620,7 @@
 }
 /* }}} */
 
-static void zend_std_unset_property(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static void zend_std_unset_property(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	zend_object *zobj;
 	zval *tmp_member = NULL;
@@ -614,9 +635,14 @@
 		zval_copy_ctor(tmp_member);
 		convert_to_string(tmp_member);
 		member = tmp_member;
+		key = NULL;
 	}
 
-	property_info = zend_get_property_info(zobj->ce, member, (zobj->ce->__unset != NULL) TSRMLS_CC);
+	if (key) {
+		property_info = zend_get_property_info_quick(zobj->ce, member, (zobj->ce->__unset != NULL), key->hash_value TSRMLS_CC);
+	} else {
+		property_info = zend_get_property_info(zobj->ce, member, (zobj->ce->__unset != NULL) TSRMLS_CC);
+	}
 
 	if (!property_info || zend_hash_quick_del(zobj->properties, property_info->name, property_info->name_length+1, property_info->h) == FAILURE) {
 		zend_guard *guard;
@@ -702,7 +728,7 @@
  * Returns the function address that should be called, or NULL
  * if no such function exists.
  */
-static inline zend_function *zend_check_private_int(zend_function *fbc, zend_class_entry *ce, char *function_name_strval, int function_name_strlen TSRMLS_DC) /* {{{ */
+static inline zend_function *zend_check_private_int(zend_function *fbc, zend_class_entry *ce, char *function_name_strval, int function_name_strlen, ulong hash_value TSRMLS_DC) /* {{{ */
 {
 	if (!ce) {
 		return 0;
@@ -724,7 +750,7 @@
 	ce = ce->parent;
 	while (ce) {
 		if (ce == EG(scope)) {
-			if (zend_hash_find(&ce->function_table, function_name_strval, function_name_strlen+1, (void **) &fbc)==SUCCESS
+			if (zend_hash_quick_find(&ce->function_table, function_name_strval, function_name_strlen+1, hash_value, (void **) &fbc)==SUCCESS
 				&& fbc->op_array.fn_flags & ZEND_ACC_PRIVATE
 				&& fbc->common.scope == EG(scope)) {
 				return fbc;
@@ -739,7 +765,7 @@
 
 ZEND_API int zend_check_private(zend_function *fbc, zend_class_entry *ce, char *function_name_strval, int function_name_strlen TSRMLS_DC) /* {{{ */
 {
-	return zend_check_private_int(fbc, ce, function_name_strval, function_name_strlen TSRMLS_CC) != NULL;
+	return zend_check_private_int(fbc, ce, function_name_strval, function_name_strlen, zend_hash_func(function_name_strval, function_name_strlen+1) TSRMLS_CC) != NULL;
 }
 /* }}} */
 
@@ -796,21 +822,29 @@
 }
 /* }}} */
 
-static union _zend_function *zend_std_get_method(zval **object_ptr, char *method_name, int method_len TSRMLS_DC) /* {{{ */
+static union _zend_function *zend_std_get_method(zval **object_ptr, char *method_name, int method_len, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
-	zend_object *zobj;
 	zend_function *fbc;
+	zval *object = *object_ptr;
+	zend_object *zobj = Z_OBJ_P(object);
+	ulong hash_value;
 	char *lc_method_name;
-	zval *object = *object_ptr;
 	ALLOCA_FLAG(use_heap)
 
-	lc_method_name = do_alloca(method_len+1, use_heap);
-	/* Create a zend_copy_str_tolower(dest, src, src_length); */
-	zend_str_tolower_copy(lc_method_name, method_name, method_len);
+	if (key) {
+		lc_method_name = Z_STRVAL(key->constant);
+		hash_value = key->hash_value;
+	} else {
+		lc_method_name = do_alloca(method_len+1, use_heap);
+		/* Create a zend_copy_str_tolower(dest, src, src_length); */
+		zend_str_tolower_copy(lc_method_name, method_name, method_len);
+		hash_value = zend_hash_func(lc_method_name, method_len+1);
+	}
 
-	zobj = Z_OBJ_P(object);
-	if (zend_hash_find(&zobj->ce->function_table, lc_method_name, method_len+1, (void **)&fbc) == FAILURE) {
-		free_alloca(lc_method_name, use_heap);
+	if (zend_hash_quick_find(&zobj->ce->function_table, lc_method_name, method_len+1, hash_value, (void **)&fbc) == FAILURE) {
+		if (!key) {
+			free_alloca(lc_method_name, use_heap);
+		}
 		if (zobj->ce->__call) {
 			return zend_get_user_call_function(zobj->ce, method_name, method_len);
 		} else {
@@ -825,7 +859,7 @@
 		/* Ensure that if we're calling a private function, we're allowed to do so.
 		 * If we're not and __call() handler exists, invoke it, otherwise error out.
 		 */
-		updated_fbc = zend_check_private_int(fbc, Z_OBJ_HANDLER_P(object, get_class_entry)(object TSRMLS_CC), lc_method_name, method_len TSRMLS_CC);
+		updated_fbc = zend_check_private_int(fbc, Z_OBJ_HANDLER_P(object, get_class_entry)(object TSRMLS_CC), lc_method_name, method_len, hash_value TSRMLS_CC);
 		if (updated_fbc) {
 			fbc = updated_fbc;
 		} else {
@@ -844,7 +878,7 @@
 		    fbc->op_array.fn_flags & ZEND_ACC_CHANGED) {
 			zend_function *priv_fbc;
 
-			if (zend_hash_find(&EG(scope)->function_table, lc_method_name, method_len+1, (void **) &priv_fbc)==SUCCESS
+			if (zend_hash_quick_find(&EG(scope)->function_table, lc_method_name, method_len+1, hash_value, (void **) &priv_fbc)==SUCCESS
 				&& priv_fbc->common.fn_flags & ZEND_ACC_PRIVATE
 				&& priv_fbc->common.scope == EG(scope)) {
 				fbc = priv_fbc;
@@ -864,7 +898,9 @@
 		}
 	}
 
-	free_alloca(lc_method_name, use_heap);
+	if (!key) {
+		free_alloca(lc_method_name, use_heap);
+	}
 	return fbc;
 }
 /* }}} */
@@ -933,13 +969,23 @@
 
 /* This is not (yet?) in the API, but it belongs in the built-in objects callbacks */
 
-ZEND_API zend_function *zend_std_get_static_method(zend_class_entry *ce, char *function_name_strval, int function_name_strlen TSRMLS_DC) /* {{{ */
+ZEND_API zend_function *zend_std_get_static_method(zend_class_entry *ce, char *function_name_strval, int function_name_strlen, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	zend_function *fbc = NULL;
 	char *lc_class_name, *lc_function_name = NULL;
+	ulong hash_value;
+	ALLOCA_FLAG(use_heap)
+
+	if (key) {
+		lc_function_name = Z_STRVAL(key->constant);
+		hash_value = key->hash_value;
+	} else {
+		lc_function_name = do_alloca(function_name_strlen+1, use_heap);
+		/* Create a zend_copy_str_tolower(dest, src, src_length); */
+		zend_str_tolower_copy(lc_function_name, function_name_strval, function_name_strlen);
+		hash_value = zend_hash_func(lc_function_name, function_name_strlen+1);
+	}
 	
-	lc_function_name = zend_str_tolower_dup(function_name_strval, function_name_strlen);
-
 	if (function_name_strlen == ce->name_length && ce->constructor) {
 		lc_class_name = zend_str_tolower_dup(ce->name, ce->name_length);
 		/* Only change the method to the constructor if the constructor isn't called __construct
@@ -950,8 +996,10 @@
 		}
 		efree(lc_class_name);
 	}
-	if (!fbc && zend_hash_find(&ce->function_table, lc_function_name, function_name_strlen+1, (void **) &fbc)==FAILURE) {
-		efree(lc_function_name);
+	if (!fbc && zend_hash_quick_find(&ce->function_table, lc_function_name, function_name_strlen+1, hash_value, (void **) &fbc)==FAILURE) {
+		if (!key) {
+			free_alloca(lc_function_name, use_heap);
+		}
 
 		if (ce->__callstatic) {
 			return zend_get_user_callstatic_function(ce, function_name_strval, function_name_strlen);
@@ -964,7 +1012,6 @@
 	   		return NULL;
 		}
 	}
-	efree(lc_function_name);
 
 #if MBO_0
 	/* right now this function is used for non static method lookup too */
@@ -980,42 +1027,55 @@
 
 		/* Ensure that if we're calling a private function, we're allowed to do so.
 		 */
-		updated_fbc = zend_check_private_int(fbc, EG(scope), function_name_strval, function_name_strlen TSRMLS_CC);
+		updated_fbc = zend_check_private_int(fbc, EG(scope), lc_function_name, function_name_strlen, hash_value TSRMLS_CC);
 		if (updated_fbc) {
 			fbc = updated_fbc;
 		} else {
 			if (ce->__callstatic) {
-				return zend_get_user_callstatic_function(ce, function_name_strval, function_name_strlen);
+				fbc = zend_get_user_callstatic_function(ce, function_name_strval, function_name_strlen);
+			} else {
+				zend_error(E_ERROR, "Call to %s method %s::%s() from context '%s'", zend_visibility_string(fbc->common.fn_flags), ZEND_FN_SCOPE_NAME(fbc), function_name_strval, EG(scope) ? EG(scope)->name : "");
 			}
-			zend_error(E_ERROR, "Call to %s method %s::%s() from context '%s'", zend_visibility_string(fbc->common.fn_flags), ZEND_FN_SCOPE_NAME(fbc), function_name_strval, EG(scope) ? EG(scope)->name : "");
 		}
 	} else if ((fbc->common.fn_flags & ZEND_ACC_PROTECTED)) {
 		/* Ensure that if we're calling a protected function, we're allowed to do so.
 		 */
 		if (!zend_check_protected(zend_get_function_root_class(fbc), EG(scope))) {
 			if (ce->__callstatic) {
-				return zend_get_user_callstatic_function(ce, function_name_strval, function_name_strlen);
+				fbc = zend_get_user_callstatic_function(ce, function_name_strval, function_name_strlen);
+			} else {
+				zend_error(E_ERROR, "Call to %s method %s::%s() from context '%s'", zend_visibility_string(fbc->common.fn_flags), ZEND_FN_SCOPE_NAME(fbc), function_name_strval, EG(scope) ? EG(scope)->name : "");
 			}
-			zend_error(E_ERROR, "Call to %s method %s::%s() from context '%s'", zend_visibility_string(fbc->common.fn_flags), ZEND_FN_SCOPE_NAME(fbc), function_name_strval, EG(scope) ? EG(scope)->name : "");
 		}
 	}
 
+	if (!key) {
+		free_alloca(lc_function_name, use_heap);
+	}
+
 	return fbc;
 }
 /* }}} */
 
-ZEND_API zval **zend_std_get_static_property(zend_class_entry *ce, char *property_name, int property_name_len, zend_bool silent TSRMLS_DC) /* {{{ */
+ZEND_API zval **zend_std_get_static_property(zend_class_entry *ce, char *property_name, int property_name_len, zend_bool silent, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	zval **retval = NULL;
 	zend_class_entry *tmp_ce = ce;
 	zend_property_info *property_info;
 	zend_property_info std_property_info;
+	ulong hash_value;
+	
+	if (key) {
+		hash_value = key->hash_value;
+	} else {
+		hash_value = zend_hash_func(property_name, property_name_len+1);
+	}
 
-	if (zend_hash_find(&ce->properties_info, property_name, property_name_len+1, (void **) &property_info)==FAILURE) {
+	if (zend_hash_quick_find(&ce->properties_info, property_name, property_name_len+1, hash_value, (void **) &property_info)==FAILURE) {
 		std_property_info.flags = ZEND_ACC_PUBLIC;
 		std_property_info.name = property_name;
 		std_property_info.name_length = property_name_len;
-		std_property_info.h = zend_get_hash_value(std_property_info.name, std_property_info.name_length+1);
+		std_property_info.h = hash_value;
 		std_property_info.ce = ce;
 		property_info = &std_property_info;
 	}
@@ -1047,7 +1107,7 @@
 }
 /* }}} */
 
-ZEND_API zend_bool zend_std_unset_static_property(zend_class_entry *ce, char *property_name, int property_name_len TSRMLS_DC) /* {{{ */
+ZEND_API zend_bool zend_std_unset_static_property(zend_class_entry *ce, char *property_name, int property_name_len, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	zend_error(E_ERROR, "Attempt to unset static property %s::$%s", ce->name, property_name);
 	return 0;
@@ -1107,7 +1167,7 @@
 }
 /* }}} */
 
-static int zend_std_has_property(zval *object, zval *member, int has_set_exists TSRMLS_DC) /* {{{ */
+static int zend_std_has_property(zval *object, zval *member, int has_set_exists, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	zend_object *zobj;
 	int result;
@@ -1124,13 +1184,18 @@
 		zval_copy_ctor(tmp_member);
 		convert_to_string(tmp_member);
 		member = tmp_member;
+		key = NULL;
 	}
 
 #if DEBUG_OBJECT_HANDLERS
 	fprintf(stderr, "Read object #%d property: %s\n", Z_OBJ_HANDLE_P(object), Z_STRVAL_P(member));
 #endif
 
-	property_info = zend_get_property_info(zobj->ce, member, 1 TSRMLS_CC);
+    if (key) {
+		property_info = zend_get_property_info_quick(zobj->ce, member, 1, key->hash_value TSRMLS_CC);
+    } else {
+		property_info = zend_get_property_info(zobj->ce, member, 1 TSRMLS_CC);
+	}
 
 	if (!property_info || zend_hash_quick_find(zobj->properties, property_info->name, property_info->name_length+1, property_info->h, (void **) &value) == FAILURE) {
 		zend_guard *guard;
Index: Zend/zend_compile.c
===================================================================
--- Zend/zend_compile.c	(revision 297868)
+++ Zend/zend_compile.c	(working copy)
@@ -32,6 +32,37 @@
 #include "zend_multibyte.h"
 #endif /* ZEND_MULTIBYTE */
 
+#define CONSTANT_EX(op_array, op) \
+	(op_array)->literals[op].constant
+
+#define CONSTANT(op) \
+	CONSTANT_EX(CG(active_op_array), op)
+
+#define SET_NODE(target, src) do { \
+		target ## _type = (src)->op_type; \
+		if ((src)->op_type == IS_CONST) { \
+			target.constant = zend_add_literal(CG(active_op_array), &(src)->u.constant); \
+		} else { \
+			target = (src)->u.op; \
+		} \
+	} while (0)
+
+#define GET_NODE(target, src) do { \
+		(target)->op_type = src ## _type; \
+		if ((target)->op_type == IS_CONST) { \
+			(target)->u.constant = CONSTANT(src.constant); \
+		} else { \
+			(target)->u.op = src; \
+			(target)->EA = 0; \
+		} \
+	} while (0)
+
+#define COPY_NODE(target, src) do { \
+		target ## _type = src ## _type; \
+		target = src; \
+	} while (0)
+
+
 ZEND_API zend_op_array *(*zend_compile_file)(zend_file_handle *file_handle, int type TSRMLS_DC);
 ZEND_API zend_op_array *(*zend_compile_string)(zval *source_string, char *filename TSRMLS_DC);
 
@@ -288,17 +319,66 @@
 }
 /* }}} */
 
+void zend_del_literal(zend_op_array *op_array, int n) /* {{{ */
+{
+	zval_dtor(&CONSTANT_EX(op_array, n));
+	if (n + 1 == op_array->last_literal) {
+		op_array->last_literal--;
+	} else {
+		Z_TYPE(CONSTANT_EX(op_array, n)) = IS_NULL;
+	}
+}
+/* }}} */
 
+int zend_add_literal(zend_op_array *op_array, const zval *zv) /* {{{ */
+{
+	int i = op_array->last_literal;
+	op_array->last_literal++;
+	if (i >= op_array->size_literal) {
+		op_array->size_literal += 16; /* FIXME */
+		op_array->literals = (zend_literal*)erealloc(op_array->literals, op_array->size_literal * sizeof(zend_literal));
+	}
+	CONSTANT_EX(op_array, i) = *zv;
+	Z_SET_REFCOUNT(CONSTANT_EX(op_array, i), 2);
+	Z_SET_ISREF(CONSTANT_EX(op_array, i));
+	return i;
+}
+/* }}} */
+
+#define LITERAL_STRINGL(op, str, len, copy) do { \
+		zval _c; \
+		ZVAL_STRINGL(&_c, str, len, copy); \
+		op.constant = zend_add_literal(CG(active_op_array), &_c); \
+	} while (0)
+
+#define LITERAL_LONG(op, val) do { \
+		zval _c; \
+		ZVAL_LONG(&_c, val); \
+		op.constant = zend_add_literal(CG(active_op_array), &_c); \
+	} while (0)
+
+#define LITERAL_LONG_EX(op_array, op, val) do { \
+		zval _c; \
+		ZVAL_LONG(&_c, val); \
+		op.constant = zend_add_literal(op_array, &_c); \
+	} while (0)
+
+#define LITERAL_NULL(op) do { \
+		zval _c; \
+		INIT_ZVAL(	_c); \
+		op.constant = zend_add_literal(CG(active_op_array), &_c); \
+	} while (0)
+ 
 void zend_do_binary_op(zend_uchar op, znode *result, const znode *op1, const znode *op2 TSRMLS_DC) /* {{{ */
 {
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = op;
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *op1;
-	opline->op2 = *op2;
-	*result = opline->result;
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, op1);
+	SET_NODE(opline->op2, op2);
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -307,21 +387,21 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = op;
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *op1;
-	*result = opline->result;
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, op1);
+	GET_NODE(result, opline->result);
 	SET_UNUSED(opline->op2);
 }
 /* }}} */
 
-#define MAKE_NOP(opline)	{ opline->opcode = ZEND_NOP;  memset(&opline->result,0,sizeof(znode)); memset(&opline->op1,0,sizeof(znode)); memset(&opline->op2,0,sizeof(znode)); opline->result.op_type=opline->op1.op_type=opline->op2.op_type=IS_UNUSED;  }
+#define MAKE_NOP(opline)	{ opline->opcode = ZEND_NOP;  memset(&opline->result,0,sizeof(opline->result)); memset(&opline->op1,0,sizeof(opline->op1)); memset(&opline->op2,0,sizeof(opline->op2)); opline->result_type=opline->op1_type=opline->op2_type=IS_UNUSED;  }
 
 
 static void zend_do_op_data(zend_op *data_op, const znode *value TSRMLS_DC) /* {{{ */
 {
 	data_op->opcode = ZEND_OP_DATA;
-	data_op->op1 = *value;
+	SET_NODE(data_op->op1, value);
 	SET_UNUSED(data_op->op2);
 }
 /* }}} */
@@ -341,18 +421,17 @@
 
 				zend_do_op_data(opline, op2 TSRMLS_CC);
 				SET_UNUSED(opline->result);
-				*result = last_op->result;
+				GET_NODE(result, last_op->result);
 				return;
 			case ZEND_FETCH_DIM_RW:
 				last_op->opcode = op;
 				last_op->extended_value = ZEND_ASSIGN_DIM;
 
 				zend_do_op_data(opline, op2 TSRMLS_CC);
-				opline->op2.u.var = get_temporary_variable(CG(active_op_array));
-				opline->op2.u.EA.type = 0;
-				opline->op2.op_type = IS_VAR;
+				opline->op2.var = get_temporary_variable(CG(active_op_array));
+				opline->op2_type = IS_VAR;
 				SET_UNUSED(opline->result);
-				*result = last_op->result;
+				GET_NODE(result,last_op->result);
 				return;
 			default:
 				break;
@@ -360,12 +439,11 @@
 	}
 
 	opline->opcode = op;
-	opline->op1 = *op1;
-	opline->op2 = *op2;
-	opline->result.op_type = IS_VAR;
-	opline->result.u.EA.type = 0;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	*result = opline->result;
+	SET_NODE(opline->op1, op1);
+	SET_NODE(opline->op2, op2);
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -385,8 +463,8 @@
 		    (CG(active_op_array)->last == 0 ||
 		     CG(active_op_array)->opcodes[CG(active_op_array)->last-1].opcode != ZEND_BEGIN_SILENCE)) {
 			result->op_type = IS_CV;
-			result->u.var = lookup_cv(CG(active_op_array), varname->u.constant.value.str.val, varname->u.constant.value.str.len);
-			result->u.EA.type = 0;
+			result->u.op.var = lookup_cv(CG(active_op_array), varname->u.constant.value.str.val, varname->u.constant.value.str.len);
+			result->EA = 0;
 			return;
 		}
 	}
@@ -399,17 +478,17 @@
 	}
 
 	opline_ptr->opcode = op;
-	opline_ptr->result.op_type = IS_VAR;
-	opline_ptr->result.u.EA.type = 0;
-	opline_ptr->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline_ptr->op1 = *varname;
-	*result = opline_ptr->result;
+	opline_ptr->result_type = IS_VAR;
+	opline_ptr->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline_ptr->op1, varname);
+	GET_NODE(result, opline_ptr->result);
 	SET_UNUSED(opline_ptr->op2);
+	opline_ptr->extended_value = ZEND_FETCH_LOCAL;
 
-	opline_ptr->op2.u.EA.type = ZEND_FETCH_LOCAL;
-	if (varname->op_type == IS_CONST && varname->u.constant.type == IS_STRING) {
+	if (varname->op_type == IS_CONST) {
+		Z_HASH_P(&CONSTANT(opline_ptr->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline_ptr->op1.constant)), Z_STRLEN(CONSTANT(opline_ptr->op1.constant))+1);
 		if (zend_is_auto_global(varname->u.constant.value.str.val, varname->u.constant.value.str.len TSRMLS_CC)) {
-			opline_ptr->op2.u.EA.type = ZEND_FETCH_GLOBAL;
+			opline_ptr->extended_value = ZEND_FETCH_GLOBAL;
 		}
 	}
 
@@ -441,42 +520,39 @@
 		init_op(&opline TSRMLS_CC);
 
 		opline.opcode = ZEND_FETCH_W;
-		opline.result.op_type = IS_VAR;
-		opline.result.u.EA.type = 0;
-		opline.result.u.var = get_temporary_variable(CG(active_op_array));
-		opline.op1.op_type = IS_CONST;
-		opline.op1.u.constant.type = IS_STRING;
-		opline.op1.u.constant.value.str.val = estrdup(CG(active_op_array)->vars[result->u.var].name);
-		opline.op1.u.constant.value.str.len = CG(active_op_array)->vars[result->u.var].name_len;
+		opline.result_type = IS_VAR;
+		opline.result.var = get_temporary_variable(CG(active_op_array));
+		opline.op1_type = IS_CONST;
+		LITERAL_STRINGL(opline.op1, estrdup(CG(active_op_array)->vars[result->u.op.var].name), CG(active_op_array)->vars[result->u.op.var].name_len, 0);
+		Z_HASH_P(&CONSTANT(opline.op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline.op1.constant)), Z_STRLEN(CONSTANT(opline.op1.constant))+1);
 		SET_UNUSED(opline.op2);
-		opline.op2 = class_node;
-		opline.op2.u.EA.type = ZEND_FETCH_STATIC_MEMBER;
-		*result = opline.result;
+		SET_NODE(opline.op2, &class_node);
+		GET_NODE(result,opline.result);
+		opline.extended_value |= ZEND_FETCH_STATIC_MEMBER;
+		opline_ptr = &opline;
 
 		zend_llist_add_element(fetch_list_ptr, &opline);
 	} else {
 		le = fetch_list_ptr->head;
 
 		opline_ptr = (zend_op *)le->data;
-		if (opline_ptr->opcode != ZEND_FETCH_W && opline_ptr->op1.op_type == IS_CV) {
+		if (opline_ptr->opcode != ZEND_FETCH_W && opline_ptr->op1_type == IS_CV) {
 			init_op(&opline TSRMLS_CC);
 			opline.opcode = ZEND_FETCH_W;
-			opline.result.op_type = IS_VAR;
-			opline.result.u.EA.type = 0;
-			opline.result.u.var = get_temporary_variable(CG(active_op_array));
-			opline.op1.op_type = IS_CONST;
-			opline.op1.u.constant.type = IS_STRING;
-			opline.op1.u.constant.value.str.val = estrdup(CG(active_op_array)->vars[opline_ptr->op1.u.var].name);
-			opline.op1.u.constant.value.str.len = CG(active_op_array)->vars[opline_ptr->op1.u.var].name_len;
+			opline.result_type = IS_VAR;
+			opline.result.var = get_temporary_variable(CG(active_op_array));
+			opline.op1_type = IS_CONST;
+			LITERAL_STRINGL(opline.op1, estrdup(CG(active_op_array)->vars[opline_ptr->op1.var].name), CG(active_op_array)->vars[opline_ptr->op1.var].name_len, 0);
+			Z_HASH_P(&CONSTANT(opline.op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline.op1.constant)), Z_STRLEN(CONSTANT(opline.op1.constant))+1);
 			SET_UNUSED(opline.op2);
-			opline.op2 = class_node;
-			opline.op2.u.EA.type = ZEND_FETCH_STATIC_MEMBER;
-			opline_ptr->op1 = opline.result;
+			SET_NODE(opline.op2, &class_node);
+			opline.extended_value |= ZEND_FETCH_STATIC_MEMBER;
+			COPY_NODE(opline_ptr->op1, opline.result);
 
 			zend_llist_prepend_element(fetch_list_ptr, &opline);
 		} else {
-			opline_ptr->op2 = class_node;
-			opline_ptr->op2.u.EA.type = ZEND_FETCH_STATIC_MEMBER;
+			SET_NODE(opline_ptr->op2, &class_node);
+			opline_ptr->extended_value |= ZEND_FETCH_STATIC_MEMBER;
 		}
 	}
 }
@@ -497,14 +573,25 @@
 
 	init_op(&opline TSRMLS_CC);
 	opline.opcode = ZEND_FETCH_DIM_W;	/* the backpatching routine assumes W */
-	opline.result.op_type = IS_VAR;
-	opline.result.u.EA.type = 0;
-	opline.result.u.var = get_temporary_variable(CG(active_op_array));
-	opline.op1 = *parent;
-	opline.op2 = *dim;
-	opline.extended_value = ZEND_FETCH_STANDARD;
-	*result = opline.result;
+	opline.result_type = IS_VAR;
+	opline.result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline.op1, parent);
+	SET_NODE(opline.op2, dim);
+	if (opline.op2_type == IS_CONST && Z_TYPE(CONSTANT(opline.op2.constant)) == IS_STRING) {
+		long index;
+		int numeric = 0;
 
+		ZEND_HANDLE_NUMERIC_EX(Z_STRVAL(CONSTANT(opline.op2.constant)), Z_STRLEN(CONSTANT(opline.op2.constant))+1, index, numeric = 1);
+		if (numeric) {
+			zval_dtor(&CONSTANT(opline.op2.constant));
+			ZVAL_LONG(&CONSTANT(opline.op2.constant), index); 
+		} else {
+			Z_HASH_P(&CONSTANT(opline.op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline.op2.constant)), Z_STRLEN(CONSTANT(opline.op2.constant))+1);
+		}
+	}
+	
+	GET_NODE(result, opline.result);
+
 	zend_stack_top(&CG(bp_stack), (void **) &fetch_list_ptr);
 	zend_llist_add_element(fetch_list_ptr, &opline);
 }
@@ -520,12 +607,12 @@
 {
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
 	opline->opcode = ZEND_PRINT;
-	opline->op1 = *arg;
+	SET_NODE(opline->op1, arg);
 	SET_UNUSED(opline->op2);
-	*result = opline->result;
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -534,7 +621,7 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_ECHO;
-	opline->op1 = *arg;
+	SET_NODE(opline->op1, arg);
 	SET_UNUSED(opline->op2);
 }
 /* }}} */
@@ -574,10 +661,10 @@
 
 static zend_bool opline_is_fetch_this(const zend_op *opline TSRMLS_DC) /* {{{ */
 {
-	if ((opline->opcode == ZEND_FETCH_W) && (opline->op1.op_type == IS_CONST)
-		&& (opline->op1.u.constant.type == IS_STRING)
-		&& (opline->op1.u.constant.value.str.len == (sizeof("this")-1))
-		&& !memcmp(opline->op1.u.constant.value.str.val, "this", sizeof("this"))) {
+	if ((opline->opcode == ZEND_FETCH_W) && (opline->op1_type == IS_CONST)
+		&& (Z_TYPE(CONSTANT(opline->op1.constant)) == IS_STRING)
+		&& (Z_STRLEN(CONSTANT(opline->op1.constant)) == (sizeof("this")-1))
+		&& !memcmp(Z_STRVAL(CONSTANT(opline->op1.constant)), "this", sizeof("this"))) {
 		return 1;
 	} else {
 		return 0;
@@ -585,7 +672,7 @@
 }
 /* }}} */
 
-void zend_do_assign(znode *result, znode *variable, const znode *value TSRMLS_DC) /* {{{ */
+void zend_do_assign(znode *result, znode *variable, znode *value TSRMLS_DC) /* {{{ */
 {
 	int last_op_number;
 	zend_op *opline;
@@ -598,21 +685,21 @@
 			opline = (zend_op *)fetch_list_ptr->head->data;
 
 			if (opline->opcode == ZEND_FETCH_DIM_W &&
-			    opline->op1.op_type == IS_CV &&
-			    opline->op1.u.var == value->u.var) {
+			    opline->op1_type == IS_CV &&
+			    opline->op1.var == value->u.op.var) {
 
 				opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 				opline->opcode = ZEND_FETCH_R;
-				opline->result.op_type = IS_VAR;
-				opline->result.u.EA.type = 0;
-				opline->result.u.var = get_temporary_variable(CG(active_op_array));
-				opline->op1.op_type = IS_CONST;
-				ZVAL_STRINGL(&opline->op1.u.constant,
-					CG(active_op_array)->vars[value->u.var].name, 
-					CG(active_op_array)->vars[value->u.var].name_len, 1);
+				opline->result_type = IS_VAR;
+				opline->result.var = get_temporary_variable(CG(active_op_array));
+				opline->op1_type = IS_CONST;
+				LITERAL_STRINGL(opline->op1,
+					CG(active_op_array)->vars[value->u.op.var].name, 
+					CG(active_op_array)->vars[value->u.op.var].name_len, 1);
+				Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant))+1);
 				SET_UNUSED(opline->op2);
-				opline->op2.u.EA.type = ZEND_FETCH_LOCAL;
-				value = &opline->result;
+				opline->extended_value = ZEND_FETCH_LOCAL;
+				GET_NODE(value, opline->result);
 			}
 		}
 	}
@@ -623,7 +710,7 @@
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	if (variable->op_type == IS_CV) {
-		if (variable->u.var == CG(active_op_array)->this_var) {
+		if (variable->u.op.var == CG(active_op_array)->this_var) {
 			zend_error(E_COMPILE_ERROR, "Cannot re-assign $this");
 	    }
 	} else if (variable->op_type == IS_VAR) {
@@ -634,8 +721,8 @@
 
 			last_op = &CG(active_op_array)->opcodes[last_op_number-n-1];
 
-			if (last_op->result.op_type == IS_VAR &&
-			    last_op->result.u.var == variable->u.var) {
+			if (last_op->result_type == IS_VAR &&
+			    last_op->result.var == variable->u.op.var) {
 				if (last_op->opcode == ZEND_FETCH_OBJ_W) {
 					if (n > 0) {
 						int opline_no = (opline-CG(active_op_array)->opcodes)/sizeof(*opline);
@@ -649,7 +736,7 @@
 					last_op->opcode = ZEND_ASSIGN_OBJ;
 					zend_do_op_data(opline, value TSRMLS_CC);
 					SET_UNUSED(opline->result);
-					*result = last_op->result;
+					GET_NODE(result, last_op->result);
 					return;
 				} else if (last_op->opcode == ZEND_FETCH_DIM_W) {
 					if (n > 0) {
@@ -664,11 +751,10 @@
 					}
 					last_op->opcode = ZEND_ASSIGN_DIM;
 					zend_do_op_data(opline, value TSRMLS_CC);
-					opline->op2.u.var = get_temporary_variable(CG(active_op_array));
-					opline->op2.u.EA.type = 0;
-					opline->op2.op_type = IS_VAR;
+					opline->op2.var = get_temporary_variable(CG(active_op_array));
+					opline->op2_type = IS_VAR;
 					SET_UNUSED(opline->result);
-					*result = last_op->result;
+					GET_NODE(result, last_op->result);
 					return;
 				} else if (opline_is_fetch_this(last_op TSRMLS_CC)) {
 					zend_error(E_COMPILE_ERROR, "Cannot re-assign $this");
@@ -681,18 +767,17 @@
 	}
 
 	opline->opcode = ZEND_ASSIGN;
-	opline->op1 = *variable;
-	opline->op2 = *value;
-	opline->result.op_type = IS_VAR;
-	opline->result.u.EA.type = 0;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	*result = opline->result;
+	SET_NODE(opline->op1, variable);
+	SET_NODE(opline->op2, value);
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
 static inline zend_bool zend_is_function_or_method_call(const znode *variable) /* {{{ */
 {
-	zend_uint type = variable->u.EA.type;
+	zend_uint type = variable->EA;
 
 	return  ((type & ZEND_PARSED_METHOD_CALL) || (type == ZEND_PARSED_FUNCTION_CALL));
 }
@@ -703,7 +788,7 @@
 	zend_op *opline;
 
 	if (lvar->op_type == IS_CV) {
-		if (lvar->u.var == CG(active_op_array)->this_var) {
+		if (lvar->u.op.var == CG(active_op_array)->this_var) {
  			zend_error(E_COMPILE_ERROR, "Cannot re-assign $this");
 	    }
 	} else if (lvar->op_type == IS_VAR) {
@@ -721,22 +806,20 @@
 	opline->opcode = ZEND_ASSIGN_REF;
 	if (zend_is_function_or_method_call(rvar)) {
 		opline->extended_value = ZEND_RETURNS_FUNCTION;
-	} else if (rvar->u.EA.type & ZEND_PARSED_NEW) {
+	} else if (rvar->EA & ZEND_PARSED_NEW) {
 		opline->extended_value = ZEND_RETURNS_NEW;
 	} else {
 		opline->extended_value = 0;
 	}
 	if (result) {
-		opline->result.op_type = IS_VAR;
-		opline->result.u.EA.type = 0;
-		opline->result.u.var = get_temporary_variable(CG(active_op_array));
-		*result = opline->result;
+		opline->result_type = IS_VAR;
+		opline->result.var = get_temporary_variable(CG(active_op_array));
+		GET_NODE(result, opline->result);
 	} else {
-		/* SET_UNUSED(opline->result); */
-		opline->result.u.EA.type |= EXT_TYPE_UNUSED;
+		opline->result_type = IS_UNUSED | EXT_TYPE_UNUSED;
 	}
-	opline->op1 = *lvar;
-	opline->op2 = *rvar;
+	SET_NODE(opline->op1, lvar);
+	SET_NODE(opline->op2, rvar);
 }
 /* }}} */
 
@@ -773,8 +856,8 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMPZ;
-	opline->op1 = *expr;
-	close_bracket_token->u.opline_num = while_cond_op_number;
+	SET_NODE(opline->op1, expr);
+	close_bracket_token->u.op.opline_num = while_cond_op_number;
 	SET_UNUSED(opline->op2);
 
 	do_begin_loop(TSRMLS_C);
@@ -788,14 +871,14 @@
 
 	/* add unconditional jump */
 	opline->opcode = ZEND_JMP;
-	opline->op1.u.opline_num = while_token->u.opline_num;
+	opline->op1.opline_num = while_token->u.op.opline_num;
 	SET_UNUSED(opline->op1);
 	SET_UNUSED(opline->op2);
 
 	/* update while's conditional jmp */
-	CG(active_op_array)->opcodes[close_bracket_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array));
+	CG(active_op_array)->opcodes[close_bracket_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array));
 
-	do_end_loop(while_token->u.opline_num, 0 TSRMLS_CC);
+	do_end_loop(while_token->u.op.opline_num, 0 TSRMLS_CC);
 
 	DEC_BPC(CG(active_op_array));
 }
@@ -807,8 +890,8 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMPZNZ;
-	opline->op1 = *expr;  /* the conditional expression */
-	second_semicolon_token->u.opline_num = for_cond_op_number;
+	SET_NODE(opline->op1, expr);  /* the conditional expression */
+	second_semicolon_token->u.op.opline_num = for_cond_op_number;
 	SET_UNUSED(opline->op2);
 }
 /* }}} */
@@ -818,8 +901,8 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMP;
-	opline->op1.u.opline_num = cond_start->u.opline_num;
-	CG(active_op_array)->opcodes[second_semicolon_token->u.opline_num].extended_value = get_next_op_number(CG(active_op_array));
+	opline->op1.opline_num = cond_start->u.op.opline_num;
+	CG(active_op_array)->opcodes[second_semicolon_token->u.op.opline_num].extended_value = get_next_op_number(CG(active_op_array));
 	SET_UNUSED(opline->op1);
 	SET_UNUSED(opline->op2);
 
@@ -834,12 +917,12 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMP;
-	opline->op1.u.opline_num = second_semicolon_token->u.opline_num+1;
-	CG(active_op_array)->opcodes[second_semicolon_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array));
+	opline->op1.opline_num = second_semicolon_token->u.op.opline_num+1;
+	CG(active_op_array)->opcodes[second_semicolon_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array));
 	SET_UNUSED(opline->op1);
 	SET_UNUSED(opline->op2);
 
-	do_end_loop(second_semicolon_token->u.opline_num+1, 0 TSRMLS_CC);
+	do_end_loop(second_semicolon_token->u.op.opline_num+1, 0 TSRMLS_CC);
 
 	DEC_BPC(CG(active_op_array));
 }
@@ -855,22 +938,20 @@
 
 		if (last_op->opcode == ZEND_FETCH_OBJ_RW) {
 			last_op->opcode = (op==ZEND_PRE_INC)?ZEND_PRE_INC_OBJ:ZEND_PRE_DEC_OBJ;
-			last_op->result.op_type = IS_VAR;
-			last_op->result.u.EA.type = 0;
-			last_op->result.u.var = get_temporary_variable(CG(active_op_array));
-			*result = last_op->result;
+			last_op->result_type = IS_VAR;
+			last_op->result.var = get_temporary_variable(CG(active_op_array));
+			GET_NODE(result, last_op->result);
 			return;
 		}
 	}
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = op;
-	opline->op1 = *op1;
+	SET_NODE(opline->op1, op1);
 	SET_UNUSED(opline->op2);
-	opline->result.op_type = IS_VAR;
-	opline->result.u.EA.type = 0;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	*result = opline->result;
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -879,25 +960,25 @@
 	int last_op_number = get_next_op_number(CG(active_op_array));
 	zend_op *opline;
 
-	if (last_op_number > 0) {
+	if (last_op_number > 0) {       	
 		zend_op *last_op = &CG(active_op_array)->opcodes[last_op_number-1];
 
 		if (last_op->opcode == ZEND_FETCH_OBJ_RW) {
 			last_op->opcode = (op==ZEND_POST_INC)?ZEND_POST_INC_OBJ:ZEND_POST_DEC_OBJ;
-			last_op->result.op_type = IS_TMP_VAR;
-			last_op->result.u.var = get_temporary_variable(CG(active_op_array));
-			*result = last_op->result;
+			last_op->result_type = IS_TMP_VAR;
+			last_op->result.var = get_temporary_variable(CG(active_op_array));
+			GET_NODE(result, last_op->result);
 			return;
 		}
 	}
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = op;
-	opline->op1 = *op1;
+	SET_NODE(opline->op1, op1);
 	SET_UNUSED(opline->op2);
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	*result = opline->result;
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -907,8 +988,8 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMPZ;
-	opline->op1 = *cond;
-	closing_bracket_token->u.opline_num = if_cond_op_number;
+	SET_NODE(opline->op1, cond);
+	closing_bracket_token->u.op.opline_num = if_cond_op_number;
 	SET_UNUSED(opline->op2);
 	INC_BPC(CG(active_op_array));
 }
@@ -931,7 +1012,7 @@
 	zend_stack_top(&CG(bp_stack), (void **) &jmp_list_ptr);
 	zend_llist_add_element(jmp_list_ptr, &if_end_op_number);
 
-	CG(active_op_array)->opcodes[closing_bracket_token->u.opline_num].op2.u.opline_num = if_end_op_number+1;
+	CG(active_op_array)->opcodes[closing_bracket_token->u.op.opline_num].op2.opline_num = if_end_op_number+1;
 	SET_UNUSED(opline->op1);
 	SET_UNUSED(opline->op2);
 }
@@ -945,7 +1026,7 @@
 
 	zend_stack_top(&CG(bp_stack), (void **) &jmp_list_ptr);
 	for (le=jmp_list_ptr->head; le; le = le->next) {
-		CG(active_op_array)->opcodes[*((int *) le->data)].op1.u.opline_num = next_op_number;
+		CG(active_op_array)->opcodes[*((int *) le->data)].op1.opline_num = next_op_number;
 	}
 	zend_llist_destroy(jmp_list_ptr);
 	zend_stack_del_top(&CG(bp_stack));
@@ -955,7 +1036,7 @@
 
 void zend_check_writable_variable(const znode *variable) /* {{{ */
 {
-	zend_uint type = variable->u.EA.type;
+	zend_uint type = variable->EA;
 
 	if (type & ZEND_PARSED_METHOD_CALL) {
 		zend_error(E_COMPILE_ERROR, "Can't use method return value in write context");
@@ -996,17 +1077,18 @@
 			if (CG(active_op_array)->last == 0 ||
 			    CG(active_op_array)->opcodes[CG(active_op_array)->last-1].opcode != ZEND_BEGIN_SILENCE) {
 
-				this_var = opline_ptr->result.u.var;
+				this_var = opline_ptr->result.var;
 				if (CG(active_op_array)->this_var == -1) {
-					CG(active_op_array)->this_var = lookup_cv(CG(active_op_array), Z_STRVAL(opline_ptr->op1.u.constant), Z_STRLEN(opline_ptr->op1.u.constant));
+					CG(active_op_array)->this_var = lookup_cv(CG(active_op_array), Z_STRVAL(CONSTANT(opline_ptr->op1.constant)), Z_STRLEN(CONSTANT(opline_ptr->op1.constant)));
+					Z_TYPE(CONSTANT(opline_ptr->op1.constant)) = IS_NULL;
 				} else {
-					efree(Z_STRVAL(opline_ptr->op1.u.constant));
+					zend_del_literal(CG(active_op_array), opline_ptr->op1.constant);
 				}
 				le = le->next;
 				if (variable->op_type == IS_VAR &&
-				    variable->u.var == this_var) {
+				    variable->u.op.var == this_var) {
 					variable->op_type = IS_CV;
-					variable->u.var = CG(active_op_array)->this_var;
+					variable->u.op.var = CG(active_op_array)->this_var;
 				}
 		    } else if (CG(active_op_array)->this_var == -1) {
 				CG(active_op_array)->this_var = lookup_cv(CG(active_op_array), estrndup("this", sizeof("this")-1), sizeof("this")-1);
@@ -1017,14 +1099,14 @@
 			opline_ptr = (zend_op *)le->data;
 			opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 			memcpy(opline, opline_ptr, sizeof(zend_op));
-			if (opline->op1.op_type == IS_VAR &&
-			    opline->op1.u.var == this_var) {
-				opline->op1.op_type = IS_CV;
-				opline->op1.u.var = CG(active_op_array)->this_var;
+			if (opline->op1_type == IS_VAR &&
+			    opline->op1.var == this_var) {
+				opline->op1_type = IS_CV;
+				opline->op1.var = CG(active_op_array)->this_var;
 			}
 			switch (type) {
 				case BP_VAR_R:
-					if (opline->opcode == ZEND_FETCH_DIM_W && opline->op2.op_type == IS_UNUSED) {
+					if (opline->opcode == ZEND_FETCH_DIM_W && opline->op2_type == IS_UNUSED) {
 						zend_error(E_COMPILE_ERROR, "Cannot use [] for reading");
 					}
 					opline->opcode -= 3;
@@ -1035,17 +1117,17 @@
 					opline->opcode += 3;
 					break;
 				case BP_VAR_IS:
-					if (opline->opcode == ZEND_FETCH_DIM_W && opline->op2.op_type == IS_UNUSED) {
+					if (opline->opcode == ZEND_FETCH_DIM_W && opline->op2_type == IS_UNUSED) {
 						zend_error(E_COMPILE_ERROR, "Cannot use [] for reading");
 					}
 					opline->opcode += 6; /* 3+3 */
 					break;
 				case BP_VAR_FUNC_ARG:
 					opline->opcode += 9; /* 3+3+3 */
-					opline->extended_value = arg_offset;
+					opline->extended_value |= arg_offset;
 					break;
 				case BP_VAR_UNSET:
-					if (opline->opcode == ZEND_FETCH_DIM_W && opline->op2.op_type == IS_UNUSED) {
+					if (opline->opcode == ZEND_FETCH_DIM_W && opline->op2_type == IS_UNUSED) {
 						zend_error(E_COMPILE_ERROR, "Cannot use [] for unsetting");
 					}
 					opline->opcode += 12; /* 3+3+3+3 */
@@ -1054,7 +1136,7 @@
 			le = le->next;
 		}
 		if (opline && type == BP_VAR_W && arg_offset) {
-			opline->extended_value = ZEND_FETCH_MAKE_REF;
+			opline->extended_value |= ZEND_FETCH_MAKE_REF;
 		}
 	}
 	zend_llist_destroy(fetch_list_ptr);
@@ -1083,15 +1165,15 @@
 	}
 
 	if (op1) {
-		opline->op1 = *op1;
-		opline->result = *op1;
+		SET_NODE(opline->op1, op1);
+		SET_NODE(opline->result, op1);
 	} else {
 		SET_UNUSED(opline->op1);
-		opline->result.op_type = IS_TMP_VAR;
-		opline->result.u.var = get_temporary_variable(CG(active_op_array));
+		opline->result_type = IS_TMP_VAR;
+		opline->result.var = get_temporary_variable(CG(active_op_array));
 	}
-	opline->op2 = *op2;
-	*result = opline->result;
+	SET_NODE(opline->op2, op2);
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -1102,15 +1184,15 @@
 	opline->opcode = ZEND_ADD_VAR;
 
 	if (op1) {
-		opline->op1 = *op1;
-		opline->result = *op1;
+		SET_NODE(opline->op1, op1);
+		SET_NODE(opline->result, op1);
 	} else {
 		SET_UNUSED(opline->op1);
-		opline->result.op_type = IS_TMP_VAR;
-		opline->result.u.var = get_temporary_variable(CG(active_op_array));
+		opline->result_type = IS_TMP_VAR;
+		opline->result.var = get_temporary_variable(CG(active_op_array));
 	}
-	opline->op2 = *op2;
-	*result = opline->result;
+	SET_NODE(opline->op2, op2);
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -1120,7 +1202,7 @@
 		zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 		opline->opcode = ZEND_FREE;
-		opline->op1 = *op1;
+		SET_NODE(opline->op1, op1);
 		SET_UNUSED(opline->op2);
 	} else if (op1->op_type==IS_VAR) {
 		zend_op *opline = &CG(active_op_array)->opcodes[CG(active_op_array)->last-1];
@@ -1128,23 +1210,23 @@
 		while (opline->opcode == ZEND_END_SILENCE || opline->opcode == ZEND_EXT_FCALL_END || opline->opcode == ZEND_OP_DATA) {
 			opline--;
 		}
-		if (opline->result.op_type == IS_VAR
-			&& opline->result.u.var == op1->u.var) {
-			opline->result.u.EA.type |= EXT_TYPE_UNUSED;
+		if (opline->result_type == IS_VAR
+			&& opline->result.var == op1->u.op.var) {
+			opline->result_type |= EXT_TYPE_UNUSED;
 		} else {
 			while (opline>CG(active_op_array)->opcodes) {
 				if (opline->opcode == ZEND_FETCH_DIM_R
-				    && opline->op1.op_type == IS_VAR
-				    && opline->op1.u.var == op1->u.var) {
+				    && opline->op1_type == IS_VAR
+				    && opline->op1.var == op1->u.op.var) {
 					/* This should the end of a list() construct
 					 * Mark its result as unused
 					 */
 					opline->extended_value = ZEND_FETCH_STANDARD;
 					break;
-				} else if (opline->result.op_type==IS_VAR
-					&& opline->result.u.var == op1->u.var) {
+				} else if (opline->result_type==IS_VAR
+					&& opline->result.var == op1->u.op.var) {
 					if (opline->opcode == ZEND_NEW) {
-						opline->result.u.EA.type |= EXT_TYPE_UNUSED;
+						opline->result_type |= EXT_TYPE_UNUSED;
 					}
 					break;
 				}
@@ -1187,7 +1269,7 @@
 	zend_op_array op_array;
 	char *name = function_name->u.constant.value.str.val;
 	int name_len = function_name->u.constant.value.str.len;
-	int function_begin_line = function_token->u.opline_num;
+	int function_begin_line = function_token->u.op.opline_num;
 	zend_uint fn_flags;
 	char *lcname;
 	zend_bool orig_interactive;
@@ -1335,6 +1417,7 @@
 		efree(lcname);
 	} else {
 		zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
+		zval key;
 
 		if (CG(current_namespace)) {
 			/* Prefix function name with current namespcae name */
@@ -1350,15 +1433,15 @@
 		}
 
 		opline->opcode = ZEND_DECLARE_FUNCTION;
-		opline->op1.op_type = IS_CONST;
-		build_runtime_defined_function_key(&opline->op1.u.constant, lcname, name_len TSRMLS_CC);
-		opline->op2.op_type = IS_CONST;
-		opline->op2.u.constant.type = IS_STRING;
-		opline->op2.u.constant.value.str.val = lcname;
-		opline->op2.u.constant.value.str.len = name_len;
-		Z_SET_REFCOUNT(opline->op2.u.constant, 1);
+		opline->op1_type = IS_CONST;
+		build_runtime_defined_function_key(&key, lcname, name_len TSRMLS_CC);
+		opline->op1.constant = zend_add_literal(CG(active_op_array), &key);		
+		Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant)));
+		opline->op2_type = IS_CONST;
+		LITERAL_STRINGL(opline->op2, lcname, name_len, 0);
+		Z_HASH_P(&CONSTANT(opline->op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))+1);
 		opline->extended_value = ZEND_DECLARE_FUNCTION;
-		zend_hash_update(CG(function_table), opline->op1.u.constant.value.str.val, opline->op1.u.constant.value.str.len, &op_array, sizeof(zend_op_array), (void **) &CG(active_op_array));
+		zend_hash_quick_update(CG(function_table), Z_STRVAL(key), Z_STRLEN(key), Z_HASH_P(&CONSTANT(opline->op1.constant)), &op_array, sizeof(zend_op_array), (void **) &CG(active_op_array));
 	}
 
 	if (CG(compiler_options) & ZEND_COMPILE_EXTENDED_INFO) {
@@ -1384,8 +1467,8 @@
 			/* Foreach stack separator */
 			zend_op dummy_opline;
 
-			dummy_opline.result.op_type = IS_UNUSED;
-			dummy_opline.op1.op_type = IS_UNUSED;
+			dummy_opline.result_type = IS_UNUSED;
+			dummy_opline.op1_type = IS_UNUSED;
 
 			zend_stack_push(&CG(foreach_copy_stack), (void *) &dummy_opline, sizeof(zend_op));
 		}
@@ -1416,13 +1499,13 @@
 	zend_do_begin_function_declaration(function_token, &function_name, 0, return_reference, NULL TSRMLS_CC);
 
 	result->op_type = IS_TMP_VAR;
-	result->u.var = get_temporary_variable(current_op_array);
+	result->u.op.var = get_temporary_variable(current_op_array);
 
 	current_op = &current_op_array->opcodes[current_op_number];
 	current_op->opcode = ZEND_DECLARE_LAMBDA_FUNCTION;
-	zval_dtor(&current_op->op2.u.constant);
-	ZVAL_LONG(&current_op->op2.u.constant, zend_hash_func(Z_STRVAL(current_op->op1.u.constant), Z_STRLEN(current_op->op1.u.constant)));
-	current_op->result = *result;
+	zend_del_literal(current_op_array, current_op->op2.constant);
+	SET_UNUSED(current_op->op2);
+	SET_NODE(current_op->result, result);
 	CG(active_op_array)->fn_flags |= ZEND_ACC_CLOSURE;
 }
 /* }}} */
@@ -1486,7 +1569,7 @@
 	}
 
 	if (var->op_type == IS_CV &&
-	    var->u.var == CG(active_op_array)->this_var &&
+	    var->u.op.var == CG(active_op_array)->this_var &&
 	    (CG(active_op_array)->fn_flags & ZEND_ACC_STATIC) == 0) {
  		zend_error(E_COMPILE_ERROR, "Cannot re-assign $this");
 	} else if (var->op_type == IS_VAR &&
@@ -1501,10 +1584,10 @@
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	CG(active_op_array)->num_args++;
 	opline->opcode = op;
-	opline->result = *var;
-	opline->op1 = *offset;
+	SET_NODE(opline->result, var);
+	SET_NODE(opline->op1, offset);
 	if (op == ZEND_RECV_INIT) {
-		opline->op2 = *initialization;
+		SET_NODE(opline->op2, initialization);
 	} else {
 		CG(active_op_array)->required_num_args = CG(active_op_array)->num_args;
 		SET_UNUSED(opline->op2);
@@ -1547,7 +1630,6 @@
 			}
 		}
 	}
-	opline->result.u.EA.type |= EXT_TYPE_UNUSED;
 }
 /* }}} */
 
@@ -1586,6 +1668,53 @@
 }
 /* }}} */
 
+static void add_lowercased_name(int literal TSRMLS_DC) /* {{{ */
+{
+	/* Hack: the literal folowing to the name is the same lowercased name */
+	char *lc_name;
+	zval c;
+	int lc_literal;
+
+if (literal + 1 != CG(active_op_array)->last_literal) {
+zend_error(E_ERROR, "Internal error 1 ???");
+}
+	lc_name = zend_str_tolower_dup(Z_STRVAL(CONSTANT(literal)), Z_STRLEN(CONSTANT(literal)));
+	ZVAL_STRINGL(&c, lc_name, Z_STRLEN(CONSTANT(literal)), 0);
+	lc_literal = zend_add_literal(CG(active_op_array), &c);
+	Z_HASH_P(&CONSTANT(lc_literal)) = zend_hash_func(lc_name, Z_STRLEN(CONSTANT(literal))+1);
+if (literal + 1 != lc_literal) {
+zend_error(E_ERROR, "Internal error 2 ???");
+}
+}
+/* }}} */
+
+static void add_lowercased_class_name(int literal TSRMLS_DC) /* {{{ */
+{
+	/* Hack: the literal folowing to the name is the same lowercased name */
+	char *lc_name;
+	int lc_len;
+	zval c;
+	int lc_literal;
+
+if (literal + 1 != CG(active_op_array)->last_literal) {
+zend_error(E_ERROR, "Internal error 3 ???");
+}
+	if (Z_STRVAL(CONSTANT(literal))[0] == '\\') {
+		lc_len = Z_STRLEN(CONSTANT(literal)) - 1;
+		lc_name = zend_str_tolower_dup(Z_STRVAL(CONSTANT(literal)) + 1, lc_len);
+	} else {
+		lc_len = Z_STRLEN(CONSTANT(literal));
+		lc_name = zend_str_tolower_dup(Z_STRVAL(CONSTANT(literal)), lc_len);
+	}
+	ZVAL_STRINGL(&c, lc_name, lc_len, 0);
+	lc_literal = zend_add_literal(CG(active_op_array), &c);
+	Z_HASH_P(&CONSTANT(lc_literal)) = zend_hash_func(lc_name, lc_len+1);
+if (literal + 1 != lc_literal) {
+zend_error(E_ERROR, "Internal error 4 ???");
+}
+}
+/* }}} */
+
 void zend_do_begin_method_call(znode *left_bracket TSRMLS_DC) /* {{{ */
 {
 	zend_op *last_op;
@@ -1598,27 +1727,27 @@
 	last_op_number = get_next_op_number(CG(active_op_array))-1;
 	last_op = &CG(active_op_array)->opcodes[last_op_number];
 
-	if ((last_op->op2.op_type == IS_CONST) && (last_op->op2.u.constant.type == IS_STRING) && (last_op->op2.u.constant.value.str.len == sizeof(ZEND_CLONE_FUNC_NAME)-1)
-		&& !zend_binary_strcasecmp(last_op->op2.u.constant.value.str.val, last_op->op2.u.constant.value.str.len, ZEND_CLONE_FUNC_NAME, sizeof(ZEND_CLONE_FUNC_NAME)-1)) {
+	if ((last_op->op2_type == IS_CONST) && (Z_TYPE(CONSTANT(last_op->op2.constant)) == IS_STRING) && (Z_STRLEN(CONSTANT(last_op->op2.constant)) == sizeof(ZEND_CLONE_FUNC_NAME)-1)
+		&& !zend_binary_strcasecmp(Z_STRVAL(CONSTANT(last_op->op2.constant)), Z_STRLEN(CONSTANT(last_op->op2.constant)), ZEND_CLONE_FUNC_NAME, sizeof(ZEND_CLONE_FUNC_NAME)-1)) {
 		zend_error(E_COMPILE_ERROR, "Cannot call __clone() method on objects - use 'clone $obj' instead");
 	}
 
 	if (last_op->opcode == ZEND_FETCH_OBJ_R) {
+		if (last_op->op2_type == IS_CONST) {
+			add_lowercased_name(last_op->op2.constant TSRMLS_CC);
+		}
 		last_op->opcode = ZEND_INIT_METHOD_CALL;
 		SET_UNUSED(last_op->result);
 		Z_LVAL(left_bracket->u.constant) = ZEND_INIT_FCALL_BY_NAME;
 	} else {
 		zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 		opline->opcode = ZEND_INIT_FCALL_BY_NAME;
-		opline->op2 = *left_bracket;
-		if (opline->op2.op_type == IS_CONST) {
-			opline->op1.op_type = IS_CONST;
-			Z_TYPE(opline->op1.u.constant) = IS_STRING;
-			Z_STRVAL(opline->op1.u.constant) = zend_str_tolower_dup(Z_STRVAL(opline->op2.u.constant), Z_STRLEN(opline->op2.u.constant));
-			Z_STRLEN(opline->op1.u.constant) = Z_STRLEN(opline->op2.u.constant);
-			opline->extended_value = zend_hash_func(Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant) + 1);
+		SET_NODE(opline->op2, left_bracket);
+		if (opline->op2_type == IS_CONST) {
+			opline->op1_type = IS_CONST;
+			LITERAL_STRINGL(opline->op1, zend_str_tolower_dup(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))), Z_STRLEN(CONSTANT(opline->op2.constant)), 0);
+			Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant))+1);
 		} else {
-			opline->extended_value = 0;
 			SET_UNUSED(opline->op1);
 		}
 	}
@@ -1633,11 +1762,11 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_CLONE;
-	opline->op1 = *expr;
+	SET_NODE(opline->op1, expr);
 	SET_UNUSED(opline->op2);
-	opline->result.op_type = IS_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	*result = opline->result;
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -1653,39 +1782,32 @@
 		/* In run-time PHP will check for function with full name and
 		   internal function with short name */
 		opline->opcode = ZEND_INIT_NS_FCALL_BY_NAME;
-		opline->op2 = *function_name;
-		opline->extended_value = 0;
-		opline->op1.op_type = IS_CONST;
-		Z_TYPE(opline->op1.u.constant) = IS_STRING;
-		Z_STRVAL(opline->op1.u.constant) = zend_str_tolower_dup(Z_STRVAL(opline->op2.u.constant), Z_STRLEN(opline->op2.u.constant));
-		Z_STRLEN(opline->op1.u.constant) = Z_STRLEN(opline->op2.u.constant);
-		opline->extended_value = zend_hash_func(Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant) + 1);
-		slash = zend_memrchr(Z_STRVAL(opline->op1.u.constant), '\\', Z_STRLEN(opline->op1.u.constant));
-		prefix_len = slash-Z_STRVAL(opline->op1.u.constant)+1;
-		name_len = Z_STRLEN(opline->op1.u.constant)-prefix_len;
+		SET_NODE(opline->op2, function_name);
+		opline->op1_type = IS_CONST;
+		LITERAL_STRINGL(opline->op1, zend_str_tolower_dup(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))), Z_STRLEN(CONSTANT(opline->op2.constant)), 0);
+		Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant))+1);
+		slash = zend_memrchr(Z_STRVAL(CONSTANT(opline->op1.constant)), '\\', Z_STRLEN(CONSTANT(opline->op1.constant)));
+		prefix_len = slash-Z_STRVAL(CONSTANT(opline->op1.constant))+1;
+		name_len = Z_STRLEN(CONSTANT(opline->op1.constant))-prefix_len;
 		opline2 = get_next_op(CG(active_op_array) TSRMLS_CC);
 		opline2->opcode = ZEND_OP_DATA;
-		opline2->op1.op_type = IS_CONST;
-		Z_TYPE(opline2->op1.u.constant) = IS_LONG;
+		SET_UNUSED(opline2->op1);
 		if(!slash) {
-			zend_error(E_CORE_ERROR, "Namespaced name %s should contain slash", Z_STRVAL(opline->op1.u.constant));
+			zend_error(E_CORE_ERROR, "Namespaced name %s should contain slash", Z_STRVAL(CONSTANT(opline->op1.constant)));
 		}
 		/* this is the length of namespace prefix */
-		Z_LVAL(opline2->op1.u.constant) = prefix_len;
+		opline2->op1.num = prefix_len;
 		/* this is the hash of the non-prefixed part, lowercased */
 		opline2->extended_value = zend_hash_func(slash+1, name_len+1);
 		SET_UNUSED(opline2->op2);
 	} else {
 		opline->opcode = ZEND_INIT_FCALL_BY_NAME;
-		opline->op2 = *function_name;
-		if (opline->op2.op_type == IS_CONST) {
-			opline->op1.op_type = IS_CONST;
-			Z_TYPE(opline->op1.u.constant) = IS_STRING;
-			Z_STRVAL(opline->op1.u.constant) = zend_str_tolower_dup(Z_STRVAL(opline->op2.u.constant), Z_STRLEN(opline->op2.u.constant));
-			Z_STRLEN(opline->op1.u.constant) = Z_STRLEN(opline->op2.u.constant);
-			opline->extended_value = zend_hash_func(Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant) + 1);
+		SET_NODE(opline->op2, function_name);
+		if (opline->op2_type == IS_CONST) {
+			opline->op1_type = IS_CONST;
+			LITERAL_STRINGL(opline->op1, zend_str_tolower_dup(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))), Z_STRLEN(CONSTANT(opline->op2.constant)), 0);
+			Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant))+1);
 		} else {
-			opline->extended_value = 0;
 			SET_UNUSED(opline->op1);
 		}
 	}
@@ -1855,16 +1977,17 @@
 				break;
 			default:
 				zend_resolve_class_name(class_name, &opline->extended_value, 0 TSRMLS_CC);
-				opline->op2 = *class_name;
+				SET_NODE(opline->op2, class_name);
+				add_lowercased_class_name(opline->op2.constant TSRMLS_CC);
 				break;
 		}
 	} else {
-		opline->op2 = *class_name;
+		SET_NODE(opline->op2, class_name);
 	}
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->result.u.EA.type = opline->extended_value;
-	opline->result.op_type = IS_VAR; /* FIXME: Hack so that INIT_FCALL_BY_NAME still knows this is a class */
-	*result = opline->result;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	opline->result_type = IS_VAR; /* FIXME: Hack so that INIT_FCALL_BY_NAME still knows this is a class */
+	GET_NODE(result, opline->result);
+	result->EA = opline->extended_value;
 }
 /* }}} */
 
@@ -1894,15 +2017,21 @@
 {
 	zend_label *dest;
 	long current, distance;
+	zval *label;
 
+	if (pass2) {
+		label = opline->op2.zv;
+	} else {
+		label = &CONSTANT_EX(op_array, opline->op2.constant);
+	}
 	if (CG(labels) == NULL ||
-	    zend_hash_find(CG(labels), Z_STRVAL(opline->op2.u.constant), Z_STRLEN(opline->op2.u.constant)+1, (void**)&dest) == FAILURE) {
+	    zend_hash_find(CG(labels), Z_STRVAL_P(label), Z_STRLEN_P(label)+1, (void**)&dest) == FAILURE) {
 
 	    if (pass2) {
 	    	CG(in_compilation) = 1;
 	    	CG(active_op_array) = op_array;
 	    	CG(zend_lineno) = opline->lineno;
-			zend_error(E_COMPILE_ERROR, "'goto' to undefined label '%s'", Z_STRVAL(opline->op2.u.constant));
+			zend_error(E_COMPILE_ERROR, "'goto' to undefined label '%s'", Z_STRVAL_P(label));
 	    } else {
 			/* Label is not defined. Delay to pass 2. */
 			INC_BPC(op_array);
@@ -1910,8 +2039,9 @@
 		}
 	}
 
-	opline->op1.u.opline_num = dest->opline_num;
-	zval_dtor(&opline->op2.u.constant);
+	opline->op1.opline_num = dest->opline_num;
+	zval_dtor(label);
+	Z_TYPE_P(label) = IS_NULL;
 
 	/* Check that we are not moving into loop or switch */
 	current = opline->extended_value;
@@ -1934,7 +2064,7 @@
 		SET_UNUSED(opline->op2);
 	} else {
 		/* Set real break distance */
-		ZVAL_LONG(&opline->op2.u.constant, distance);
+		ZVAL_LONG(label, distance);
 	}
 
     if (pass2) {
@@ -1950,7 +2080,7 @@
 	opline->opcode = ZEND_GOTO;
 	opline->extended_value = CG(active_op_array)->current_brk_cont;
 	SET_UNUSED(opline->op1);
-	opline->op2 = *label;
+	SET_NODE(opline->op2, label);
 	zend_resolve_goto_label(CG(active_op_array), opline, 0 TSRMLS_CC);
 }
 /* }}} */
@@ -2013,7 +2143,7 @@
 		if ((sizeof(ZEND_CONSTRUCTOR_FUNC_NAME)-1) == Z_STRLEN(method_name->u.constant) &&
 		    memcmp(lcname, ZEND_CONSTRUCTOR_FUNC_NAME, sizeof(ZEND_CONSTRUCTOR_FUNC_NAME)-1) == 0) {
 			zval_dtor(&method_name->u.constant);
-			SET_UNUSED(*method_name);
+			method_name->op_type = IS_UNUSED;
 		}
 		efree(lcname);
 	}
@@ -2023,13 +2153,21 @@
 		fetch_type = ZEND_FETCH_CLASS_GLOBAL;
 		zend_resolve_class_name(class_name, &fetch_type, 1 TSRMLS_CC);
 		class_node = *class_name;
+		opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	} else {
 		zend_do_fetch_class(&class_node, class_name TSRMLS_CC);
+		opline = get_next_op(CG(active_op_array) TSRMLS_CC);
+		opline->extended_value = class_node.EA	;
 	}
-	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_INIT_STATIC_METHOD_CALL;
-	opline->op1 = class_node;
-	opline->op2 = *method_name;
+	SET_NODE(opline->op1, &class_node);
+	if (opline->op1_type == IS_CONST) {
+		add_lowercased_class_name(opline->op1.constant TSRMLS_CC);
+	}
+	SET_NODE(opline->op2, method_name);
+	if (opline->op2_type == IS_CONST) {
+		add_lowercased_name(opline->op2.constant TSRMLS_CC);
+	}
 
 	zend_stack_push(&CG(function_call_stack), (void *) &ptr, sizeof(zend_function *));
 	zend_do_extended_fcall_begin(TSRMLS_C);
@@ -2051,17 +2189,17 @@
 		opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 		if (!is_method && !is_dynamic_fcall && function_name->op_type==IS_CONST) {
 			opline->opcode = ZEND_DO_FCALL;
-			opline->op1 = *function_name;
-			ZVAL_LONG(&opline->op2.u.constant, zend_hash_func(Z_STRVAL(function_name->u.constant), Z_STRLEN(function_name->u.constant) + 1));
+			SET_NODE(opline->op1, function_name);
+			Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant))+1);
 		} else {
 			opline->opcode = ZEND_DO_FCALL_BY_NAME;
 			SET_UNUSED(opline->op1);
 		}
 	}
 
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->result.op_type = IS_VAR;
-	*result = opline->result;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	opline->result_type = IS_VAR;
+	GET_NODE(result, opline->result)	;
 	SET_UNUSED(opline->op2);
 
 	zend_stack_del_top(&CG(function_call_stack));
@@ -2170,8 +2308,8 @@
 		}
 	}
 	opline->opcode = op;
-	opline->op1 = *param;
-	opline->op2.u.opline_num = offset;
+	SET_NODE(opline->op1, param);
+	opline->op2.opline_num = offset;
 	SET_UNUSED(opline->op2);
 }
 /* }}} */
@@ -2187,7 +2325,7 @@
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = (switch_entry->cond.op_type == IS_TMP_VAR) ? ZEND_FREE : ZEND_SWITCH_FREE;
-	opline->op1 = switch_entry->cond;
+	SET_NODE(opline->op1, &switch_entry->cond);
 	SET_UNUSED(opline->op2);
 	opline->extended_value = 0;
 	return 0;
@@ -2199,22 +2337,22 @@
 	zend_op *opline;
 
 	/* If we reach the seperator then stop applying the stack */
-	if (foreach_copy->result.op_type == IS_UNUSED && foreach_copy->op1.op_type == IS_UNUSED) {
+	if (foreach_copy->result_type == IS_UNUSED && foreach_copy->op1_type == IS_UNUSED) {
 		return 1;
 	}
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
-	opline->opcode = (foreach_copy->result.op_type == IS_TMP_VAR) ? ZEND_FREE : ZEND_SWITCH_FREE;
-	opline->op1 = foreach_copy->result;
+	opline->opcode = (foreach_copy->result_type == IS_TMP_VAR) ? ZEND_FREE : ZEND_SWITCH_FREE;
+	COPY_NODE(opline->op1, foreach_copy->result);
 	SET_UNUSED(opline->op2);
 	opline->extended_value = 1;
 
-	if (foreach_copy->op1.op_type != IS_UNUSED) {
+	if (foreach_copy->op1_type != IS_UNUSED) {
 		opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
-		opline->opcode = (foreach_copy->op1.op_type == IS_TMP_VAR) ? ZEND_FREE : ZEND_SWITCH_FREE;
-		opline->op1 = foreach_copy->op1;
+		opline->opcode = (foreach_copy->op1_type == IS_TMP_VAR) ? ZEND_FREE : ZEND_SWITCH_FREE;
+		COPY_NODE(opline->op1, foreach_copy->op1);
 		SET_UNUSED(opline->op2);
 		opline->extended_value = 0;
 	}
@@ -2248,7 +2386,7 @@
 
 	end_op_number = get_next_op_number(CG(active_op_array));
 	while (start_op_number < end_op_number) {
-		CG(active_op_array)->opcodes[start_op_number].op1.u.EA.type = EXT_TYPE_FREE_ON_RETURN;
+		CG(active_op_array)->opcodes[start_op_number].extended_value |= EXT_TYPE_FREE_ON_RETURN;
 		start_op_number++;
 	}
 
@@ -2257,14 +2395,14 @@
 	opline->opcode = ZEND_RETURN;
 
 	if (expr) {
-		opline->op1 = *expr;
+		SET_NODE(opline->op1, expr);
 
 		if (do_end_vparse && zend_is_function_or_method_call(expr)) {
 			opline->extended_value = ZEND_RETURNS_FUNCTION;
 		}
 	} else {
-		opline->op1.op_type = IS_CONST;
-		INIT_ZVAL(opline->op1.u.constant);
+		opline->op1_type = IS_CONST;
+		LITERAL_NULL(opline->op1);
 	}
 
 	SET_UNUSED(opline->op2);
@@ -2289,7 +2427,7 @@
 
 void zend_do_first_catch(znode *open_parentheses TSRMLS_DC) /* {{{ */
 {
-	open_parentheses->u.opline_num = get_next_op_number(CG(active_op_array));
+	open_parentheses->u.op.opline_num = get_next_op_number(CG(active_op_array));
 }
 /* }}} */
 
@@ -2310,7 +2448,7 @@
 	zend_stack_top(&CG(bp_stack), (void **) &jmp_list_ptr);
 	zend_llist_add_element(jmp_list_ptr, &jmp_op_number);
 
-	zend_add_catch_element(try_token->u.opline_num, get_next_op_number(CG(active_op_array)) TSRMLS_CC);
+	zend_add_catch_element(try_token->u.op.opline_num, get_next_op_number(CG(active_op_array)) TSRMLS_CC);
 }
 /* }}} */
 
@@ -2318,12 +2456,12 @@
 {
 	CG(active_op_array)->last--;
 	zend_do_if_end(TSRMLS_C);
-	if (last_additional_catch->u.opline_num == -1) {
-		CG(active_op_array)->opcodes[first_catch->u.opline_num].op1.u.EA.type = 1;
-		CG(active_op_array)->opcodes[first_catch->u.opline_num].extended_value = get_next_op_number(CG(active_op_array));
+	if (last_additional_catch->u.op.opline_num == -1) {
+		CG(active_op_array)->opcodes[first_catch->u.op.opline_num].result.num = 1;
+		CG(active_op_array)->opcodes[first_catch->u.op.opline_num].extended_value = get_next_op_number(CG(active_op_array));
 	} else {
-		CG(active_op_array)->opcodes[last_additional_catch->u.opline_num].op1.u.EA.type = 1;
-		CG(active_op_array)->opcodes[last_additional_catch->u.opline_num].extended_value = get_next_op_number(CG(active_op_array));
+		CG(active_op_array)->opcodes[last_additional_catch->u.op.opline_num].result.num = 1;
+		CG(active_op_array)->opcodes[last_additional_catch->u.op.opline_num].extended_value = get_next_op_number(CG(active_op_array));
 	}
 	DEC_BPC(CG(active_op_array));
 }
@@ -2331,7 +2469,7 @@
 
 void zend_do_try(znode *try_token TSRMLS_DC) /* {{{ */
 {
-	try_token->u.opline_num = zend_add_try_element(get_next_op_number(CG(active_op_array)) TSRMLS_CC);
+	try_token->u.op.opline_num = zend_add_try_element(get_next_op_number(CG(active_op_array)) TSRMLS_CC);
 	INC_BPC(CG(active_op_array));
 }
 /* }}} */
@@ -2353,19 +2491,17 @@
 	}
 
 	if (first_catch) {
-		first_catch->u.opline_num = catch_op_number;
+		first_catch->u.op.opline_num = catch_op_number;
 	}
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_CATCH;
-	opline->op1 = catch_class;
-/*	SET_UNUSED(opline->op1); */ /* FIXME: Define IS_CLASS or something like that */
-	opline->op2.op_type = IS_CV;
-	opline->op2.u.var = lookup_cv(CG(active_op_array), catch_var->u.constant.value.str.val, catch_var->u.constant.value.str.len);
-	opline->op2.u.EA.type = 0;
-	opline->op1.u.EA.type = 0; /* 1 means it's the last catch in the block */
+	SET_NODE(opline->op1, &catch_class);
+	opline->op2_type = IS_CV;
+	opline->op2.var = lookup_cv(CG(active_op_array), catch_var->u.constant.value.str.val, catch_var->u.constant.value.str.len);
+	opline->result.num = 0; /* 1 means it's the last catch in the block */
 
-	try_token->u.opline_num = catch_op_number;
+	try_token->u.op.opline_num = catch_op_number;
 }
 /* }}} */
 
@@ -2383,7 +2519,7 @@
 	zend_stack_top(&CG(bp_stack), (void **) &jmp_list_ptr);
 	zend_llist_add_element(jmp_list_ptr, &jmp_op_number);
 
-	CG(active_op_array)->opcodes[try_token->u.opline_num].extended_value = get_next_op_number(CG(active_op_array));
+	CG(active_op_array)->opcodes[try_token->u.op.opline_num].extended_value = get_next_op_number(CG(active_op_array));
 }
 /* }}} */
 
@@ -2393,7 +2529,7 @@
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_THROW;
-	opline->op1 = *expr;
+	SET_NODE(opline->op1, expr);
 	SET_UNUSED(opline->op2);
 }
 /* }}} */
@@ -2926,16 +3062,25 @@
 }
 /* }}} */
 
-ZEND_API int do_bind_function(zend_op *opline, HashTable *function_table, zend_bool compile_time) /* {{{ */
+ZEND_API int do_bind_function(const zend_op_array *op_array, zend_op *opline, HashTable *function_table, zend_bool compile_time) /* {{{ */
 {
 	zend_function *function;
+	zval *op1, *op2;
 
-	zend_hash_find(function_table, opline->op1.u.constant.value.str.val, opline->op1.u.constant.value.str.len, (void *) &function);
-	if (zend_hash_add(function_table, opline->op2.u.constant.value.str.val, opline->op2.u.constant.value.str.len+1, function, sizeof(zend_function), NULL)==FAILURE) {
+	if (compile_time) {
+		op1 = &CONSTANT_EX(op_array, opline->op1.constant);
+		op2 = &CONSTANT_EX(op_array, opline->op2.constant);
+	} else {
+		op1 = opline->op1.zv;
+		op2 = opline->op2.zv;
+	}
+
+	zend_hash_quick_find(function_table, Z_STRVAL_P(op1), Z_STRLEN_P(op1), Z_HASH_P(op1), (void *) &function);
+	if (zend_hash_quick_add(function_table, Z_STRVAL_P(op2), Z_STRLEN_P(op2)+1, Z_HASH_P(op2), function, sizeof(zend_function), NULL)==FAILURE) {
 		int error_level = compile_time ? E_COMPILE_ERROR : E_ERROR;
 		zend_function *old_function;
 
-		if (zend_hash_find(function_table, opline->op2.u.constant.value.str.val, opline->op2.u.constant.value.str.len+1, (void *) &old_function)==SUCCESS
+		if (zend_hash_quick_find(function_table, Z_STRVAL_P(op2), Z_STRLEN_P(op2)+1, Z_HASH_P(op2), (void *) &old_function)==SUCCESS
 			&& old_function->type == ZEND_USER_FUNCTION
 			&& old_function->op_array.last > 0) {
 			zend_error(error_level, "Cannot redeclare %s() (previously declared in %s:%d)",
@@ -2954,18 +3099,26 @@
 }
 /* }}} */
 
-ZEND_API zend_class_entry *do_bind_class(const zend_op *opline, HashTable *class_table, zend_bool compile_time TSRMLS_DC) /* {{{ */
+ZEND_API zend_class_entry *do_bind_class(const zend_op_array* op_array, const zend_op *opline, HashTable *class_table, zend_bool compile_time TSRMLS_DC) /* {{{ */
 {
 	zend_class_entry *ce, **pce;
+	zval *op1, *op2;
 
-	if (zend_hash_find(class_table, opline->op1.u.constant.value.str.val, opline->op1.u.constant.value.str.len, (void **) &pce)==FAILURE) {
-		zend_error(E_COMPILE_ERROR, "Internal Zend error - Missing class information for %s", opline->op1.u.constant.value.str.val);
+	if (compile_time) {
+		op1 = &CONSTANT_EX(op_array, opline->op1.constant);
+		op2 = &CONSTANT_EX(op_array, opline->op2.constant);
+	} else {
+		op1 = opline->op1.zv;
+		op2 = opline->op2.zv;
+	}
+	if (zend_hash_quick_find(class_table, Z_STRVAL_P(op1), Z_STRLEN_P(op1), Z_HASH_P(op1), (void **) &pce)==FAILURE) {
+		zend_error(E_COMPILE_ERROR, "Internal Zend error - Missing class information for %s", Z_STRVAL_P(op1));
 		return NULL;
 	} else {
 		ce = *pce;
 	}
 	ce->refcount++;
-	if (zend_hash_add(class_table, opline->op2.u.constant.value.str.val, opline->op2.u.constant.value.str.len+1, &ce, sizeof(zend_class_entry *), NULL)==FAILURE) {
+	if (zend_hash_quick_add(class_table, Z_STRVAL_P(op2), Z_STRLEN_P(op2)+1, Z_HASH_P(op2), &ce, sizeof(zend_class_entry *), NULL)==FAILURE) {
 		ce->refcount--;
 		if (!compile_time) {
 			/* If we're in compile time, in practice, it's quite possible
@@ -2985,13 +3138,22 @@
 }
 /* }}} */
 
-ZEND_API zend_class_entry *do_bind_inherited_class(const zend_op *opline, HashTable *class_table, zend_class_entry *parent_ce, zend_bool compile_time TSRMLS_DC) /* {{{ */
+ZEND_API zend_class_entry *do_bind_inherited_class(const zend_op_array *op_array, const zend_op *opline, HashTable *class_table, zend_class_entry *parent_ce, zend_bool compile_time TSRMLS_DC) /* {{{ */
 {
 	zend_class_entry *ce, **pce;
 	int found_ce;
+	zval *op1, *op2;
 
-	found_ce = zend_hash_find(class_table, opline->op1.u.constant.value.str.val, opline->op1.u.constant.value.str.len, (void **) &pce);
+	if (compile_time) {
+		op1 = &CONSTANT_EX(op_array, opline->op1.constant);
+		op2 = &CONSTANT_EX(op_array, opline->op2.constant);
+	} else {
+		op1 = opline->op1.zv;
+		op2 = opline->op2.zv;
+	}
 
+	found_ce = zend_hash_quick_find(class_table, Z_STRVAL_P(op1), Z_STRLEN_P(op1), Z_HASH_P(op1), (void **) &pce);
+
 	if (found_ce == FAILURE) {
 		if (!compile_time) {
 			/* If we're in compile time, in practice, it's quite possible
@@ -2999,7 +3161,7 @@
 			 * so we shut up about it.  This allows the if (!defined('FOO')) { return; }
 			 * approach to work.
 			 */
-			zend_error(E_COMPILE_ERROR, "Cannot redeclare class %s", opline->op2.u.constant.value.str.val);
+			zend_error(E_COMPILE_ERROR, "Cannot redeclare class %s", Z_STRVAL_P(op2));
 		}
 		return NULL;
 	} else {
@@ -3015,7 +3177,7 @@
 	ce->refcount++;
 
 	/* Register the derived class */
-	if (zend_hash_add(class_table, opline->op2.u.constant.value.str.val, opline->op2.u.constant.value.str.len+1, pce, sizeof(zend_class_entry *), NULL)==FAILURE) {
+	if (zend_hash_quick_add(class_table, Z_STRVAL_P(op2), Z_STRLEN_P(op2)+1, Z_HASH_P(op2), pce, sizeof(zend_class_entry *), NULL)==FAILURE) {
 		zend_error(E_COMPILE_ERROR, "Cannot redeclare class %s", ce->name);
 	}
 	return ce;
@@ -3033,13 +3195,13 @@
 
 	switch (opline->opcode) {
 		case ZEND_DECLARE_FUNCTION:
-			if (do_bind_function(opline, CG(function_table), 1) == FAILURE) {
+			if (do_bind_function(CG(active_op_array), opline, CG(function_table), 1) == FAILURE) {
 				return;
 			}
 			table = CG(function_table);
 			break;
 		case ZEND_DECLARE_CLASS:
-			if (do_bind_class(opline, CG(class_table), 1 TSRMLS_CC) == NULL) {
+			if (do_bind_class(CG(active_op_array), opline, CG(class_table), 1 TSRMLS_CC) == NULL) {
 				return;
 			}
 			table = CG(class_table);
@@ -3047,9 +3209,10 @@
 		case ZEND_DECLARE_INHERITED_CLASS:
 			{
 				zend_op *fetch_class_opline = opline-1;
-				zval *parent_name = &fetch_class_opline->op2.u.constant;
+				zval *parent_name;
 				zend_class_entry **pce;
 
+				parent_name = &CONSTANT(fetch_class_opline->op2.constant);
 				if ((zend_lookup_class(Z_STRVAL_P(parent_name), Z_STRLEN_P(parent_name), &pce TSRMLS_CC) == FAILURE) ||
 				    ((CG(compiler_options) & ZEND_COMPILE_IGNORE_INTERNAL_CLASSES) &&
 				     ((*pce)->type == ZEND_INTERNAL_CLASS))) {
@@ -3057,20 +3220,20 @@
 						zend_uint *opline_num = &CG(active_op_array)->early_binding;
 
 						while (*opline_num != -1) {
-							opline_num = &CG(active_op_array)->opcodes[*opline_num].result.u.opline_num;
+							opline_num = &CG(active_op_array)->opcodes[*opline_num].result.opline_num;
 						}
 						*opline_num = opline - CG(active_op_array)->opcodes;
 						opline->opcode = ZEND_DECLARE_INHERITED_CLASS_DELAYED;
-						opline->result.op_type = IS_UNUSED;
-						opline->result.u.opline_num = -1;
+						opline->result_type = IS_UNUSED;
+						opline->result.opline_num = -1;
 					}
 					return;
 				}
-				if (do_bind_inherited_class(opline, CG(class_table), *pce, 1 TSRMLS_CC) == NULL) {
+				if (do_bind_inherited_class(CG(active_op_array), opline, CG(class_table), *pce, 1 TSRMLS_CC) == NULL) {
 					return;
 				}
 				/* clear unnecessary ZEND_FETCH_CLASS opcode */
-				zval_dtor(&fetch_class_opline->op2.u.constant);
+				zend_del_literal(CG(active_op_array), fetch_class_opline->op2.constant);
 				MAKE_NOP(fetch_class_opline);
 
 				table = CG(class_table);
@@ -3085,9 +3248,9 @@
 			return;
 	}
 
-	zend_hash_del(table, opline->op1.u.constant.value.str.val, opline->op1.u.constant.value.str.len);
-	zval_dtor(&opline->op1.u.constant);
-	zval_dtor(&opline->op2.u.constant);
+	zend_hash_quick_del(table, Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant)), Z_HASH_P(&CONSTANT(opline->op1.constant)));
+	zend_del_literal(CG(active_op_array), opline->op1.constant);
+	zend_del_literal(CG(active_op_array), opline->op2.constant);
 	MAKE_NOP(opline);
 }
 /* }}} */
@@ -3101,10 +3264,10 @@
 
 		CG(in_compilation) = 1;
 		while (opline_num != -1) {
-			if (zend_lookup_class(Z_STRVAL(op_array->opcodes[opline_num-1].op2.u.constant), Z_STRLEN(op_array->opcodes[opline_num-1].op2.u.constant), &pce TSRMLS_CC) == SUCCESS) {
-				do_bind_inherited_class(&op_array->opcodes[opline_num], EG(class_table), *pce, 1 TSRMLS_CC);
+			if (zend_lookup_class(Z_STRVAL_P(op_array->opcodes[opline_num-1].op2.zv), Z_STRLEN_P(op_array->opcodes[opline_num-1].op2.zv), &pce TSRMLS_CC) == SUCCESS) {
+				do_bind_inherited_class(op_array, &op_array->opcodes[opline_num], EG(class_table), *pce, 0 TSRMLS_CC);
 			}
-			opline_num = op_array->opcodes[opline_num].result.u.opline_num;
+			opline_num = op_array->opcodes[opline_num].result.opline_num;
 		}
 		CG(in_compilation) = orig_in_compilation;
 	}
@@ -3118,17 +3281,17 @@
 
 	opline->opcode = ZEND_JMPNZ_EX;
 	if (expr1->op_type == IS_TMP_VAR) {
-		opline->result = *expr1;
+		SET_NODE(opline->result, expr1);
 	} else {
-		opline->result.u.var = get_temporary_variable(CG(active_op_array));
-		opline->result.op_type = IS_TMP_VAR;
+		opline->result.var = get_temporary_variable(CG(active_op_array));
+		opline->result_type = IS_TMP_VAR;
 	}
-	opline->op1 = *expr1;
+	SET_NODE(opline->op1, expr1);
 	SET_UNUSED(opline->op2);
 
-	op_token->u.opline_num = next_op_number;
+	op_token->u.op.opline_num = next_op_number;
 
-	*expr1 = opline->result;
+	GET_NODE(expr1, opline->result);
 }
 /* }}} */
 
@@ -3138,11 +3301,11 @@
 
 	*result = *expr1; /* we saved the original result in expr1 */
 	opline->opcode = ZEND_BOOL;
-	opline->result = *result;
-	opline->op1 = *expr2;
+	SET_NODE(opline->result, result);
+	SET_NODE(opline->op1, expr2);
 	SET_UNUSED(opline->op2);
 
-	CG(active_op_array)->opcodes[op_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array));
+	CG(active_op_array)->opcodes[op_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array));
 }
 /* }}} */
 
@@ -3153,17 +3316,17 @@
 
 	opline->opcode = ZEND_JMPZ_EX;
 	if (expr1->op_type == IS_TMP_VAR) {
-		opline->result = *expr1;
+		SET_NODE(opline->result, expr1);
 	} else {
-		opline->result.u.var = get_temporary_variable(CG(active_op_array));
-		opline->result.op_type = IS_TMP_VAR;
+		opline->result.var = get_temporary_variable(CG(active_op_array));
+		opline->result_type = IS_TMP_VAR;
 	}
-	opline->op1 = *expr1;
+	SET_NODE(opline->op1, expr1);
 	SET_UNUSED(opline->op2);
 
-	op_token->u.opline_num = next_op_number;
+	op_token->u.op.opline_num = next_op_number;
 
-	*expr1 = opline->result;
+	GET_NODE(expr1, opline->result);
 }
 /* }}} */
 
@@ -3173,11 +3336,11 @@
 
 	*result = *expr1; /* we saved the original result in expr1 */
 	opline->opcode = ZEND_BOOL;
-	opline->result = *result;
-	opline->op1 = *expr2;
+	SET_NODE(opline->result, result);
+	SET_NODE(opline->op1, expr2);
 	SET_UNUSED(opline->op2);
 
-	CG(active_op_array)->opcodes[op_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array));
+	CG(active_op_array)->opcodes[op_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array));
 }
 /* }}} */
 
@@ -3193,11 +3356,11 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMPNZ;
-	opline->op1 = *expr;
-	opline->op2.u.opline_num = do_token->u.opline_num;
+	SET_NODE(opline->op1, expr);
+	opline->op2.opline_num = do_token->u.op.opline_num;
 	SET_UNUSED(opline->op2);
 
-	do_end_loop(expr_open_bracket->u.opline_num, 0 TSRMLS_CC);
+	do_end_loop(expr_open_bracket->u.op.opline_num, 0 TSRMLS_CC);
 
 	DEC_BPC(CG(active_op_array));
 }
@@ -3208,15 +3371,13 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = op;
-	opline->op1.u.opline_num = CG(active_op_array)->current_brk_cont;
+	opline->op1.opline_num = CG(active_op_array)->current_brk_cont;
 	SET_UNUSED(opline->op1);
 	if (expr) {
-		opline->op2 = *expr;
+		SET_NODE(opline->op2, expr);
 	} else {
-		Z_TYPE(opline->op2.u.constant) = IS_LONG;
-		Z_LVAL(opline->op2.u.constant) = 1;
-		INIT_PZVAL(&opline->op2.u.constant);
-		opline->op2.op_type = IS_CONST;
+		LITERAL_LONG(opline->op2, 1);
+		opline->op2_type = IS_CONST;
 	}
 }
 /* }}} */
@@ -3249,13 +3410,13 @@
 		opline->opcode = ZEND_JMP;
 		SET_UNUSED(opline->op1);
 		SET_UNUSED(opline->op2);
-		opline->op1.u.opline_num = switch_entry_ptr->default_case;
+		opline->op1.opline_num = switch_entry_ptr->default_case;
 	}
 
 	if (case_list->op_type != IS_UNUSED) { /* non-empty switch */
 		int next_op_number = get_next_op_number(CG(active_op_array));
-
-		CG(active_op_array)->opcodes[case_list->u.opline_num].op1.u.opline_num = next_op_number;
+		           	
+		CG(active_op_array)->opcodes[case_list->u.op.opline_num].op1.opline_num = next_op_number;
 	}
 
 	/* remember break/continue loop information */
@@ -3266,7 +3427,7 @@
 		/* emit free for the switch condition*/
 		opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 		opline->opcode = (switch_entry_ptr->cond.op_type == IS_TMP_VAR) ? ZEND_FREE : ZEND_SWITCH_FREE;
-		opline->op1 = switch_entry_ptr->cond;
+		SET_NODE(opline->op1, &switch_entry_ptr->cond);
 		SET_UNUSED(opline->op2);
 	}
 	if (switch_entry_ptr->cond.op_type == IS_CONST) {
@@ -3292,27 +3453,27 @@
 		switch_entry_ptr->control_var = get_temporary_variable(CG(active_op_array));
 	}
 	opline->opcode = ZEND_CASE;
-	opline->result.u.var = switch_entry_ptr->control_var;
-	opline->result.op_type = IS_TMP_VAR;
-	opline->op1 = switch_entry_ptr->cond;
-	opline->op2 = *case_expr;
-	if (opline->op1.op_type == IS_CONST) {
-		zval_copy_ctor(&opline->op1.u.constant);
+	opline->result.var = switch_entry_ptr->control_var;
+	opline->result_type = IS_TMP_VAR;
+	SET_NODE(opline->op1, &switch_entry_ptr->cond);
+	SET_NODE(opline->op2, case_expr);
+	if (opline->op1_type == IS_CONST) {
+		zval_copy_ctor(&CONSTANT(opline->op1.constant));
 	}
-	result = opline->result;
+	GET_NODE(&result, opline->result);
 
 	next_op_number = get_next_op_number(CG(active_op_array));
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_JMPZ;
-	opline->op1 = result;
+	SET_NODE(opline->op1, &result);
 	SET_UNUSED(opline->op2);
-	case_token->u.opline_num = next_op_number;
+	case_token->u.op.opline_num = next_op_number;
 
 	if (case_list->op_type==IS_UNUSED) {
 		return;
 	}
 	next_op_number = get_next_op_number(CG(active_op_array));
-	CG(active_op_array)->opcodes[case_list->u.opline_num].op1.u.opline_num = next_op_number;
+	CG(active_op_array)->opcodes[case_list->u.op.opline_num].op1.opline_num = next_op_number;
 }
 /* }}} */
 
@@ -3324,14 +3485,14 @@
 	opline->opcode = ZEND_JMP;
 	SET_UNUSED(opline->op1);
 	SET_UNUSED(opline->op2);
-	result->u.opline_num = next_op_number;
+	result->u.op.opline_num = next_op_number;
 
-	switch (CG(active_op_array)->opcodes[case_token->u.opline_num].opcode) {
+	switch (CG(active_op_array)->opcodes[case_token->u.op.opline_num].opcode) {
 		case ZEND_JMP:
-			CG(active_op_array)->opcodes[case_token->u.opline_num].op1.u.opline_num = get_next_op_number(CG(active_op_array));
+			CG(active_op_array)->opcodes[case_token->u.op.opline_num].op1.opline_num = get_next_op_number(CG(active_op_array));
 			break;
 		case ZEND_JMPZ:
-			CG(active_op_array)->opcodes[case_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array));
+			CG(active_op_array)->opcodes[case_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array));
 			break;
 	}
 }
@@ -3348,7 +3509,7 @@
 	opline->opcode = ZEND_JMP;
 	SET_UNUSED(opline->op1);
 	SET_UNUSED(opline->op2);
-	default_token->u.opline_num = next_op_number;
+	default_token->u.op.opline_num = next_op_number;
 
 	next_op_number = get_next_op_number(CG(active_op_array));
 	switch_entry_ptr->default_case = next_op_number;
@@ -3356,7 +3517,7 @@
 	if (case_list->op_type==IS_UNUSED) {
 		return;
 	}
-	CG(active_op_array)->opcodes[case_list->u.opline_num].op1.u.opline_num = next_op_number;
+	CG(active_op_array)->opcodes[case_list->u.op.opline_num].op1.opline_num = next_op_number;
 }
 /* }}} */
 
@@ -3367,7 +3528,7 @@
 	zend_class_entry *new_class_entry;
 	char *lcname;
 	int error = 0;
-	zval **ns_name;
+	zval **ns_name, key;
 
 	if (CG(active_class_entry)) {
 		zend_error(E_COMPILE_ERROR, "Class declarations may not be nested");
@@ -3416,11 +3577,11 @@
 
 	zend_initialize_class_data(new_class_entry, 1 TSRMLS_CC);
 	new_class_entry->filename = zend_get_compiled_filename(TSRMLS_C);
-	new_class_entry->line_start = class_token->u.opline_num;
-	new_class_entry->ce_flags |= class_token->u.EA.type;
+	new_class_entry->line_start = class_token->u.op.opline_num;
+	new_class_entry->ce_flags |= class_token->EA;
 
 	if (parent_class_name && parent_class_name->op_type != IS_UNUSED) {
-		switch (parent_class_name->u.EA.type) {
+		switch (parent_class_name->EA) {
 			case ZEND_FETCH_CLASS_SELF:
 				zend_error(E_COMPILE_ERROR, "Cannot use 'self' as class name as it is reserved");
 				break;
@@ -3437,29 +3598,29 @@
 	}
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
-	opline->op1.op_type = IS_CONST;
-	build_runtime_defined_function_key(&opline->op1.u.constant, lcname, new_class_entry->name_length TSRMLS_CC);
+	opline->op1_type = IS_CONST;
+	build_runtime_defined_function_key(&key, lcname, new_class_entry->name_length TSRMLS_CC);
+	opline->op1.constant = zend_add_literal(CG(active_op_array), &key);
+	Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant)));
 	
-	opline->op2.op_type = IS_CONST;
-	opline->op2.u.constant.type = IS_STRING;
-	Z_SET_REFCOUNT(opline->op2.u.constant, 1);
+	opline->op2_type = IS_CONST;
 
 	if (doing_inheritance) {
-		opline->extended_value = parent_class_name->u.var;
+		opline->extended_value = parent_class_name->u.op.var;
 		opline->opcode = ZEND_DECLARE_INHERITED_CLASS;
 	} else {
 		opline->opcode = ZEND_DECLARE_CLASS;
 	}
 
-	opline->op2.u.constant.value.str.val = lcname;
-	opline->op2.u.constant.value.str.len = new_class_entry->name_length;
+	LITERAL_STRINGL(opline->op2, lcname, new_class_entry->name_length, 0);
+	Z_HASH_P(&CONSTANT(opline->op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))+1);
 	
-	zend_hash_update(CG(class_table), opline->op1.u.constant.value.str.val, opline->op1.u.constant.value.str.len, &new_class_entry, sizeof(zend_class_entry *), NULL);
+	zend_hash_quick_update(CG(class_table), Z_STRVAL(key), Z_STRLEN(key), Z_HASH_P(&CONSTANT(opline->op1.constant)), &new_class_entry, sizeof(zend_class_entry *), NULL);
 	CG(active_class_entry) = new_class_entry;
 
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->result.op_type = IS_VAR;
-	CG(implementing_class) = opline->result;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	opline->result_type = IS_VAR;
+	GET_NODE(&CG(implementing_class), opline->result);
 
 	if (CG(doc_comment)) {
 		CG(active_class_entry)->doc_comment = CG(doc_comment);
@@ -3475,7 +3636,7 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_VERIFY_ABSTRACT_CLASS;
-	opline->op1 = CG(implementing_class);
+	SET_NODE(opline->op1, &CG(implementing_class));
 	SET_UNUSED(opline->op2);
 }
 /* }}} */
@@ -3541,10 +3702,11 @@
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_ADD_INTERFACE;
-	opline->op1 = CG(implementing_class);
+	SET_NODE(opline->op1, &CG(implementing_class));
 	zend_resolve_class_name(interface_name, &opline->extended_value, 0 TSRMLS_CC);
 	opline->extended_value = (opline->extended_value & ~ZEND_FETCH_CLASS_MASK) | ZEND_FETCH_CLASS_INTERFACE;
-	opline->op2 = *interface_name;
+	SET_NODE(opline->op2, interface_name);
+	add_lowercased_class_name(opline->op2.constant TSRMLS_CC);
 	CG(active_class_entry)->num_interfaces++;
 }
 /* }}} */
@@ -3680,17 +3842,17 @@
 	zend_stack_top(&CG(bp_stack), (void **) &fetch_list_ptr);
 
 	if (object->op_type == IS_CV) {
-		if (object->u.var == CG(active_op_array)->this_var) {
-		    SET_UNUSED(*object); /* this means $this for objects */
+		if (object->u.op.var == CG(active_op_array)->this_var) {
+			object->op_type = IS_UNUSED; /* this means $this for objects */
 	    }
 	} else if (fetch_list_ptr->count == 1) {
 		zend_llist_element *le = fetch_list_ptr->head;
 		zend_op *opline_ptr = (zend_op *) le->data;
 
 		if (opline_is_fetch_this(opline_ptr TSRMLS_CC)) {
-			efree(Z_STRVAL(opline_ptr->op1.u.constant));
+			zend_del_literal(CG(active_op_array), opline_ptr->op1.constant);
 			SET_UNUSED(opline_ptr->op1); /* this means $this for objects */
-			opline_ptr->op2 = *property;
+			SET_NODE(opline_ptr->op2, property);
 			/* if it was usual fetch, we change it to object fetch */
 			switch (opline_ptr->opcode) {
 				case ZEND_FETCH_W:
@@ -3712,19 +3874,24 @@
 					opline_ptr->opcode = ZEND_FETCH_OBJ_FUNC_ARG;
 					break;
 			}
-			*result = opline_ptr->result;
+			if (opline_ptr->op2_type == IS_CONST && Z_TYPE(CONSTANT(opline_ptr->op2.constant)) == IS_STRING) {
+				Z_HASH_P(&CONSTANT(opline_ptr->op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline_ptr->op2.constant)), Z_STRLEN(CONSTANT(opline_ptr->op2.constant))+1);
+			}
+			GET_NODE(result, opline_ptr->result);
 			return;
 		}
 	}
 
 	init_op(&opline TSRMLS_CC);
 	opline.opcode = ZEND_FETCH_OBJ_W;	/* the backpatching routine assumes W */
-	opline.result.op_type = IS_VAR;
-	opline.result.u.EA.type = 0;
-	opline.result.u.var = get_temporary_variable(CG(active_op_array));
-	opline.op1 = *object;
-	opline.op2 = *property;
-	*result = opline.result;
+	opline.result_type = IS_VAR;
+	opline.result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline.op1, object);
+	SET_NODE(opline.op2, property);
+	if (opline.op2_type == IS_CONST && Z_TYPE(CONSTANT(opline.op2.constant)) == IS_STRING) {
+		Z_HASH_P(&CONSTANT(opline.op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline.op2.constant)), Z_STRLEN(CONSTANT(opline.op2.constant))+1);
+	}
+	GET_NODE(result, opline.result);
 
 	zend_llist_add_element(fetch_list_ptr, &opline);
 }
@@ -3743,40 +3910,6 @@
 }
 /* }}} */
 
-void zend_do_declare_implicit_property(TSRMLS_D) /* {{{ */
-{
-/* Fixes bug #26182. Not sure why we needed to do this in the first place.
-   Has to be checked with Zeev.
-*/
-#if ANDI_0
-	zend_op *opline_ptr;
-	zend_llist_element *le;
-	zend_llist *fetch_list_ptr;
-
-
-	zend_stack_top(&CG(bp_stack), (void **) &fetch_list_ptr);
-
-	if (fetch_list_ptr->count != 1) {
-		return;
-	}
-
-	le = fetch_list_ptr->head;
-	opline_ptr = (zend_op *) le->data;
-
-	if (opline_ptr->op1.op_type == IS_UNUSED
-		&& CG(active_class_entry)
-		&& opline_ptr->op2.op_type == IS_CONST
-		&& !zend_hash_exists(&CG(active_class_entry)->properties_info, opline_ptr->op2.u.constant.value.str.val, opline_ptr->op2.u.constant.value.str.len+1)) {
-		znode property;
-
-		property = opline_ptr->op2;
-		property.u.constant.value.str.val = estrndup(opline_ptr->op2.u.constant.value.str.val, opline_ptr->op2.u.constant.value.str.len);
-		zend_do_declare_property(&property, NULL, ZEND_ACC_PUBLIC|ZEND_ACC_IMPLICIT_PUBLIC TSRMLS_CC);
-	}
-#endif
-}
-/* }}} */
-
 void zend_do_push_object(const znode *object TSRMLS_DC) /* {{{ */
 {
 	zend_stack_push(&CG(object_stack), object, sizeof(znode));
@@ -3800,12 +3933,12 @@
 	zend_op *opline;
 	unsigned char *ptr = NULL;
 
-	new_token->u.opline_num = get_next_op_number(CG(active_op_array));
+	new_token->u.op.opline_num = get_next_op_number(CG(active_op_array));
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_NEW;
-	opline->result.op_type = IS_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *class_type;
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, class_type);
 	SET_UNUSED(opline->op2);
 
 	zend_stack_push(&CG(function_call_stack), (void *) &ptr, sizeof(unsigned char *));
@@ -3819,8 +3952,8 @@
 	zend_do_end_function_call(NULL, &ctor_result, argument_list, 1, 0 TSRMLS_CC);
 	zend_do_free(&ctor_result TSRMLS_CC);
 
-	CG(active_op_array)->opcodes[new_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array));
-	*result = CG(active_op_array)->opcodes[new_token->u.opline_num].result;
+	CG(active_op_array)->opcodes[new_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array));
+	GET_NODE(result, CG(active_op_array)->opcodes[new_token->u.op.opline_num].result);
 }
 /* }}} */
 
@@ -3916,11 +4049,15 @@
 				}
 				opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 				opline->opcode = ZEND_FETCH_CONSTANT;
-				opline->result.op_type = IS_TMP_VAR;
-				opline->result.u.var = get_temporary_variable(CG(active_op_array));
-				opline->op1 = *constant_container;
-				opline->op2 = *constant_name;
-				*result = opline->result;
+				opline->result_type = IS_TMP_VAR;
+				opline->result.var = get_temporary_variable(CG(active_op_array));
+				SET_NODE(opline->op1, constant_container);
+				if (opline->op1_type == IS_CONST) {
+					add_lowercased_class_name(opline->op1.constant TSRMLS_CC);
+				}
+				SET_NODE(opline->op2, constant_name);
+				Z_HASH_P(&CONSTANT(opline->op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))+1);
+				GET_NODE(result, opline->result);
 				break;
 		}
 		return;
@@ -3956,9 +4093,9 @@
 
 			opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 			opline->opcode = ZEND_FETCH_CONSTANT;
-			opline->result.op_type = IS_TMP_VAR;
-			opline->result.u.var = get_temporary_variable(CG(active_op_array));
-			*result = opline->result;
+			opline->result_type = IS_TMP_VAR;
+			opline->result.var = get_temporary_variable(CG(active_op_array));
+			GET_NODE(result, opline->result);
 			SET_UNUSED(opline->op1);
 			if(compound) {
 				/* the name is unambiguous */
@@ -3966,7 +4103,8 @@
 			} else {
 				opline->extended_value = IS_CONSTANT_UNQUALIFIED;
 			}
-			opline->op2 = *constant_name;
+			SET_NODE(opline->op2, constant_name);
+			Z_HASH_P(&CONSTANT(opline->op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))+1);
 			break;
 	}
 }
@@ -3985,25 +4123,22 @@
 			opline->opcode = ZEND_SEND_VAR;
 			break;
 	}
-	opline->op1 = *cmd;
-	opline->op2.u.opline_num = 0;
+	SET_NODE(opline->op1, cmd);
+	opline->op2.opline_num = 0;
 	opline->extended_value = ZEND_DO_FCALL;
 	SET_UNUSED(opline->op2);
 
 	/* FIXME: exception support not added to this op2 */
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_DO_FCALL;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->result.op_type = IS_VAR;
-	Z_STRVAL(opline->op1.u.constant) = estrndup("shell_exec", sizeof("shell_exec")-1);
-	Z_STRLEN(opline->op1.u.constant) = sizeof("shell_exec")-1;
-	INIT_PZVAL(&opline->op1.u.constant);
-	Z_TYPE(opline->op1.u.constant) = IS_STRING;
-	opline->op1.op_type = IS_CONST;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	opline->result_type = IS_VAR;
+	LITERAL_STRINGL(opline->op1, estrndup("shell_exec", sizeof("shell_exec")-1), sizeof("shell_exec")-1, 0);
+	Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant))+1);
+	opline->op1_type = IS_CONST;
 	opline->extended_value = 1;
 	SET_UNUSED(opline->op2);
-	ZVAL_LONG(&opline->op2.u.constant, zend_hash_func("shell_exec", sizeof("shell_exec")));
-	*result = opline->result;
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -4012,13 +4147,25 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_INIT_ARRAY;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->result.op_type = IS_TMP_VAR;
-	*result = opline->result;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	opline->result_type = IS_TMP_VAR;
+	GET_NODE(result, opline->result);
 	if (expr) {
-		opline->op1 = *expr;
+		SET_NODE(opline->op1, expr);
 		if (offset) {
-			opline->op2 = *offset;
+			SET_NODE(opline->op2, offset);
+			if (opline->op2_type == IS_CONST && Z_TYPE(CONSTANT(opline->op2.constant)) == IS_STRING) {
+				long index;
+				int numeric = 0;
+
+				ZEND_HANDLE_NUMERIC_EX(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))+1, index, numeric = 1);
+				if (numeric) {
+					zval_dtor(&CONSTANT(opline->op2.constant));
+					ZVAL_LONG(&CONSTANT(opline->op2.constant), index); 
+				} else {
+					Z_HASH_P(&CONSTANT(opline->op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))+1);
+				}
+			}
 		} else {
 			SET_UNUSED(opline->op2);
 		}
@@ -4035,10 +4182,22 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_ADD_ARRAY_ELEMENT;
-	opline->result = *result;
-	opline->op1 = *expr;
+	SET_NODE(opline->result, result);
+	SET_NODE(opline->op1, expr);
 	if (offset) {
-		opline->op2 = *offset;
+		SET_NODE(opline->op2, offset);
+		if (opline->op2_type == IS_CONST && Z_TYPE(CONSTANT(opline->op2.constant)) == IS_STRING) {
+			long index;
+			int numeric = 0;
+
+			ZEND_HANDLE_NUMERIC_EX(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))+1, index, numeric = 1);
+			if (numeric) {
+				zval_dtor(&CONSTANT(opline->op2.constant));
+				ZVAL_LONG(&CONSTANT(opline->op2.constant), index); 
+			} else {
+				Z_HASH_P(&CONSTANT(opline->op2.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op2.constant)), Z_STRLEN(CONSTANT(opline->op2.constant))+1);
+			}
+		}
 	} else {
 		SET_UNUSED(opline->op2);
 	}
@@ -4154,19 +4313,16 @@
 						opline->opcode = ZEND_FETCH_DIM_TMP_VAR;
 						break;
 				}
-				opline->extended_value = ZEND_FETCH_ADD_LOCK;
+				opline->extended_value |= ZEND_FETCH_ADD_LOCK;
 			} else {
 				opline->opcode = ZEND_FETCH_DIM_R;
 			}
-			opline->result.op_type = IS_VAR;
-			opline->result.u.EA.type = 0;
-			opline->result.u.var = get_temporary_variable(CG(active_op_array));
-			opline->op1 = last_container;
-			opline->op2.op_type = IS_CONST;
-			Z_TYPE(opline->op2.u.constant) = IS_LONG;
-			Z_LVAL(opline->op2.u.constant) = *((int *) dimension->data);
-			INIT_PZVAL(&opline->op2.u.constant);
-			last_container = opline->result;
+			opline->result_type = IS_VAR;
+			opline->result.var = get_temporary_variable(CG(active_op_array));
+			SET_NODE(opline->op1, &last_container);
+			opline->op2_type = IS_CONST;
+			LITERAL_LONG(opline->op2, *((int *) dimension->data));
+			GET_NODE(&last_container, opline->result);
 			dimension = dimension->next;
 		}
 		((list_llist_element *) le->data)->value = last_container;
@@ -4220,13 +4376,15 @@
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = (fetch_type == ZEND_FETCH_LEXICAL) ? ZEND_FETCH_R : ZEND_FETCH_W;		/* the default mode must be Write, since fetch_simple_variable() is used to define function arguments */
-	opline->result.op_type = IS_VAR;
-	opline->result.u.EA.type = 0;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *varname;
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, varname);
+	if (opline->op1_type == IS_CONST) {
+		Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant))+1);
+	}
 	SET_UNUSED(opline->op2);
-	opline->op2.u.EA.type = ZEND_FETCH_STATIC;
-	result = opline->result;
+	opline->extended_value = ZEND_FETCH_STATIC;
+	GET_NODE(&result, opline->result);
 
 	if (varname->op_type == IS_CONST) {
 		zval_copy_ctor(&varname->u.constant);
@@ -4242,9 +4400,7 @@
 	} else {
 		zend_do_assign_ref(NULL, &lval, &result TSRMLS_CC);
 	}
-	CG(active_op_array)->opcodes[CG(active_op_array)->last-1].result.u.EA.type |= EXT_TYPE_UNUSED;
-
-/*	zval_dtor(&varname->u.constant); */
+	CG(active_op_array)->opcodes[CG(active_op_array)->last-1].result_type |= EXT_TYPE_UNUSED;
 }
 /* }}} */
 
@@ -4282,13 +4438,15 @@
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_FETCH_W;		/* the default mode must be Write, since fetch_simple_variable() is used to define function arguments */
-	opline->result.op_type = IS_VAR;
-	opline->result.u.EA.type = 0;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *varname;
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, varname);
+	if (opline->op1_type == IS_CONST) {
+		Z_HASH_P(&CONSTANT(opline->op1.constant)) = zend_hash_func(Z_STRVAL(CONSTANT(opline->op1.constant)), Z_STRLEN(CONSTANT(opline->op1.constant))+1);
+	}
 	SET_UNUSED(opline->op2);
-	opline->op2.u.EA.type = fetch_type;
-	result = opline->result;
+	opline->extended_value = fetch_type;
+	GET_NODE(&result, opline->result);
 
 	if (varname->op_type == IS_CONST) {
 		zval_copy_ctor(&varname->u.constant);
@@ -4296,7 +4454,7 @@
 	fetch_simple_variable(&lval, varname, 0 TSRMLS_CC); /* Relies on the fact that the default fetch is BP_VAR_W */
 
 	zend_do_assign_ref(NULL, &lval, &result TSRMLS_CC);
-	CG(active_op_array)->opcodes[CG(active_op_array)->last-1].result.u.EA.type |= EXT_TYPE_UNUSED;
+	CG(active_op_array)->opcodes[CG(active_op_array)->last-1].result_type |= EXT_TYPE_UNUSED;
 }
 /* }}} */
 
@@ -4305,12 +4463,12 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_CAST;
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *expr;
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, expr);
 	SET_UNUSED(opline->op2);
 	opline->extended_value = type;
-	*result = opline->result;
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -4321,12 +4479,12 @@
 		zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 		opline->opcode = ZEND_INCLUDE_OR_EVAL;
-		opline->result.op_type = IS_VAR;
-		opline->result.u.var = get_temporary_variable(CG(active_op_array));
-		opline->op1 = *op1;
+		opline->result_type = IS_VAR;
+		opline->result.var = get_temporary_variable(CG(active_op_array));
+		SET_NODE(opline->op1, op1);
 		SET_UNUSED(opline->op2);
-		Z_LVAL(opline->op2.u.constant) = type;
-		*result = opline->result;
+		opline->extended_value = type;
+		GET_NODE(result, opline->result);
 	}
 	zend_do_extended_fcall_end(TSRMLS_C);
 }
@@ -4355,11 +4513,10 @@
 	if (variable->op_type == IS_CV) {
 		zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 		opline->opcode = ZEND_UNSET_VAR;
-		opline->op1 = *variable;
+		SET_NODE(opline->op1, variable);
 		SET_UNUSED(opline->op2);
-		opline->op2.u.EA.type = ZEND_FETCH_LOCAL;
 		SET_UNUSED(opline->result);
-		opline->extended_value = ZEND_QUICK_SET;
+		opline->extended_value = ZEND_FETCH_LOCAL | ZEND_QUICK_SET;
 	} else {
 		last_op = &CG(active_op_array)->opcodes[get_next_op_number(CG(active_op_array))-1];
 
@@ -4390,11 +4547,10 @@
 	if (variable->op_type == IS_CV) {
 		last_op = get_next_op(CG(active_op_array) TSRMLS_CC);
 		last_op->opcode = ZEND_ISSET_ISEMPTY_VAR;
-		last_op->op1 = *variable;
+		SET_NODE(last_op->op1, variable);
 		SET_UNUSED(last_op->op2);
-		last_op->op2.u.EA.type = ZEND_FETCH_LOCAL;
-		last_op->result.u.var = get_temporary_variable(CG(active_op_array));
-		last_op->extended_value = ZEND_QUICK_SET;
+		last_op->result.var = get_temporary_variable(CG(active_op_array));
+		last_op->extended_value = ZEND_FETCH_LOCAL | ZEND_QUICK_SET;
 	} else {
 		last_op = &CG(active_op_array)->opcodes[get_next_op_number(CG(active_op_array))-1];
 
@@ -4409,12 +4565,11 @@
 				last_op->opcode = ZEND_ISSET_ISEMPTY_PROP_OBJ;
 				break;
 		}
-		last_op->extended_value = 0;
 	}
-	last_op->result.op_type = IS_TMP_VAR;
+	last_op->result_type = IS_TMP_VAR;
 	last_op->extended_value |= type;
 
-	*result = last_op->result;
+	GET_NODE(result, last_op->result);
 }
 /* }}} */
 
@@ -4436,13 +4591,13 @@
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_INSTANCEOF;
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *expr;
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, expr);
 
-	opline->op2 = *class_znode;
+	SET_NODE(opline->op2, class_znode);
 
-	*result = opline->result;
+	GET_NODE(result, opline->result);
 }
 /* }}} */
 
@@ -4460,53 +4615,50 @@
 			is_variable = 1;
 		}
 		/* save the location of FETCH_W instruction(s) */
-		open_brackets_token->u.opline_num = get_next_op_number(CG(active_op_array));
+		open_brackets_token->u.op.opline_num = get_next_op_number(CG(active_op_array));
 		zend_do_end_variable_parse(array, BP_VAR_W, 0 TSRMLS_CC);
 		if (CG(active_op_array)->last > 0 &&
 		    CG(active_op_array)->opcodes[CG(active_op_array)->last-1].opcode == ZEND_FETCH_OBJ_W) {
 			/* Only lock the container if we are fetching from a real container and not $this */
-			if (CG(active_op_array)->opcodes[CG(active_op_array)->last-1].op1.op_type == IS_VAR) {
+			if (CG(active_op_array)->opcodes[CG(active_op_array)->last-1].op1_type == IS_VAR) {
 				CG(active_op_array)->opcodes[CG(active_op_array)->last-1].extended_value |= ZEND_FETCH_ADD_LOCK;
 				push_container = 1;
 			}
 		}
 	} else {
 		is_variable = 0;
-		open_brackets_token->u.opline_num = get_next_op_number(CG(active_op_array));
+		open_brackets_token->u.op.opline_num = get_next_op_number(CG(active_op_array));
 	}
 
 	/* save the location of FE_RESET */
-	foreach_token->u.opline_num = get_next_op_number(CG(active_op_array));
+	foreach_token->u.op.opline_num = get_next_op_number(CG(active_op_array));
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	/* Preform array reset */
 	opline->opcode = ZEND_FE_RESET;
-	opline->result.op_type = IS_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *array;
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, array);
 	SET_UNUSED(opline->op2);
 	opline->extended_value = is_variable ? ZEND_FE_RESET_VARIABLE : 0;
 
-	dummy_opline.result = opline->result;
+	COPY_NODE(dummy_opline.result, opline->result);
 	if (push_container) {
-		dummy_opline.op1 = CG(active_op_array)->opcodes[CG(active_op_array)->last-2].op1;
+		COPY_NODE(dummy_opline.op1, CG(active_op_array)->opcodes[CG(active_op_array)->last-2].op1);
 	} else {
-		znode tmp;
-
-		tmp.op_type = IS_UNUSED;
-		dummy_opline.op1 = tmp;
+		dummy_opline.op1_type = IS_UNUSED;
 	}
 	zend_stack_push(&CG(foreach_copy_stack), (void *) &dummy_opline, sizeof(zend_op));
 
 	/* save the location of FE_FETCH */
-	as_token->u.opline_num = get_next_op_number(CG(active_op_array));
+	as_token->u.op.opline_num = get_next_op_number(CG(active_op_array));
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_FE_FETCH;
-	opline->result.op_type = IS_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = dummy_opline.result;
+	opline->result_type = IS_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	COPY_NODE(opline->op1, dummy_opline.result);
 	opline->extended_value = 0;
 	SET_UNUSED(opline->op2);
 
@@ -4524,7 +4676,7 @@
 	znode dummy, value_node;
 	zend_bool assign_by_ref=0;
 
-	opline = &CG(active_op_array)->opcodes[as_token->u.opline_num];
+	opline = &CG(active_op_array)->opcodes[as_token->u.op.	opline_num];
 	if (key->op_type != IS_UNUSED) {
 		znode *tmp;
 
@@ -4537,38 +4689,38 @@
 		opline->extended_value |= ZEND_FE_FETCH_WITH_KEY;
 	}
 
-	if ((key->op_type != IS_UNUSED) && (key->u.EA.type & ZEND_PARSED_REFERENCE_VARIABLE)) {
+	if ((key->op_type != IS_UNUSED) && (key->EA & ZEND_PARSED_REFERENCE_VARIABLE)) {
 		zend_error(E_COMPILE_ERROR, "Key element cannot be a reference");
 	}
 
-	if (value->u.EA.type & ZEND_PARSED_REFERENCE_VARIABLE) {
+	if (value->EA & ZEND_PARSED_REFERENCE_VARIABLE) {
 		assign_by_ref = 1;
 		if (!(opline-1)->extended_value) {
 			zend_error(E_COMPILE_ERROR, "Cannot create references to elements of a temporary array expression");
 		}
 		/* Mark extended_value for assign-by-reference */
 		opline->extended_value |= ZEND_FE_FETCH_BYREF;
-		CG(active_op_array)->opcodes[foreach_token->u.opline_num].extended_value |= ZEND_FE_RESET_REFERENCE;
+		CG(active_op_array)->opcodes[foreach_token->u.op.opline_num].extended_value |= ZEND_FE_RESET_REFERENCE;
 	} else {
 		zend_op *foreach_copy;
-		zend_op *fetch = &CG(active_op_array)->opcodes[foreach_token->u.opline_num];
-		zend_op	*end = &CG(active_op_array)->opcodes[open_brackets_token->u.opline_num];
+		zend_op *fetch = &CG(active_op_array)->opcodes[foreach_token->u.op.opline_num];
+		zend_op	*end = &CG(active_op_array)->opcodes[open_brackets_token->u.op.opline_num];
 
 		/* Change "write context" into "read context" */
 		fetch->extended_value = 0;  /* reset ZEND_FE_RESET_VARIABLE */
 		while (fetch != end) {
 			--fetch;
-			if (fetch->opcode == ZEND_FETCH_DIM_W && fetch->op2.op_type == IS_UNUSED) {
+			if (fetch->opcode == ZEND_FETCH_DIM_W && fetch->op2_type == IS_UNUSED) {
 				zend_error(E_COMPILE_ERROR, "Cannot use [] for reading");
 			}
 			fetch->opcode -= 3; /* FETCH_W -> FETCH_R */
 		}
 		/* prevent double SWITCH_FREE */
 		zend_stack_top(&CG(foreach_copy_stack), (void **) &foreach_copy);
-		foreach_copy->op1.op_type = IS_UNUSED;
+		foreach_copy->op1_type = IS_UNUSED;
 	}
 
-	value_node = opline->result;
+	GET_NODE(&value_node, opline->result);
 
 	if (assign_by_ref) {
 		zend_do_end_variable_parse(value, BP_VAR_W, 0 TSRMLS_CC);
@@ -4582,11 +4734,10 @@
 	if (key->op_type != IS_UNUSED) {
 		znode key_node;
 
-		opline = &CG(active_op_array)->opcodes[as_token->u.opline_num+1];
-		opline->result.op_type = IS_TMP_VAR;
-		opline->result.u.EA.type = 0;
-		opline->result.u.opline_num = get_temporary_variable(CG(active_op_array));
-		key_node = opline->result;
+		opline = &CG(active_op_array)->opcodes[as_token->u.op.opline_num+1];
+		opline->result_type = IS_TMP_VAR;
+		opline->result.opline_num = get_temporary_variable(CG(active_op_array));
+		GET_NODE(&key_node, opline->result);
 
 		zend_do_assign(&dummy, key, &key_node TSRMLS_CC);
 		zend_do_free(&dummy TSRMLS_CC);
@@ -4603,14 +4754,14 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMP;
-	opline->op1.u.opline_num = as_token->u.opline_num;
+	opline->op1.opline_num = as_token->u.op.opline_num;
 	SET_UNUSED(opline->op1);
 	SET_UNUSED(opline->op2);
 
-	CG(active_op_array)->opcodes[foreach_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array)); /* FE_RESET */
-	CG(active_op_array)->opcodes[as_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array)); /* FE_FETCH */
+	CG(active_op_array)->opcodes[foreach_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array)); /* FE_RESET */
+	CG(active_op_array)->opcodes[as_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array)); /* FE_FETCH */
 
-	do_end_loop(as_token->u.opline_num, 1 TSRMLS_CC);
+	do_end_loop(as_token->u.op.opline_num, 1 TSRMLS_CC);
 
 	zend_stack_top(&CG(foreach_copy_stack), (void **) &container_ptr);
 	generate_free_foreach_copy(container_ptr TSRMLS_CC);
@@ -4698,7 +4849,7 @@
 
 	zend_stack_top(&CG(declare_stack), (void **) &declarables);
 	/* We should restore if there was more than (current - start) - (ticks?1:0) opcodes */
-	if ((get_next_op_number(CG(active_op_array)) - declare_token->u.opline_num) - ((Z_LVAL(CG(declarables).ticks))?1:0)) {
+	if ((get_next_op_number(CG(active_op_array)) - declare_token->u.op.opline_num) - ((Z_LVAL(CG(declarables).ticks))?1:0)) {
 		CG(declarables) = *declarables;
 	}
 }
@@ -4709,7 +4860,7 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_EXIT;
-	opline->op1 = *message;
+	SET_NODE(opline->op1, message);
 	SET_UNUSED(opline->op2);
 
 	result->op_type = IS_CONST;
@@ -4723,11 +4874,11 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_BEGIN_SILENCE;
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
 	SET_UNUSED(opline->op1);
 	SET_UNUSED(opline->op2);
-	*strudel_token = opline->result;
+	GET_NODE(strudel_token, opline->result);
 }
 /* }}} */
 
@@ -4736,7 +4887,7 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_END_SILENCE;
-	opline->op1 = *strudel_token;
+	SET_NODE(opline->op1, strudel_token);
 	SET_UNUSED(opline->op2);
 }
 /* }}} */
@@ -4747,14 +4898,14 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMP_SET;
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *value;
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, value);
 	SET_UNUSED(opline->op2);
 	
-	*colon_token = opline->result;
+	GET_NODE(colon_token, opline->result);
 
-	jmp_token->u.opline_num = op_number;
+	jmp_token->u.op	.opline_num = op_number;
 
 	INC_BPC(CG(active_op_array));
 }
@@ -4766,13 +4917,13 @@
 
 	opline->opcode = ZEND_QM_ASSIGN;
 	opline->extended_value = 0;
-	opline->result = *colon_token;
-	opline->op1 = *false_value;
+	SET_NODE(opline->result, colon_token);
+	SET_NODE(opline->op1, false_value);
 	SET_UNUSED(opline->op2);
 	
-	*result = opline->result;
+	GET_NODE(result, opline->result);
 
-	CG(active_op_array)->opcodes[jmp_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array));
+	CG(active_op_array)->opcodes[jmp_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array));
 	
 	DEC_BPC(CG(active_op_array));
 }
@@ -4786,10 +4937,10 @@
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_JMPZ;
-	opline->op1 = *cond;
+	SET_NODE(opline->op1, cond);
 	SET_UNUSED(opline->op2);
-	opline->op2.u.opline_num = jmpz_op_number;
-	*qm_token = opline->op2;
+	opline->op2.opline_num = jmpz_op_number;
+	GET_NODE(qm_token, opline->op2);
 
 	INC_BPC(CG(active_op_array));
 }
@@ -4799,16 +4950,16 @@
 {
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
-	CG(active_op_array)->opcodes[qm_token->u.opline_num].op2.u.opline_num = get_next_op_number(CG(active_op_array))+1; /* jmp over the ZEND_JMP */
+	CG(active_op_array)->opcodes[qm_token->u.op.opline_num].op2.opline_num = get_next_op_number(CG(active_op_array))+1; /* jmp over the ZEND_JMP */
 
 	opline->opcode = ZEND_QM_ASSIGN;
-	opline->result.op_type = IS_TMP_VAR;
-	opline->result.u.var = get_temporary_variable(CG(active_op_array));
-	opline->op1 = *true_value;
+	opline->result_type = IS_TMP_VAR;
+	opline->result.var = get_temporary_variable(CG(active_op_array));
+	SET_NODE(opline->op1, true_value);
 	SET_UNUSED(opline->op2);
 
-	*qm_token = opline->result;
-	colon_token->u.opline_num = get_next_op_number(CG(active_op_array));
+	GET_NODE(qm_token, opline->result);
+	colon_token->u.op.opline_num = get_next_op_number(CG(active_op_array));
 
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_JMP;
@@ -4822,13 +4973,13 @@
 	zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 	opline->opcode = ZEND_QM_ASSIGN;
-	opline->result = *qm_token;
-	opline->op1 = *false_value;
+	SET_NODE(opline->result, qm_token);
+	SET_NODE(opline->op1, false_value);
 	SET_UNUSED(opline->op2);
 
-	CG(active_op_array)->opcodes[colon_token->u.opline_num].op1.u.opline_num = get_next_op_number(CG(active_op_array));
+	CG(active_op_array)->opcodes[colon_token->u.op.opline_num].op1.opline_num = get_next_op_number(CG(active_op_array));
 
-	*result = opline->result;
+	GET_NODE(result, opline->result);
 
 	DEC_BPC(CG(active_op_array));
 }
@@ -4888,9 +5039,9 @@
 		zend_op *opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 
 		opline->opcode = ZEND_TICKS;
-		opline->op1.u.constant = CG(declarables).ticks;
-		opline->op1.op_type = IS_CONST;
+		SET_UNUSED(opline->op1);
 		SET_UNUSED(opline->op2);
+		opline->extended_value = Z_LVAL(CG(declarables).ticks);
 	}
 }
 /* }}} */
@@ -5266,8 +5417,8 @@
 	opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	opline->opcode = ZEND_DECLARE_CONST;
 	SET_UNUSED(opline->result);
-	opline->op1 = *name;
-	opline->op2 = *value;
+	SET_NODE(opline->op1, name);
+	SET_NODE(opline->op2, value);
 }
 /* }}} */
 
Index: Zend/zend_object_handlers.h
===================================================================
--- Zend/zend_object_handlers.h	(revision 297868)
+++ Zend/zend_object_handlers.h	(working copy)
@@ -24,13 +24,14 @@
 
 union _zend_function;
 struct _zend_property_info;
+struct _zend_literal;
 
 /* The following rule applies to read_property() and read_dimension() implementations:
    If you return a zval which is not otherwise referenced by the extension or the engine's
    symbol table, its reference count should be 0.
 */
 /* Used to fetch property from the object, read-only */
-typedef zval *(*zend_object_read_property_t)(zval *object, zval *member, int type TSRMLS_DC);
+typedef zval *(*zend_object_read_property_t)(zval *object, zval *member, int type, const struct _zend_literal *key TSRMLS_DC);
 
 /* Used to fetch dimension from the object, read-only */
 typedef zval *(*zend_object_read_dimension_t)(zval *object, zval *offset, int type TSRMLS_DC);
@@ -42,14 +43,14 @@
    any changes.  You should NOT modify the reference count of the value passed to you.
 */
 /* Used to set property of the object */
-typedef void (*zend_object_write_property_t)(zval *object, zval *member, zval *value TSRMLS_DC);
+typedef void (*zend_object_write_property_t)(zval *object, zval *member, zval *value, const struct _zend_literal *key TSRMLS_DC);
 
 /* Used to set dimension of the object */
 typedef void (*zend_object_write_dimension_t)(zval *object, zval *offset, zval *value TSRMLS_DC);
 
 
 /* Used to create pointer to the property of the object, for future direct r/w access */
-typedef zval **(*zend_object_get_property_ptr_ptr_t)(zval *object, zval *member TSRMLS_DC);
+typedef zval **(*zend_object_get_property_ptr_ptr_t)(zval *object, zval *member, const struct _zend_literal *key TSRMLS_DC);
 
 /* Used to set object value. Can be used to override assignments and scalar
    write ops (like ++, +=) on the object */
@@ -66,13 +67,13 @@
  * 1 (set) whether property exists and is true
  * 2 (exists) whether property exists
  */
-typedef int (*zend_object_has_property_t)(zval *object, zval *member, int has_set_exists TSRMLS_DC);
+typedef int (*zend_object_has_property_t)(zval *object, zval *member, int has_set_exists, const struct _zend_literal *key TSRMLS_DC);
 
 /* Used to check if a dimension of the object exists */
 typedef int (*zend_object_has_dimension_t)(zval *object, zval *member, int check_empty TSRMLS_DC);
 
 /* Used to remove a property of the object */
-typedef void (*zend_object_unset_property_t)(zval *object, zval *member TSRMLS_DC);
+typedef void (*zend_object_unset_property_t)(zval *object, zval *member, const struct _zend_literal *key TSRMLS_DC);
 
 /* Used to remove a dimension of the object */
 typedef void (*zend_object_unset_dimension_t)(zval *object, zval *offset TSRMLS_DC);
@@ -87,7 +88,7 @@
 /* Andi - EX(fbc) (function being called) needs to be initialized already in the INIT fcall opcode so that the parameters can be parsed the right way. We need to add another callback for this.
  */
 typedef int (*zend_object_call_method_t)(char *method, INTERNAL_FUNCTION_PARAMETERS);
-typedef union _zend_function *(*zend_object_get_method_t)(zval **object_ptr, char *method, int method_len TSRMLS_DC);
+typedef union _zend_function *(*zend_object_get_method_t)(zval **object_ptr, char *method, int method_len, const struct _zend_literal *key TSRMLS_DC);
 typedef union _zend_function *(*zend_object_get_constructor_t)(zval *object TSRMLS_DC);
 
 /* Object maintenance/destruction */
@@ -143,9 +144,9 @@
 extern ZEND_API zend_object_handlers std_object_handlers;
 
 BEGIN_EXTERN_C()
-ZEND_API union _zend_function *zend_std_get_static_method(zend_class_entry *ce, char *function_name_strval, int function_name_strlen TSRMLS_DC);
-ZEND_API zval **zend_std_get_static_property(zend_class_entry *ce, char *property_name, int property_name_len, zend_bool silent TSRMLS_DC);
-ZEND_API zend_bool zend_std_unset_static_property(zend_class_entry *ce, char *property_name, int property_name_len TSRMLS_DC);
+ZEND_API union _zend_function *zend_std_get_static_method(zend_class_entry *ce, char *function_name_strval, int function_name_strlen, const struct _zend_literal *key TSRMLS_DC);
+ZEND_API zval **zend_std_get_static_property(zend_class_entry *ce, char *property_name, int property_name_len, zend_bool silent, const struct _zend_literal *key TSRMLS_DC);
+ZEND_API zend_bool zend_std_unset_static_property(zend_class_entry *ce, char *property_name, int property_name_len, const struct _zend_literal *key TSRMLS_DC);
 ZEND_API union _zend_function *zend_std_get_constructor(zval *object TSRMLS_DC);
 ZEND_API struct _zend_property_info *zend_get_property_info(zend_class_entry *ce, zval *member, int silent TSRMLS_DC);
 ZEND_API HashTable *zend_std_get_properties(zval *object TSRMLS_DC);
Index: Zend/zend_compile.h
===================================================================
--- Zend/zend_compile.h	(revision 297868)
+++ Zend/zend_compile.h	(working copy)
@@ -34,7 +34,7 @@
 
 #define FREE_PNODE(znode)	zval_dtor(&znode->u.constant);
 
-#define SET_UNUSED(op)  (op).op_type = IS_UNUSED
+#define SET_UNUSED(op)  op ## _type = IS_UNUSED
 
 #define INC_BPC(op_array)	if (op_array->fn_flags & ZEND_ACC_INTERACTIVE) { ((op_array)->backpatch_count++); }
 #define DEC_BPC(op_array)	if (op_array->fn_flags & ZEND_ACC_INTERACTIVE) { ((op_array)->backpatch_count--); }
@@ -52,20 +52,33 @@
 typedef struct _zend_op_array zend_op_array;
 typedef struct _zend_op zend_op;
 
-typedef struct _znode {
+typedef struct _zend_literal {
+	zval constant;
+	ulong hash_value;
+} zend_literal;
+
+#define Z_HASH_P(zv) \
+	(((zend_literal*)(zv))->hash_value)
+
+typedef union _znode_op {	
+	zend_uint      constant;
+	zend_uint      var;
+	zend_uint      num;
+	zend_ulong     hash;
+	zend_uint      opline_num; /*  Needs to be signed */
+	zend_op       *jmp_addr;
+	zval          *zv;
+	zend_literal  *literal;
+} znode_op;
+
+typedef struct _znode { /* used only during compilation */ 
 	int op_type;
 	union {
-		zval constant;
-
-		zend_uint var;
-		zend_uint opline_num; /*  Needs to be signed */
+		znode_op op;
+		zval constant; /* replaced by literal/zv */
 		zend_op_array *op_array;
-		zend_op *jmp_addr;
-		struct {
-			zend_uint var;	/* dummy */
-			zend_uint type;
-		} EA;
 	} u;
+	zend_uint EA;      /* extended attributes */
 } znode;
 
 typedef struct _zend_execute_data zend_execute_data;
@@ -80,12 +93,15 @@
 
 struct _zend_op {
 	opcode_handler_t handler;
-	znode result;
-	znode op1;
-	znode op2;
+	znode_op op1;
+	znode_op op2;
+	znode_op result;
 	ulong extended_value;
 	uint lineno;
 	zend_uchar opcode;
+	zend_uchar op1_type;
+	zend_uchar op2_type;
+	zend_uchar result_type;
 };
 
 
@@ -236,6 +252,9 @@
 	zend_uint doc_comment_len;
 	zend_uint early_binding; /* the linked list of delayed declarations */
 
+	zend_literal *literals;
+	int last_literal, size_literal;
+
 	void *reserved[ZEND_MAX_RESERVED_RESOURCES];
 };
 
@@ -335,8 +354,7 @@
 #define IS_UNUSED	(1<<3)	/* Unused variable */
 #define IS_CV		(1<<4)	/* Compiled variable */
 
-#define EXT_TYPE_UNUSED				(1<<0)
-#define EXT_TYPE_FREE_ON_RETURN		(2<<0)
+#define EXT_TYPE_UNUSED	(1<<5)
 
 #include "zend_globals.h"
 
@@ -373,7 +391,7 @@
 void zend_do_binary_op(zend_uchar op, znode *result, const znode *op1, const znode *op2 TSRMLS_DC);
 void zend_do_unary_op(zend_uchar op, znode *result, const znode *op1 TSRMLS_DC);
 void zend_do_binary_assign_op(zend_uchar op, znode *result, const znode *op1, const znode *op2 TSRMLS_DC);
-void zend_do_assign(znode *result, znode *variable, const znode *value TSRMLS_DC);
+void zend_do_assign(znode *result, znode *variable, znode *value TSRMLS_DC);
 void zend_do_assign_ref(znode *result, const znode *lvar, const znode *rvar TSRMLS_DC);
 void fetch_simple_variable(znode *result, znode *varname, int bp TSRMLS_DC);
 void fetch_simple_variable_ex(znode *result, znode *varname, int bp, zend_uchar op TSRMLS_DC);
@@ -442,9 +460,9 @@
 void zend_do_end_catch(const znode *try_token TSRMLS_DC);
 void zend_do_throw(const znode *expr TSRMLS_DC);
 
-ZEND_API int do_bind_function(zend_op *opline, HashTable *function_table, zend_bool compile_time);
-ZEND_API zend_class_entry *do_bind_class(const zend_op *opline, HashTable *class_table, zend_bool compile_time TSRMLS_DC);
-ZEND_API zend_class_entry *do_bind_inherited_class(const zend_op *opline, HashTable *class_table, zend_class_entry *parent_ce, zend_bool compile_time TSRMLS_DC);
+ZEND_API int do_bind_function(const zend_op_array *op_array, zend_op *opline, HashTable *function_table, zend_bool compile_time);
+ZEND_API zend_class_entry *do_bind_class(const zend_op_array *op_array, const zend_op *opline, HashTable *class_table, zend_bool compile_time TSRMLS_DC);
+ZEND_API zend_class_entry *do_bind_inherited_class(const zend_op_array *op_array, const zend_op *opline, HashTable *class_table, zend_class_entry *parent_ce, zend_bool compile_time TSRMLS_DC);
 ZEND_API void zend_do_inherit_interfaces(zend_class_entry *ce, const zend_class_entry *iface TSRMLS_DC);
 ZEND_API void zend_do_implement_interface(zend_class_entry *ce, zend_class_entry *iface TSRMLS_DC);
 void zend_do_implements_interface(znode *interface_znode TSRMLS_DC);
@@ -472,7 +490,6 @@
 void zend_do_begin_class_declaration(const znode *class_token, znode *class_name, const znode *parent_class_name TSRMLS_DC);
 void zend_do_end_class_declaration(const znode *class_token, const znode *parent_token TSRMLS_DC);
 void zend_do_declare_property(const znode *var_name, const znode *value, zend_uint access_type TSRMLS_DC);
-void zend_do_declare_implicit_property(TSRMLS_D);
 void zend_do_declare_class_constant(znode *var_name, const znode *value TSRMLS_DC);
 
 void zend_do_fetch_property(znode *result, znode *object, const znode *property TSRMLS_DC);
@@ -608,6 +625,8 @@
 
 int zendlex(znode *zendlval TSRMLS_DC);
 
+int zend_add_literal(zend_op_array *op_array, const zval *zv);
+
 /* BEGIN: OPCODES */
 
 #include "zend_vm_opcodes.h"
@@ -616,18 +635,6 @@
 
 /* END: OPCODES */
 
-
-
-
-/* global/local fetches */
-#define ZEND_FETCH_GLOBAL			0
-#define ZEND_FETCH_LOCAL			1
-#define ZEND_FETCH_STATIC			2
-#define ZEND_FETCH_STATIC_MEMBER	3
-#define ZEND_FETCH_GLOBAL_LOCK		4
-#define ZEND_FETCH_LEXICAL			5
-
-
 /* class fetches */
 #define ZEND_FETCH_CLASS_DEFAULT	0
 #define ZEND_FETCH_CLASS_SELF		1
@@ -679,23 +686,36 @@
 #define ZEND_REQUIRE			(1<<3)
 #define ZEND_REQUIRE_ONCE		(1<<4)
 
-#define ZEND_ISSET				(1<<0)
-#define ZEND_ISEMPTY			(1<<1)
-#define ZEND_ISSET_ISEMPTY_MASK	(ZEND_ISSET | ZEND_ISEMPTY)
-#define ZEND_QUICK_SET			(1<<2)
-
 #define ZEND_CT	(1<<0)
 #define ZEND_RT (1<<1)
 
-#define ZEND_FETCH_STANDARD		0
-#define ZEND_FETCH_ADD_LOCK		(1<<0)
-#define ZEND_FETCH_MAKE_REF		(1<<1)
+/* global/local fetches */
+#define ZEND_FETCH_GLOBAL			0x00000000
+#define ZEND_FETCH_LOCAL			0x10000000
+#define ZEND_FETCH_STATIC			0x20000000
+#define ZEND_FETCH_STATIC_MEMBER	0x30000000
+#define ZEND_FETCH_GLOBAL_LOCK		0x40000000
+#define ZEND_FETCH_LEXICAL			0x50000000
 
+#define ZEND_FETCH_TYPE_MASK		0x70000000
+
+#define ZEND_FETCH_STANDARD		    0x00000000
+#define ZEND_FETCH_ADD_LOCK		    0x08000000
+#define ZEND_FETCH_MAKE_REF		    0x04000000
+
+#define ZEND_ISSET				    0x02000000
+#define ZEND_ISEMPTY			    0x01000000
+#define ZEND_ISSET_ISEMPTY_MASK	    (ZEND_ISSET | ZEND_ISEMPTY)
+#define ZEND_QUICK_SET			    0x00800000
+
+#define ZEND_FETCH_ARG_MASK         0x000fffff
+
 #define ZEND_FE_FETCH_BYREF	1
 #define ZEND_FE_FETCH_WITH_KEY	2
 
-#define ZEND_FE_RESET_VARIABLE 		1
-#define ZEND_FE_RESET_REFERENCE		2
+#define ZEND_FE_RESET_VARIABLE 		(1<<0)
+#define ZEND_FE_RESET_REFERENCE		(1<<1)
+#define EXT_TYPE_FREE_ON_RETURN		(1<<2)
 
 #define ZEND_MEMBER_FUNC_CALL	1<<0
 
Index: Zend/zend_API.c
===================================================================
--- Zend/zend_API.c	(revision 297868)
+++ Zend/zend_API.c	(working copy)
@@ -971,7 +971,7 @@
 
 		MAKE_STD_ZVAL(member);
 		ZVAL_STRINGL(member, hash_key->arKey, hash_key->nKeyLength-1, 1);
-		obj_ht->write_property(obj, member, *value TSRMLS_CC);
+		obj_ht->write_property(obj, member, *value, 0 TSRMLS_CC);
 		zval_ptr_dtor(&member);
 	}
 	return ZEND_HASH_APPLY_KEEP;
@@ -1435,7 +1435,7 @@
 	MAKE_STD_ZVAL(z_key);
 	ZVAL_STRINGL(z_key, key, key_len-1, 1);
 
-	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp TSRMLS_CC);
+	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp, 0 TSRMLS_CC);
 	zval_ptr_dtor(&tmp); /* write_property will add 1 to refcount */
 	zval_ptr_dtor(&z_key);
 	return SUCCESS;
@@ -1453,7 +1453,7 @@
 	MAKE_STD_ZVAL(z_key);
 	ZVAL_STRINGL(z_key, key, key_len-1, 1);
 
-	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp TSRMLS_CC);
+	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp, 0 TSRMLS_CC);
 	zval_ptr_dtor(&tmp); /* write_property will add 1 to refcount */
 	zval_ptr_dtor(&z_key);
 	return SUCCESS;
@@ -1471,7 +1471,7 @@
 	MAKE_STD_ZVAL(z_key);
 	ZVAL_STRINGL(z_key, key, key_len-1, 1);
 
-	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp TSRMLS_CC);
+	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp, 0 TSRMLS_CC);
 	zval_ptr_dtor(&tmp); /* write_property will add 1 to refcount */
 	zval_ptr_dtor(&z_key);
 	return SUCCESS;
@@ -1489,7 +1489,7 @@
 	MAKE_STD_ZVAL(z_key);
 	ZVAL_STRINGL(z_key, key, key_len-1, 1);
 
-	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp TSRMLS_CC);
+	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp, 0 TSRMLS_CC);
 	zval_ptr_dtor(&tmp); /* write_property will add 1 to refcount */
 	zval_ptr_dtor(&z_key);
 	return SUCCESS;
@@ -1507,7 +1507,7 @@
 	MAKE_STD_ZVAL(z_key);
 	ZVAL_STRINGL(z_key, key, key_len-1, 1);
 
-	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp TSRMLS_CC);
+	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp, 0 TSRMLS_CC);
 	zval_ptr_dtor(&tmp); /* write_property will add 1 to refcount */
 	zval_ptr_dtor(&z_key);
 	return SUCCESS;
@@ -1525,7 +1525,7 @@
 	MAKE_STD_ZVAL(z_key);
 	ZVAL_STRINGL(z_key, key, key_len-1, 1);
 
-	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp TSRMLS_CC);
+	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp, 0 TSRMLS_CC);
 	zval_ptr_dtor(&tmp); /* write_property will add 1 to refcount */
 	zval_ptr_dtor(&z_key);
 	return SUCCESS;
@@ -1543,7 +1543,7 @@
 	MAKE_STD_ZVAL(z_key);
 	ZVAL_STRINGL(z_key, key, key_len-1, 1);
 
-	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp TSRMLS_CC);
+	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, tmp, 0 TSRMLS_CC);
 	zval_ptr_dtor(&tmp); /* write_property will add 1 to refcount */
 	zval_ptr_dtor(&z_key);
 	return SUCCESS;
@@ -1557,7 +1557,7 @@
 	MAKE_STD_ZVAL(z_key);
 	ZVAL_STRINGL(z_key, key, key_len-1, 1);
 
-	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, value TSRMLS_CC);
+	Z_OBJ_HANDLER_P(arg, write_property)(arg, z_key, value, 0 TSRMLS_CC);
 	zval_ptr_dtor(&z_key);
 	return SUCCESS;
 }
@@ -1893,7 +1893,7 @@
 			}
 		}
 		fname_len = strlen(ptr->fname);
-		lowercase_name = zend_str_tolower_dup(ptr->fname, fname_len);
+ 		lowercase_name = zend_str_tolower_dup(ptr->fname, fname_len);
 		if (zend_hash_add(target_function_table, lowercase_name, fname_len+1, &function, sizeof(zend_function), (void**)&reg_function) == FAILURE) {
 			unload=1;
 			efree(lowercase_name);
@@ -2381,7 +2381,7 @@
 			*strict_class = 1;
 			ret = 1;
 		}
-	} else if (zend_lookup_class_ex(name, name_len, 1, &pce TSRMLS_CC) == SUCCESS) {
+	} else if (zend_lookup_class_ex(name, name_len, NULL, 1, &pce TSRMLS_CC) == SUCCESS) {
 		zend_class_entry *scope = EG(active_op_array) ? EG(active_op_array)->scope : NULL;
 
 		fcc->calling_scope = *pce;
@@ -2546,7 +2546,7 @@
 				call_via_handler = 1;
 				retval = 1;
 			} else if (Z_OBJ_HT_P(fcc->object_ptr)->get_method) {
-				fcc->function_handler = Z_OBJ_HT_P(fcc->object_ptr)->get_method(&fcc->object_ptr, mname, mlen TSRMLS_CC);
+				fcc->function_handler = Z_OBJ_HT_P(fcc->object_ptr)->get_method(&fcc->object_ptr, mname, mlen, NULL TSRMLS_CC);
 				if (fcc->function_handler) {
 					if (strict_class &&
 					    (!fcc->function_handler->common.scope ||
@@ -2567,7 +2567,7 @@
 			if (fcc->calling_scope->get_static_method) {
 				fcc->function_handler = fcc->calling_scope->get_static_method(fcc->calling_scope, mname, mlen TSRMLS_CC);
 			} else {
-				fcc->function_handler = zend_std_get_static_method(fcc->calling_scope, mname, mlen TSRMLS_CC);
+				fcc->function_handler = zend_std_get_static_method(fcc->calling_scope, mname, mlen, NULL TSRMLS_CC);
 			}
 			if (fcc->function_handler) {
 				retval = 1;
@@ -3343,7 +3343,7 @@
 	}
 	MAKE_STD_ZVAL(property);
 	ZVAL_STRINGL(property, name, name_length, 1);
-	Z_OBJ_HT_P(object)->write_property(object, property, value TSRMLS_CC);
+	Z_OBJ_HT_P(object)->write_property(object, property, value, 0 TSRMLS_CC);
 	zval_ptr_dtor(&property);
 
 	EG(scope) = old_scope;
@@ -3428,7 +3428,7 @@
 	zend_class_entry *old_scope = EG(scope);
 
 	EG(scope) = scope;
-	property = zend_std_get_static_property(scope, name, name_length, 0 TSRMLS_CC);
+	property = zend_std_get_static_property(scope, name, name_length, 0, NULL TSRMLS_CC);
 	EG(scope) = old_scope;
 	if (!property) {
 		return FAILURE;
@@ -3546,7 +3546,7 @@
 
 	MAKE_STD_ZVAL(property);
 	ZVAL_STRINGL(property, name, name_length, 1);
-	value = Z_OBJ_HT_P(object)->read_property(object, property, silent?BP_VAR_IS:BP_VAR_R TSRMLS_CC);
+	value = Z_OBJ_HT_P(object)->read_property(object, property, silent?BP_VAR_IS:BP_VAR_R, 0 TSRMLS_CC);
 	zval_ptr_dtor(&property);
 
 	EG(scope) = old_scope;
@@ -3560,7 +3560,7 @@
 	zend_class_entry *old_scope = EG(scope);
 
 	EG(scope) = scope;
-	property = zend_std_get_static_property(scope, name, name_length, silent TSRMLS_CC);
+	property = zend_std_get_static_property(scope, name, name_length, silent, NULL TSRMLS_CC);
 	EG(scope) = old_scope;
 
 	return property?*property:NULL;
Index: Zend/zend_vm_gen.php
===================================================================
--- Zend/zend_vm_gen.php	(revision 297868)
+++ Zend/zend_vm_gen.php	(working copy)
@@ -82,7 +82,7 @@
 );
 
 $op1_type = array(
-	"ANY"    => "opline->op1.op_type",
+	"ANY"    => "opline->op1_type",
 	"TMP"    => "IS_TMP_VAR",
 	"VAR"    => "IS_VAR",
 	"CONST"  => "IS_CONST",
@@ -91,7 +91,7 @@
 );
 
 $op2_type = array(
-	"ANY"    => "opline->op2.op_type",
+	"ANY"    => "opline->op2_type",
 	"TMP"    => "IS_TMP_VAR",
 	"VAR"    => "IS_VAR",
 	"CONST"  => "IS_CONST",
@@ -118,75 +118,75 @@
 );
 
 $op1_get_zval_ptr = array(
-	"ANY"    => "get_zval_ptr(&opline->op1, EX(Ts), &free_op1, \\1)",
-	"TMP"    => "_get_zval_ptr_tmp(&opline->op1, EX(Ts), &free_op1 TSRMLS_CC)",
-	"VAR"    => "_get_zval_ptr_var(&opline->op1, EX(Ts), &free_op1 TSRMLS_CC)",
-	"CONST"  => "&opline->op1.u.constant",
+	"ANY"    => "get_zval_ptr(opline->op1_type, &opline->op1, EX(Ts), &free_op1, \\1)",
+	"TMP"    => "_get_zval_ptr_tmp(opline->op1.var, EX(Ts), &free_op1 TSRMLS_CC)",
+	"VAR"    => "_get_zval_ptr_var(opline->op1.var, EX(Ts), &free_op1 TSRMLS_CC)",
+	"CONST"  => "opline->op1.zv",
 	"UNUSED" => "NULL",
-	"CV"     => "_get_zval_ptr_cv(&opline->op1, EX(Ts), \\1 TSRMLS_CC)",
+	"CV"     => "_get_zval_ptr_cv(opline->op1.var, \\1 TSRMLS_CC)",
 );
 
 $op2_get_zval_ptr = array(
-	"ANY"    => "get_zval_ptr(&opline->op2, EX(Ts), &free_op2, \\1)",
-	"TMP"    => "_get_zval_ptr_tmp(&opline->op2, EX(Ts), &free_op2 TSRMLS_CC)",
-	"VAR"    => "_get_zval_ptr_var(&opline->op2, EX(Ts), &free_op2 TSRMLS_CC)",
-	"CONST"  => "&opline->op2.u.constant",
+	"ANY"    => "get_zval_ptr(opline->op2_type, &opline->op2, EX(Ts), &free_op2, \\1)",
+	"TMP"    => "_get_zval_ptr_tmp(opline->op2.var, EX(Ts), &free_op2 TSRMLS_CC)",
+	"VAR"    => "_get_zval_ptr_var(opline->op2.var, EX(Ts), &free_op2 TSRMLS_CC)",
+	"CONST"  => "opline->op2.zv",
 	"UNUSED" => "NULL",
-	"CV"     => "_get_zval_ptr_cv(&opline->op2, EX(Ts), \\1 TSRMLS_CC)",
+	"CV"     => "_get_zval_ptr_cv(opline->op2.var, \\1 TSRMLS_CC)",
 );
 
 $op1_get_zval_ptr_ptr = array(
-	"ANY"    => "get_zval_ptr_ptr(&opline->op1, EX(Ts), &free_op1, \\1)",
+	"ANY"    => "get_zval_ptr_ptr(opline->op1_type, &opline->op1, EX(Ts), &free_op1, \\1)",
 	"TMP"    => "NULL",
-	"VAR"    => "_get_zval_ptr_ptr_var(&opline->op1, EX(Ts), &free_op1 TSRMLS_CC)",
+	"VAR"    => "_get_zval_ptr_ptr_var(opline->op1.var, EX(Ts), &free_op1 TSRMLS_CC)",
 	"CONST"  => "NULL",
 	"UNUSED" => "NULL",
-	"CV"     => "_get_zval_ptr_ptr_cv(&opline->op1, EX(Ts), \\1 TSRMLS_CC)",
+	"CV"     => "_get_zval_ptr_ptr_cv(opline->op1.var, \\1 TSRMLS_CC)",
 );
 
 $op2_get_zval_ptr_ptr = array(
-	"ANY"    => "get_zval_ptr_ptr(&opline->op2, EX(Ts), &free_op2, \\1)",
+	"ANY"    => "get_zval_ptr_ptr(opline->op2_type, &opline->op2, EX(Ts), &free_op2, \\1)",
 	"TMP"    => "NULL",
-	"VAR"    => "_get_zval_ptr_ptr_var(&opline->op2, EX(Ts), &free_op2 TSRMLS_CC)",
+	"VAR"    => "_get_zval_ptr_ptr_var(opline->op2.var, EX(Ts), &free_op2 TSRMLS_CC)",
 	"CONST"  => "NULL",
 	"UNUSED" => "NULL",
-	"CV"     => "_get_zval_ptr_ptr_cv(&opline->op2, EX(Ts), \\1 TSRMLS_CC)",
+	"CV"     => "_get_zval_ptr_ptr_cv(opline->op2.var, \\1 TSRMLS_CC)",
 );
 
 $op1_get_obj_zval_ptr = array(
-	"ANY"    => "get_obj_zval_ptr(&opline->op1, EX(Ts), &free_op1, \\1)",
-	"TMP"    => "_get_zval_ptr_tmp(&opline->op1, EX(Ts), &free_op1 TSRMLS_CC)",
-	"VAR"    => "_get_zval_ptr_var(&opline->op1, EX(Ts), &free_op1 TSRMLS_CC)",
-	"CONST"  => "&opline->op1.u.constant",
+	"ANY"    => "get_obj_zval_ptr(opline->op1_type, &opline->op1, EX(Ts), &free_op1, \\1)",
+	"TMP"    => "_get_zval_ptr_tmp(opline->op1.var, EX(Ts), &free_op1 TSRMLS_CC)",
+	"VAR"    => "_get_zval_ptr_var(opline->op1.var, EX(Ts), &free_op1 TSRMLS_CC)",
+	"CONST"  => "opline->op1.zv",
 	"UNUSED" => "_get_obj_zval_ptr_unused(TSRMLS_C)",
-	"CV"     => "_get_zval_ptr_cv(&opline->op1, EX(Ts), \\1 TSRMLS_CC)",
+	"CV"     => "_get_zval_ptr_cv(opline->op1.var, \\1 TSRMLS_CC)",
 );
 
 $op2_get_obj_zval_ptr = array(
-	"ANY"    => "get_obj_zval_ptr(&opline->op2, EX(Ts), &free_op2, \\1)",
-	"TMP"    => "_get_zval_ptr_tmp(&opline->op2, EX(Ts), &free_op2 TSRMLS_CC)",
-	"VAR"    => "_get_zval_ptr_var(&opline->op2, EX(Ts), &free_op2 TSRMLS_CC)",
-	"CONST"  => "&opline->op2.u.constant",
+	"ANY"    => "get_obj_zval_ptr(opline->op2_type, &opline->op2, EX(Ts), &free_op2, \\1)",
+	"TMP"    => "_get_zval_ptr_tmp(opline->op2.var, EX(Ts), &free_op2 TSRMLS_CC)",
+	"VAR"    => "_get_zval_ptr_var(opline->op2.var, EX(Ts), &free_op2 TSRMLS_CC)",
+	"CONST"  => "opline->op2.zv",
 	"UNUSED" => "_get_obj_zval_ptr_unused(TSRMLS_C)",
-	"CV"     => "_get_zval_ptr_cv(&opline->op2, EX(Ts), \\1 TSRMLS_CC)",
+	"CV"     => "_get_zval_ptr_cv(opline->op2.var, \\1 TSRMLS_CC)",
 );
 
 $op1_get_obj_zval_ptr_ptr = array(
-	"ANY"    => "get_obj_zval_ptr_ptr(&opline->op1, EX(Ts), &free_op1, \\1)",
+	"ANY"    => "get_obj_zval_ptr_ptr(opline->op1_type, &opline->op1, EX(Ts), &free_op1, \\1)",
 	"TMP"    => "NULL",
-	"VAR"    => "_get_zval_ptr_ptr_var(&opline->op1, EX(Ts), &free_op1 TSRMLS_CC)",
+	"VAR"    => "_get_zval_ptr_ptr_var(opline->op1.var, EX(Ts), &free_op1 TSRMLS_CC)",
 	"CONST"  => "NULL",
 	"UNUSED" => "_get_obj_zval_ptr_ptr_unused(TSRMLS_C)",
-	"CV"     => "_get_zval_ptr_ptr_cv(&opline->op1, EX(Ts), \\1 TSRMLS_CC)",
+	"CV"     => "_get_zval_ptr_ptr_cv(opline->op1.var, \\1 TSRMLS_CC)",
 );
 
 $op2_get_obj_zval_ptr_ptr = array(
-	"ANY"    => "get_obj_zval_ptr_ptr(&opline->op2, EX(Ts), &free_op2, \\1)",
+	"ANY"    => "get_obj_zval_ptr_ptr(opline->op2_type, &opline->op2, EX(Ts), &free_op2, \\1)",
 	"TMP"    => "NULL",
-	"VAR"    => "_get_zval_ptr_ptr_var(&opline->op2, EX(Ts), &free_op2 TSRMLS_CC)",
+	"VAR"    => "_get_zval_ptr_ptr_var(opline->op2.var, EX(Ts), &free_op2 TSRMLS_CC)",
 	"CONST"  => "NULL",
 	"UNUSED" => "_get_obj_zval_ptr_ptr_unused(TSRMLS_C)",
-	"CV"     => "_get_zval_ptr_ptr_cv(&opline->op2, EX(Ts), \\1 TSRMLS_CC)",
+	"CV"     => "_get_zval_ptr_ptr_cv(opline->op2.var, \\1 TSRMLS_CC)",
 );
 
 $op1_is_tmp_free = array(
@@ -694,7 +694,7 @@
 		$done = 1;
 		out($f,"static int ZEND_FASTCALL ZEND_NULL_HANDLER(ZEND_OPCODE_HANDLER_ARGS)\n");
 		out($f,"{\n");
-		out($f,"\tzend_error_noreturn(E_ERROR, \"Invalid opcode %d/%d/%d.\", EX(opline)->opcode, EX(opline)->op1.op_type, EX(opline)->op2.op_type);\n");
+		out($f,"\tzend_error_noreturn(E_ERROR, \"Invalid opcode %d/%d/%d.\", EX(opline)->opcode, EX(opline)->op1_type, EX(opline)->op2_type);\n");
 		out($f,"}\n\n");
 	}
 }
@@ -768,11 +768,11 @@
 			break;
 		case ZEND_VM_KIND_SWITCH:
 			out($f,"default:\n");
-			out($f,"\tzend_error_noreturn(E_ERROR, \"Invalid opcode %d/%d/%d.\", EX(opline)->opcode, EX(opline)->op1.op_type, EX(opline)->op2.op_type);\n");
+			out($f,"\tzend_error_noreturn(E_ERROR, \"Invalid opcode %d/%d/%d.\", EX(opline)->opcode, EX(opline)->op1_type, EX(opline)->op2_type);\n");
 			break;
 		case ZEND_VM_KIND_GOTO:
 			out($f,"ZEND_NULL_HANDLER:\n");
-			out($f,"\tzend_error_noreturn(E_ERROR, \"Invalid opcode %d/%d/%d.\", EX(opline)->opcode, EX(opline)->op1.op_type, EX(opline)->op2.op_type);\n");
+			out($f,"\tzend_error_noreturn(E_ERROR, \"Invalid opcode %d/%d/%d.\", EX(opline)->opcode, EX(opline)->op1_type, EX(opline)->op2_type);\n");
 			break;
 	}
 }
@@ -1185,7 +1185,7 @@
 		out($f, "\t\t\t_UNUSED_CODE, /* 15             */\n");
 		out($f, "\t\t\t_CV_CODE      /* 16 = IS_CV     */\n");
 		out($f, "\t\t};\n");
-		out($f, "\t\treturn zend_opcode_handlers[opcode * 25 + zend_vm_decode[op->op1.op_type] * 5 + zend_vm_decode[op->op2.op_type]];\n");
+		out($f, "\t\treturn zend_opcode_handlers[opcode * 25 + zend_vm_decode[op->op1_type] * 5 + zend_vm_decode[op->op2_type]];\n");
 		if (ZEND_VM_OLD_EXECUTOR) {
 			out($f, "\t}\n");
 		}
Index: Zend/zend_language_parser.y
===================================================================
--- Zend/zend_language_parser.y	(revision 297868)
+++ Zend/zend_language_parser.y	(working copy)
@@ -219,12 +219,12 @@
 		'{' inner_statement_list '}'
 	|	T_IF '(' expr ')' { zend_do_if_cond(&$3, &$4 TSRMLS_CC); } statement { zend_do_if_after_statement(&$4, 1 TSRMLS_CC); } elseif_list else_single { zend_do_if_end(TSRMLS_C); }
 	|	T_IF '(' expr ')' ':' { zend_do_if_cond(&$3, &$4 TSRMLS_CC); } inner_statement_list { zend_do_if_after_statement(&$4, 1 TSRMLS_CC); } new_elseif_list new_else_single T_ENDIF ';' { zend_do_if_end(TSRMLS_C); }
-	|	T_WHILE '(' { $1.u.opline_num = get_next_op_number(CG(active_op_array));  } expr  ')' { zend_do_while_cond(&$4, &$5 TSRMLS_CC); } while_statement { zend_do_while_end(&$1, &$5 TSRMLS_CC); }
-	|	T_DO { $1.u.opline_num = get_next_op_number(CG(active_op_array));  zend_do_do_while_begin(TSRMLS_C); } statement T_WHILE '(' { $5.u.opline_num = get_next_op_number(CG(active_op_array)); } expr ')' ';' { zend_do_do_while_end(&$1, &$5, &$7 TSRMLS_CC); }
+	|	T_WHILE '(' { $1.u.op.opline_num = get_next_op_number(CG(active_op_array));  } expr  ')' { zend_do_while_cond(&$4, &$5 TSRMLS_CC); } while_statement { zend_do_while_end(&$1, &$5 TSRMLS_CC); }
+	|	T_DO { $1.u.op.opline_num = get_next_op_number(CG(active_op_array));  zend_do_do_while_begin(TSRMLS_C); } statement T_WHILE '(' { $5.u.op.opline_num = get_next_op_number(CG(active_op_array)); } expr ')' ';' { zend_do_do_while_end(&$1, &$5, &$7 TSRMLS_CC); }
 	|	T_FOR
 			'('
 				for_expr
-			';' { zend_do_free(&$3 TSRMLS_CC); $4.u.opline_num = get_next_op_number(CG(active_op_array)); }
+			';' { zend_do_free(&$3 TSRMLS_CC); $4.u.op.opline_num = get_next_op_number(CG(active_op_array)); }
 				for_expr
 			';' { zend_do_extended_info(TSRMLS_C); zend_do_for_cond(&$6, &$7 TSRMLS_CC); }
 				for_expr
@@ -252,7 +252,7 @@
 		{ zend_do_foreach_begin(&$1, &$2, &$3, &$4, 0 TSRMLS_CC); }
 		variable foreach_optional_arg ')' { zend_check_writable_variable(&$6); zend_do_foreach_cont(&$1, &$2, &$4, &$6, &$7 TSRMLS_CC); }
 		foreach_statement { zend_do_foreach_end(&$1, &$4 TSRMLS_CC); }
-	|	T_DECLARE { $1.u.opline_num = get_next_op_number(CG(active_op_array)); zend_do_declare_begin(TSRMLS_C); } '(' declare_list ')' declare_statement { zend_do_declare_end(&$1 TSRMLS_CC); }
+	|	T_DECLARE { $1.u.op.opline_num = get_next_op_number(CG(active_op_array)); zend_do_declare_begin(TSRMLS_C); } '(' declare_list ')' declare_statement { zend_do_declare_end(&$1 TSRMLS_CC); }
 	|	';'		/* empty statement */
 	|	T_TRY { zend_do_try(&$1 TSRMLS_CC); } '{' inner_statement_list '}'
 		T_CATCH '(' { zend_initialize_try_catch_element(&$1 TSRMLS_CC); }
@@ -267,7 +267,7 @@
 
 additional_catches:
 		non_empty_additional_catches { $$ = $1; }
-	|	/* empty */ { $$.u.opline_num = -1; }
+	|	/* empty */ { $$.u.op.opline_num = -1; }
 ;
 
 non_empty_additional_catches:
@@ -277,7 +277,7 @@
 
 
 additional_catch:
-	T_CATCH '(' fully_qualified_class_name { $$.u.opline_num = get_next_op_number(CG(active_op_array)); } T_VARIABLE ')' { zend_do_begin_catch(&$1, &$3, &$5, NULL TSRMLS_CC); } '{' inner_statement_list '}' { zend_do_end_catch(&$1 TSRMLS_CC); }
+	T_CATCH '(' fully_qualified_class_name { $$.u.op.opline_num = get_next_op_number(CG(active_op_array)); } T_VARIABLE ')' { zend_do_begin_catch(&$1, &$3, &$5, NULL TSRMLS_CC); } '{' inner_statement_list '}' { zend_do_end_catch(&$1 TSRMLS_CC); }
 ;
 
 
@@ -327,9 +327,9 @@
 
 
 class_entry_type:
-		T_CLASS			{ $$.u.opline_num = CG(zend_lineno); $$.u.EA.type = 0; }
-	|	T_ABSTRACT T_CLASS { $$.u.opline_num = CG(zend_lineno); $$.u.EA.type = ZEND_ACC_EXPLICIT_ABSTRACT_CLASS; }
-	|	T_FINAL T_CLASS { $$.u.opline_num = CG(zend_lineno); $$.u.EA.type = ZEND_ACC_FINAL_CLASS; }
+		T_CLASS			{ $$.u.op.opline_num = CG(zend_lineno); $$.EA = 0; }
+	|	T_ABSTRACT T_CLASS { $$.u.op.opline_num = CG(zend_lineno); $$.EA = ZEND_ACC_EXPLICIT_ABSTRACT_CLASS; }
+	|	T_FINAL T_CLASS { $$.u.op.opline_num = CG(zend_lineno); $$.EA = ZEND_ACC_FINAL_CLASS; }
 ;
 
 extends_from:
@@ -338,7 +338,7 @@
 ;
 
 interface_entry:
-	T_INTERFACE		{ $$.u.opline_num = CG(zend_lineno); $$.u.EA.type = ZEND_ACC_INTERFACE; }
+	T_INTERFACE		{ $$.u.op.opline_num = CG(zend_lineno); $$.EA = ZEND_ACC_INTERFACE; }
 ;
 
 interface_extends_list:
@@ -364,7 +364,7 @@
 
 foreach_variable:
 		variable			{ zend_check_writable_variable(&$1); $$ = $1; }
-	|	'&' variable		{ zend_check_writable_variable(&$2); $$ = $2;  $$.u.EA.type |= ZEND_PARSED_REFERENCE_VARIABLE; }
+	|	'&' variable		{ zend_check_writable_variable(&$2); $$ = $2;  $$.EA |= ZEND_PARSED_REFERENCE_VARIABLE; }
 ;
 
 for_statement:
@@ -450,14 +450,14 @@
 
 
 non_empty_parameter_list:
-		optional_class_type T_VARIABLE				{ znode tmp;  fetch_simple_variable(&tmp, &$2, 0 TSRMLS_CC); $$.op_type = IS_CONST; Z_LVAL($$.u.constant)=1; Z_TYPE($$.u.constant)=IS_LONG; INIT_PZVAL(&$$.u.constant); zend_do_receive_arg(ZEND_RECV, &tmp, &$$, NULL, &$1, &$2, 0 TSRMLS_CC); }
-	|	optional_class_type '&' T_VARIABLE			{ znode tmp;  fetch_simple_variable(&tmp, &$3, 0 TSRMLS_CC); $$.op_type = IS_CONST; Z_LVAL($$.u.constant)=1; Z_TYPE($$.u.constant)=IS_LONG; INIT_PZVAL(&$$.u.constant); zend_do_receive_arg(ZEND_RECV, &tmp, &$$, NULL, &$1, &$3, 1 TSRMLS_CC); }
-	|	optional_class_type '&' T_VARIABLE '=' static_scalar			{ znode tmp;  fetch_simple_variable(&tmp, &$3, 0 TSRMLS_CC); $$.op_type = IS_CONST; Z_LVAL($$.u.constant)=1; Z_TYPE($$.u.constant)=IS_LONG; INIT_PZVAL(&$$.u.constant); zend_do_receive_arg(ZEND_RECV_INIT, &tmp, &$$, &$5, &$1, &$3, 1 TSRMLS_CC); }
-	|	optional_class_type T_VARIABLE '=' static_scalar				{ znode tmp;  fetch_simple_variable(&tmp, &$2, 0 TSRMLS_CC); $$.op_type = IS_CONST; Z_LVAL($$.u.constant)=1; Z_TYPE($$.u.constant)=IS_LONG; INIT_PZVAL(&$$.u.constant); zend_do_receive_arg(ZEND_RECV_INIT, &tmp, &$$, &$4, &$1, &$2, 0 TSRMLS_CC); }
-	|	non_empty_parameter_list ',' optional_class_type T_VARIABLE 	{ znode tmp;  fetch_simple_variable(&tmp, &$4, 0 TSRMLS_CC); $$=$1; Z_LVAL($$.u.constant)++; zend_do_receive_arg(ZEND_RECV, &tmp, &$$, NULL, &$3, &$4, 0 TSRMLS_CC); }
-	|	non_empty_parameter_list ',' optional_class_type '&' T_VARIABLE	{ znode tmp;  fetch_simple_variable(&tmp, &$5, 0 TSRMLS_CC); $$=$1; Z_LVAL($$.u.constant)++; zend_do_receive_arg(ZEND_RECV, &tmp, &$$, NULL, &$3, &$5, 1 TSRMLS_CC); }
-	|	non_empty_parameter_list ',' optional_class_type '&' T_VARIABLE	 '=' static_scalar { znode tmp;  fetch_simple_variable(&tmp, &$5, 0 TSRMLS_CC); $$=$1; Z_LVAL($$.u.constant)++; zend_do_receive_arg(ZEND_RECV_INIT, &tmp, &$$, &$7, &$3, &$5, 1 TSRMLS_CC); }
-	|	non_empty_parameter_list ',' optional_class_type T_VARIABLE '=' static_scalar 	{ znode tmp;  fetch_simple_variable(&tmp, &$4, 0 TSRMLS_CC); $$=$1; Z_LVAL($$.u.constant)++; zend_do_receive_arg(ZEND_RECV_INIT, &tmp, &$$, &$6, &$3, &$4, 0 TSRMLS_CC); }
+		optional_class_type T_VARIABLE				{ znode tmp;  fetch_simple_variable(&tmp, &$2, 0 TSRMLS_CC); $$.op_type = IS_UNUSED; $$.u.op.num=1; Z_TYPE($$.u.constant)=IS_LONG; INIT_PZVAL(&$$.u.constant); zend_do_receive_arg(ZEND_RECV, &tmp, &$$, NULL, &$1, &$2, 0 TSRMLS_CC); }
+	|	optional_class_type '&' T_VARIABLE			{ znode tmp;  fetch_simple_variable(&tmp, &$3, 0 TSRMLS_CC); $$.op_type = IS_UNUSED; $$.u.op.num=1; Z_TYPE($$.u.constant)=IS_LONG; INIT_PZVAL(&$$.u.constant); zend_do_receive_arg(ZEND_RECV, &tmp, &$$, NULL, &$1, &$3, 1 TSRMLS_CC); }
+	|	optional_class_type '&' T_VARIABLE '=' static_scalar			{ znode tmp;  fetch_simple_variable(&tmp, &$3, 0 TSRMLS_CC); $$.op_type = IS_UNUSED; $$.u.op.num=1; Z_TYPE($$.u.constant)=IS_LONG; INIT_PZVAL(&$$.u.constant); zend_do_receive_arg(ZEND_RECV_INIT, &tmp, &$$, &$5, &$1, &$3, 1 TSRMLS_CC); }
+	|	optional_class_type T_VARIABLE '=' static_scalar				{ znode tmp;  fetch_simple_variable(&tmp, &$2, 0 TSRMLS_CC); $$.op_type = IS_UNUSED; $$.u.op.num=1; Z_TYPE($$.u.constant)=IS_LONG; INIT_PZVAL(&$$.u.constant); zend_do_receive_arg(ZEND_RECV_INIT, &tmp, &$$, &$4, &$1, &$2, 0 TSRMLS_CC); }
+	|	non_empty_parameter_list ',' optional_class_type T_VARIABLE 	{ znode tmp;  fetch_simple_variable(&tmp, &$4, 0 TSRMLS_CC); $$=$1; $$.u.op.num++; zend_do_receive_arg(ZEND_RECV, &tmp, &$$, NULL, &$3, &$4, 0 TSRMLS_CC); }
+	|	non_empty_parameter_list ',' optional_class_type '&' T_VARIABLE	{ znode tmp;  fetch_simple_variable(&tmp, &$5, 0 TSRMLS_CC); $$=$1; $$.u.op.num++; zend_do_receive_arg(ZEND_RECV, &tmp, &$$, NULL, &$3, &$5, 1 TSRMLS_CC); }
+	|	non_empty_parameter_list ',' optional_class_type '&' T_VARIABLE	 '=' static_scalar { znode tmp;  fetch_simple_variable(&tmp, &$5, 0 TSRMLS_CC); $$=$1; $$.u.op.num++; zend_do_receive_arg(ZEND_RECV_INIT, &tmp, &$$, &$7, &$3, &$5, 1 TSRMLS_CC); }
+	|	non_empty_parameter_list ',' optional_class_type T_VARIABLE '=' static_scalar 	{ znode tmp;  fetch_simple_variable(&tmp, &$4, 0 TSRMLS_CC); $$=$1; $$.u.op.num++; zend_do_receive_arg(ZEND_RECV_INIT, &tmp, &$$, &$6, &$3, &$4, 0 TSRMLS_CC); }
 ;
 
 
@@ -580,7 +580,7 @@
 		T_LIST '(' { zend_do_list_init(TSRMLS_C); } assignment_list ')' '=' expr { zend_do_list_end(&$$, &$7 TSRMLS_CC); }
 	|	variable '=' expr		{ zend_check_writable_variable(&$1); zend_do_assign(&$$, &$1, &$3 TSRMLS_CC); }
 	|	variable '=' '&' variable { zend_check_writable_variable(&$1); zend_do_end_variable_parse(&$4, BP_VAR_W, 1 TSRMLS_CC); zend_do_end_variable_parse(&$1, BP_VAR_W, 0 TSRMLS_CC); zend_do_assign_ref(&$$, &$1, &$4 TSRMLS_CC); }
-	|	variable '=' '&' T_NEW class_name_reference { zend_error(E_DEPRECATED, "Assigning the return value of new by reference is deprecated");  zend_check_writable_variable(&$1); zend_do_extended_fcall_begin(TSRMLS_C); zend_do_begin_new_object(&$4, &$5 TSRMLS_CC); } ctor_arguments { zend_do_end_new_object(&$3, &$4, &$7 TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C); zend_do_end_variable_parse(&$1, BP_VAR_W, 0 TSRMLS_CC); $3.u.EA.type = ZEND_PARSED_NEW; zend_do_assign_ref(&$$, &$1, &$3 TSRMLS_CC); }
+	|	variable '=' '&' T_NEW class_name_reference { zend_error(E_DEPRECATED, "Assigning the return value of new by reference is deprecated");  zend_check_writable_variable(&$1); zend_do_extended_fcall_begin(TSRMLS_C); zend_do_begin_new_object(&$4, &$5 TSRMLS_CC); } ctor_arguments { zend_do_end_new_object(&$3, &$4, &$7 TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C); zend_do_end_variable_parse(&$1, BP_VAR_W, 0 TSRMLS_CC); $3.EA = ZEND_PARSED_NEW; zend_do_assign_ref(&$$, &$1, &$3 TSRMLS_CC); }
 	|	T_NEW class_name_reference { zend_do_extended_fcall_begin(TSRMLS_C); zend_do_begin_new_object(&$1, &$2 TSRMLS_CC); } ctor_arguments { zend_do_end_new_object(&$$, &$1, &$4 TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C);}
 	|	T_CLONE expr { zend_do_clone(&$$, &$2 TSRMLS_CC); }
 	|	variable T_PLUS_EQUAL expr 	{ zend_check_writable_variable(&$1); zend_do_end_variable_parse(&$1, BP_VAR_RW, 0 TSRMLS_CC); zend_do_binary_assign_op(ZEND_ASSIGN_ADD, &$$, &$1, &$3 TSRMLS_CC); }
@@ -652,7 +652,7 @@
 ;
 
 function:
-	T_FUNCTION { $$.u.opline_num = CG(zend_lineno); }
+	T_FUNCTION { $$.u.op.opline_num = CG(zend_lineno); }
 ;
 
 lexical_vars:
@@ -668,18 +668,18 @@
 ;
 
 function_call:
-		namespace_name '(' { $2.u.opline_num = zend_do_begin_function_call(&$1, 1 TSRMLS_CC); }
+		namespace_name '(' { $2.u.op.opline_num = zend_do_begin_function_call(&$1, 1 TSRMLS_CC); }
 				function_call_parameter_list
-				')' { zend_do_end_function_call(&$1, &$$, &$4, 0, $2.u.opline_num TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C); }
-	|	T_NAMESPACE T_NS_SEPARATOR namespace_name '(' { $1.op_type = IS_CONST; ZVAL_EMPTY_STRING(&$1.u.constant);  zend_do_build_namespace_name(&$1, &$1, &$3 TSRMLS_CC); $4.u.opline_num = zend_do_begin_function_call(&$1, 0 TSRMLS_CC); }
+				')' { zend_do_end_function_call(&$1, &$$, &$4, 0, $2.u.op.opline_num TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C); }
+	|	T_NAMESPACE T_NS_SEPARATOR namespace_name '(' { $1.op_type = IS_CONST; ZVAL_EMPTY_STRING(&$1.u.constant);  zend_do_build_namespace_name(&$1, &$1, &$3 TSRMLS_CC); $4.u.op.opline_num = zend_do_begin_function_call(&$1, 0 TSRMLS_CC); }
 				function_call_parameter_list
-				')' { zend_do_end_function_call(&$1, &$$, &$6, 0, $4.u.opline_num TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C); }
-	|	T_NS_SEPARATOR namespace_name '(' { $3.u.opline_num = zend_do_begin_function_call(&$2, 0 TSRMLS_CC); }
+				')' { zend_do_end_function_call(&$1, &$$, &$6, 0, $4.u.op.opline_num TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C); }
+	|	T_NS_SEPARATOR namespace_name '(' { $3.u.op.opline_num = zend_do_begin_function_call(&$2, 0 TSRMLS_CC); }
 				function_call_parameter_list
-				')' { zend_do_end_function_call(&$2, &$$, &$5, 0, $3.u.opline_num TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C); }
-	|	class_name T_PAAMAYIM_NEKUDOTAYIM T_STRING '(' { $4.u.opline_num = zend_do_begin_class_member_function_call(&$1, &$3 TSRMLS_CC); }
+				')' { zend_do_end_function_call(&$2, &$$, &$5, 0, $3.u.op.opline_num TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C); }
+	|	class_name T_PAAMAYIM_NEKUDOTAYIM T_STRING '(' { $4.u.op.opline_num = zend_do_begin_class_member_function_call(&$1, &$3 TSRMLS_CC); }
 			function_call_parameter_list
-			')' { zend_do_end_function_call($4.u.opline_num?NULL:&$3, &$$, &$6, $4.u.opline_num, $4.u.opline_num TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C);}
+			')' { zend_do_end_function_call($4.u.op.opline_num?NULL:&$3, &$$, &$6, $4.u.op.opline_num, $4.u.op.opline_num TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C);}
 	|	class_name T_PAAMAYIM_NEKUDOTAYIM variable_without_objects '(' { zend_do_end_variable_parse(&$3, BP_VAR_R, 0 TSRMLS_CC); zend_do_begin_class_member_function_call(&$1, &$3 TSRMLS_CC); }
 			function_call_parameter_list
 			')' { zend_do_end_function_call(NULL, &$$, &$6, 1, 1 TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C);}
@@ -717,8 +717,8 @@
 
 dynamic_class_name_reference:
 		base_variable T_OBJECT_OPERATOR { zend_do_push_object(&$1 TSRMLS_CC); }
-			object_property { zend_do_push_object(&$4 TSRMLS_CC); zend_do_declare_implicit_property(TSRMLS_C); } dynamic_class_name_variable_properties
-			{ zend_do_pop_object(&$$ TSRMLS_CC); $$.u.EA.type = ZEND_PARSED_MEMBER; }
+			object_property { zend_do_push_object(&$4 TSRMLS_CC); } dynamic_class_name_variable_properties
+			{ zend_do_pop_object(&$$ TSRMLS_CC); $$.EA = ZEND_PARSED_MEMBER; }
 	|	base_variable { $$ = $1; }
 ;
 
@@ -730,7 +730,7 @@
 
 
 dynamic_class_name_variable_property:
-		T_OBJECT_OPERATOR object_property { zend_do_push_object(&$2 TSRMLS_CC); zend_do_declare_implicit_property(TSRMLS_C); }
+		T_OBJECT_OPERATOR object_property { zend_do_push_object(&$2 TSRMLS_CC); }
 ;
 
 exit_expr:
@@ -836,26 +836,26 @@
 variable:
 		base_variable_with_function_calls T_OBJECT_OPERATOR { zend_do_push_object(&$1 TSRMLS_CC); }
 			object_property { zend_do_push_object(&$4 TSRMLS_CC); } method_or_not variable_properties
-			{ zend_do_pop_object(&$$ TSRMLS_CC); $$.u.EA.type = $1.u.EA.type | ($7.u.EA.type ? $7.u.EA.type : $6.u.EA.type); }
+			{ zend_do_pop_object(&$$ TSRMLS_CC); $$.EA = $1.EA | ($7.EA ? $7.EA : $6.EA); }
 	|	base_variable_with_function_calls { $$ = $1; }
 ;
 
 variable_properties:
-		variable_properties variable_property { $$.u.EA.type = $2.u.EA.type; }
-	|	/* empty */ { $$.u.EA.type = 0; }
+		variable_properties variable_property { $$.EA = $2.EA; }
+	|	/* empty */ { $$.EA = 0; }
 ;
 
 
 variable_property:
-		T_OBJECT_OPERATOR object_property { zend_do_push_object(&$2 TSRMLS_CC); } method_or_not { $$.u.EA.type = $4.u.EA.type; }
+		T_OBJECT_OPERATOR object_property { zend_do_push_object(&$2 TSRMLS_CC); } method_or_not { $$.EA = $4.EA; }
 ;
 
 method_or_not:
 		'(' { zend_do_pop_object(&$1 TSRMLS_CC); zend_do_begin_method_call(&$1 TSRMLS_CC); }
 				function_call_parameter_list ')'
 			{ zend_do_end_function_call(&$1, &$$, &$3, 1, 1 TSRMLS_CC); zend_do_extended_fcall_end(TSRMLS_C);
-			  zend_do_push_object(&$$ TSRMLS_CC); $$.u.EA.type = ZEND_PARSED_METHOD_CALL; }
-	|	/* empty */ { zend_do_declare_implicit_property(TSRMLS_C); $$.u.EA.type = ZEND_PARSED_MEMBER; }
+			  zend_do_push_object(&$$ TSRMLS_CC); $$.EA = ZEND_PARSED_METHOD_CALL; }
+	|	/* empty */ { $$.EA = ZEND_PARSED_MEMBER; }
 ;
 
 variable_without_objects:
@@ -875,14 +875,14 @@
 
 base_variable_with_function_calls:
 		base_variable		{ $$ = $1; }
-	|	function_call { zend_do_begin_variable_parse(TSRMLS_C); $$ = $1; $$.u.EA.type = ZEND_PARSED_FUNCTION_CALL; }
+	|	function_call { zend_do_begin_variable_parse(TSRMLS_C); $$ = $1; $$.EA = ZEND_PARSED_FUNCTION_CALL; }
 ;
 
 
 base_variable:
-		reference_variable { $$ = $1; $$.u.EA.type = ZEND_PARSED_VARIABLE; }
-	|	simple_indirect_reference reference_variable { zend_do_indirect_references(&$$, &$1, &$2 TSRMLS_CC); $$.u.EA.type = ZEND_PARSED_VARIABLE; }
-	|	static_member { $$ = $1; $$.u.EA.type = ZEND_PARSED_STATIC_MEMBER; }
+		reference_variable { $$ = $1; $$.EA = ZEND_PARSED_VARIABLE; }
+	|	simple_indirect_reference reference_variable { zend_do_indirect_references(&$$, &$1, &$2 TSRMLS_CC); $$.EA = ZEND_PARSED_VARIABLE; }
+	|	static_member { $$ = $1; $$.EA = ZEND_PARSED_STATIC_MEMBER; }
 ;
 
 reference_variable:
Index: Zend/zend_execute_API.c
===================================================================
--- Zend/zend_execute_API.c	(revision 297868)
+++ Zend/zend_execute_API.c	(working copy)
@@ -1023,7 +1023,7 @@
 }
 /* }}} */
 
-ZEND_API int zend_lookup_class_ex(const char *name, int name_length, int use_autoload, zend_class_entry ***ce TSRMLS_DC) /* {{{ */
+ZEND_API int zend_lookup_class_ex(const char *name, int name_length, const zend_literal *key, int use_autoload, zend_class_entry ***ce TSRMLS_DC) /* {{{ */
 {
 	zval **args[1];
 	zval autoload_function;
@@ -1038,23 +1038,31 @@
 	ulong hash;
 	ALLOCA_FLAG(use_heap)
 
-	if (name == NULL || !name_length) {
-		return FAILURE;
-	}
+	if (key) {
+		lc_name = Z_STRVAL(key->constant);
+		lc_length = Z_STRLEN(key->constant) + 1;
+		hash = key->hash_value;
+	} else {
+		if (name == NULL || !name_length) {
+			return FAILURE;
+		}
 
-	lc_free = lc_name = do_alloca(name_length + 1, use_heap);
-	zend_str_tolower_copy(lc_name, name, name_length);
-	lc_length = name_length + 1;
+		lc_free = lc_name = do_alloca(name_length + 1, use_heap);
+		zend_str_tolower_copy(lc_name, name, name_length);
+		lc_length = name_length + 1;
 
-	if (lc_name[0] == '\\') {
-		lc_name += 1;
-		lc_length -= 1;
+		if (lc_name[0] == '\\') {
+			lc_name += 1;
+			lc_length -= 1;
+		}
+
+		hash = zend_inline_hash_func(lc_name, lc_length);
 	}
 
-	hash = zend_inline_hash_func(lc_name, lc_length);
-
 	if (zend_hash_quick_find(EG(class_table), lc_name, lc_length, hash, (void **) ce) == SUCCESS) {
-		free_alloca(lc_free, use_heap);
+		if (!key) {
+			free_alloca(lc_free, use_heap);
+		}
 		return SUCCESS;
 	}
 
@@ -1062,7 +1070,9 @@
 	 * (doesn't impact fuctionality of __autoload()
 	*/
 	if (!use_autoload || zend_is_compiling(TSRMLS_C)) {
-		free_alloca(lc_free, use_heap);
+		if (!key) {
+			free_alloca(lc_free, use_heap);
+		}
 		return FAILURE;
 	}
 
@@ -1072,7 +1082,9 @@
 	}
 
 	if (zend_hash_quick_add(EG(in_autoload), lc_name, lc_length, hash, (void**)&dummy, sizeof(char), NULL) == FAILURE) {
-		free_alloca(lc_free, use_heap);
+		if (!key) {
+			free_alloca(lc_free, use_heap);
+		}
 		return FAILURE;
 	}
 
@@ -1118,20 +1130,19 @@
 		zval_ptr_dtor(&retval_ptr);
 	}
 
-	if (retval == FAILURE) {
+	if (retval == SUCCESS) {
+		retval = zend_hash_quick_find(EG(class_table), lc_name, lc_length, hash, (void **) ce);
+	}
+	if (!key) {
 		free_alloca(lc_free, use_heap);
-		return FAILURE;
 	}
-
-	retval = zend_hash_quick_find(EG(class_table), lc_name, lc_length, hash, (void **) ce);
-	free_alloca(lc_free, use_heap);
 	return retval;
 }
 /* }}} */
 
 ZEND_API int zend_lookup_class(const char *name, int name_length, zend_class_entry ***ce TSRMLS_DC) /* {{{ */
 {
-	return zend_lookup_class_ex(name, name_length, 1, ce TSRMLS_CC);
+	return zend_lookup_class_ex(name, name_length, NULL, 1, ce TSRMLS_CC);
 }
 /* }}} */
 
@@ -1249,8 +1260,8 @@
 
 	ret_opline = get_next_op(CG(active_op_array) TSRMLS_CC);
 	ret_opline->opcode = ZEND_RETURN;
-	ret_opline->op1.op_type = IS_CONST;
-	INIT_ZVAL(ret_opline->op1.u.constant);
+	ret_opline->op1_type = IS_CONST;
+	ret_opline->op1.constant = zend_add_literal(CG(active_op_array), &EG(uninitialized_zval));
 	SET_UNUSED(ret_opline->op2);
 
 	if (!CG(active_op_array)->start_op) {
@@ -1261,29 +1272,27 @@
 	end=CG(active_op_array)->opcodes+CG(active_op_array)->last;
 
 	while (opline<end) {
-		if (opline->op1.op_type == IS_CONST) {
-			Z_SET_ISREF(opline->op1.u.constant);
-			Z_SET_REFCOUNT(opline->op1.u.constant, 2); /* Make sure is_ref won't be reset */
+		if (opline->op1_type == IS_CONST) {
+			opline->op1.zv = &CG(active_op_array)->literals[opline->op1.constant].constant;
 		}
-		if (opline->op2.op_type == IS_CONST) {
-			Z_SET_ISREF(opline->op2.u.constant);
-			Z_SET_REFCOUNT(opline->op2.u.constant, 2);
+		if (opline->op2_type == IS_CONST) {
+			opline->op2.zv = &CG(active_op_array)->literals[opline->op2.constant].constant;
 		}
 		switch (opline->opcode) {
 			case ZEND_GOTO:
-				if (Z_TYPE(opline->op2.u.constant) != IS_LONG) {
+				if (Z_TYPE_P(opline->op2.zv) != IS_LONG) {
 					zend_resolve_goto_label(CG(active_op_array), opline, 1 TSRMLS_CC);
 				}
 				/* break omitted intentionally */
 			case ZEND_JMP:
-				opline->op1.u.jmp_addr = &CG(active_op_array)->opcodes[opline->op1.u.opline_num];
+				opline->op1.jmp_addr = &CG(active_op_array)->opcodes[opline->op1.opline_num];
 				break;
 			case ZEND_JMPZ:
 			case ZEND_JMPNZ:
 			case ZEND_JMPZ_EX:
 			case ZEND_JMPNZ_EX:
 			case ZEND_JMP_SET:
-				opline->op2.u.jmp_addr = &CG(active_op_array)->opcodes[opline->op2.u.opline_num];
+				opline->op2.jmp_addr = &CG(active_op_array)->opcodes[opline->op2.opline_num];
 				break;
 		}
 		ZEND_VM_SET_OPCODE_HANDLER(opline);
@@ -1547,7 +1556,7 @@
 			break;
 	}
 
-	if (zend_lookup_class_ex(class_name, class_name_len, use_autoload, &pce TSRMLS_CC) == FAILURE) {
+	if (zend_lookup_class_ex(class_name, class_name_len, NULL, use_autoload, &pce TSRMLS_CC) == FAILURE) {
 		if (use_autoload) {
 			if (!silent && !EG(exception)) {
 				if (fetch_type == ZEND_FETCH_CLASS_INTERFACE) {
@@ -1563,6 +1572,27 @@
 }
 /* }}} */
 
+zend_class_entry *zend_fetch_class_by_name(const char *class_name, uint class_name_len, const zend_literal *key, int fetch_type TSRMLS_DC) /* {{{ */
+{
+	zend_class_entry **pce;
+	int use_autoload = (fetch_type & ZEND_FETCH_CLASS_NO_AUTOLOAD) == 0;
+
+	if (zend_lookup_class_ex(class_name, class_name_len, key, use_autoload, &pce TSRMLS_CC) == FAILURE) {
+		if (use_autoload) {
+			if ((fetch_type & ZEND_FETCH_CLASS_SILENT) == 0 && !EG(exception)) {
+				if ((fetch_type & ZEND_FETCH_CLASS_MASK) == ZEND_FETCH_CLASS_INTERFACE) {
+					zend_error(E_ERROR, "Interface '%s' not found", class_name);
+				} else {
+					zend_error(E_ERROR, "Class '%s' not found", class_name);
+				}	
+			}
+		}
+		return NULL;
+	}
+	return *pce;
+}
+/* }}} */
+
 #define MAX_ABSTRACT_INFO_CNT 3
 #define MAX_ABSTRACT_INFO_FMT "%s%s%s%s"
 #define DISPLAY_ABSTRACT_FN(idx) \
@@ -1684,7 +1714,7 @@
 				EG(active_symbol_table) = *(EG(symtable_cache_ptr)--);
 			} else {
 				ALLOC_HASHTABLE(EG(active_symbol_table));
-				zend_hash_init(EG(active_symbol_table), 0, NULL, ZVAL_PTR_DTOR, 0);
+				zend_hash_init(EG(active_symbol_table), ex->op_array->last_var, NULL, ZVAL_PTR_DTOR, 0);
 				/*printf("Cache miss!  Initialized %x\n", EG(active_symbol_table));*/
 			}
 			ex->symbol_table = EG(active_symbol_table);
Index: Zend/zend_vm_def.h
===================================================================
--- Zend/zend_vm_def.h	(revision 297868)
+++ Zend/zend_vm_def.h	(working copy)
@@ -30,7 +30,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	add_function(&EX_T(opline->result.u.var).tmp_var,
+	add_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -43,7 +43,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	sub_function(&EX_T(opline->result.u.var).tmp_var,
+	sub_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -56,7 +56,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	mul_function(&EX_T(opline->result.u.var).tmp_var,
+	mul_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -69,7 +69,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	div_function(&EX_T(opline->result.u.var).tmp_var,
+	div_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -82,7 +82,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	mod_function(&EX_T(opline->result.u.var).tmp_var,
+	mod_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -95,7 +95,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	shift_left_function(&EX_T(opline->result.u.var).tmp_var,
+	shift_left_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -108,7 +108,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	shift_right_function(&EX_T(opline->result.u.var).tmp_var,
+	shift_right_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -121,7 +121,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	concat_function(&EX_T(opline->result.u.var).tmp_var,
+	concat_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -134,7 +134,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	is_identical_function(&EX_T(opline->result.u.var).tmp_var,
+	is_identical_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -146,7 +146,7 @@
 {
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
-	zval *result = &EX_T(opline->result.u.var).tmp_var;
+	zval *result = &EX_T(opline->result.var).tmp_var;
 
 	is_identical_function(result,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
@@ -161,7 +161,7 @@
 {
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
-	zval *result = &EX_T(opline->result.u.var).tmp_var;
+	zval *result = &EX_T(opline->result.var).tmp_var;
 
 	compare_function(result,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
@@ -176,7 +176,7 @@
 {
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
-	zval *result = &EX_T(opline->result.u.var).tmp_var;
+	zval *result = &EX_T(opline->result.var).tmp_var;
 
 	compare_function(result,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
@@ -191,7 +191,7 @@
 {
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
-	zval *result = &EX_T(opline->result.u.var).tmp_var;
+	zval *result = &EX_T(opline->result.var).tmp_var;
 
 	compare_function(result,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
@@ -206,7 +206,7 @@
 {
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
-	zval *result = &EX_T(opline->result.u.var).tmp_var;
+	zval *result = &EX_T(opline->result.var).tmp_var;
 
 	compare_function(result,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
@@ -222,7 +222,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	bitwise_or_function(&EX_T(opline->result.u.var).tmp_var,
+	bitwise_or_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -235,7 +235,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	bitwise_and_function(&EX_T(opline->result.u.var).tmp_var,
+	bitwise_and_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -248,7 +248,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	bitwise_xor_function(&EX_T(opline->result.u.var).tmp_var,
+	bitwise_xor_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -261,7 +261,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
 
-	boolean_xor_function(&EX_T(opline->result.u.var).tmp_var,
+	boolean_xor_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R),
 		GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
@@ -274,7 +274,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1;
 
-	bitwise_not_function(&EX_T(opline->result.u.var).tmp_var,
+	bitwise_not_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
 	ZEND_VM_NEXT_OPCODE();
@@ -285,7 +285,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1;
 
-	boolean_not_function(&EX_T(opline->result.u.var).tmp_var,
+	boolean_not_function(&EX_T(opline->result.var).tmp_var,
 		GET_OP1_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 	FREE_OP1();
 	ZEND_VM_NEXT_OPCODE();
@@ -299,15 +299,15 @@
 	zval **object_ptr = GET_OP1_OBJ_ZVAL_PTR_PTR(BP_VAR_W);
 	zval *object;
 	zval *property = GET_OP2_ZVAL_PTR(BP_VAR_R);
-	zval *value = get_zval_ptr(&op_data->op1, EX(Ts), &free_op_data1, BP_VAR_R);
-	znode *result = &opline->result;
+	zval *value = get_zval_ptr(op_data->op1_type, &op_data->op1, EX(Ts), &free_op_data1, BP_VAR_R);
+	znode_op *result = &opline->result;
 	int have_get_ptr = 0;
 
 	if (OP1_TYPE == IS_VAR && !object_ptr) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an object");
 	}
 
-	EX_T(result->u.var).var.ptr_ptr = NULL;
+	EX_T(result->var).var.ptr_ptr = NULL;
 	make_real_object(object_ptr TSRMLS_CC);
 	object = *object_ptr;
 
@@ -316,9 +316,9 @@
 		FREE_OP2();
 		FREE_OP(free_op_data1);
 
-		if (!RETURN_VALUE_UNUSED(result)) {
-			EX_T(result->u.var).var.ptr = EG(uninitialized_zval_ptr);
-			EX_T(result->u.var).var.ptr_ptr = NULL;
+		if (RETURN_VALUE_USED(opline)) {
+			EX_T(result->var).var.ptr = EG(uninitialized_zval_ptr);
+			EX_T(result->var).var.ptr_ptr = NULL;
 			PZVAL_LOCK(EG(uninitialized_zval_ptr));
 		}
 	} else {
@@ -330,15 +330,15 @@
 		/* here property is a string */
 		if (opline->extended_value == ZEND_ASSIGN_OBJ
 			&& Z_OBJ_HT_P(object)->get_property_ptr_ptr) {
-			zval **zptr = Z_OBJ_HT_P(object)->get_property_ptr_ptr(object, property TSRMLS_CC);
+			zval **zptr = Z_OBJ_HT_P(object)->get_property_ptr_ptr(object, property, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 			if (zptr != NULL) { 			/* NULL means no success in getting PTR */
 				SEPARATE_ZVAL_IF_NOT_REF(zptr);
 
 				have_get_ptr = 1;
 				binary_op(*zptr, *zptr, value TSRMLS_CC);
-				if (!RETURN_VALUE_UNUSED(result)) {
-					EX_T(result->u.var).var.ptr = *zptr;
-					EX_T(result->u.var).var.ptr_ptr = NULL;
+				if (RETURN_VALUE_USED(opline)) {
+					EX_T(result->var).var.ptr = *zptr;
+					EX_T(result->var).var.ptr_ptr = NULL;
 					PZVAL_LOCK(*zptr);
 				}
 			}
@@ -349,7 +349,7 @@
 
 			if (opline->extended_value == ZEND_ASSIGN_OBJ) {
 				if (Z_OBJ_HT_P(object)->read_property) {
-					z = Z_OBJ_HT_P(object)->read_property(object, property, BP_VAR_R TSRMLS_CC);
+					z = Z_OBJ_HT_P(object)->read_property(object, property, BP_VAR_R, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 				}
 			} else /* if (opline->extended_value == ZEND_ASSIGN_DIM) */ {
 				if (Z_OBJ_HT_P(object)->read_dimension) {
@@ -371,21 +371,21 @@
 				SEPARATE_ZVAL_IF_NOT_REF(&z);
 				binary_op(z, z, value TSRMLS_CC);
 				if (opline->extended_value == ZEND_ASSIGN_OBJ) {
-					Z_OBJ_HT_P(object)->write_property(object, property, z TSRMLS_CC);
+					Z_OBJ_HT_P(object)->write_property(object, property, z, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 				} else /* if (opline->extended_value == ZEND_ASSIGN_DIM) */ {
 					Z_OBJ_HT_P(object)->write_dimension(object, property, z TSRMLS_CC);
 				}
-				if (!RETURN_VALUE_UNUSED(result)) {
-					EX_T(result->u.var).var.ptr = z;
-					EX_T(result->u.var).var.ptr_ptr = NULL;
+				if (RETURN_VALUE_USED(opline)) {
+					EX_T(result->var).var.ptr = z;
+					EX_T(result->var).var.ptr_ptr = NULL;
 					PZVAL_LOCK(z);
 				}
 				zval_ptr_dtor(&z);
 			} else {
 				zend_error(E_WARNING, "Attempt to assign property of non-object");
-				if (!RETURN_VALUE_UNUSED(result)) {
-					EX_T(result->u.var).var.ptr = EG(uninitialized_zval_ptr);
-					EX_T(result->u.var).var.ptr_ptr = NULL;
+				if (RETURN_VALUE_USED(opline)) {
+					EX_T(result->var).var.ptr = EG(uninitialized_zval_ptr);
+					EX_T(result->var).var.ptr_ptr = NULL;
 					PZVAL_LOCK(EG(uninitialized_zval_ptr));
 				}
 			}
@@ -430,9 +430,9 @@
 					zend_op *op_data = opline+1;
 					zval *dim = GET_OP2_ZVAL_PTR(BP_VAR_R);
 
-					zend_fetch_dimension_address(&EX_T(op_data->op2.u.var), container, dim, IS_OP2_TMP_FREE(), BP_VAR_RW TSRMLS_CC);
-					value = get_zval_ptr(&op_data->op1, EX(Ts), &free_op_data1, BP_VAR_R);
-					var_ptr = _get_zval_ptr_ptr_var(&op_data->op2, EX(Ts), &free_op_data2 TSRMLS_CC);
+					zend_fetch_dimension_address(&EX_T(op_data->op2.var), container, dim, OP2_TYPE, BP_VAR_RW TSRMLS_CC);
+					value = get_zval_ptr(op_data->op1_type, &op_data->op1, EX(Ts), &free_op_data1, BP_VAR_R);
+					var_ptr = _get_zval_ptr_ptr_var(op_data->op2.var, EX(Ts), &free_op_data2 TSRMLS_CC);
 					ZEND_VM_INC_OPCODE();
 				}
 			}
@@ -449,8 +449,8 @@
 	}
 
 	if (*var_ptr == EG(error_zval_ptr)) {
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, EG(uninitialized_zval_ptr));
+		if (RETURN_VALUE_USED(opline)) {
+			AI_SET_PTR(EX_T(opline->result.var).var, EG(uninitialized_zval_ptr));
 			PZVAL_LOCK(EG(uninitialized_zval_ptr));
 		}
 		FREE_OP2();
@@ -472,8 +472,8 @@
 		binary_op(*var_ptr, *var_ptr, value TSRMLS_CC);
 	}
 
-	if (!RETURN_VALUE_UNUSED(&opline->result)) {
-		AI_SET_PTR(EX_T(opline->result.u.var).var, *var_ptr);
+	if (RETURN_VALUE_USED(opline)) {
+		AI_SET_PTR(EX_T(opline->result.var).var, *var_ptr);
 		PZVAL_LOCK(*var_ptr);
 	}
 	FREE_OP2();
@@ -548,7 +548,7 @@
 	zval **object_ptr = GET_OP1_OBJ_ZVAL_PTR_PTR(BP_VAR_W);
 	zval *object;
 	zval *property = GET_OP2_ZVAL_PTR(BP_VAR_R);
-	zval **retval = &EX_T(opline->result.u.var).var.ptr;
+	zval **retval = &EX_T(opline->result.var).var.ptr;
 	int have_get_ptr = 0;
 
 	if (OP1_TYPE == IS_VAR && !object_ptr) {
@@ -561,7 +561,7 @@
 	if (Z_TYPE_P(object) != IS_OBJECT) {
 		zend_error(E_WARNING, "Attempt to increment/decrement property of non-object");
 		FREE_OP2();
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
+		if (RETURN_VALUE_USED(opline)) {
 			*retval = EG(uninitialized_zval_ptr);
 			PZVAL_LOCK(*retval);
 		}
@@ -576,13 +576,13 @@
 	}
 
 	if (Z_OBJ_HT_P(object)->get_property_ptr_ptr) {
-		zval **zptr = Z_OBJ_HT_P(object)->get_property_ptr_ptr(object, property TSRMLS_CC);
+		zval **zptr = Z_OBJ_HT_P(object)->get_property_ptr_ptr(object, property, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 		if (zptr != NULL) { 			/* NULL means no success in getting PTR */
 			SEPARATE_ZVAL_IF_NOT_REF(zptr);
 
 			have_get_ptr = 1;
 			incdec_op(*zptr);
-			if (!RETURN_VALUE_UNUSED(&opline->result)) {
+			if (RETURN_VALUE_USED(opline)) {
 				*retval = *zptr;
 				PZVAL_LOCK(*retval);
 			}
@@ -591,7 +591,7 @@
 
 	if (!have_get_ptr) {
 		if (Z_OBJ_HT_P(object)->read_property && Z_OBJ_HT_P(object)->write_property) {
-			zval *z = Z_OBJ_HT_P(object)->read_property(object, property, BP_VAR_R TSRMLS_CC);
+			zval *z = Z_OBJ_HT_P(object)->read_property(object, property, BP_VAR_R, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 
 			if (Z_TYPE_P(z) == IS_OBJECT && Z_OBJ_HT_P(z)->get) {
 				zval *value = Z_OBJ_HT_P(z)->get(z TSRMLS_CC);
@@ -607,12 +607,12 @@
 			SEPARATE_ZVAL_IF_NOT_REF(&z);
 			incdec_op(z);
 			*retval = z;
-			Z_OBJ_HT_P(object)->write_property(object, property, z TSRMLS_CC);
-			SELECTIVE_PZVAL_LOCK(*retval, &opline->result);
+			Z_OBJ_HT_P(object)->write_property(object, property, z, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
+			SELECTIVE_PZVAL_LOCK(*retval, opline);
 			zval_ptr_dtor(&z);
 		} else {
 			zend_error(E_WARNING, "Attempt to increment/decrement property of non-object");
-			if (!RETURN_VALUE_UNUSED(&opline->result)) {
+			if (RETURN_VALUE_USED(opline)) {
 				*retval = EG(uninitialized_zval_ptr);
 				PZVAL_LOCK(*retval);
 			}
@@ -645,7 +645,7 @@
 	zval **object_ptr = GET_OP1_OBJ_ZVAL_PTR_PTR(BP_VAR_W);
 	zval *object;
 	zval *property = GET_OP2_ZVAL_PTR(BP_VAR_R);
-	zval *retval = &EX_T(opline->result.u.var).tmp_var;
+	zval *retval = &EX_T(opline->result.var).tmp_var;
 	int have_get_ptr = 0;
 
 	if (OP1_TYPE == IS_VAR && !object_ptr) {
@@ -670,7 +670,7 @@
 	}
 
 	if (Z_OBJ_HT_P(object)->get_property_ptr_ptr) {
-		zval **zptr = Z_OBJ_HT_P(object)->get_property_ptr_ptr(object, property TSRMLS_CC);
+		zval **zptr = Z_OBJ_HT_P(object)->get_property_ptr_ptr(object, property, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 		if (zptr != NULL) { 			/* NULL means no success in getting PTR */
 			have_get_ptr = 1;
 			SEPARATE_ZVAL_IF_NOT_REF(zptr);
@@ -685,7 +685,7 @@
 
 	if (!have_get_ptr) {
 		if (Z_OBJ_HT_P(object)->read_property && Z_OBJ_HT_P(object)->write_property) {
-			zval *z = Z_OBJ_HT_P(object)->read_property(object, property, BP_VAR_R TSRMLS_CC);
+			zval *z = Z_OBJ_HT_P(object)->read_property(object, property, BP_VAR_R, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 			zval *z_copy;
 
 			if (Z_TYPE_P(z) == IS_OBJECT && Z_OBJ_HT_P(z)->get) {
@@ -706,7 +706,7 @@
 			INIT_PZVAL(z_copy);
 			incdec_op(z_copy);
 			Z_ADDREF_P(z);
-			Z_OBJ_HT_P(object)->write_property(object, property, z_copy TSRMLS_CC);
+			Z_OBJ_HT_P(object)->write_property(object, property, z_copy, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 			zval_ptr_dtor(&z_copy);
 			zval_ptr_dtor(&z);
 		} else {
@@ -744,8 +744,8 @@
 		zend_error_noreturn(E_ERROR, "Cannot increment/decrement overloaded objects nor string offsets");
 	}
 	if (OP1_TYPE == IS_VAR && *var_ptr == EG(error_zval_ptr)) {
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, EG(uninitialized_zval_ptr));
+		if (RETURN_VALUE_USED(opline)) {
+			AI_SET_PTR(EX_T(opline->result.var).var, EG(uninitialized_zval_ptr));
 			PZVAL_LOCK(EG(uninitialized_zval_ptr));
 		}
 		FREE_OP1_VAR_PTR();
@@ -766,8 +766,8 @@
 		increment_function(*var_ptr);
 	}
 
-	if (!RETURN_VALUE_UNUSED(&opline->result)) {
-		AI_SET_PTR(EX_T(opline->result.u.var).var, *var_ptr);
+	if (RETURN_VALUE_USED(opline)) {
+		AI_SET_PTR(EX_T(opline->result.var).var, *var_ptr);
 		PZVAL_LOCK(*var_ptr);
 	}
 
@@ -785,8 +785,8 @@
 		zend_error_noreturn(E_ERROR, "Cannot increment/decrement overloaded objects nor string offsets");
 	}
 	if (OP1_TYPE == IS_VAR && *var_ptr == EG(error_zval_ptr)) {
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, EG(uninitialized_zval_ptr));
+		if (RETURN_VALUE_USED(opline)) {
+			AI_SET_PTR(EX_T(opline->result.var).var, EG(uninitialized_zval_ptr));
 			PZVAL_LOCK(EG(uninitialized_zval_ptr));
 		}
 		FREE_OP1_VAR_PTR();
@@ -807,8 +807,8 @@
 		decrement_function(*var_ptr);
 	}
 
-	if (!RETURN_VALUE_UNUSED(&opline->result)) {
-		AI_SET_PTR(EX_T(opline->result.u.var).var, *var_ptr);
+	if (RETURN_VALUE_USED(opline)) {
+		AI_SET_PTR(EX_T(opline->result.var).var, *var_ptr);
 		PZVAL_LOCK(*var_ptr);
 	}
 
@@ -826,15 +826,15 @@
 		zend_error_noreturn(E_ERROR, "Cannot increment/decrement overloaded objects nor string offsets");
 	}
 	if (OP1_TYPE == IS_VAR && *var_ptr == EG(error_zval_ptr)) {
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			EX_T(opline->result.u.var).tmp_var = *EG(uninitialized_zval_ptr);
+		if (RETURN_VALUE_USED(opline)) {
+			EX_T(opline->result.var).tmp_var = *EG(uninitialized_zval_ptr);
 		}
 		FREE_OP1_VAR_PTR();
 		ZEND_VM_NEXT_OPCODE();
 	}
 
-	EX_T(opline->result.u.var).tmp_var = **var_ptr;
-	zendi_zval_copy_ctor(EX_T(opline->result.u.var).tmp_var);
+	EX_T(opline->result.var).tmp_var = **var_ptr;
+	zendi_zval_copy_ctor(EX_T(opline->result.var).tmp_var);
 
 	SEPARATE_ZVAL_IF_NOT_REF(var_ptr);
 
@@ -864,15 +864,15 @@
 		zend_error_noreturn(E_ERROR, "Cannot increment/decrement overloaded objects nor string offsets");
 	}
 	if (OP1_TYPE == IS_VAR && *var_ptr == EG(error_zval_ptr)) {
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			EX_T(opline->result.u.var).tmp_var = *EG(uninitialized_zval_ptr);
+		if (RETURN_VALUE_USED(opline)) {
+			EX_T(opline->result.var).tmp_var = *EG(uninitialized_zval_ptr);
 		}
 		FREE_OP1_VAR_PTR();
 		ZEND_VM_NEXT_OPCODE();
 	}
 
-	EX_T(opline->result.u.var).tmp_var = **var_ptr;
-	zendi_zval_copy_ctor(EX_T(opline->result.u.var).tmp_var);
+	EX_T(opline->result.var).tmp_var = **var_ptr;
+	zendi_zval_copy_ctor(EX_T(opline->result.var).tmp_var);
 
 	SEPARATE_ZVAL_IF_NOT_REF(var_ptr);
 
@@ -916,8 +916,8 @@
 {
 	zend_op *opline = EX(opline);
 
-	Z_LVAL(EX_T(opline->result.u.var).tmp_var) = 1;
-	Z_TYPE(EX_T(opline->result.u.var).tmp_var) = IS_LONG;
+	Z_LVAL(EX_T(opline->result.var).tmp_var) = 1;
+	Z_TYPE(EX_T(opline->result.var).tmp_var) = IS_LONG;
 
 	ZEND_VM_DISPATCH_TO_HANDLER(ZEND_ECHO);
 }
@@ -930,6 +930,7 @@
 	zval **retval;
 	zval tmp_varname;
 	HashTable *target_symbol_table;
+	ulong hash_value;
 
  	if (OP1_TYPE != IS_CONST && Z_TYPE_P(varname) != IS_STRING) {
 		tmp_varname = *varname;
@@ -938,17 +939,23 @@
 		varname = &tmp_varname;
 	}
 
-	if (opline->op2.u.EA.type == ZEND_FETCH_STATIC_MEMBER) {
-		retval = zend_std_get_static_property(EX_T(opline->op2.u.var).class_entry, Z_STRVAL_P(varname), Z_STRLEN_P(varname), 0 TSRMLS_CC);
+	if ((opline->extended_value & ZEND_FETCH_TYPE_MASK) == ZEND_FETCH_STATIC_MEMBER) {
+		retval = zend_std_get_static_property(EX_T(opline->op2.var).class_entry, Z_STRVAL_P(varname), Z_STRLEN_P(varname), 0, ((OP1_TYPE == IS_CONST) ? opline->op1.literal : NULL) TSRMLS_CC);
 		FREE_OP1();
 	} else {
-		target_symbol_table = zend_get_target_symbol_table(opline, EX(Ts), type, varname TSRMLS_CC);
+		target_symbol_table = zend_get_target_symbol_table(opline->extended_value & ZEND_FETCH_TYPE_MASK TSRMLS_CC);
 /*
 		if (!target_symbol_table) {
 			ZEND_VM_NEXT_OPCODE();
 		}
 */
-		if (zend_hash_find(target_symbol_table, varname->value.str.val, varname->value.str.len+1, (void **) &retval) == FAILURE) {
+		if (OP1_TYPE == IS_CONST) {
+			hash_value = Z_HASH_P(varname);
+		} else {
+			hash_value = zend_hash_func(Z_STRVAL_P(varname), Z_STRLEN_P(varname)+1);
+		}
+
+		if (zend_hash_quick_find(target_symbol_table, Z_STRVAL_P(varname), Z_STRLEN_P(varname)+1, hash_value, (void **) &retval) == FAILURE) {
 			switch (type) {
 				case BP_VAR_R:
 				case BP_VAR_UNSET:
@@ -964,13 +971,13 @@
 						zval *new_zval = &EG(uninitialized_zval);
 
 						Z_ADDREF_P(new_zval);
-						zend_hash_update(target_symbol_table, varname->value.str.val, varname->value.str.len+1, &new_zval, sizeof(zval *), (void **) &retval);
+						zend_hash_quick_update(target_symbol_table, Z_STRVAL_P(varname), Z_STRLEN_P(varname)+1, hash_value, &new_zval, sizeof(zval *), (void **) &retval);
 					}
 					break;
 				EMPTY_SWITCH_DEFAULT_CASE()
 			}
 		}
-		switch (opline->op2.u.EA.type) {
+		switch (opline->extended_value & ZEND_FETCH_TYPE_MASK) {
 			case ZEND_FETCH_GLOBAL:
 				if (OP1_TYPE != IS_TMP_VAR) {
 					FREE_OP1();
@@ -984,7 +991,7 @@
 				break;
 			case ZEND_FETCH_GLOBAL_LOCK:
 				if (OP1_TYPE == IS_VAR && !free_op1.var) {
-					PZVAL_LOCK(*EX_T(opline->op1.u.var).var.ptr_ptr);
+					PZVAL_LOCK(*EX_T(opline->op1.var).var.ptr_ptr);
 				}
 				break;
 		}
@@ -994,7 +1001,7 @@
 	if (OP1_TYPE != IS_CONST && varname == &tmp_varname) {
 		zval_dtor(varname);
 	}
-	if (!RETURN_VALUE_UNUSED(&opline->result)) {
+	if (RETURN_VALUE_USED(opline)) {
 		if (opline->extended_value & ZEND_FETCH_MAKE_REF) {
 			SEPARATE_ZVAL_TO_MAKE_IS_REF(retval);
 		}
@@ -1002,21 +1009,21 @@
 		switch (type) {
 			case BP_VAR_R:
 			case BP_VAR_IS:
-				AI_SET_PTR(EX_T(opline->result.u.var).var, *retval);
+				AI_SET_PTR(EX_T(opline->result.var).var, *retval);
 				break;
 			case BP_VAR_UNSET: {
 				zend_free_op free_res;
 
-				EX_T(opline->result.u.var).var.ptr_ptr = retval;
-				PZVAL_UNLOCK(*EX_T(opline->result.u.var).var.ptr_ptr, &free_res);
-				if (EX_T(opline->result.u.var).var.ptr_ptr != &EG(uninitialized_zval_ptr)) {
-					SEPARATE_ZVAL_IF_NOT_REF(EX_T(opline->result.u.var).var.ptr_ptr);
+				EX_T(opline->result.var).var.ptr_ptr = retval;
+				PZVAL_UNLOCK(*EX_T(opline->result.var).var.ptr_ptr, &free_res);
+				if (EX_T(opline->result.var).var.ptr_ptr != &EG(uninitialized_zval_ptr)) {
+					SEPARATE_ZVAL_IF_NOT_REF(EX_T(opline->result.var).var.ptr_ptr);
 				}
-				PZVAL_LOCK(*EX_T(opline->result.u.var).var.ptr_ptr);
+				PZVAL_LOCK(*EX_T(opline->result.var).var.ptr_ptr);
 				FREE_OP_VAR_PTR(free_res);
 				break;
 			default:
-				EX_T(opline->result.u.var).var.ptr_ptr = retval;
+				EX_T(opline->result.var).var.ptr_ptr = retval;
 				break;
 			}
 		}
@@ -1042,7 +1049,7 @@
 ZEND_VM_HANDLER(92, ZEND_FETCH_FUNC_ARG, CONST|TMP|VAR|CV, ANY)
 {
 	ZEND_VM_DISPATCH_TO_HELPER_EX(zend_fetch_var_address_helper, type,
-		ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), EX(opline)->extended_value)?BP_VAR_W:BP_VAR_R);
+		ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), (EX(opline)->extended_value & ZEND_FETCH_ARG_MASK))?BP_VAR_W:BP_VAR_R);
 }
 
 ZEND_VM_HANDLER(95, ZEND_FETCH_UNSET, CONST|TMP|VAR|CV, ANY)
@@ -1062,16 +1069,16 @@
 	zval *dim = GET_OP2_ZVAL_PTR(BP_VAR_R);
 	zval **container;
 
-	if (opline->extended_value == ZEND_FETCH_ADD_LOCK &&
+	if ((opline->extended_value & ZEND_FETCH_ADD_LOCK) &&
 	    OP1_TYPE != IS_CV &&
-	    EX_T(opline->op1.u.var).var.ptr_ptr) {
-		PZVAL_LOCK(*EX_T(opline->op1.u.var).var.ptr_ptr);
+	    EX_T(opline->op1.var).var.ptr_ptr) {
+		PZVAL_LOCK(*EX_T(opline->op1.var).var.ptr_ptr);
 	}
 	container = GET_OP1_ZVAL_PTR_PTR(BP_VAR_R);
 	if (OP1_TYPE == IS_VAR && !container) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an array");
 	}
-	zend_fetch_dimension_address_read(RETURN_VALUE_UNUSED(&opline->result)?NULL:&EX_T(opline->result.u.var), container, dim, IS_OP2_TMP_FREE(), BP_VAR_R TSRMLS_CC);
+	zend_fetch_dimension_address_read(!RETURN_VALUE_USED(opline)?NULL:&EX_T(opline->result.var), container, dim, OP2_TYPE, BP_VAR_R TSRMLS_CC);
 	FREE_OP2();
 	FREE_OP1_VAR_PTR();
 	ZEND_VM_NEXT_OPCODE();
@@ -1087,23 +1094,23 @@
 	if (OP1_TYPE == IS_VAR && !container) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an array");
 	}
-	zend_fetch_dimension_address(&EX_T(opline->result.u.var), container, dim, IS_OP2_TMP_FREE(), BP_VAR_W TSRMLS_CC);
+	zend_fetch_dimension_address(&EX_T(opline->result.var), container, dim, OP2_TYPE, BP_VAR_W TSRMLS_CC);
 	FREE_OP2();
 	if (OP1_TYPE == IS_VAR && OP1_FREE &&
 	    READY_TO_DESTROY(free_op1.var)) {
-		AI_USE_PTR(EX_T(opline->result.u.var).var);
-		if (!PZVAL_IS_REF(*EX_T(opline->result.u.var).var.ptr_ptr) &&
-		    Z_REFCOUNT_PP(EX_T(opline->result.u.var).var.ptr_ptr) > 2) {
-			SEPARATE_ZVAL(EX_T(opline->result.u.var).var.ptr_ptr);
+		AI_USE_PTR(EX_T(opline->result.var).var);
+		if (!PZVAL_IS_REF(*EX_T(opline->result.var).var.ptr_ptr) &&
+		    Z_REFCOUNT_PP(EX_T(opline->result.var).var.ptr_ptr) > 2) {
+			SEPARATE_ZVAL(EX_T(opline->result.var).var.ptr_ptr);
 		}
 	}
 	FREE_OP1_VAR_PTR();
 
 	/* We are going to assign the result by reference */
-	if (opline->extended_value && EX_T(opline->result.u.var).var.ptr_ptr) {
-		Z_DELREF_PP(EX_T(opline->result.u.var).var.ptr_ptr);
-		SEPARATE_ZVAL_TO_MAKE_IS_REF(EX_T(opline->result.u.var).var.ptr_ptr);
-		Z_ADDREF_PP(EX_T(opline->result.u.var).var.ptr_ptr);
+	if (opline->extended_value && EX_T(opline->result.var).var.ptr_ptr) {
+		Z_DELREF_PP(EX_T(opline->result.var).var.ptr_ptr);
+		SEPARATE_ZVAL_TO_MAKE_IS_REF(EX_T(opline->result.var).var.ptr_ptr);
+		Z_ADDREF_PP(EX_T(opline->result.var).var.ptr_ptr);
 	}
 
 	ZEND_VM_NEXT_OPCODE();
@@ -1119,14 +1126,14 @@
 	if (OP1_TYPE == IS_VAR && !container) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an array");
 	}
-	zend_fetch_dimension_address(&EX_T(opline->result.u.var), container, dim, IS_OP2_TMP_FREE(), BP_VAR_RW TSRMLS_CC);
+	zend_fetch_dimension_address(&EX_T(opline->result.var), container, dim, OP2_TYPE, BP_VAR_RW TSRMLS_CC);
 	FREE_OP2();
 	if (OP1_TYPE == IS_VAR && OP1_FREE &&
 	    READY_TO_DESTROY(free_op1.var)) {
-		AI_USE_PTR(EX_T(opline->result.u.var).var);
-		if (!PZVAL_IS_REF(*EX_T(opline->result.u.var).var.ptr_ptr) &&
-		    Z_REFCOUNT_PP(EX_T(opline->result.u.var).var.ptr_ptr) > 2) {
-			SEPARATE_ZVAL(EX_T(opline->result.u.var).var.ptr_ptr);
+		AI_USE_PTR(EX_T(opline->result.var).var);
+		if (!PZVAL_IS_REF(*EX_T(opline->result.var).var.ptr_ptr) &&
+		    Z_REFCOUNT_PP(EX_T(opline->result.var).var.ptr_ptr) > 2) {
+			SEPARATE_ZVAL(EX_T(opline->result.var).var.ptr_ptr);
 		}
 	}
 	FREE_OP1_VAR_PTR();
@@ -1143,7 +1150,7 @@
 	if (OP1_TYPE == IS_VAR && !container) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an array");
 	}
-	zend_fetch_dimension_address_read(&EX_T(opline->result.u.var), container, dim, IS_OP2_TMP_FREE(), BP_VAR_IS TSRMLS_CC);
+	zend_fetch_dimension_address_read(&EX_T(opline->result.var), container, dim, OP2_TYPE, BP_VAR_IS TSRMLS_CC);
 	FREE_OP2();
 	FREE_OP1_VAR_PTR();
 	ZEND_VM_NEXT_OPCODE();
@@ -1156,18 +1163,18 @@
 	zval *dim = GET_OP2_ZVAL_PTR(BP_VAR_R);
 	zval **container;
 
-	if (ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), opline->extended_value)) {
+	if (ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), (opline->extended_value & ZEND_FETCH_ARG_MASK))) {
 		container = GET_OP1_ZVAL_PTR_PTR(BP_VAR_W);
 		if (OP1_TYPE == IS_VAR && !container) {
 			zend_error_noreturn(E_ERROR, "Cannot use string offset as an array");
 		}
-		zend_fetch_dimension_address(&EX_T(opline->result.u.var), container, dim, IS_OP2_TMP_FREE(), BP_VAR_W TSRMLS_CC);
+		zend_fetch_dimension_address(&EX_T(opline->result.var), container, dim, OP2_TYPE, BP_VAR_W TSRMLS_CC);
 		if (OP1_TYPE == IS_VAR && OP1_FREE &&
 		    READY_TO_DESTROY(free_op1.var)) {
-			AI_USE_PTR(EX_T(opline->result.u.var).var);
-			if (!PZVAL_IS_REF(*EX_T(opline->result.u.var).var.ptr_ptr) &&
-			    Z_REFCOUNT_PP(EX_T(opline->result.u.var).var.ptr_ptr) > 2) {
-				SEPARATE_ZVAL(EX_T(opline->result.u.var).var.ptr_ptr);
+			AI_USE_PTR(EX_T(opline->result.var).var);
+			if (!PZVAL_IS_REF(*EX_T(opline->result.var).var.ptr_ptr) &&
+			    Z_REFCOUNT_PP(EX_T(opline->result.var).var.ptr_ptr) > 2) {
+				SEPARATE_ZVAL(EX_T(opline->result.var).var.ptr_ptr);
 			}
 		}
 	} else {
@@ -1178,7 +1185,7 @@
 		if (OP1_TYPE == IS_VAR && !container) {
 			zend_error_noreturn(E_ERROR, "Cannot use string offset as an array");
 		}
-		zend_fetch_dimension_address_read(&EX_T(opline->result.u.var), container, dim, IS_OP2_TMP_FREE(), BP_VAR_R TSRMLS_CC);
+		zend_fetch_dimension_address_read(&EX_T(opline->result.var), container, dim, OP2_TYPE, BP_VAR_R TSRMLS_CC);
 	}
 	FREE_OP2();
 	FREE_OP1_VAR_PTR();
@@ -1193,8 +1200,8 @@
 	zval *dim = GET_OP2_ZVAL_PTR(BP_VAR_R);
 
 	/* Not needed in DIM_UNSET
-	if (opline->extended_value == ZEND_FETCH_ADD_LOCK) {
-		PZVAL_LOCK(*EX_T(opline->op1.u.var).var.ptr_ptr);
+	if (opline->extended_value & ZEND_FETCH_ADD_LOCK) {
+		PZVAL_LOCK(*EX_T(opline->op1.var).var.ptr_ptr);
 	}
 	*/
 	if (OP1_TYPE == IS_CV) {
@@ -1205,27 +1212,27 @@
 	if (OP1_TYPE == IS_VAR && !container) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an array");
 	}
-	zend_fetch_dimension_address(&EX_T(opline->result.u.var), container, dim, IS_OP2_TMP_FREE(), BP_VAR_UNSET TSRMLS_CC);
+	zend_fetch_dimension_address(&EX_T(opline->result.var), container, dim, OP2_TYPE, BP_VAR_UNSET TSRMLS_CC);
 	FREE_OP2();
 	if (OP1_TYPE == IS_VAR && OP1_FREE &&
 	    READY_TO_DESTROY(free_op1.var)) {
-		AI_USE_PTR(EX_T(opline->result.u.var).var);
-		if (!PZVAL_IS_REF(*EX_T(opline->result.u.var).var.ptr_ptr) &&
-		    Z_REFCOUNT_PP(EX_T(opline->result.u.var).var.ptr_ptr) > 2) {
-			SEPARATE_ZVAL(EX_T(opline->result.u.var).var.ptr_ptr);
+		AI_USE_PTR(EX_T(opline->result.var).var);
+		if (!PZVAL_IS_REF(*EX_T(opline->result.var).var.ptr_ptr) &&
+		    Z_REFCOUNT_PP(EX_T(opline->result.var).var.ptr_ptr) > 2) {
+			SEPARATE_ZVAL(EX_T(opline->result.var).var.ptr_ptr);
 		}
 	}
 	FREE_OP1_VAR_PTR();
-	if (EX_T(opline->result.u.var).var.ptr_ptr == NULL) {
+	if (EX_T(opline->result.var).var.ptr_ptr == NULL) {
 		zend_error_noreturn(E_ERROR, "Cannot unset string offsets");
 	} else {
 		zend_free_op free_res;
 
-		PZVAL_UNLOCK(*EX_T(opline->result.u.var).var.ptr_ptr, &free_res);
-		if (EX_T(opline->result.u.var).var.ptr_ptr != &EG(uninitialized_zval_ptr)) {
-			SEPARATE_ZVAL_IF_NOT_REF(EX_T(opline->result.u.var).var.ptr_ptr);
+		PZVAL_UNLOCK(*EX_T(opline->result.var).var.ptr_ptr, &free_res);
+		if (EX_T(opline->result.var).var.ptr_ptr != &EG(uninitialized_zval_ptr)) {
+			SEPARATE_ZVAL_IF_NOT_REF(EX_T(opline->result.var).var.ptr_ptr);
 		}
-		PZVAL_LOCK(*EX_T(opline->result.u.var).var.ptr_ptr);
+		PZVAL_LOCK(*EX_T(opline->result.var).var.ptr_ptr);
 		FREE_OP_VAR_PTR(free_res);
 	}
 	ZEND_VM_NEXT_OPCODE();
@@ -1243,8 +1250,8 @@
 		if (type != BP_VAR_IS) {
 			zend_error(E_NOTICE, "Trying to get property of non-object");
 		}
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, EG(uninitialized_zval_ptr));
+		if (RETURN_VALUE_USED(opline)) {
+			AI_SET_PTR(EX_T(opline->result.var).var, EG(uninitialized_zval_ptr));
 			PZVAL_LOCK(EG(uninitialized_zval_ptr));
 		}
 		FREE_OP2();
@@ -1256,16 +1263,16 @@
 		}
 
 		/* here we are sure we are dealing with an object */
-		retval = Z_OBJ_HT_P(container)->read_property(container, offset, type TSRMLS_CC);
+		retval = Z_OBJ_HT_P(container)->read_property(container, offset, type, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 
-		if (RETURN_VALUE_UNUSED(&opline->result)) {
+		if (!RETURN_VALUE_USED(opline)) {
 			if (Z_REFCOUNT_P(retval) == 0) {
 				GC_REMOVE_ZVAL_FROM_BUFFER(retval);
 				zval_dtor(retval);
 				FREE_ZVAL(retval);
 			}
 		} else {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, retval);
+			AI_SET_PTR(EX_T(opline->result.var).var, retval);
 			PZVAL_LOCK(retval);
 		}
 
@@ -1293,8 +1300,8 @@
 	zval **container;
 
 	if (OP1_TYPE == IS_VAR && (opline->extended_value & ZEND_FETCH_ADD_LOCK)) {
-		PZVAL_LOCK(*EX_T(opline->op1.u.var).var.ptr_ptr);
-		EX_T(opline->op1.u.var).var.ptr = *EX_T(opline->op1.u.var).var.ptr_ptr;
+		PZVAL_LOCK(*EX_T(opline->op1.var).var.ptr_ptr);
+		EX_T(opline->op1.var).var.ptr = *EX_T(opline->op1.var).var.ptr_ptr;
 	}
 
 	if (IS_OP2_TMP_FREE()) {
@@ -1304,7 +1311,7 @@
 	if (OP1_TYPE == IS_VAR && !container) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an object");
 	}
-	zend_fetch_property_address(&EX_T(opline->result.u.var), container, property, BP_VAR_W TSRMLS_CC);
+	zend_fetch_property_address(&EX_T(opline->result.var), container, property, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL), BP_VAR_W TSRMLS_CC);
 	if (IS_OP2_TMP_FREE()) {
 		zval_ptr_dtor(&property);
 	} else {
@@ -1312,19 +1319,19 @@
 	}
 	if (OP1_TYPE == IS_VAR && OP1_FREE &&
 	    READY_TO_DESTROY(free_op1.var)) {
-		AI_USE_PTR(EX_T(opline->result.u.var).var);
-		if (!PZVAL_IS_REF(*EX_T(opline->result.u.var).var.ptr_ptr) &&
-		    Z_REFCOUNT_PP(EX_T(opline->result.u.var).var.ptr_ptr) > 2) {
-			SEPARATE_ZVAL(EX_T(opline->result.u.var).var.ptr_ptr);
+		AI_USE_PTR(EX_T(opline->result.var).var);
+		if (!PZVAL_IS_REF(*EX_T(opline->result.var).var.ptr_ptr) &&
+		    Z_REFCOUNT_PP(EX_T(opline->result.var).var.ptr_ptr) > 2) {
+			SEPARATE_ZVAL(EX_T(opline->result.var).var.ptr_ptr);
 		}
 	}
 	FREE_OP1_VAR_PTR();
 
 	/* We are going to assign the result by reference */
 	if (opline->extended_value & ZEND_FETCH_MAKE_REF) {
-		Z_DELREF_PP(EX_T(opline->result.u.var).var.ptr_ptr);
-		SEPARATE_ZVAL_TO_MAKE_IS_REF(EX_T(opline->result.u.var).var.ptr_ptr);
-		Z_ADDREF_PP(EX_T(opline->result.u.var).var.ptr_ptr);
+		Z_DELREF_PP(EX_T(opline->result.var).var.ptr_ptr);
+		SEPARATE_ZVAL_TO_MAKE_IS_REF(EX_T(opline->result.var).var.ptr_ptr);
+		Z_ADDREF_PP(EX_T(opline->result.var).var.ptr_ptr);
 	}
 	
 	ZEND_VM_NEXT_OPCODE();
@@ -1343,7 +1350,7 @@
 	if (OP1_TYPE == IS_VAR && !container) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an object");
 	}
-	zend_fetch_property_address(&EX_T(opline->result.u.var), container, property, BP_VAR_RW TSRMLS_CC);
+	zend_fetch_property_address(&EX_T(opline->result.var), container, property, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL), BP_VAR_RW TSRMLS_CC);
 	if (IS_OP2_TMP_FREE()) {
 		zval_ptr_dtor(&property);
 	} else {
@@ -1351,10 +1358,10 @@
 	}
 	if (OP1_TYPE == IS_VAR && OP1_FREE &&
 	    READY_TO_DESTROY(free_op1.var)) {
-		AI_USE_PTR(EX_T(opline->result.u.var).var);
-		if (!PZVAL_IS_REF(*EX_T(opline->result.u.var).var.ptr_ptr) &&
-		    Z_REFCOUNT_PP(EX_T(opline->result.u.var).var.ptr_ptr) > 2) {
-			SEPARATE_ZVAL(EX_T(opline->result.u.var).var.ptr_ptr);
+		AI_USE_PTR(EX_T(opline->result.var).var);
+		if (!PZVAL_IS_REF(*EX_T(opline->result.var).var.ptr_ptr) &&
+		    Z_REFCOUNT_PP(EX_T(opline->result.var).var.ptr_ptr) > 2) {
+			SEPARATE_ZVAL(EX_T(opline->result.var).var.ptr_ptr);
 		}
 	}
 	FREE_OP1_VAR_PTR();
@@ -1370,7 +1377,7 @@
 {
 	zend_op *opline = EX(opline);
 
-	if (ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), opline->extended_value)) {
+	if (ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), (opline->extended_value & ZEND_FETCH_ARG_MASK))) {
 		/* Behave like FETCH_OBJ_W */
 		zend_free_op free_op1, free_op2;
 		zval *property = GET_OP2_ZVAL_PTR(BP_VAR_R);
@@ -1382,7 +1389,7 @@
 		if (OP1_TYPE == IS_VAR && !container) {
 			zend_error_noreturn(E_ERROR, "Cannot use string offset as an object");
 		}
-		zend_fetch_property_address(&EX_T(opline->result.u.var), container, property, BP_VAR_W TSRMLS_CC);
+		zend_fetch_property_address(&EX_T(opline->result.var), container, property, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL), BP_VAR_W TSRMLS_CC);
 		if (IS_OP2_TMP_FREE()) {
 			zval_ptr_dtor(&property);
 		} else {
@@ -1390,10 +1397,10 @@
 		}
 		if (OP1_TYPE == IS_VAR && OP1_FREE &&
 		    READY_TO_DESTROY(free_op1.var)) {
-			AI_USE_PTR(EX_T(opline->result.u.var).var);
-			if (!PZVAL_IS_REF(*EX_T(opline->result.u.var).var.ptr_ptr) &&
-			    Z_REFCOUNT_PP(EX_T(opline->result.u.var).var.ptr_ptr) > 2) {
-				SEPARATE_ZVAL(EX_T(opline->result.u.var).var.ptr_ptr);
+			AI_USE_PTR(EX_T(opline->result.var).var);
+			if (!PZVAL_IS_REF(*EX_T(opline->result.var).var.ptr_ptr) &&
+			    Z_REFCOUNT_PP(EX_T(opline->result.var).var.ptr_ptr) > 2) {
+				SEPARATE_ZVAL(EX_T(opline->result.var).var.ptr_ptr);
 			}
 		}
 		FREE_OP1_VAR_PTR();
@@ -1421,7 +1428,7 @@
 	if (OP1_TYPE == IS_VAR && !container) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an object");
 	}
-	zend_fetch_property_address(&EX_T(opline->result.u.var), container, property, BP_VAR_UNSET TSRMLS_CC);
+	zend_fetch_property_address(&EX_T(opline->result.var), container, property, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL), BP_VAR_UNSET TSRMLS_CC);
 	if (IS_OP2_TMP_FREE()) {
 		zval_ptr_dtor(&property);
 	} else {
@@ -1429,19 +1436,19 @@
 	}
 	if (OP1_TYPE == IS_VAR && OP1_FREE &&
 	    READY_TO_DESTROY(free_op1.var)) {
-		AI_USE_PTR(EX_T(opline->result.u.var).var);
-		if (!PZVAL_IS_REF(*EX_T(opline->result.u.var).var.ptr_ptr) &&
-		    Z_REFCOUNT_PP(EX_T(opline->result.u.var).var.ptr_ptr) > 2) {
-			SEPARATE_ZVAL(EX_T(opline->result.u.var).var.ptr_ptr);
+		AI_USE_PTR(EX_T(opline->result.var).var);
+		if (!PZVAL_IS_REF(*EX_T(opline->result.var).var.ptr_ptr) &&
+		    Z_REFCOUNT_PP(EX_T(opline->result.var).var.ptr_ptr) > 2) {
+			SEPARATE_ZVAL(EX_T(opline->result.var).var.ptr_ptr);
 		}
 	}
 	FREE_OP1_VAR_PTR();
 
-	PZVAL_UNLOCK(*EX_T(opline->result.u.var).var.ptr_ptr, &free_res);
-	if (EX_T(opline->result.u.var).var.ptr_ptr != &EG(uninitialized_zval_ptr)) {
-		SEPARATE_ZVAL_IF_NOT_REF(EX_T(opline->result.u.var).var.ptr_ptr);
+	PZVAL_UNLOCK(*EX_T(opline->result.var).var.ptr_ptr, &free_res);
+	if (EX_T(opline->result.var).var.ptr_ptr != &EG(uninitialized_zval_ptr)) {
+		SEPARATE_ZVAL_IF_NOT_REF(EX_T(opline->result.var).var.ptr_ptr);
 	}
-	PZVAL_LOCK(*EX_T(opline->result.u.var).var.ptr_ptr);
+	PZVAL_LOCK(*EX_T(opline->result.var).var.ptr_ptr);
 	FREE_OP_VAR_PTR(free_res);
 	ZEND_VM_NEXT_OPCODE();
 }
@@ -1453,16 +1460,16 @@
 	zval *container = GET_OP1_ZVAL_PTR(BP_VAR_R);
 
 	if (Z_TYPE_P(container) != IS_ARRAY) {
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, EG(uninitialized_zval_ptr));
+		if (RETURN_VALUE_USED(opline)) {
+			AI_SET_PTR(EX_T(opline->result.var).var, EG(uninitialized_zval_ptr));
 			PZVAL_LOCK(EG(uninitialized_zval_ptr));
 		}
 	} else {
 		zend_free_op free_op2;
 		zval *dim = GET_OP2_ZVAL_PTR(BP_VAR_R);
 
-		AI_SET_PTR(EX_T(opline->result.u.var).var, *zend_fetch_dimension_address_inner(Z_ARRVAL_P(container), dim, BP_VAR_R TSRMLS_CC));
-		SELECTIVE_PZVAL_LOCK(EX_T(opline->result.u.var).var.ptr, &opline->result);
+		AI_SET_PTR(EX_T(opline->result.var).var, *zend_fetch_dimension_address_inner(Z_ARRVAL_P(container), dim, OP2_TYPE, BP_VAR_R TSRMLS_CC));
+		SELECTIVE_PZVAL_LOCK(EX_T(opline->result.var).var.ptr, opline);
 		FREE_OP2();
 	}
 	ZEND_VM_NEXT_OPCODE();
@@ -1482,7 +1489,7 @@
 	if (OP1_TYPE == IS_VAR && !object_ptr) {
 		zend_error_noreturn(E_ERROR, "Cannot use string offset as an array");
 	}
-	zend_assign_to_object(&opline->result, object_ptr, property_name, &op_data->op1, EX(Ts), ZEND_ASSIGN_OBJ TSRMLS_CC);
+	zend_assign_to_object(RETURN_VALUE_USED(opline)?&EX_T(opline->result.var).var.ptr:NULL, object_ptr, property_name, op_data->op1_type, &op_data->op1, EX(Ts), ZEND_ASSIGN_OBJ, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 	if (IS_OP2_TMP_FREE()) {
 		zval_ptr_dtor(&property_name);
 	} else {
@@ -1511,7 +1518,7 @@
 		if (IS_OP2_TMP_FREE()) {
 			MAKE_REAL_ZVAL_PTR(property_name);
 		}
-		zend_assign_to_object(&opline->result, object_ptr, property_name, &op_data->op1, EX(Ts), ZEND_ASSIGN_DIM TSRMLS_CC);
+		zend_assign_to_object(RETURN_VALUE_USED(opline)?&EX_T(opline->result.var).var.ptr:NULL, object_ptr, property_name, op_data->op1_type, &op_data->op1, EX(Ts), ZEND_ASSIGN_DIM, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 		if (IS_OP2_TMP_FREE()) {
 			zval_ptr_dtor(&property_name);
 		} else {
@@ -1523,27 +1530,27 @@
 		zval *dim = GET_OP2_ZVAL_PTR(BP_VAR_R);
 		zval **variable_ptr_ptr;
 
-		zend_fetch_dimension_address(&EX_T(op_data->op2.u.var), object_ptr, dim, IS_OP2_TMP_FREE(), BP_VAR_W TSRMLS_CC);
+		zend_fetch_dimension_address(&EX_T(op_data->op2.var), object_ptr, dim, OP2_TYPE, BP_VAR_W TSRMLS_CC);
 		FREE_OP2();
 
-		value = get_zval_ptr(&op_data->op1, EX(Ts), &free_op_data1, BP_VAR_R);
-		variable_ptr_ptr = _get_zval_ptr_ptr_var(&op_data->op2, EX(Ts), &free_op_data2 TSRMLS_CC);
+		value = get_zval_ptr(op_data->op1_type, &op_data->op1, EX(Ts), &free_op_data1, BP_VAR_R);
+		variable_ptr_ptr = _get_zval_ptr_ptr_var(op_data->op2.var, EX(Ts), &free_op_data2 TSRMLS_CC);
 		if (!variable_ptr_ptr) {
-			if (zend_assign_to_string_offset(&EX_T(op_data->op2.u.var), value, op_data->op1.op_type TSRMLS_CC)) {
-				if (!RETURN_VALUE_UNUSED(&opline->result)) {
-					EX_T(opline->result.u.var).var.ptr_ptr = &EX_T(opline->result.u.var).var.ptr;
-					ALLOC_ZVAL(EX_T(opline->result.u.var).var.ptr);
-					INIT_PZVAL(EX_T(opline->result.u.var).var.ptr);
-					ZVAL_STRINGL(EX_T(opline->result.u.var).var.ptr, Z_STRVAL_P(EX_T(op_data->op2.u.var).str_offset.str)+EX_T(op_data->op2.u.var).str_offset.offset, 1, 1);
+			if (zend_assign_to_string_offset(&EX_T(op_data->op2.var), value, op_data->op1_type TSRMLS_CC)) {
+				if (RETURN_VALUE_USED(opline)) {
+					EX_T(opline->result.var).var.ptr_ptr = &EX_T(opline->result.var).var.ptr;
+					ALLOC_ZVAL(EX_T(opline->result.var).var.ptr);
+					INIT_PZVAL(EX_T(opline->result.var).var.ptr);
+					ZVAL_STRINGL(EX_T(opline->result.var).var.ptr, Z_STRVAL_P(EX_T(op_data->op2.var).str_offset.str)+EX_T(op_data->op2.var).str_offset.offset, 1, 1);
 				}
-			} else if (!RETURN_VALUE_UNUSED(&opline->result)) {
-				AI_SET_PTR(EX_T(opline->result.u.var).var, EG(uninitialized_zval_ptr));
+			} else if (RETURN_VALUE_USED(opline)) {
+				AI_SET_PTR(EX_T(opline->result.var).var, EG(uninitialized_zval_ptr));
 				PZVAL_LOCK(EG(uninitialized_zval_ptr));
 			}
 		} else {
 		 	value = zend_assign_to_variable(variable_ptr_ptr, value, IS_TMP_FREE(free_op_data1) TSRMLS_CC);
-			if (!RETURN_VALUE_UNUSED(&opline->result)) {
-				AI_SET_PTR(EX_T(opline->result.u.var).var, value);
+			if (RETURN_VALUE_USED(opline)) {
+				AI_SET_PTR(EX_T(opline->result.var).var, value);
 				PZVAL_LOCK(value);
 			}
 		}
@@ -1564,21 +1571,21 @@
 	zval **variable_ptr_ptr = GET_OP1_ZVAL_PTR_PTR(BP_VAR_W);
 
 	if (OP1_TYPE == IS_VAR && !variable_ptr_ptr) {
-		if (zend_assign_to_string_offset(&EX_T(opline->op1.u.var), value, OP2_TYPE TSRMLS_CC)) {
-			if (!RETURN_VALUE_UNUSED(&opline->result)) {
-				EX_T(opline->result.u.var).var.ptr_ptr = &EX_T(opline->result.u.var).var.ptr;
-				ALLOC_ZVAL(EX_T(opline->result.u.var).var.ptr);
-				INIT_PZVAL(EX_T(opline->result.u.var).var.ptr);
-				ZVAL_STRINGL(EX_T(opline->result.u.var).var.ptr, Z_STRVAL_P(EX_T(opline->op1.u.var).str_offset.str)+EX_T(opline->op1.u.var).str_offset.offset, 1, 1);
+		if (zend_assign_to_string_offset(&EX_T(opline->op1.var), value, OP2_TYPE TSRMLS_CC)) {
+			if (RETURN_VALUE_USED(opline)) {
+				EX_T(opline->result.var).var.ptr_ptr = &EX_T(opline->result.var).var.ptr;
+				ALLOC_ZVAL(EX_T(opline->result.var).var.ptr);
+				INIT_PZVAL(EX_T(opline->result.var).var.ptr);
+				ZVAL_STRINGL(EX_T(opline->result.var).var.ptr, Z_STRVAL_P(EX_T(opline->op1.var).str_offset.str)+EX_T(opline->op1.var).str_offset.offset, 1, 1);
 			}
-		} else if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, EG(uninitialized_zval_ptr));
+		} else if (RETURN_VALUE_USED(opline)) {
+			AI_SET_PTR(EX_T(opline->result.var).var, EG(uninitialized_zval_ptr));
 			PZVAL_LOCK(EG(uninitialized_zval_ptr));
 		}
 	} else {
 	 	value = zend_assign_to_variable(variable_ptr_ptr, value, IS_OP2_TMP_FREE() TSRMLS_CC);
-		if (!RETURN_VALUE_UNUSED(&opline->result)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, value);
+		if (RETURN_VALUE_USED(opline)) {
+			AI_SET_PTR(EX_T(opline->result.var).var, value);
 			PZVAL_LOCK(value);
 		}
 	}
@@ -1602,7 +1609,7 @@
 	    value_ptr_ptr &&
 	    !Z_ISREF_PP(value_ptr_ptr) &&
 	    opline->extended_value == ZEND_RETURNS_FUNCTION &&
-	    !EX_T(opline->op2.u.var).var.fcall_returned_reference) {
+	    !EX_T(opline->op2.var).var.fcall_returned_reference) {
 		if (free_op2.var == NULL) {
 			PZVAL_LOCK(*value_ptr_ptr); /* undo the effect of get_zval_ptr_ptr() */
 		}
@@ -1615,7 +1622,7 @@
 	} else if (OP2_TYPE == IS_VAR && opline->extended_value == ZEND_RETURNS_NEW) {
 		PZVAL_LOCK(*value_ptr_ptr);
 	}
-	if (OP1_TYPE == IS_VAR && EX_T(opline->op1.u.var).var.ptr_ptr == &EX_T(opline->op1.u.var).var.ptr) {
+	if (OP1_TYPE == IS_VAR && EX_T(opline->op1.var).var.ptr_ptr == &EX_T(opline->op1.var).var.ptr) {
 		zend_error_noreturn(E_ERROR, "Cannot assign by reference to overloaded object");
 	}
 
@@ -1630,8 +1637,8 @@
 		Z_DELREF_PP(variable_ptr_ptr);
 	}
 
-	if (!RETURN_VALUE_UNUSED(&opline->result)) {
-		AI_SET_PTR(EX_T(opline->result.u.var).var, *variable_ptr_ptr);
+	if (RETURN_VALUE_USED(opline)) {
+		AI_SET_PTR(EX_T(opline->result.var).var, *variable_ptr_ptr);
 		PZVAL_LOCK(*variable_ptr_ptr);
 	}
 
@@ -1644,9 +1651,9 @@
 ZEND_VM_HANDLER(42, ZEND_JMP, ANY, ANY)
 {
 #if DEBUG_ZEND>=2
-	printf("Jumping to %d\n", EX(opline)->op1.u.opline_num);
+	printf("Jumping to %d\n", EX(opline)->op1.opline_num);
 #endif
-	ZEND_VM_SET_OPCODE(EX(opline)->op1.u.jmp_addr);
+	ZEND_VM_SET_OPCODE(EX(opline)->op1.jmp_addr);
 	ZEND_VM_CONTINUE(); /* CHECK_ME */
 }
 
@@ -1668,9 +1675,9 @@
 	}
 	if (!ret) {
 #if DEBUG_ZEND>=2
-		printf("Conditional jmp to %d\n", opline->op2.u.opline_num);
+		printf("Conditional jmp to %d\n", opline->op2.opline_num);
 #endif
-		ZEND_VM_SET_OPCODE(opline->op2.u.jmp_addr);
+		ZEND_VM_SET_OPCODE(opline->op2.jmp_addr);
 		ZEND_VM_CONTINUE();
 	}
 
@@ -1695,9 +1702,9 @@
 	}
 	if (ret) {
 #if DEBUG_ZEND>=2
-		printf("Conditional jmp to %d\n", opline->op2.u.opline_num);
+		printf("Conditional jmp to %d\n", opline->op2.opline_num);
 #endif
-		ZEND_VM_SET_OPCODE(opline->op2.u.jmp_addr);
+		ZEND_VM_SET_OPCODE(opline->op2.jmp_addr);
 		ZEND_VM_CONTINUE();
 	}
 
@@ -1728,9 +1735,9 @@
 		ZEND_VM_CONTINUE(); /* CHECK_ME */
 	} else {
 #if DEBUG_ZEND>=2
-		printf("Conditional jmp on false to %d\n", opline->op2.u.opline_num);
+		printf("Conditional jmp on false to %d\n", opline->op2.opline_num);
 #endif
-		ZEND_VM_SET_OPCODE(&EX(op_array)->opcodes[opline->op2.u.opline_num]);
+		ZEND_VM_SET_OPCODE(&EX(op_array)->opcodes[opline->op2.opline_num]);
 		ZEND_VM_CONTINUE(); /* CHECK_ME */
 	}
 }
@@ -1751,13 +1758,13 @@
 			ZEND_VM_CONTINUE();
 		}
 	}
-	Z_LVAL(EX_T(opline->result.u.var).tmp_var) = retval;
-	Z_TYPE(EX_T(opline->result.u.var).tmp_var) = IS_BOOL;
+	Z_LVAL(EX_T(opline->result.var).tmp_var) = retval;
+	Z_TYPE(EX_T(opline->result.var).tmp_var) = IS_BOOL;
 	if (!retval) {
 #if DEBUG_ZEND>=2
-		printf("Conditional jmp to %d\n", opline->op2.u.opline_num);
+		printf("Conditional jmp to %d\n", opline->op2.opline_num);
 #endif
-		ZEND_VM_SET_OPCODE(opline->op2.u.jmp_addr);
+		ZEND_VM_SET_OPCODE(opline->op2.jmp_addr);
 		ZEND_VM_CONTINUE();
 	}
 	ZEND_VM_NEXT_OPCODE();
@@ -1779,13 +1786,13 @@
 			ZEND_VM_CONTINUE();
 		}
 	}
-	Z_LVAL(EX_T(opline->result.u.var).tmp_var) = retval;
-	Z_TYPE(EX_T(opline->result.u.var).tmp_var) = IS_BOOL;
+	Z_LVAL(EX_T(opline->result.var).tmp_var) = retval;
+	Z_TYPE(EX_T(opline->result.var).tmp_var) = IS_BOOL;
 	if (retval) {
 #if DEBUG_ZEND>=2
-		printf("Conditional jmp to %d\n", opline->op2.u.opline_num);
+		printf("Conditional jmp to %d\n", opline->op2.opline_num);
 #endif
-		ZEND_VM_SET_OPCODE(opline->op2.u.jmp_addr);
+		ZEND_VM_SET_OPCODE(opline->op2.jmp_addr);
 		ZEND_VM_CONTINUE();
 	}
 	ZEND_VM_NEXT_OPCODE();
@@ -1793,13 +1800,13 @@
 
 ZEND_VM_HANDLER(70, ZEND_FREE, TMP, ANY)
 {
-	zendi_zval_dtor(EX_T(EX(opline)->op1.u.var).tmp_var);
+	zendi_zval_dtor(EX_T(EX(opline)->op1.var).tmp_var);
 	ZEND_VM_NEXT_OPCODE();
 }
 
 ZEND_VM_HANDLER(53, ZEND_INIT_STRING, ANY, ANY)
 {
-	zval *tmp = &EX_T(EX(opline)->result.u.var).tmp_var;
+	zval *tmp = &EX_T(EX(opline)->result.var).tmp_var;
 
 	tmp->value.str.val = emalloc(1);
 	tmp->value.str.val[0] = 0;
@@ -1813,7 +1820,7 @@
 ZEND_VM_HANDLER(54, ZEND_ADD_CHAR, TMP|UNUSED, CONST)
 {
 	zend_op *opline = EX(opline);
-	zval *str = &EX_T(opline->result.u.var).tmp_var;
+	zval *str = &EX_T(opline->result.var).tmp_var;
 
 	if (OP1_TYPE == IS_UNUSED) {
 		/* Initialize for erealloc in add_char_to_string */
@@ -1824,7 +1831,7 @@
 		INIT_PZVAL(str);
 	}
 
-	add_char_to_string(str, str, &opline->op2.u.constant);
+	add_char_to_string(str, str, opline->op2.zv);
 
 	/* FREE_OP is missing intentionally here - we're always working on the same temporary variable */
 	ZEND_VM_NEXT_OPCODE();
@@ -1833,7 +1840,7 @@
 ZEND_VM_HANDLER(55, ZEND_ADD_STRING, TMP|UNUSED, CONST)
 {
 	zend_op *opline = EX(opline);
-	zval *str = &EX_T(opline->result.u.var).tmp_var;
+	zval *str = &EX_T(opline->result.var).tmp_var;
 
 	if (OP1_TYPE == IS_UNUSED) {
 		/* Initialize for erealloc in add_string_to_string */
@@ -1844,7 +1851,7 @@
 		INIT_PZVAL(str);
 	}
 
-	add_string_to_string(str, str, &opline->op2.u.constant);
+	add_string_to_string(str, str, opline->op2.zv);
 
 	/* FREE_OP is missing intentionally here - we're always working on the same temporary variable */
 	ZEND_VM_NEXT_OPCODE();
@@ -1854,7 +1861,7 @@
 {
 	zend_op *opline = EX(opline);
 	zend_free_op free_op2;
-	zval *str = &EX_T(opline->result.u.var).tmp_var;
+	zval *str = &EX_T(opline->result.var).tmp_var;
 	zval *var = GET_OP2_ZVAL_PTR(BP_VAR_R);
 	zval var_copy;
 	int use_copy = 0;
@@ -1897,16 +1904,18 @@
 
 
 	if (OP2_TYPE == IS_UNUSED) {
-		EX_T(opline->result.u.var).class_entry = zend_fetch_class(NULL, 0, opline->extended_value TSRMLS_CC);
+		EX_T(opline->result.var).class_entry = zend_fetch_class(NULL, 0, opline->extended_value TSRMLS_CC);
 		ZEND_VM_NEXT_OPCODE();
 	} else {
 		zend_free_op free_op2;
 		zval *class_name = GET_OP2_ZVAL_PTR(BP_VAR_R);
 
-		if (OP2_TYPE != IS_CONST && Z_TYPE_P(class_name) == IS_OBJECT) {
-			EX_T(opline->result.u.var).class_entry = Z_OBJCE_P(class_name);
+		if (OP2_TYPE == IS_CONST) {
+			EX_T(opline->result.var).class_entry = zend_fetch_class_by_name(Z_STRVAL_P(class_name), Z_STRLEN_P(class_name), opline->op2.literal + 1, opline->extended_value TSRMLS_CC);
+		} else if (Z_TYPE_P(class_name) == IS_OBJECT) {
+			EX_T(opline->result.var).class_entry = Z_OBJCE_P(class_name);
 		} else if (Z_TYPE_P(class_name) == IS_STRING) {
-			EX_T(opline->result.u.var).class_entry = zend_fetch_class(Z_STRVAL_P(class_name), Z_STRLEN_P(class_name), opline->extended_value TSRMLS_CC);
+			EX_T(opline->result.var).class_entry = zend_fetch_class(Z_STRVAL_P(class_name), Z_STRLEN_P(class_name), opline->extended_value TSRMLS_CC);
 		} else {
 			zend_error_noreturn(E_ERROR, "Class name must be a valid object or a string");
 		}
@@ -1943,7 +1952,7 @@
 		}
 
 		/* First, locate the function. */
-		EX(fbc) = Z_OBJ_HT_P(EX(object))->get_method(&EX(object), function_name_strval, function_name_strlen TSRMLS_CC);
+		EX(fbc) = Z_OBJ_HT_P(EX(object))->get_method(&EX(object), function_name_strval, function_name_strlen, ((OP2_TYPE == IS_CONST) ? (opline->op2.literal + 1) : NULL) TSRMLS_CC);
 		if (!EX(fbc)) {
 			zend_error_noreturn(E_ERROR, "Call to undefined method %s::%s()", Z_OBJ_CLASS_NAME_P(EX(object)), function_name_strval);
 		}
@@ -1983,15 +1992,15 @@
 
 	if (OP1_TYPE == IS_CONST) {
 		/* no function found. try a static method in class */
-		ce = zend_fetch_class(Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant), opline->extended_value TSRMLS_CC);
+		ce = zend_fetch_class_by_name(Z_STRVAL_P(opline->op1.zv), Z_STRLEN_P(opline->op1.zv), opline->op1.literal + 1, opline->extended_value TSRMLS_CC);
 		if (!ce) {
-			zend_error_noreturn(E_ERROR, "Class '%s' not found", Z_STRVAL(opline->op1.u.constant));
+			zend_error_noreturn(E_ERROR, "Class '%s' not found", Z_STRVAL_P(opline->op1.zv));
 		}
 		EX(called_scope) = ce;
 	} else {
-		ce = EX_T(opline->op1.u.var).class_entry;
+		ce = EX_T(opline->op1.var).class_entry;
 		
-		if (opline->op1.u.EA.type == ZEND_FETCH_CLASS_PARENT || opline->op1.u.EA.type == ZEND_FETCH_CLASS_SELF) {
+		if (opline->extended_value == ZEND_FETCH_CLASS_PARENT || opline->extended_value == ZEND_FETCH_CLASS_SELF) {
 			EX(called_scope) = EG(called_scope);
 		} else {
 			EX(called_scope) = ce;
@@ -2003,8 +2012,8 @@
 		zend_free_op free_op2;
 
 		if (OP2_TYPE == IS_CONST) {
-			function_name_strval = Z_STRVAL(opline->op2.u.constant);
-			function_name_strlen = Z_STRLEN(opline->op2.u.constant);
+			function_name_strval = Z_STRVAL_P(opline->op2.zv);
+			function_name_strlen = Z_STRLEN_P(opline->op2.zv);
 		} else {
 			function_name = GET_OP2_ZVAL_PTR(BP_VAR_R);
 
@@ -2020,7 +2029,7 @@
 			if (ce->get_static_method) {
 				EX(fbc) = ce->get_static_method(ce, function_name_strval, function_name_strlen TSRMLS_CC);
 			} else {
-				EX(fbc) = zend_std_get_static_method(ce, function_name_strval, function_name_strlen TSRMLS_CC);
+				EX(fbc) = zend_std_get_static_method(ce, function_name_strval, function_name_strlen, ((OP2_TYPE == IS_CONST) ? (opline->op2.literal + 1) : NULL) TSRMLS_CC);
 			}
 			if (!EX(fbc)) {
 				zend_error_noreturn(E_ERROR, "Call to undefined method %s::%s()", ce->name, function_name_strval);
@@ -2081,8 +2090,8 @@
 	zend_ptr_stack_3_push(&EG(arg_types_stack), EX(fbc), EX(object), EX(called_scope));
 
 	if (OP2_TYPE == IS_CONST) {
-		if (zend_hash_quick_find(EG(function_table), Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant)+1, opline->extended_value, (void **) &EX(fbc)) == FAILURE) {
-			zend_error_noreturn(E_ERROR, "Call to undefined function %s()", Z_STRVAL(opline->op2.u.constant));
+		if (zend_hash_quick_find(EG(function_table), Z_STRVAL_P(opline->op1.zv), Z_STRLEN_P(opline->op1.zv)+1, Z_HASH_P(opline->op1.zv), (void **) &EX(fbc)) == FAILURE) {
+			zend_error_noreturn(E_ERROR, "Call to undefined function %s()", Z_STRVAL_P(opline->op2.zv));
 		}
 	} else {
 		function_name = GET_OP2_ZVAL_PTR(BP_VAR_R);
@@ -2130,10 +2139,10 @@
 	ZEND_VM_INC_OPCODE();
 	zend_ptr_stack_3_push(&EG(arg_types_stack), EX(fbc), EX(object), EX(called_scope));
 
-	if (zend_hash_quick_find(EG(function_table), Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant)+1, opline->extended_value, (void **) &EX(fbc))==FAILURE) {
-		char *short_name = Z_STRVAL(opline->op1.u.constant)+Z_LVAL(op_data->op1.u.constant);
-		if (zend_hash_quick_find(EG(function_table), short_name, Z_STRLEN(opline->op1.u.constant)-Z_LVAL(op_data->op1.u.constant)+1, op_data->extended_value, (void **) &EX(fbc))==FAILURE) {
-			zend_error_noreturn(E_ERROR, "Call to undefined function %s()", Z_STRVAL(opline->op2.u.constant));
+	if (zend_hash_quick_find(EG(function_table), Z_STRVAL_P(opline->op1.zv), Z_STRLEN_P(opline->op1.zv)+1, Z_HASH_P(opline->op1.zv), (void **) &EX(fbc))==FAILURE) {
+		char *short_name = Z_STRVAL_P(opline->op1.zv)+op_data->op1.num;
+		if (zend_hash_quick_find(EG(function_table), short_name, Z_STRLEN_P(opline->op1.zv)-op_data->op1.num+1, op_data->extended_value, (void **) &EX(fbc))==FAILURE) {
+			zend_error_noreturn(E_ERROR, "Call to undefined function %s()", Z_STRVAL_P(opline->op2.zv));
 		}
 	}
 
@@ -2173,11 +2182,11 @@
 			EX(object) = EX(current_object);
 
 			if (RETURN_VALUE_USED(EX(call_opline))) {
-				if (!EX_T(EX(call_opline)->result.u.var).var.ptr) { /* there was no return statement */
-					ALLOC_ZVAL(EX_T(EX(call_opline)->result.u.var).var.ptr);
-					INIT_PZVAL(EX_T(EX(call_opline)->result.u.var).var.ptr);
-					Z_LVAL_P(EX_T(EX(call_opline)->result.u.var).var.ptr) = 1;
-					Z_TYPE_P(EX_T(EX(call_opline)->result.u.var).var.ptr) = IS_BOOL;
+				if (!EX_T(EX(call_opline)->result.var).var.ptr) { /* there was no return statement */
+					ALLOC_ZVAL(EX_T(EX(call_opline)->result.var).var.ptr);
+					INIT_PZVAL(EX_T(EX(call_opline)->result.var).var.ptr);
+					Z_LVAL_P(EX_T(EX(call_opline)->result.var).var.ptr) = 1;
+					Z_TYPE_P(EX_T(EX(call_opline)->result.var).var.ptr) = IS_BOOL;
 				}
 			}
 
@@ -2235,8 +2244,8 @@
 
 			if (EG(exception)) {
 				zend_throw_exception_internal(NULL TSRMLS_CC);
-				if (RETURN_VALUE_USED(EX(call_opline)) && EX_T(EX(call_opline)->result.u.var).var.ptr) {
-					zval_ptr_dtor(&EX_T(EX(call_opline)->result.u.var).var.ptr);
+				if (RETURN_VALUE_USED(EX(call_opline)) && EX_T(EX(call_opline)->result.var).var.ptr) {
+					zval_ptr_dtor(&EX_T(EX(call_opline)->result.var).var.ptr);
 				}
 			}
 
@@ -2293,9 +2302,9 @@
 	EX(function_state).arguments = zend_vm_stack_push_args(opline->extended_value TSRMLS_CC);
 
 	if (EX(function_state).function->type == ZEND_INTERNAL_FUNCTION) {
-		ALLOC_INIT_ZVAL(EX_T(opline->result.u.var).var.ptr);
-		EX_T(opline->result.u.var).var.ptr_ptr = &EX_T(opline->result.u.var).var.ptr;
-		EX_T(opline->result.u.var).var.fcall_returned_reference = EX(function_state).function->common.return_reference;
+		ALLOC_INIT_ZVAL(EX_T(opline->result.var).var.ptr);
+		EX_T(opline->result.var).var.ptr_ptr = &EX_T(opline->result.var).var.ptr;
+		EX_T(opline->result.var).var.fcall_returned_reference = EX(function_state).function->common.return_reference;
 
 		if (EX(function_state).function->common.arg_info) {
 			zend_uint i=0;
@@ -2309,13 +2318,13 @@
 		}
 		if (!zend_execute_internal) {
 			/* saves one function call if zend_execute_internal is not used */
-			((zend_internal_function *) EX(function_state).function)->handler(opline->extended_value, EX_T(opline->result.u.var).var.ptr, EX(function_state).function->common.return_reference?&EX_T(opline->result.u.var).var.ptr:NULL, EX(object), RETURN_VALUE_USED(opline) TSRMLS_CC);
+			((zend_internal_function *) EX(function_state).function)->handler(opline->extended_value, EX_T(opline->result.var).var.ptr, EX(function_state).function->common.return_reference?&EX_T(opline->result.var).var.ptr:NULL, EX(object), RETURN_VALUE_USED(opline) TSRMLS_CC);
 		} else {
 			zend_execute_internal(EXECUTE_DATA, RETURN_VALUE_USED(opline) TSRMLS_CC);
 		}
 
 		if (!RETURN_VALUE_USED(opline)) {
-			zval_ptr_dtor(&EX_T(opline->result.u.var).var.ptr);
+			zval_ptr_dtor(&EX_T(opline->result.var).var.ptr);
 		}
 	} else if (EX(function_state).function->type == ZEND_USER_FUNCTION) {
 		EX(original_return_value) = EG(return_value_ptr_ptr);
@@ -2323,10 +2332,10 @@
 		EG(active_op_array) = &EX(function_state).function->op_array;
 		EG(return_value_ptr_ptr) = NULL;
 		if (RETURN_VALUE_USED(opline)) {			
-			EG(return_value_ptr_ptr) = &EX_T(opline->result.u.var).var.ptr;
-			EX_T(opline->result.u.var).var.ptr = NULL;
-			EX_T(opline->result.u.var).var.ptr_ptr = &EX_T(opline->result.u.var).var.ptr;
-			EX_T(opline->result.u.var).var.fcall_returned_reference = EX(function_state).function->common.return_reference;
+			EG(return_value_ptr_ptr) = &EX_T(opline->result.var).var.ptr;
+			EX_T(opline->result.var).var.ptr = NULL;
+			EX_T(opline->result.var).var.ptr_ptr = &EX_T(opline->result.var).var.ptr;
+			EX_T(opline->result.var).var.fcall_returned_reference = EX(function_state).function->common.return_reference;
 		}
 
 		if (zend_execute == execute && !EG(exception)) {
@@ -2352,11 +2361,11 @@
 		}
 		EG(active_symbol_table) = EX(symbol_table);
 	} else { /* ZEND_OVERLOADED_FUNCTION */
-		ALLOC_INIT_ZVAL(EX_T(opline->result.u.var).var.ptr);
+		ALLOC_INIT_ZVAL(EX_T(opline->result.var).var.ptr);
 
 			/* Not sure what should be done here if it's a static method */
 		if (EX(object)) {
-			Z_OBJ_HT_P(EX(object))->call_method(EX(function_state).function->common.function_name, opline->extended_value, EX_T(opline->result.u.var).var.ptr, &EX_T(opline->result.u.var).var.ptr, EX(object), RETURN_VALUE_USED(opline) TSRMLS_CC);
+			Z_OBJ_HT_P(EX(object))->call_method(EX(function_state).function->common.function_name, opline->extended_value, EX_T(opline->result.var).var.ptr, &EX_T(opline->result.var).var.ptr, EX(object), RETURN_VALUE_USED(opline) TSRMLS_CC);
 		} else {
 			zend_error_noreturn(E_ERROR, "Cannot call overloaded function for non-object");
 		}
@@ -2367,12 +2376,12 @@
 		efree(EX(function_state).function);
 
 		if (!RETURN_VALUE_USED(opline)) {
-			zval_ptr_dtor(&EX_T(opline->result.u.var).var.ptr);
+			zval_ptr_dtor(&EX_T(opline->result.var).var.ptr);
 		} else {
-			Z_UNSET_ISREF_P(EX_T(opline->result.u.var).var.ptr);
-			Z_SET_REFCOUNT_P(EX_T(opline->result.u.var).var.ptr, 1);
-			EX_T(opline->result.u.var).var.fcall_returned_reference = 0;
-			EX_T(opline->result.u.var).var.ptr_ptr = &EX_T(opline->result.u.var).var.ptr;
+			Z_UNSET_ISREF_P(EX_T(opline->result.var).var.ptr);
+			Z_SET_REFCOUNT_P(EX_T(opline->result.var).var.ptr, 1);
+			EX_T(opline->result.var).var.fcall_returned_reference = 0;
+			EX_T(opline->result.var).var.ptr_ptr = &EX_T(opline->result.var).var.ptr;
 		}
 	}
 
@@ -2403,8 +2412,8 @@
 
 	if (EG(exception)) {
 		zend_throw_exception_internal(NULL TSRMLS_CC);
-		if (RETURN_VALUE_USED(opline) && EX_T(opline->result.u.var).var.ptr) {
-			zval_ptr_dtor(&EX_T(opline->result.u.var).var.ptr);
+		if (RETURN_VALUE_USED(opline) && EX_T(opline->result.var).var.ptr) {
+			zval_ptr_dtor(&EX_T(opline->result.var).var.ptr);
 		}
 	}
 
@@ -2425,7 +2434,7 @@
 
 	zend_ptr_stack_3_push(&EG(arg_types_stack), EX(fbc), EX(object), EX(called_scope));
 
-	if (zend_hash_quick_find(EG(function_table), fname->value.str.val, fname->value.str.len+1, Z_LVAL(opline->op2.u.constant), (void **) &EX(function_state).function)==FAILURE) {
+	if (zend_hash_quick_find(EG(function_table), Z_STRVAL_P(fname), Z_STRLEN_P(fname)+1, Z_HASH_P(fname), (void **) &EX(function_state).function)==FAILURE) {
 		zend_error_noreturn(E_ERROR, "Call to undefined function %s()", fname->value.str.val);
 	}
 	EX(object) = NULL;
@@ -2458,8 +2467,8 @@
 
 		if (OP1_TYPE == IS_VAR && !Z_ISREF_PP(retval_ptr_ptr)) {
 			if (opline->extended_value == ZEND_RETURNS_FUNCTION &&
-			    EX_T(opline->op1.u.var).var.fcall_returned_reference) {
-			} else if (EX_T(opline->op1.u.var).var.ptr_ptr == &EX_T(opline->op1.u.var).var.ptr) {
+			    EX_T(opline->op1.var).var.fcall_returned_reference) {
+			} else if (EX_T(opline->op1.var).var.ptr_ptr == &EX_T(opline->op1.var).var.ptr) {
 				if (OP1_TYPE == IS_VAR && !OP1_FREE) {
 					PZVAL_LOCK(*retval_ptr_ptr); /* undo the effect of get_zval_ptr_ptr() */
 				}
@@ -2547,9 +2556,9 @@
 		ZEND_VM_CONTINUE(); /* CHECK_ME */
 	}
 	ce = Z_OBJCE_P(EG(exception));
-	if (ce != EX_T(opline->op1.u.var).class_entry) {
-		if (!instanceof_function(ce, EX_T(opline->op1.u.var).class_entry TSRMLS_CC)) {
-			if (opline->op1.u.EA.type) {
+	if (ce != EX_T(opline->op1.var).class_entry) {
+		if (!instanceof_function(ce, EX_T(opline->op1.var).class_entry TSRMLS_CC)) {
+			if (opline->result.num) {
 				zend_throw_exception_internal(NULL TSRMLS_CC);
 				ZEND_VM_NEXT_OPCODE();
 			}
@@ -2559,15 +2568,15 @@
 	}
 
 	if (!EG(active_symbol_table)) {
-		if (EX(CVs)[opline->op2.u.var]) {
-			zval_ptr_dtor(EX(CVs)[opline->op2.u.var]);
+		if (EX(CVs)[opline->op2.var]) {
+			zval_ptr_dtor(EX(CVs)[opline->op2.var]);
 		}
-		EX(CVs)[opline->op2.u.var] = (zval**)EX(CVs) + (EX(op_array)->last_var + opline->op2.u.var);
-		*EX(CVs)[opline->op2.u.var] = EG(exception);
+		EX(CVs)[opline->op2.var] = (zval**)EX(CVs) + (EX(op_array)->last_var + opline->op2.var);
+		*EX(CVs)[opline->op2.var] = EG(exception);
 	} else {
-		zend_compiled_variable *cv = &CV_DEF_OF(opline->op2.u.var);
+		zend_compiled_variable *cv = &CV_DEF_OF(opline->op2.var);
 		zend_hash_quick_update(EG(active_symbol_table), cv->name, cv->name_len+1, cv->hash_value,
-		    &EG(exception), sizeof(zval *), (void**)&EX(CVs)[opline->op2.u.var]);
+		    &EG(exception), sizeof(zval *), (void**)&EX(CVs)[opline->op2.var]);
 	}
 	EG(exception) = NULL;
 	ZEND_VM_NEXT_OPCODE();
@@ -2577,8 +2586,8 @@
 {
 	zend_op *opline = EX(opline);
 	if (opline->extended_value==ZEND_DO_FCALL_BY_NAME
-		&& ARG_MUST_BE_SENT_BY_REF(EX(fbc), opline->op2.u.opline_num)) {
-			zend_error_noreturn(E_ERROR, "Cannot pass parameter %d by reference", opline->op2.u.opline_num);
+		&& ARG_MUST_BE_SENT_BY_REF(EX(fbc), opline->op2.opline_num)) {
+			zend_error_noreturn(E_ERROR, "Cannot pass parameter %d by reference", opline->op2.opline_num);
 	}
 	{
 		zval *valptr;
@@ -2635,21 +2644,21 @@
 		if (!(opline->extended_value & ZEND_ARG_SEND_BY_REF)) {
 			ZEND_VM_DISPATCH_TO_HELPER(zend_send_by_var_helper);
 		}
-	} else if (!ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), opline->op2.u.opline_num)) {
+	} else if (!ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), opline->op2.opline_num)) {
 		ZEND_VM_DISPATCH_TO_HELPER(zend_send_by_var_helper);
 	}
 
 	if (OP1_TYPE == IS_VAR &&
 		(opline->extended_value & ZEND_ARG_SEND_FUNCTION) &&
-		EX_T(opline->op1.u.var).var.fcall_returned_reference &&
-		EX_T(opline->op1.u.var).var.ptr) {
-		varptr = EX_T(opline->op1.u.var).var.ptr;
+		EX_T(opline->op1.var).var.fcall_returned_reference &&
+		EX_T(opline->op1.var).var.ptr) {
+		varptr = EX_T(opline->op1.var).var.ptr;
 		PZVAL_UNLOCK_EX(varptr, &free_op1, 0);
 	} else {
 		varptr = GET_OP1_ZVAL_PTR(BP_VAR_R);
 	}
 	if ((!(opline->extended_value & ZEND_ARG_SEND_FUNCTION) ||
-	     EX_T(opline->op1.u.var).var.fcall_returned_reference) &&
+	     EX_T(opline->op1.var).var.fcall_returned_reference) &&
 	    varptr != &EG(uninitialized_zval) &&
 	    (PZVAL_IS_REF(varptr) ||
 	     (Z_REFCOUNT_P(varptr) == 1 && (OP1_TYPE == IS_CV || free_op1.var)))) {
@@ -2661,7 +2670,7 @@
 
 		if ((opline->extended_value & ZEND_ARG_COMPILE_TIME_BOUND) ?
 			!(opline->extended_value & ZEND_ARG_SEND_SILENT) :
-			!ARG_MAY_BE_SENT_BY_REF(EX(fbc), opline->op2.u.opline_num)) {
+			!ARG_MAY_BE_SENT_BY_REF(EX(fbc), opline->op2.opline_num)) {
 			zend_error(E_STRICT, "Only variables should be passed by reference");
 		}
 		ALLOC_ZVAL(valptr);
@@ -2687,7 +2696,7 @@
 		zend_error_noreturn(E_ERROR, "Only variables can be passed by reference");
 	}
 
-      	if (EX(function_state).function->type == ZEND_INTERNAL_FUNCTION && !ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), opline->op2.u.opline_num)) {
+      	if (EX(function_state).function->type == ZEND_INTERNAL_FUNCTION && !ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), opline->op2.opline_num)) {
                ZEND_VM_DISPATCH_TO_HELPER(zend_send_by_var_helper);
         }
 
@@ -2705,7 +2714,7 @@
 	zend_op *opline = EX(opline);
 
 	if ((opline->extended_value == ZEND_DO_FCALL_BY_NAME)
-		&& ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), opline->op2.u.opline_num)) {
+		&& ARG_SHOULD_BE_SENT_BY_REF(EX(fbc), opline->op2.opline_num)) {
 		ZEND_VM_DISPATCH_TO_HANDLER(ZEND_SEND_REF);
 	}
 	ZEND_VM_DISPATCH_TO_HELPER(zend_send_by_var_helper);
@@ -2714,7 +2723,7 @@
 ZEND_VM_HANDLER(63, ZEND_RECV, ANY, ANY)
 {
 	zend_op *opline = EX(opline);
-	zend_uint arg_num = Z_LVAL(opline->op1.u.constant);
+	zend_uint arg_num = opline->op1.num;
 	zval **param = zend_vm_stack_get_arg(arg_num TSRMLS_CC);
 
 	if (param == NULL) {
@@ -2724,20 +2733,20 @@
 
 		if (zend_verify_arg_type((zend_function *) EG(active_op_array), arg_num, NULL, opline->extended_value TSRMLS_CC)) {
 			if(ptr && ptr->op_array) {
-				zend_error(E_WARNING, "Missing argument %ld for %s%s%s(), called in %s on line %d and defined", opline->op1.u.constant.value.lval, class_name, space, get_active_function_name(TSRMLS_C), ptr->op_array->filename, ptr->opline->lineno);
+				zend_error(E_WARNING, "Missing argument %u for %s%s%s(), called in %s on line %d and defined", opline->op1.num, class_name, space, get_active_function_name(TSRMLS_C), ptr->op_array->filename, ptr->opline->lineno);
 			} else {
-				zend_error(E_WARNING, "Missing argument %ld for %s%s%s()", opline->op1.u.constant.value.lval, class_name, space, get_active_function_name(TSRMLS_C));
+				zend_error(E_WARNING, "Missing argument %u for %s%s%s()", opline->op1.num, class_name, space, get_active_function_name(TSRMLS_C));
 			}
 		}
-		if (opline->result.op_type == IS_VAR) {
-			PZVAL_UNLOCK_FREE(*EX_T(opline->result.u.var).var.ptr_ptr);
+		if (opline->result_type == IS_VAR) {
+			PZVAL_UNLOCK_FREE(*EX_T(opline->result.var).var.ptr_ptr);
 		}
 	} else {
 		zend_free_op free_res;
 		zval **var_ptr;
 
 		zend_verify_arg_type((zend_function *) EG(active_op_array), arg_num, *param, opline->extended_value TSRMLS_CC);
-		var_ptr = get_zval_ptr_ptr(&opline->result, EX(Ts), &free_res, BP_VAR_W);
+		var_ptr = get_zval_ptr_ptr(opline->result_type, &opline->result, EX(Ts), &free_res, BP_VAR_W);
 		Z_DELREF_PP(var_ptr);
 		*var_ptr = *param;
 		Z_ADDREF_PP(var_ptr);
@@ -2750,15 +2759,16 @@
 {
 	zend_op *opline = EX(opline);
 	zval *assignment_value;
-	zend_uint arg_num = Z_LVAL(opline->op1.u.constant);
+	zend_uint arg_num = opline->op1.num;
 	zend_free_op free_res;
 	zval **param = zend_vm_stack_get_arg(arg_num TSRMLS_CC);
 	zval **var_ptr;
 
 	if (param == NULL) {
 		ALLOC_ZVAL(assignment_value);
-		*assignment_value = opline->op2.u.constant;
-		if ((Z_TYPE(opline->op2.u.constant) & IS_CONSTANT_TYPE_MASK) == IS_CONSTANT || Z_TYPE(opline->op2.u.constant)==IS_CONSTANT_ARRAY) {
+		*assignment_value = *opline->op2.zv;
+		if ((Z_TYPE_P(assignment_value) & IS_CONSTANT_TYPE_MASK) == IS_CONSTANT ||
+		     Z_TYPE_P(assignment_value)==IS_CONSTANT_ARRAY) {
 			Z_SET_REFCOUNT_P(assignment_value, 1);
 			zval_update_constant(&assignment_value, 0 TSRMLS_CC);
 		} else {
@@ -2771,7 +2781,7 @@
 	}
 
 	zend_verify_arg_type((zend_function *) EG(active_op_array), arg_num, assignment_value, opline->extended_value TSRMLS_CC);
-	var_ptr = get_zval_ptr_ptr(&opline->result, EX(Ts), &free_res, BP_VAR_W);
+	var_ptr = get_zval_ptr_ptr(opline->result_type, &opline->result, EX(Ts), &free_res, BP_VAR_W);
 	Z_DELREF_PP(var_ptr);
 	*var_ptr = assignment_value;
 
@@ -2784,8 +2794,8 @@
 	zend_free_op free_op1;
 
 	/* PHP 3.0 returned "" for false and 1 for true, here we use 0 and 1 for now */
-	Z_LVAL(EX_T(opline->result.u.var).tmp_var) = i_zend_is_true(GET_OP1_ZVAL_PTR(BP_VAR_R));
-	Z_TYPE(EX_T(opline->result.u.var).tmp_var) = IS_BOOL;
+	Z_LVAL(EX_T(opline->result.var).tmp_var) = i_zend_is_true(GET_OP1_ZVAL_PTR(BP_VAR_R));
+	Z_TYPE(EX_T(opline->result.var).tmp_var) = IS_BOOL;
 	FREE_OP1();
 
 	ZEND_VM_NEXT_OPCODE();
@@ -2797,7 +2807,7 @@
 	zend_free_op free_op2;
 	zend_brk_cont_element *el;
 
-	el = zend_brk_cont(GET_OP2_ZVAL_PTR(BP_VAR_R), opline->op1.u.opline_num,
+	el = zend_brk_cont(GET_OP2_ZVAL_PTR(BP_VAR_R), opline->op1.opline_num,
 	                   EX(op_array), EX(Ts) TSRMLS_CC);
 	FREE_OP2();
 	ZEND_VM_JMP(EX(op_array)->opcodes + el->brk);
@@ -2809,7 +2819,7 @@
 	zend_free_op free_op2;
 	zend_brk_cont_element *el;
 
-	el = zend_brk_cont(GET_OP2_ZVAL_PTR(BP_VAR_R), opline->op1.u.opline_num,
+	el = zend_brk_cont(GET_OP2_ZVAL_PTR(BP_VAR_R), opline->op1.opline_num,
 	                   EX(op_array), EX(Ts) TSRMLS_CC);
 	FREE_OP2();
 	ZEND_VM_JMP(EX(op_array)->opcodes + el->cont);
@@ -2821,24 +2831,24 @@
 	zend_op *opline = EX(opline);
 	zend_brk_cont_element *el;
 
-	el = zend_brk_cont(&opline->op2.u.constant, opline->extended_value,
+	el = zend_brk_cont(opline->op2.zv, opline->extended_value,
  	                   EX(op_array), EX(Ts) TSRMLS_CC);
 
 	brk_opline = EX(op_array)->opcodes + el->brk;
 
 	switch (brk_opline->opcode) {
 		case ZEND_SWITCH_FREE:
-			if (brk_opline->op1.u.EA.type != EXT_TYPE_FREE_ON_RETURN) {
-				zend_switch_free(&EX_T(brk_opline->op1.u.var), brk_opline->extended_value TSRMLS_CC);
+			if (!(brk_opline->extended_value & EXT_TYPE_FREE_ON_RETURN)) {
+				zend_switch_free(&EX_T(brk_opline->op1.var), brk_opline->extended_value TSRMLS_CC);
 			}
 			break;
 		case ZEND_FREE:
-			if (brk_opline->op1.u.EA.type != EXT_TYPE_FREE_ON_RETURN) {
-				zendi_zval_dtor(EX_T(brk_opline->op1.u.var).tmp_var);
+			if (!(brk_opline->extended_value & EXT_TYPE_FREE_ON_RETURN)) {
+				zendi_zval_dtor(EX_T(brk_opline->op1.var).tmp_var);
 			}
 			break;
 	}
-	ZEND_VM_JMP(opline->op1.u.jmp_addr);
+	ZEND_VM_JMP(opline->op1.jmp_addr);
 }
 
 ZEND_VM_HANDLER(48, ZEND_CASE, CONST|TMP|VAR|CV, CONST|TMP|VAR|CV)
@@ -2848,14 +2858,14 @@
 	zend_free_op free_op1, free_op2;
 
 	if (OP1_TYPE==IS_VAR) {
-		if (EX_T(opline->op1.u.var).var.ptr_ptr) {
-			PZVAL_LOCK(EX_T(opline->op1.u.var).var.ptr);
+		if (EX_T(opline->op1.var).var.ptr_ptr) {
+			PZVAL_LOCK(EX_T(opline->op1.var).var.ptr);
 		} else {
 			switch_expr_is_overloaded = 1;
-			Z_ADDREF_P(EX_T(opline->op1.u.var).str_offset.str);
+			Z_ADDREF_P(EX_T(opline->op1.var).str_offset.str);
 		}
 	}
-	is_equal_function(&EX_T(opline->result.u.var).tmp_var,
+	is_equal_function(&EX_T(opline->result.var).tmp_var,
 				 GET_OP1_ZVAL_PTR(BP_VAR_R),
 				 GET_OP2_ZVAL_PTR(BP_VAR_R) TSRMLS_CC);
 
@@ -2867,8 +2877,8 @@
 		 * are allocated at each get_zval_ptr())
 		 */
 		FREE_OP1();
-		EX_T(opline->op1.u.var).var.ptr_ptr = NULL;
-		EX_T(opline->op1.u.var).var.ptr = NULL;
+		EX_T(opline->op1.var).var.ptr_ptr = NULL;
+		EX_T(opline->op1.var).var.ptr = NULL;
 	}
 	ZEND_VM_NEXT_OPCODE();
 }
@@ -2877,7 +2887,7 @@
 {
 	zend_op *opline = EX(opline);
 
-	zend_switch_free(&EX_T(opline->op1.u.var), opline->extended_value TSRMLS_CC);
+	zend_switch_free(&EX_T(opline->op1.var), opline->extended_value TSRMLS_CC);
 	ZEND_VM_NEXT_OPCODE();
 }
 
@@ -2887,32 +2897,32 @@
 	zval *object_zval;
 	zend_function *constructor;
 
-	if (EX_T(opline->op1.u.var).class_entry->ce_flags & (ZEND_ACC_INTERFACE|ZEND_ACC_IMPLICIT_ABSTRACT_CLASS|ZEND_ACC_EXPLICIT_ABSTRACT_CLASS)) {
+	if (EX_T(opline->op1.var).class_entry->ce_flags & (ZEND_ACC_INTERFACE|ZEND_ACC_IMPLICIT_ABSTRACT_CLASS|ZEND_ACC_EXPLICIT_ABSTRACT_CLASS)) {
 		char *class_type;
 
-		if (EX_T(opline->op1.u.var).class_entry->ce_flags & ZEND_ACC_INTERFACE) {
+		if (EX_T(opline->op1.var).class_entry->ce_flags & ZEND_ACC_INTERFACE) {
 			class_type = "interface";
 		} else {
 			class_type = "abstract class";
 		}
-		zend_error_noreturn(E_ERROR, "Cannot instantiate %s %s", class_type,  EX_T(opline->op1.u.var).class_entry->name);
+		zend_error_noreturn(E_ERROR, "Cannot instantiate %s %s", class_type,  EX_T(opline->op1.var).class_entry->name);
 	}
 	ALLOC_ZVAL(object_zval);
-	object_init_ex(object_zval, EX_T(opline->op1.u.var).class_entry);
+	object_init_ex(object_zval, EX_T(opline->op1.var).class_entry);
 	INIT_PZVAL(object_zval);
 
 	constructor = Z_OBJ_HT_P(object_zval)->get_constructor(object_zval TSRMLS_CC);
 
 	if (constructor == NULL) {
 		if (RETURN_VALUE_USED(opline)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, object_zval);
+			AI_SET_PTR(EX_T(opline->result.var).var, object_zval);
 		} else {
 			zval_ptr_dtor(&object_zval);
 		}
-		ZEND_VM_JMP(EX(op_array)->opcodes + opline->op2.u.opline_num);
+		ZEND_VM_JMP(EX(op_array)->opcodes + opline->op2.opline_num);
 	} else {
 		if (RETURN_VALUE_USED(opline)) {
-			AI_SET_PTR(EX_T(opline->result.u.var).var, object_zval);
+			AI_SET_PTR(EX_T(opline->result.var).var, object_zval);
 			PZVAL_LOCK(object_zval);
 		}
 
@@ -2921,7 +2931,7 @@
 		/* We are not handling overloaded classes right now */
 		EX(object) = object_zval;
 		EX(fbc) = constructor;
-		EX(called_scope) = EX_T(opline->op1.u.var).class_entry;
+		EX(called_scope) = EX_T(opline->op1.var).class_entry;
 
 		ZEND_VM_NEXT_OPCODE();
 	}
@@ -2969,15 +2979,15 @@
 		}
 	}
 
-	EX_T(opline->result.u.var).var.ptr_ptr = &EX_T(opline->result.u.var).var.ptr;
+	EX_T(opline->result.var).var.ptr_ptr = &EX_T(opline->result.var).var.ptr;
 	if (!EG(exception)) {
-		ALLOC_ZVAL(EX_T(opline->result.u.var).var.ptr);
-		Z_OBJVAL_P(EX_T(opline->result.u.var).var.ptr) = clone_call(obj TSRMLS_CC);
-		Z_TYPE_P(EX_T(opline->result.u.var).var.ptr) = IS_OBJECT;
-		Z_SET_REFCOUNT_P(EX_T(opline->result.u.var).var.ptr, 1);
-		Z_SET_ISREF_P(EX_T(opline->result.u.var).var.ptr);
+		ALLOC_ZVAL(EX_T(opline->result.var).var.ptr);
+		Z_OBJVAL_P(EX_T(opline->result.var).var.ptr) = clone_call(obj TSRMLS_CC);
+		Z_TYPE_P(EX_T(opline->result.var).var.ptr) = IS_OBJECT;
+		Z_SET_REFCOUNT_P(EX_T(opline->result.var).var.ptr, 1);
+		Z_SET_ISREF_P(EX_T(opline->result.var).var.ptr);
 		if (!RETURN_VALUE_USED(opline) || EG(exception)) {
-			zval_ptr_dtor(&EX_T(opline->result.u.var).var.ptr);
+			zval_ptr_dtor(&EX_T(opline->result.var).var.ptr);
 		}
 	}
 	FREE_OP1_IF_VAR();
@@ -2990,20 +3000,20 @@
 
 	if (OP1_TYPE == IS_UNUSED) {
 		/* namespaced constant */
-		if (!zend_get_constant_ex(Z_STRVAL(opline->op2.u.constant), Z_STRLEN(opline->op2.u.constant), &EX_T(opline->result.u.var).tmp_var, NULL, opline->extended_value TSRMLS_CC)) {
+		if (!zend_get_constant_ex(Z_STRVAL_P(opline->op2.zv), Z_STRLEN_P(opline->op2.zv), &EX_T(opline->result.var).tmp_var, NULL, opline->extended_value TSRMLS_CC)) {
 			if ((opline->extended_value & IS_CONSTANT_UNQUALIFIED) != 0) {
-				char *actual = (char *)zend_memrchr(Z_STRVAL(opline->op2.u.constant), '\\', Z_STRLEN(opline->op2.u.constant));
+				char *actual = (char *)zend_memrchr(Z_STRVAL_P(opline->op2.zv), '\\', Z_STRLEN_P(opline->op2.zv));
 				if(!actual) {
-					actual = Z_STRVAL(opline->op2.u.constant);
+					actual = Z_STRVAL_P(opline->op2.zv);
 				} else {
 					actual++;
 				}
 				/* non-qualified constant - allow text substitution */
 				zend_error(E_NOTICE, "Use of undefined constant %s - assumed '%s'", actual, actual);
-				ZVAL_STRINGL(&EX_T(opline->result.u.var).tmp_var, actual, Z_STRLEN(opline->op2.u.constant)-(actual - Z_STRVAL(opline->op2.u.constant)), 1);
+				ZVAL_STRINGL(&EX_T(opline->result.var).tmp_var, actual, Z_STRLEN_P(opline->op2.zv)-(actual - Z_STRVAL_P(opline->op2.zv)), 1);
 			} else {
 				zend_error_noreturn(E_ERROR, "Undefined constant '%s'",
-							Z_STRVAL(opline->op2.u.constant), Z_STRVAL(opline->op2.u.constant));
+							Z_STRVAL_P(opline->op2.zv), Z_STRVAL_P(opline->op2.zv));
 			}
 		}
 		ZEND_VM_NEXT_OPCODE();
@@ -3014,15 +3024,15 @@
 
 		if (OP1_TYPE == IS_CONST) {
 
-			ce = zend_fetch_class(Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant), opline->extended_value TSRMLS_CC);
+			ce = zend_fetch_class_by_name(Z_STRVAL_P(opline->op1.zv), Z_STRLEN_P(opline->op1.zv), opline->op1.literal + 1, opline->extended_value TSRMLS_CC);
 			if (!ce) {
-				zend_error_noreturn(E_ERROR, "Undefined class constant '%s'", Z_STRVAL(opline->op2.u.constant));
+				zend_error_noreturn(E_ERROR, "Undefined class constant '%s'", Z_STRVAL_P(opline->op2.zv));
 			}
 		} else {
-			ce = EX_T(opline->op1.u.var).class_entry;
+			ce = EX_T(opline->op1.var).class_entry;
 		}
 
-		if (zend_hash_find(&ce->constants_table, Z_STRVAL(opline->op2.u.constant), Z_STRLEN(opline->op2.u.constant)+1, (void **) &value) == SUCCESS) {
+		if (zend_hash_quick_find(&ce->constants_table, Z_STRVAL_P(opline->op2.zv), Z_STRLEN_P(opline->op2.zv)+1, Z_HASH_P(opline->op2.zv), (void **) &value) == SUCCESS) {
 			if (Z_TYPE_PP(value) == IS_CONSTANT_ARRAY ||
 			    (Z_TYPE_PP(value) & IS_CONSTANT_TYPE_MASK) == IS_CONSTANT) {
 				zend_class_entry *old_scope = EG(scope);
@@ -3031,10 +3041,10 @@
 				zval_update_constant(value, (void *) 1 TSRMLS_CC);
 				EG(scope) = old_scope;
 			}
-			EX_T(opline->result.u.var).tmp_var = **value;
-			zval_copy_ctor(&EX_T(opline->result.u.var).tmp_var);
+			EX_T(opline->result.var).tmp_var = **value;
+			zval_copy_ctor(&EX_T(opline->result.var).tmp_var);
 		} else {
-			zend_error_noreturn(E_ERROR, "Undefined class constant '%s'", Z_STRVAL(opline->op2.u.constant));
+			zend_error_noreturn(E_ERROR, "Undefined class constant '%s'", Z_STRVAL_P(opline->op2.zv));
 		}
 
 		ZEND_VM_NEXT_OPCODE();
@@ -3045,9 +3055,11 @@
 {
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1, free_op2;
-	zval *array_ptr = &EX_T(opline->result.u.var).tmp_var;
+	zval *array_ptr = &EX_T(opline->result.var).tmp_var;
 	zval *expr_ptr;
 	zval *offset=GET_OP2_ZVAL_PTR(BP_VAR_R);
+	ulong hval;
+	long index;
 
 #if !defined(ZEND_VM_SPEC) || OP1_TYPE == IS_VAR || OP1_TYPE == IS_CV
 	zval **expr_ptr_ptr = NULL;
@@ -3090,14 +3102,22 @@
 	if (offset) {
 		switch (Z_TYPE_P(offset)) {
 			case IS_DOUBLE:
-				zend_hash_index_update(Z_ARRVAL_P(array_ptr), zend_dval_to_lval(Z_DVAL_P(offset)), &expr_ptr, sizeof(zval *), NULL);
-				break;
+				index = zend_dval_to_lval(Z_DVAL_P(offset));
+				ZEND_VM_C_GOTO(num_index);
 			case IS_LONG:
 			case IS_BOOL:
-				zend_hash_index_update(Z_ARRVAL_P(array_ptr), Z_LVAL_P(offset), &expr_ptr, sizeof(zval *), NULL);
+				index = Z_LVAL_P(offset);
+ZEND_VM_C_LABEL(num_index):
+				zend_hash_index_update(Z_ARRVAL_P(array_ptr), index, &expr_ptr, sizeof(zval *), NULL);
 				break;
 			case IS_STRING:
-				zend_symtable_update(Z_ARRVAL_P(array_ptr), Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1, &expr_ptr, sizeof(zval *), NULL);
+				if (OP2_TYPE == IS_CONST) {
+					hval = Z_HASH_P(offset);
+				} else {
+					ZEND_HANDLE_NUMERIC_EX(Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1, index, ZEND_VM_C_GOTO(num_index));
+					hval = zend_hash_func(Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1);
+				}
+				zend_hash_quick_update(Z_ARRVAL_P(array_ptr), Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1, hval, &expr_ptr, sizeof(zval *), NULL);
 				break;
 			case IS_NULL:
 				zend_hash_update(Z_ARRVAL_P(array_ptr), "", sizeof(""), &expr_ptr, sizeof(zval *), NULL);
@@ -3124,7 +3144,7 @@
 {
 	zend_op *opline = EX(opline);
 
-	array_init(&EX_T(opline->result.u.var).tmp_var);
+	array_init(&EX_T(opline->result.var).tmp_var);
 	if (OP1_TYPE == IS_UNUSED) {
 		ZEND_VM_NEXT_OPCODE();
 #if !defined(ZEND_VM_SPEC) || OP1_TYPE != IS_UNUSED
@@ -3139,7 +3159,7 @@
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1;
 	zval *expr = GET_OP1_ZVAL_PTR(BP_VAR_R);
-	zval *result = &EX_T(opline->result.u.var).tmp_var;
+	zval *result = &EX_T(opline->result.var).tmp_var;
 
 	if (opline->extended_value != IS_STRING) {
 		*result = *expr;
@@ -3208,7 +3228,7 @@
 
 	return_value_used = RETURN_VALUE_USED(opline);
 
-	switch (Z_LVAL(opline->op2.u.constant)) {
+	switch (opline->extended_value) {
 		case ZEND_INCLUDE_ONCE:
 		case ZEND_REQUIRE_ONCE: {
 				zend_file_handle file_handle;
@@ -3230,14 +3250,14 @@
 					}
 
 					if (zend_hash_add_empty_element(&EG(included_files), file_handle.opened_path, strlen(file_handle.opened_path)+1)==SUCCESS) {
-						new_op_array = zend_compile_file(&file_handle, (Z_LVAL(opline->op2.u.constant)==ZEND_INCLUDE_ONCE?ZEND_INCLUDE:ZEND_REQUIRE) TSRMLS_CC);
+						new_op_array = zend_compile_file(&file_handle, (opline->extended_value==ZEND_INCLUDE_ONCE?ZEND_INCLUDE:ZEND_REQUIRE) TSRMLS_CC);
 						zend_destroy_file_handle(&file_handle TSRMLS_CC);
 					} else {
 						zend_file_handle_dtor(&file_handle TSRMLS_CC);
 						failure_retval=1;
 					}
 				} else {
-					if (Z_LVAL(opline->op2.u.constant)==ZEND_INCLUDE_ONCE) {
+					if (opline->extended_value == ZEND_INCLUDE_ONCE) {
 						zend_message_dispatcher(ZMSG_FAILED_INCLUDE_FOPEN, Z_STRVAL_P(inc_filename) TSRMLS_CC);
 					} else {
 						zend_message_dispatcher(ZMSG_FAILED_REQUIRE_FOPEN, Z_STRVAL_P(inc_filename) TSRMLS_CC);
@@ -3250,7 +3270,7 @@
 			break;
 		case ZEND_INCLUDE:
 		case ZEND_REQUIRE:
-			new_op_array = compile_filename(Z_LVAL(opline->op2.u.constant), inc_filename TSRMLS_CC);
+			new_op_array = compile_filename(opline->extended_value, inc_filename TSRMLS_CC);
 			break;
 		case ZEND_EVAL: {
 				char *eval_desc = zend_make_compiled_string_description("eval()'d code" TSRMLS_CC);
@@ -3265,12 +3285,12 @@
 		zval_dtor(&tmp_inc_filename);
 	}
 	FREE_OP1();
-	EX_T(opline->result.u.var).var.ptr_ptr = &EX_T(opline->result.u.var).var.ptr;
+	EX_T(opline->result.var).var.ptr_ptr = &EX_T(opline->result.var).var.ptr;
 	if (new_op_array && !EG(exception)) {
 		EX(original_return_value) = EG(return_value_ptr_ptr);
-		EG(return_value_ptr_ptr) = return_value_used ? EX_T(opline->result.u.var).var.ptr_ptr : NULL;
+		EG(return_value_ptr_ptr) = return_value_used ? EX_T(opline->result.var).var.ptr_ptr : NULL;
 		EG(active_op_array) = new_op_array;
-		EX_T(opline->result.u.var).var.ptr = NULL;
+		EX_T(opline->result.var).var.ptr = NULL;
 
 		EX(current_object) = EX(object);
 
@@ -3292,11 +3312,11 @@
 		EX(object) = EX(current_object);
 
 		if (return_value_used) {
-			if (!EX_T(opline->result.u.var).var.ptr) { /* there was no return statement */
-				ALLOC_ZVAL(EX_T(opline->result.u.var).var.ptr);
-				INIT_PZVAL(EX_T(opline->result.u.var).var.ptr);
-				Z_LVAL_P(EX_T(opline->result.u.var).var.ptr) = 1;
-				Z_TYPE_P(EX_T(opline->result.u.var).var.ptr) = IS_BOOL;
+			if (!EX_T(opline->result.var).var.ptr) { /* there was no return statement */
+				ALLOC_ZVAL(EX_T(opline->result.var).var.ptr);
+				INIT_PZVAL(EX_T(opline->result.var).var.ptr);
+				Z_LVAL_P(EX_T(opline->result.var).var.ptr) = 1;
+				Z_TYPE_P(EX_T(opline->result.var).var.ptr) = IS_BOOL;
 			}
 		}
 
@@ -3310,10 +3330,10 @@
 		}
 	} else {
 		if (return_value_used) {
-			ALLOC_ZVAL(EX_T(opline->result.u.var).var.ptr);
-			INIT_ZVAL(*EX_T(opline->result.u.var).var.ptr);
-			Z_LVAL_P(EX_T(opline->result.u.var).var.ptr) = failure_retval;
-			Z_TYPE_P(EX_T(opline->result.u.var).var.ptr) = IS_BOOL;
+			ALLOC_ZVAL(EX_T(opline->result.var).var.ptr);
+			INIT_ZVAL(*EX_T(opline->result.var).var.ptr);
+			Z_LVAL_P(EX_T(opline->result.var).var.ptr) = failure_retval;
+			Z_TYPE_P(EX_T(opline->result.var).var.ptr) = IS_BOOL;
 		}
 	}
 	ZEND_VM_NEXT_OPCODE();
@@ -3329,7 +3349,7 @@
 	if (OP1_TYPE == IS_CV && (opline->extended_value & ZEND_QUICK_SET)) {
 		if (EG(active_symbol_table)) {
 			zend_execute_data *ex = EX(prev_execute_data);
-			zend_compiled_variable *cv = &CV_DEF_OF(opline->op1.u.var);
+			zend_compiled_variable *cv = &CV_DEF_OF(opline->op1.var);
 
 			if (zend_hash_quick_del(EG(active_symbol_table), cv->name, cv->name_len+1, cv->hash_value) == SUCCESS) {
 				while (ex && ex->symbol_table == EG(active_symbol_table)) {
@@ -3348,17 +3368,17 @@
 					ex = ex->prev_execute_data;
 				}
 			}
-			EX(CVs)[opline->op1.u.var] = NULL;
-		} else if (EX(CVs)[opline->op1.u.var]) {
-			zval_ptr_dtor(EX(CVs)[opline->op1.u.var]);
-			EX(CVs)[opline->op1.u.var] = NULL;
+			EX(CVs)[opline->op1.var] = NULL;
+		} else if (EX(CVs)[opline->op1.var]) {
+			zval_ptr_dtor(EX(CVs)[opline->op1.var]);
+			EX(CVs)[opline->op1.var] = NULL;
 		}
 		ZEND_VM_NEXT_OPCODE();
 	}
 
 	varname = GET_OP1_ZVAL_PTR(BP_VAR_R);
 
-	if (Z_TYPE_P(varname) != IS_STRING) {
+	if (OP1_TYPE != IS_CONST && Z_TYPE_P(varname) != IS_STRING) {
 		tmp = *varname;
 		zval_copy_ctor(&tmp);
 		convert_to_string(&tmp);
@@ -3367,12 +3387,12 @@
 		Z_ADDREF_P(varname);
 	}
 
-	if (opline->op2.u.EA.type == ZEND_FETCH_STATIC_MEMBER) {
-		zend_std_unset_static_property(EX_T(opline->op2.u.var).class_entry, Z_STRVAL_P(varname), Z_STRLEN_P(varname) TSRMLS_CC);
+	if ((opline->extended_value & ZEND_FETCH_TYPE_MASK) == ZEND_FETCH_STATIC_MEMBER) {
+		zend_std_unset_static_property(EX_T(opline->op2.var).class_entry, Z_STRVAL_P(varname), Z_STRLEN_P(varname), ((OP1_TYPE == IS_CONST) ? opline->op1.literal : NULL) TSRMLS_CC);
 	} else {
 		ulong hash_value = zend_inline_hash_func(varname->value.str.val, varname->value.str.len+1);
 
-		target_symbol_table = zend_get_target_symbol_table(opline, EX(Ts), BP_VAR_IS, varname TSRMLS_CC);
+		target_symbol_table = zend_get_target_symbol_table(opline->extended_value & ZEND_FETCH_TYPE_MASK TSRMLS_CC);
 		if (zend_hash_quick_del(target_symbol_table, varname->value.str.val, varname->value.str.len+1, hash_value) == SUCCESS) {
 			zend_execute_data *ex = EXECUTE_DATA;
 
@@ -3409,6 +3429,8 @@
 	zend_free_op free_op1, free_op2;
 	zval **container = GET_OP1_OBJ_ZVAL_PTR_PTR(BP_VAR_UNSET);
 	zval *offset = GET_OP2_ZVAL_PTR(BP_VAR_R);
+	ulong hval;
+	long index;
 
 	if (OP1_TYPE != IS_VAR || container) {
 		if (OP1_TYPE == IS_CV && container != &EG(uninitialized_zval_ptr)) {
@@ -3420,28 +3442,35 @@
 
 				switch (Z_TYPE_P(offset)) {
 					case IS_DOUBLE:
-						zend_hash_index_del(ht, zend_dval_to_lval(Z_DVAL_P(offset)));
-						break;
+						index = zend_dval_to_lval(Z_DVAL_P(offset));
+						ZEND_VM_C_GOTO(num_index_dim);
 					case IS_RESOURCE:
 					case IS_BOOL:
 					case IS_LONG:
-						zend_hash_index_del(ht, Z_LVAL_P(offset));
+ZEND_VM_C_LABEL(num_index_dim):
+						index = Z_LVAL_P(offset);
+						zend_hash_index_del(ht, index);
 						break;
 					case IS_STRING:
 						if (OP2_TYPE == IS_CV || OP2_TYPE == IS_VAR) {
 							Z_ADDREF_P(offset);
 						}
-						if (zend_symtable_del(ht, offset->value.str.val, offset->value.str.len+1) == SUCCESS &&
+						if (OP2_TYPE == IS_CONST) {
+							hval = Z_HASH_P(offset);
+						} else {
+							ZEND_HANDLE_NUMERIC_EX(Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1, index, ZEND_VM_C_GOTO(num_index_dim));
+							hval = zend_hash_func(Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1);
+						}
+						if (zend_hash_quick_del(ht, Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1, hval) == SUCCESS &&
 					    ht == &EG(symbol_table)) {
 							zend_execute_data *ex;
-							ulong hash_value = zend_inline_hash_func(offset->value.str.val, offset->value.str.len+1);
 
 							for (ex = EXECUTE_DATA; ex; ex = ex->prev_execute_data) {
 								if (ex->op_array && ex->symbol_table == ht) {
 									int i;
 
 									for (i = 0; i < ex->op_array->last_var; i++) {
-										if (ex->op_array->vars[i].hash_value == hash_value &&
+										if (ex->op_array->vars[i].hash_value == hval &&
 										    ex->op_array->vars[i].name_len == offset->value.str.len &&
 										    !memcmp(ex->op_array->vars[i].name, offset->value.str.val, offset->value.str.len)) {
 											ex->CVs[i] = NULL;
@@ -3510,7 +3539,7 @@
 				MAKE_REAL_ZVAL_PTR(offset);
 			}
 			if (Z_OBJ_HT_P(*container)->unset_property) {
-				Z_OBJ_HT_P(*container)->unset_property(*container, offset TSRMLS_CC);
+				Z_OBJ_HT_P(*container)->unset_property(*container, offset, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 			} else {
 				zend_error(E_NOTICE, "Trying to unset property of non-object");
 			}
@@ -3547,7 +3576,7 @@
 		} else if (Z_TYPE_PP(array_ptr_ptr) == IS_OBJECT) {
 			if(Z_OBJ_HT_PP(array_ptr_ptr)->get_class_entry == NULL) {
 				zend_error(E_WARNING, "foreach() cannot iterate over objects without PHP class");
-				ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.u.opline_num);
+				ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.opline_num);
 			}
 
 			ce = Z_OBJCE_PP(array_ptr_ptr);
@@ -3619,7 +3648,7 @@
 		}
 	}
 
-	AI_SET_PTR(EX_T(opline->result.u.var).var, array_ptr);
+	AI_SET_PTR(EX_T(opline->result.var).var, array_ptr);
 	PZVAL_LOCK(array_ptr);
 
 	if (iter) {
@@ -3669,7 +3698,7 @@
 			}
 		}
 		is_empty = zend_hash_has_more_elements(fe_ht) != SUCCESS;
-		zend_hash_get_pointer(fe_ht, &EX_T(opline->result.u.var).fe.fe_pos);
+		zend_hash_get_pointer(fe_ht, &EX_T(opline->result.var).fe.fe_pos);
 	} else {
 		zend_error(E_WARNING, "Invalid argument supplied for foreach()");
 		is_empty = 1;
@@ -3681,7 +3710,7 @@
 		FREE_OP1_IF_VAR();
 	}
 	if (is_empty) {
-		ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.u.opline_num);
+		ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.opline_num);
 	} else {
 		ZEND_VM_NEXT_OPCODE();
 	}
@@ -3691,7 +3720,7 @@
 {
 	zend_op *opline = EX(opline);
 	zend_free_op free_op1;
-	zval *array = EX_T(opline->op1.u.var).var.ptr;
+	zval *array = EX_T(opline->op1.var).var.ptr;
 	zval **value;
 	char *str_key;
 	uint str_key_len;
@@ -3705,18 +3734,18 @@
 		default:
 		case ZEND_ITER_INVALID:
 			zend_error(E_WARNING, "Invalid argument supplied for foreach()");
-			ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.u.opline_num);
+			ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.opline_num);
 
 		case ZEND_ITER_PLAIN_OBJECT: {
 			char *class_name, *prop_name;
 			zend_object *zobj = zend_objects_get_address(array TSRMLS_CC);
 
 			fe_ht = HASH_OF(array);
-			zend_hash_set_pointer(fe_ht, &EX_T(opline->op1.u.var).fe.fe_pos);
+			zend_hash_set_pointer(fe_ht, &EX_T(opline->op1.var).fe.fe_pos);
 			do {
 				if (zend_hash_get_current_data(fe_ht, (void **) &value)==FAILURE) {
 					/* reached end of iteration */
-					ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.u.opline_num);
+					ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.opline_num);
 				}
 				key_type = zend_hash_get_current_key_ex(fe_ht, &str_key, &str_key_len, &int_key, 0, NULL);
 
@@ -3724,7 +3753,7 @@
 			} while (key_type == HASH_KEY_NON_EXISTANT ||
 			         (key_type != HASH_KEY_IS_LONG &&
 			          zend_check_property_access(zobj, str_key, str_key_len-1 TSRMLS_CC) != SUCCESS));
-			zend_hash_get_pointer(fe_ht, &EX_T(opline->op1.u.var).fe.fe_pos);
+			zend_hash_get_pointer(fe_ht, &EX_T(opline->op1.var).fe.fe_pos);
 			if (use_key && key_type != HASH_KEY_IS_LONG) {
 				zend_unmangle_property_name(str_key, str_key_len-1, &class_name, &prop_name);
 				str_key_len = strlen(prop_name);
@@ -3736,16 +3765,16 @@
 
 		case ZEND_ITER_PLAIN_ARRAY:
 			fe_ht = HASH_OF(array);
-			zend_hash_set_pointer(fe_ht, &EX_T(opline->op1.u.var).fe.fe_pos);
+			zend_hash_set_pointer(fe_ht, &EX_T(opline->op1.var).fe.fe_pos);
 			if (zend_hash_get_current_data(fe_ht, (void **) &value)==FAILURE) {
 				/* reached end of iteration */
-				ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.u.opline_num);
+				ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.opline_num);
 			}
 			if (use_key) {
 				key_type = zend_hash_get_current_key_ex(fe_ht, &str_key, &str_key_len, &int_key, 1, NULL);
 			}
 			zend_hash_move_forward(fe_ht);
-			zend_hash_get_pointer(fe_ht, &EX_T(opline->op1.u.var).fe.fe_pos);
+			zend_hash_get_pointer(fe_ht, &EX_T(opline->op1.var).fe.fe_pos);
 			break;
 
 		case ZEND_ITER_OBJECT:
@@ -3768,7 +3797,7 @@
 					zval_ptr_dtor(&array);
 					ZEND_VM_NEXT_OPCODE();
 				}
-				ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.u.opline_num);
+				ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.opline_num);
 			}
 			iter->funcs->get_current_data(iter, &value TSRMLS_CC);
 			if (EG(exception)) {
@@ -3778,7 +3807,7 @@
 			}
 			if (!value) {
 				/* failure in get_current_data */
-				ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.u.opline_num);
+				ZEND_VM_JMP(EX(op_array)->opcodes+opline->op2.opline_num);
 			}
 			if (use_key) {
 				if (iter->funcs->get_current_key) {
@@ -3799,16 +3828,16 @@
 	if (opline->extended_value & ZEND_FE_FETCH_BYREF) {
 		SEPARATE_ZVAL_IF_NOT_REF(value);
 		Z_SET_ISREF_PP(value);
-		EX_T(opline->result.u.var).var.ptr_ptr = value;
+		EX_T(opline->result.var).var.ptr_ptr = value;
 		Z_ADDREF_PP(value);
 	} else {
-		AI_SET_PTR(EX_T(opline->result.u.var).var, *value);
+		AI_SET_PTR(EX_T(opline->result.var).var, *value);
 		PZVAL_LOCK(*value);
 	}
 
 	if (use_key) {
 		zend_op *op_data = opline+1;
-		zval *key = &EX_T(op_data->result.u.var).tmp_var;
+		zval *key = &EX_T(op_data->result.var).tmp_var;
 
 		switch (key_type) {
 			case HASH_KEY_IS_STRING:
@@ -3838,10 +3867,10 @@
 	zend_bool isset = 1;
 
 	if (OP1_TYPE == IS_CV && (opline->extended_value & ZEND_QUICK_SET)) {
-		if (EX(CVs)[opline->op1.u.var]) {
-			value = EX(CVs)[opline->op1.u.var];
+		if (EX(CVs)[opline->op1.var]) {
+			value = EX(CVs)[opline->op1.var];
 		} else if (EG(active_symbol_table)) {
-			zend_compiled_variable *cv = &CV_DEF_OF(opline->op1.u.var);
+			zend_compiled_variable *cv = &CV_DEF_OF(opline->op1.var);
 
 			if (zend_hash_quick_find(EG(active_symbol_table), cv->name, cv->name_len+1, cv->hash_value, (void **) &value) == FAILURE) {
 				isset = 0;
@@ -3854,20 +3883,20 @@
 		zend_free_op free_op1;
 		zval tmp, *varname = GET_OP1_ZVAL_PTR(BP_VAR_IS);
 
-		if (Z_TYPE_P(varname) != IS_STRING) {
+		if (OP1_TYPE != IS_CONST && Z_TYPE_P(varname) != IS_STRING) {
 			tmp = *varname;
 			zval_copy_ctor(&tmp);
 			convert_to_string(&tmp);
 			varname = &tmp;
 		}
 
-		if (opline->op2.u.EA.type == ZEND_FETCH_STATIC_MEMBER) {
-			value = zend_std_get_static_property(EX_T(opline->op2.u.var).class_entry, Z_STRVAL_P(varname), Z_STRLEN_P(varname), 1 TSRMLS_CC);
+		if ((opline->extended_value & ZEND_FETCH_TYPE_MASK) == ZEND_FETCH_STATIC_MEMBER) {
+			value = zend_std_get_static_property(EX_T(opline->op2.var).class_entry, Z_STRVAL_P(varname), Z_STRLEN_P(varname), 1, ((OP1_TYPE == IS_CONST) ? opline->op1.literal : NULL) TSRMLS_CC);
 			if (!value) {
 				isset = 0;
 			}
 		} else {
-			target_symbol_table = zend_get_target_symbol_table(opline, EX(Ts), BP_VAR_IS, varname TSRMLS_CC);
+			target_symbol_table = zend_get_target_symbol_table(opline->extended_value & ZEND_FETCH_TYPE_MASK TSRMLS_CC);
 			if (zend_hash_find(target_symbol_table, varname->value.str.val, varname->value.str.len+1, (void **) &value) == FAILURE) {
 				isset = 0;
 			}
@@ -3879,23 +3908,20 @@
 		FREE_OP1();
 	}
 
-	Z_TYPE(EX_T(opline->result.u.var).tmp_var) = IS_BOOL;
+	Z_TYPE(EX_T(opline->result.var).tmp_var) = IS_BOOL;
 
-	switch (opline->extended_value & ZEND_ISSET_ISEMPTY_MASK) {
-		case ZEND_ISSET:
-			if (isset && Z_TYPE_PP(value) == IS_NULL) {
-				Z_LVAL(EX_T(opline->result.u.var).tmp_var) = 0;
-			} else {
-				Z_LVAL(EX_T(opline->result.u.var).tmp_var) = isset;
-			}
-			break;
-		case ZEND_ISEMPTY:
-			if (!isset || !i_zend_is_true(*value)) {
-				Z_LVAL(EX_T(opline->result.u.var).tmp_var) = 1;
-			} else {
-				Z_LVAL(EX_T(opline->result.u.var).tmp_var) = 0;
-			}
-			break;
+	if (opline->extended_value & ZEND_ISSET) {
+		if (isset && Z_TYPE_PP(value) == IS_NULL) {
+			Z_LVAL(EX_T(opline->result.var).tmp_var) = 0;
+		} else {
+			Z_LVAL(EX_T(opline->result.var).tmp_var) = isset;
+		}
+	} else /* if (opline->extended_value & ZEND_ISEMPTY) */ {
+		if (!isset || !i_zend_is_true(*value)) {
+			Z_LVAL(EX_T(opline->result.var).tmp_var) = 1;
+		} else {
+			Z_LVAL(EX_T(opline->result.var).tmp_var) = 0;
+		}
 	}
 
 	ZEND_VM_NEXT_OPCODE();
@@ -3908,6 +3934,8 @@
 	zval **container = GET_OP1_OBJ_ZVAL_PTR_PTR(BP_VAR_IS);
 	zval **value = NULL;
 	int result = 0;
+	ulong hval;
+	long index;
 
 	if (OP1_TYPE != IS_VAR || container) {
 		zend_free_op free_op2;
@@ -3921,19 +3949,27 @@
 
 			switch (Z_TYPE_P(offset)) {
 				case IS_DOUBLE:
-					if (zend_hash_index_find(ht, zend_dval_to_lval(Z_DVAL_P(offset)), (void **) &value) == SUCCESS) {
-						isset = 1;
-					}
-					break;
+					index = zend_dval_to_lval(Z_DVAL_P(offset));
+					ZEND_VM_C_GOTO(num_index_prop);
 				case IS_RESOURCE:
 				case IS_BOOL:
 				case IS_LONG:
-					if (zend_hash_index_find(ht, Z_LVAL_P(offset), (void **) &value) == SUCCESS) {
+					index = Z_LVAL_P(offset);
+ZEND_VM_C_LABEL(num_index_prop):
+					if (zend_hash_index_find(ht, index, (void **) &value) == SUCCESS) {
 						isset = 1;
 					}
 					break;
 				case IS_STRING:
-					if (zend_symtable_find(ht, offset->value.str.val, offset->value.str.len+1, (void **) &value) == SUCCESS) {
+					if (OP2_TYPE == IS_CONST) {
+						hval = Z_HASH_P(offset);
+					} else {
+						if (!prop_dim) {
+							ZEND_HANDLE_NUMERIC_EX(Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1, index, ZEND_VM_C_GOTO(num_index_prop));
+						}
+						hval = zend_hash_func(Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1);
+					}
+					if (zend_hash_quick_find(ht, Z_STRVAL_P(offset), Z_STRLEN_P(offset)+1, hval, (void **) &value) == SUCCESS) {
 						isset = 1;
 					}
 					break;
@@ -3948,21 +3984,18 @@
 					break;
 			}
 
-			switch (opline->extended_value) {
-				case ZEND_ISSET:
-					if (isset && Z_TYPE_PP(value) == IS_NULL) {
-						result = 0;
-					} else {
-						result = isset;
-					}
-					break;
-				case ZEND_ISEMPTY:
-					if (!isset || !i_zend_is_true(*value)) {
-						result = 0;
-					} else {
-						result = 1;
-					}
-					break;
+			if (opline->extended_value & ZEND_ISSET) {
+				if (isset && Z_TYPE_PP(value) == IS_NULL) {
+					result = 0;
+				} else {
+					result = isset;
+				}
+			} else /* if (opline->extended_value & ZEND_ISEMPTY) */ {
+				if (!isset || !i_zend_is_true(*value)) {
+					result = 0;
+				} else {
+					result = 1;
+				}
 			}
 			FREE_OP2();
 		} else if (Z_TYPE_PP(container) == IS_OBJECT) {
@@ -3971,14 +4004,14 @@
 			}
 			if (prop_dim) {
 				if (Z_OBJ_HT_P(*container)->has_property) {
-					result = Z_OBJ_HT_P(*container)->has_property(*container, offset, (opline->extended_value == ZEND_ISEMPTY) TSRMLS_CC);
+					result = Z_OBJ_HT_P(*container)->has_property(*container, offset, (opline->extended_value & ZEND_ISEMPTY) != 0, ((OP2_TYPE == IS_CONST) ? opline->op2.literal : NULL) TSRMLS_CC);
 				} else {
 					zend_error(E_NOTICE, "Trying to check property of non-object");
 					result = 0;
 				}
 			} else {
 				if (Z_OBJ_HT_P(*container)->has_dimension) {
-					result = Z_OBJ_HT_P(*container)->has_dimension(*container, offset, (opline->extended_value == ZEND_ISEMPTY) TSRMLS_CC);
+					result = Z_OBJ_HT_P(*container)->has_dimension(*container, offset, (opline->extended_value & ZEND_ISEMPTY) != 0 TSRMLS_CC);
 				} else {
 					zend_error(E_NOTICE, "Trying to check element of non-array");
 					result = 0;
@@ -3999,17 +4032,14 @@
 				offset = &tmp;
 			}
 			if (Z_TYPE_P(offset) == IS_LONG) {
-				switch (opline->extended_value) {
-					case ZEND_ISSET:
-						if (offset->value.lval >= 0 && offset->value.lval < Z_STRLEN_PP(container)) {
-							result = 1;
-						}
-						break;
-					case ZEND_ISEMPTY:
-						if (offset->value.lval >= 0 && offset->value.lval < Z_STRLEN_PP(container) && Z_STRVAL_PP(container)[offset->value.lval] != '0') {
-							result = 1;
-						}
-						break;
+				if (opline->extended_value & ZEND_ISSET) {
+					if (offset->value.lval >= 0 && offset->value.lval < Z_STRLEN_PP(container)) {
+						result = 1;
+					}
+				} else /* if (opline->extended_value & ZEND_ISEMPTY) */ {
+					if (offset->value.lval >= 0 && offset->value.lval < Z_STRLEN_PP(container) && Z_STRVAL_PP(container)[offset->value.lval] != '0') {
+						result = 1;
+					}
 				}
 			}
 			FREE_OP2();
@@ -4018,15 +4048,12 @@
 		}
 	}
 
-	Z_TYPE(EX_T(opline->result.u.var).tmp_var) = IS_BOOL;
+	Z_TYPE(EX_T(opline->result.var).tmp_var) = IS_BOOL;
 
-	switch (opline->extended_value) {
-		case ZEND_ISSET:
-			Z_LVAL(EX_T(opline->result.u.var).tmp_var) = result;
-			break;
-		case ZEND_ISEMPTY:
-			Z_LVAL(EX_T(opline->result.u.var).tmp_var) = !result;
-			break;
+	if (opline->extended_value & ZEND_ISSET) {
+		Z_LVAL(EX_T(opline->result.var).tmp_var) = result;
+	} else /* if (opline->extended_value & ZEND_ISEMPTY) */ {
+		Z_LVAL(EX_T(opline->result.var).tmp_var) = !result;
 	}
 
 	FREE_OP1_VAR_PTR();
@@ -4068,10 +4095,10 @@
 {
 	zend_op *opline = EX(opline);
 
-	Z_LVAL(EX_T(opline->result.u.var).tmp_var) = EG(error_reporting);
-	Z_TYPE(EX_T(opline->result.u.var).tmp_var) = IS_LONG;  /* shouldn't be necessary */
+	Z_LVAL(EX_T(opline->result.var).tmp_var) = EG(error_reporting);
+	Z_TYPE(EX_T(opline->result.var).tmp_var) = IS_LONG;  /* shouldn't be necessary */
 	if (EX(old_error_reporting) == NULL) {
-		EX(old_error_reporting) = &EX_T(opline->result.u.var).tmp_var;
+		EX(old_error_reporting) = &EX_T(opline->result.var).tmp_var;
 	}
 
 	if (EG(error_reporting)) {
@@ -4091,14 +4118,14 @@
 	zend_op *opline = EX(opline);
 	zval restored_error_reporting;
 
-	if (!EG(error_reporting) && Z_LVAL(EX_T(opline->op1.u.var).tmp_var) != 0) {
+	if (!EG(error_reporting) && Z_LVAL(EX_T(opline->op1.var).tmp_var) != 0) {
 		Z_TYPE(restored_error_reporting) = IS_LONG;
-		Z_LVAL(restored_error_reporting) = Z_LVAL(EX_T(opline->op1.u.var).tmp_var);
+		Z_LVAL(restored_error_reporting) = Z_LVAL(EX_T(opline->op1.var).tmp_var);
 		convert_to_string(&restored_error_reporting);
 		zend_alter_ini_entry_ex("error_reporting", sizeof("error_reporting"), Z_STRVAL(restored_error_reporting), Z_STRLEN(restored_error_reporting), ZEND_INI_USER, ZEND_INI_STAGE_RUNTIME, 1 TSRMLS_CC);
 		zendi_zval_dtor(restored_error_reporting);
 	}
-	if (EX(old_error_reporting) == &EX_T(opline->op1.u.var).tmp_var) {
+	if (EX(old_error_reporting) == &EX_T(opline->op1.var).tmp_var) {
 		EX(old_error_reporting) = NULL;
 	}
 	ZEND_VM_NEXT_OPCODE();
@@ -4111,13 +4138,13 @@
 	zval *value = GET_OP1_ZVAL_PTR(BP_VAR_R);
 
 	if (i_zend_is_true(value)) {
-		EX_T(opline->result.u.var).tmp_var = *value;
-		zendi_zval_copy_ctor(EX_T(opline->result.u.var).tmp_var);
+		EX_T(opline->result.var).tmp_var = *value;
+		zendi_zval_copy_ctor(EX_T(opline->result.var).tmp_var);
 		FREE_OP1();
 #if DEBUG_ZEND>=2
-		printf("Conditional jmp to %d\n", opline->op2.u.opline_num);
+		printf("Conditional jmp to %d\n", opline->op2.opline_num);
 #endif
-		ZEND_VM_JMP(opline->op2.u.jmp_addr);
+		ZEND_VM_JMP(opline->op2.jmp_addr);
 	}
 
 	FREE_OP1();
@@ -4130,9 +4157,9 @@
 	zend_free_op free_op1;
 	zval *value = GET_OP1_ZVAL_PTR(BP_VAR_R);
 
-	EX_T(opline->result.u.var).tmp_var = *value;
+	EX_T(opline->result.var).tmp_var = *value;
 	if (!IS_OP1_TMP_FREE()) {
-		zval_copy_ctor(&EX_T(opline->result.u.var).tmp_var);
+		zval_copy_ctor(&EX_T(opline->result.var).tmp_var);
 	}
 	FREE_OP1_IF_VAR();
 	ZEND_VM_NEXT_OPCODE();
@@ -4166,7 +4193,7 @@
 {
 	zend_op *opline = EX(opline);
 
-	EX_T(opline->result.u.var).class_entry = do_bind_class(opline, EG(class_table), 0 TSRMLS_CC);
+	EX_T(opline->result.var).class_entry = do_bind_class(EX(op_array), opline, EG(class_table), 0 TSRMLS_CC);
 	ZEND_VM_NEXT_OPCODE();
 }
 
@@ -4174,7 +4201,7 @@
 {
 	zend_op *opline = EX(opline);
 
-	EX_T(opline->result.u.var).class_entry = do_bind_inherited_class(opline, EG(class_table), EX_T(opline->extended_value).class_entry, 0 TSRMLS_CC);
+	EX_T(opline->result.var).class_entry = do_bind_inherited_class(EX(op_array), opline, EG(class_table), EX_T(opline->extended_value).class_entry, 0 TSRMLS_CC);
 	ZEND_VM_NEXT_OPCODE();
 }
 
@@ -4183,28 +4210,28 @@
 	zend_op *opline = EX(opline);
 	zend_class_entry **pce, **pce_orig;
 
-	if (zend_hash_find(EG(class_table), Z_STRVAL(opline->op2.u.constant), Z_STRLEN(opline->op2.u.constant)+1, (void**)&pce) == FAILURE ||
-	    (zend_hash_find(EG(class_table), Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant), (void**)&pce_orig) == SUCCESS &&
+	if (zend_hash_quick_find(EG(class_table), Z_STRVAL_P(opline->op2.zv), Z_STRLEN_P(opline->op2.zv)+1, Z_HASH_P(opline->op2.zv), (void**)&pce) == FAILURE ||
+	    (zend_hash_quick_find(EG(class_table), Z_STRVAL_P(opline->op1.zv), Z_STRLEN_P(opline->op1.zv), Z_HASH_P(opline->op1.zv), (void**)&pce_orig) == SUCCESS &&
 	     *pce != *pce_orig)) {
-		do_bind_inherited_class(opline, EG(class_table), EX_T(opline->extended_value).class_entry, 0 TSRMLS_CC);
+		do_bind_inherited_class(EX(op_array), opline, EG(class_table), EX_T(opline->extended_value).class_entry, 0 TSRMLS_CC);
 	}
 	ZEND_VM_NEXT_OPCODE();
 }
 
 ZEND_VM_HANDLER(141, ZEND_DECLARE_FUNCTION, ANY, ANY)
 {
-	do_bind_function(EX(opline), EG(function_table), 0);
+	do_bind_function(EX(op_array), EX(opline), EG(function_table), 0);
 	ZEND_VM_NEXT_OPCODE();
 }
 
-ZEND_VM_HANDLER(105, ZEND_TICKS, CONST, ANY)
+ZEND_VM_HANDLER(105, ZEND_TICKS, ANY, ANY)
 {
 	zend_op *opline = EX(opline);
 
-	if (++EG(ticks_count)>=Z_LVAL(opline->op1.u.constant)) {
+	if (++EG(ticks_count)>=opline->extended_value) {
 		EG(ticks_count)=0;
 		if (zend_ticks_function) {
-			zend_ticks_function(Z_LVAL(opline->op1.u.constant));
+			zend_ticks_function(opline->extended_value);
 		}
 	}
 	ZEND_VM_NEXT_OPCODE();
@@ -4218,11 +4245,11 @@
 	zend_bool result;
 
 	if (Z_TYPE_P(expr) == IS_OBJECT && Z_OBJ_HT_P(expr)->get_class_entry) {
-		result = instanceof_function(Z_OBJCE_P(expr), EX_T(opline->op2.u.var).class_entry TSRMLS_CC);
+		result = instanceof_function(Z_OBJCE_P(expr), EX_T(opline->op2.var).class_entry TSRMLS_CC);
 	} else {
 		result = 0;
 	}
-	ZVAL_BOOL(&EX_T(opline->result.u.var).tmp_var, result);
+	ZVAL_BOOL(&EX_T(opline->result.var).tmp_var, result);
 	FREE_OP1();
 	ZEND_VM_NEXT_OPCODE();
 }
@@ -4240,8 +4267,8 @@
 ZEND_VM_HANDLER(144, ZEND_ADD_INTERFACE, ANY, CONST)
 {
 	zend_op *opline = EX(opline);
-	zend_class_entry *ce = EX_T(opline->op1.u.var).class_entry;
-	zend_class_entry *iface = zend_fetch_class(Z_STRVAL(opline->op2.u.constant), Z_STRLEN(opline->op2.u.constant), opline->extended_value TSRMLS_CC);
+	zend_class_entry *ce = EX_T(opline->op1.var).class_entry;
+	zend_class_entry *iface = zend_fetch_class_by_name(Z_STRVAL_P(opline->op2.zv), Z_STRLEN_P(opline->op2.zv), opline->op2.literal + 1, opline->extended_value TSRMLS_CC);
 
 	if (iface) {
 		if (!(iface->ce_flags & ZEND_ACC_INTERFACE)) {
@@ -4311,13 +4338,13 @@
 
 				switch (brk_opline->opcode) {
 					case ZEND_SWITCH_FREE:
-						if (brk_opline->op1.u.EA.type != EXT_TYPE_FREE_ON_RETURN) {
-							zend_switch_free(&EX_T(brk_opline->op1.u.var), brk_opline->extended_value TSRMLS_CC);
+						if (!(brk_opline->extended_value & EXT_TYPE_FREE_ON_RETURN)) {
+							zend_switch_free(&EX_T(brk_opline->op1.var), brk_opline->extended_value TSRMLS_CC);
 						}
 						break;
 					case ZEND_FREE:
-						if (brk_opline->op1.u.EA.type != EXT_TYPE_FREE_ON_RETURN) {
-							zendi_zval_dtor(EX_T(brk_opline->op1.u.var).tmp_var);
+						if (!(brk_opline->extended_value & EXT_TYPE_FREE_ON_RETURN)) {
+							zendi_zval_dtor(EX_T(brk_opline->op1.var).tmp_var);
 						}
 						break;
 				}
@@ -4345,7 +4372,7 @@
 
 ZEND_VM_HANDLER(146, ZEND_VERIFY_ABSTRACT_CLASS, ANY, ANY)
 {
-	zend_verify_abstract_class(EX_T(EX(opline)->op1.u.var).class_entry TSRMLS_CC);
+	zend_verify_abstract_class(EX_T(EX(opline)->op1.var).class_entry TSRMLS_CC);
 	ZEND_VM_NEXT_OPCODE();
 }
 
@@ -4404,17 +4431,17 @@
 	ZEND_VM_NEXT_OPCODE();
 }
 
-ZEND_VM_HANDLER(153, ZEND_DECLARE_LAMBDA_FUNCTION, CONST, CONST)
+ZEND_VM_HANDLER(153, ZEND_DECLARE_LAMBDA_FUNCTION, CONST, UNUSED)
 {
 	zend_op *opline = EX(opline);
 	zend_function *op_array;
 
-	if (zend_hash_quick_find(EG(function_table), Z_STRVAL(opline->op1.u.constant), Z_STRLEN(opline->op1.u.constant), Z_LVAL(opline->op2.u.constant), (void *) &op_array) == FAILURE ||
+	if (zend_hash_quick_find(EG(function_table), Z_STRVAL_P(opline->op1.zv), Z_STRLEN_P(opline->op1.zv), Z_HASH_P(opline->op1.zv), (void *) &op_array) == FAILURE ||
 	    op_array->type != ZEND_USER_FUNCTION) {
 		zend_error_noreturn(E_ERROR, "Base lambda function for closure not found");
 	}
 
-	zend_create_closure(&EX_T(opline->result.u.var).tmp_var, op_array TSRMLS_CC);
+	zend_create_closure(&EX_T(opline->result.var).tmp_var, op_array TSRMLS_CC);
 
 	ZEND_VM_NEXT_OPCODE();
 }
Index: Zend/zend_opcode.c
===================================================================
--- Zend/zend_opcode.c	(revision 297868)
+++ Zend/zend_opcode.c	(working copy)
@@ -67,7 +67,7 @@
 	op_array->opcodes = NULL;
 	op_array_alloc_ops(op_array);
 
-	op_array->size_var = 0; /* FIXME:??? */
+	op_array->size_var = 0;
 	op_array->last_var = 0;
 	op_array->vars = NULL;
 
@@ -103,6 +103,10 @@
 
 	op_array->early_binding = -1;
 
+	op_array->size_literal = 0;
+	op_array->last_literal = 0;
+	op_array->literals = NULL;
+
 	memset(op_array->reserved, 0, ZEND_MAX_RESERVED_RESOURCES * sizeof(void*));
 
 	zend_llist_apply_with_argument(&zend_extensions, (llist_apply_with_arg_func_t) zend_extension_op_array_ctor_handler, op_array TSRMLS_CC);
@@ -220,8 +224,8 @@
 
 ZEND_API void destroy_op_array(zend_op_array *op_array TSRMLS_DC)
 {
-	zend_op *opline = op_array->opcodes;
-	zend_op *end = op_array->opcodes+op_array->last;
+	zend_literal *literal = op_array->literals;
+	zend_literal *end;
 	zend_uint i;
 
 	if (op_array->static_variables) {
@@ -244,20 +248,13 @@
 		efree(op_array->vars);
 	}
 
-	while (opline<end) {
-		if (opline->op1.op_type==IS_CONST) {
-#if DEBUG_ZEND>2
-			printf("Reducing refcount for %x 1=>0 (destroying)\n", &opline->op1.u.constant);
-#endif
-			zval_dtor(&opline->op1.u.constant);
+	if (literal) {
+	 	end = literal + op_array->last_literal;
+	 	while (literal < end) {
+			zval_dtor(&literal->constant);
+			literal++;
 		}
-		if (opline->op2.op_type==IS_CONST) {
-#if DEBUG_ZEND>2
-			printf("Reducing refcount for %x 1=>0 (destroying)\n", &opline->op2.u.constant);
-#endif
-			zval_dtor(&opline->op2.u.constant);
-		}
-		opline++;
+		efree(op_array->literals);
 	}
 	efree(op_array->opcodes);
 
@@ -377,39 +374,41 @@
 		op_array->opcodes = (zend_op *) erealloc(op_array->opcodes, sizeof(zend_op)*op_array->last);
 		op_array->size = op_array->last;
 	}
+	if (!(op_array->fn_flags & ZEND_ACC_INTERACTIVE) && op_array->size_literal != op_array->last_literal) {
+		op_array->literals = (zend_literal*)erealloc(op_array->literals, sizeof(zend_literal) * op_array->last_literal);
+		op_array->size_literal = op_array->last_literal;
+	}
 
 	opline = op_array->opcodes;
 	end = opline + op_array->last;
 	while (opline < end) {
-		if (opline->op1.op_type == IS_CONST) {
-			Z_SET_ISREF(opline->op1.u.constant);
-			Z_SET_REFCOUNT(opline->op1.u.constant, 2); /* Make sure is_ref won't be reset */
+		if (opline->op1_type == IS_CONST) {
+			opline->op1.zv = &op_array->literals[opline->op1.constant].constant;
 		}
-		if (opline->op2.op_type == IS_CONST) {
-			Z_SET_ISREF(opline->op2.u.constant);
-			Z_SET_REFCOUNT(opline->op2.u.constant, 2);
+		if (opline->op2_type == IS_CONST) {
+			opline->op2.zv = &op_array->literals[opline->op2.constant].constant;
 		}
 		switch (opline->opcode) {
 			case ZEND_GOTO:
-				if (Z_TYPE(opline->op2.u.constant) != IS_LONG) {
+				if (Z_TYPE_P(opline->op2.zv) != IS_LONG) {
 					zend_resolve_goto_label(op_array, opline, 1 TSRMLS_CC);
 				}
 				/* break omitted intentionally */
 			case ZEND_JMP:
-				opline->op1.u.jmp_addr = &op_array->opcodes[opline->op1.u.opline_num];
+				opline->op1.jmp_addr = &op_array->opcodes[opline->op1.opline_num];
 				break;
 			case ZEND_JMPZ:
 			case ZEND_JMPNZ:
 			case ZEND_JMPZ_EX:
 			case ZEND_JMPNZ_EX:
 			case ZEND_JMP_SET:
-				opline->op2.u.jmp_addr = &op_array->opcodes[opline->op2.u.opline_num];
+				opline->op2.jmp_addr = &op_array->opcodes[opline->op2.opline_num];
 				break;
 		}
 		ZEND_VM_SET_OPCODE_HANDLER(opline);
 		opline++;
 	}
-	
+
 	op_array->done_pass_two = 1;
 	return 0;
 }
Index: main/main.c
===================================================================
--- main/main.c	(revision 297868)
+++ main/main.c	(working copy)
@@ -668,7 +668,7 @@
 				EG(current_execute_data)->opline &&
 				EG(current_execute_data)->opline->opcode == ZEND_INCLUDE_OR_EVAL
 	) {
-		switch (EG(current_execute_data)->opline->op2.u.constant.value.lval) {
+		switch (EG(current_execute_data)->opline->extended_value) {
 			case ZEND_EVAL:
 				function = "eval";
 				is_function = 1;
Index: ext/xsl/xsltprocessor.c
===================================================================
--- ext/xsl/xsltprocessor.c	(revision 297868)
+++ ext/xsl/xsltprocessor.c	(working copy)
@@ -427,7 +427,7 @@
 	std_hnd = zend_get_std_object_handlers();
 	MAKE_STD_ZVAL(member);
 	ZVAL_STRING(member, "cloneDocument", 0);
-	cloneDocu = std_hnd->read_property(id, member, BP_VAR_IS TSRMLS_CC);
+	cloneDocu = std_hnd->read_property(id, member, BP_VAR_IS, NULL TSRMLS_CC);
 	if (Z_TYPE_P(cloneDocu) != IS_NULL) {
 		convert_to_long(cloneDocu);
 		clone_docu = Z_LVAL_P(cloneDocu);
@@ -524,7 +524,7 @@
 
 	MAKE_STD_ZVAL(member);
 	ZVAL_STRING(member, "doXInclude", 0);
-	doXInclude = std_hnd->read_property(id, member, BP_VAR_IS TSRMLS_CC);
+	doXInclude = std_hnd->read_property(id, member, BP_VAR_IS, NULL TSRMLS_CC);
 	if (Z_TYPE_P(doXInclude) != IS_NULL) {
 		convert_to_long(doXInclude);
 		ctxt->xinclude = Z_LVAL_P(doXInclude);
Index: ext/zip/php_zip.c
===================================================================
--- ext/zip/php_zip.c	(revision 297868)
+++ ext/zip/php_zip.c	(working copy)
@@ -812,7 +812,7 @@
 }
 /* }}} */
 
-static zval **php_zip_get_property_ptr_ptr(zval *object, zval *member TSRMLS_DC) /* {{{ */
+static zval **php_zip_get_property_ptr_ptr(zval *object, zval *member, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	ze_zip_object *obj;
 	zval tmp_member;
@@ -827,19 +827,24 @@
 		zval_copy_ctor(&tmp_member);
 		convert_to_string(&tmp_member);
 		member = &tmp_member;
+		key = NULL;
 	}
 
 	ret = FAILURE;
 	obj = (ze_zip_object *)zend_objects_get_address(object TSRMLS_CC);
 
 	if (obj->prop_handler != NULL) {
-		ret = zend_hash_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, (void **) &hnd);
+		if (key) {
+			ret = zend_hash_quick_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, key->hash_value, (void **) &hnd);
+		} else {	
+			ret = zend_hash_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, (void **) &hnd);
+		}
 	}
 
 
 	if (ret == FAILURE) {
 		std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->get_property_ptr_ptr(object, member TSRMLS_CC);
+		retval = std_hnd->get_property_ptr_ptr(object, member, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -849,7 +854,7 @@
 }
 /* }}} */
 
-static zval* php_zip_read_property(zval *object, zval *member, int type TSRMLS_DC) /* {{{ */
+static zval* php_zip_read_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	ze_zip_object *obj;
 	zval tmp_member;
@@ -863,13 +868,18 @@
 		zval_copy_ctor(&tmp_member);
 		convert_to_string(&tmp_member);
 		member = &tmp_member;
+		key = NULL;
 	}
 
 	ret = FAILURE;
 	obj = (ze_zip_object *)zend_objects_get_address(object TSRMLS_CC);
 
 	if (obj->prop_handler != NULL) {
-		ret = zend_hash_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, (void **) &hnd);
+		if (key) {
+			ret = zend_hash_quick_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, key->hash_value, (void **) &hnd);
+		} else {
+			ret = zend_hash_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, (void **) &hnd);
+		}
 	}
 
 	if (ret == SUCCESS) {
@@ -882,7 +892,7 @@
 		}
 	} else {
 		std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->read_property(object, member, type TSRMLS_CC);
+		retval = std_hnd->read_property(object, member, type, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
@@ -892,7 +902,7 @@
 }
 /* }}} */
 
-static int php_zip_has_property(zval *object, zval *member, int type TSRMLS_DC) /* {{{ */
+static int php_zip_has_property(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC) /* {{{ */
 {
 	ze_zip_object *obj;
 	zval tmp_member;
@@ -905,13 +915,18 @@
 		zval_copy_ctor(&tmp_member);
 		convert_to_string(&tmp_member);
 		member = &tmp_member;
+		key = NULL;
 	}
 
 	ret = FAILURE;
 	obj = (ze_zip_object *)zend_objects_get_address(object TSRMLS_CC);
 
 	if (obj->prop_handler != NULL) {
-		ret = zend_hash_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, (void **) &hnd);
+		if (key) {
+			ret = zend_hash_quick_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, key->hash_value, (void **) &hnd);
+		} else {
+			ret = zend_hash_find(obj->prop_handler, Z_STRVAL_P(member), Z_STRLEN_P(member)+1, (void **) &hnd);
+		}
 	}
 
 	if (ret == SUCCESS) {
@@ -933,7 +948,7 @@
 		zval_ptr_dtor(&tmp);
 	} else {
 		std_hnd = zend_get_std_object_handlers();
-		retval = std_hnd->has_property(object, member, type TSRMLS_CC);
+		retval = std_hnd->has_property(object, member, type, key TSRMLS_CC);
 	}
 
 	if (member == &tmp_member) {
Index: ext/com_dotnet/com_handlers.c
===================================================================
--- ext/com_dotnet/com_handlers.c	(revision 297868)
+++ ext/com_dotnet/com_handlers.c	(working copy)
@@ -29,7 +29,7 @@
 #include "php_com_dotnet_internal.h"
 #include "Zend/zend_exceptions.h"
 
-static zval *com_property_read(zval *object, zval *member, int type TSRMLS_DC)
+static zval *com_property_read(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC)
 {
 	zval *return_value;
 	php_com_dotnet_object *obj;
@@ -64,7 +64,7 @@
 	return return_value;
 }
 
-static void com_property_write(zval *object, zval *member, zval *value TSRMLS_DC)
+static void com_property_write(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	php_com_dotnet_object *obj;
 	VARIANT v;
@@ -196,7 +196,7 @@
 }
 #endif
 
-static int com_property_exists(zval *object, zval *member, int check_empty TSRMLS_DC)
+static int com_property_exists(zval *object, zval *member, int check_empty, const zend_literal *key TSRMLS_DC)
 {
 	DISPID dispid;
 	php_com_dotnet_object *obj;
@@ -222,7 +222,7 @@
 	return 0;
 }
 
-static void com_property_delete(zval *object, zval *member TSRMLS_DC)
+static void com_property_delete(zval *object, zval *member, const zend_literal *key TSRMLS_DC)
 {
 	php_error_docref(NULL TSRMLS_CC, E_WARNING, "Cannot delete properties from a COM object");
 }
@@ -259,7 +259,7 @@
 			INTERNAL_FUNCTION_PARAM_PASSTHRU);
 }
 
-static union _zend_function *com_method_get(zval **object_ptr, char *name, int len TSRMLS_DC)
+static union _zend_function *com_method_get(zval **object_ptr, char *name, int len, const zend_literal *key TSRMLS_DC)
 {
 	zend_internal_function f, *fptr = NULL;
 	php_com_dotnet_object *obj;
Index: ext/com_dotnet/com_saproxy.c
===================================================================
--- ext/com_dotnet/com_saproxy.c	(revision 297868)
+++ ext/com_dotnet/com_saproxy.c	(working copy)
@@ -71,7 +71,7 @@
 	}
 }
 
-static zval *saproxy_property_read(zval *object, zval *member, int type TSRMLS_DC)
+static zval *saproxy_property_read(zval *object, zval *member, int type, const zend_literal *key TSRMLS_DC)
 {
 	zval *return_value;
 	
@@ -83,7 +83,7 @@
 	return return_value;
 }
 
-static void saproxy_property_write(zval *object, zval *member, zval *value TSRMLS_DC)
+static void saproxy_property_write(zval *object, zval *member, zval *value, const zend_literal *key TSRMLS_DC)
 {
 	php_com_throw_exception(E_INVALIDARG, "safearray has no properties" TSRMLS_CC);
 }
@@ -293,7 +293,7 @@
 }
 #endif
 
-static int saproxy_property_exists(zval *object, zval *member, int check_empty TSRMLS_DC)
+static int saproxy_property_exists(zval *object, zval *member, int check_empty, const zend_literal *key TSRMLS_DC)
 {
 	/* no properties */
 	return 0;
@@ -305,7 +305,7 @@
 	return 0;
 }
 
-static void saproxy_property_delete(zval *object, zval *member TSRMLS_DC)
+static void saproxy_property_delete(zval *object, zval *member, const zend_literal *key TSRMLS_DC)
 {
 	php_error_docref(NULL TSRMLS_CC, E_WARNING, "Cannot delete properties from a COM object");
 }
@@ -321,7 +321,7 @@
 	return NULL;
 }
 
-static union _zend_function *saproxy_method_get(zval **object, char *name, int len TSRMLS_DC)
+static union _zend_function *saproxy_method_get(zval **object, char *name, int len, const zend_literal *key TSRMLS_DC)
 {
 	/* no methods */
 	return NULL;
